/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(ge){for(var e=[],E=0,N=ge.length;E<N;E++)e[E]=Ce[ge[E]];return e};define(Ce[66],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=void 0;function E(R){return(m,g,w)=>{let A=null,k=null;if(typeof w.value=="function"?(A="value",k=w.value):typeof w.get=="function"&&(A="get",k=w.get),!k)throw new Error("not supported");w[A]=R(k,g)}}function N(R,m,g){let w=null,A=null;if(typeof g.value=="function"?(w="value",A=g.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",A=g.get),!A)throw new Error("not supported");const k=`$memoize$${m}`;g[w]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$th=N;function I(R,m,g){return E((w,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...p){this[l]||(this[l]=g?g():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...p),p=[this[l]]),this[k]=setTimeout(()=>{w.apply(this,p),this[l]=g?g():void 0},R)}})}e.$uh=I;function L(R,m,g){return E((w,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,p=`$throttle$lastRun$${A}`,b=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=g?g():void 0),(this[p]===null||this[p]===void 0)&&(this[p]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[b])return;const o=this[p]+R;o<=Date.now()?(this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[p]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}e.$vh=L}),define(Ce[89],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=void 0;class E{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$XM=E,e.$YM=new E("id#")}),define(Ce[119],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(i,s=!1){let u=0;const d=i.length;let v="",f=0,S=16,F=0;function $(q){let C=0,P=0;for(;C<q;){const J=i.charCodeAt(u);if(J>=48&&J<=57)P=P*16+J-48;else if(J>=65&&J<=70)P=P*16+J-65+10;else if(J>=97&&J<=102)P=P*16+J-97+10;else break;u++,C++}return C<q&&(P=-1),P}function y(q){u=q,v="",f=0,S=16,F=0}function D(){const q=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return F=3,i.substring(q,u);let C=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;C=u}else F=3;return i.substring(q,C)}function M(){let q="",C=u;for(;;){if(u>=d){q+=i.substring(C,u),F=2;break}const P=i.charCodeAt(u);if(P===34){q+=i.substring(C,u),u++;break}if(P===92){if(q+=i.substring(C,u),u++,u>=d){F=2;break}switch(i.charCodeAt(u++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ce=$(4);ce>=0?q+=String.fromCharCode(ce):F=4;break}default:F=5}C=u;continue}if(P>=0&&P<=31)if(g(P)){q+=i.substring(C,u),F=2;break}else F=6;u++}return q}function O(){if(v="",F=0,f=u,u>=d)return f=d,S=17;let q=i.charCodeAt(u);if(m(q)){do u++,v+=String.fromCharCode(q),q=i.charCodeAt(u);while(m(q));return S=15}if(g(q))return u++,v+=String.fromCharCode(q),q===13&&i.charCodeAt(u)===10&&(u++,v+=`
`),S=14;switch(q){case 123:return u++,S=1;case 125:return u++,S=2;case 91:return u++,S=3;case 93:return u++,S=4;case 58:return u++,S=6;case 44:return u++,S=5;case 34:return u++,v=M(),S=10;case 47:{const C=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return v=i.substring(C,u),S=12}if(i.charCodeAt(u+1)===42){u+=2;const P=d-1;let J=!1;for(;u<P;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,J=!0;break}u++}return J||(u++,F=1),v=i.substring(C,u),S=13}return v+=String.fromCharCode(q),u++,S=16}case 45:if(v+=String.fromCharCode(q),u++,u===d||!w(i.charCodeAt(u)))return S=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=D(),S=11;default:for(;u<d&&W(q);)u++,q=i.charCodeAt(u);if(f!==u){switch(v=i.substring(f,u),v){case"true":return S=8;case"false":return S=9;case"null":return S=7}return S=16}return v+=String.fromCharCode(q),u++,S=16}}function W(q){if(m(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let q;do q=O();while(q>=12&&q<=15);return q}return{setPosition:y,getPosition:()=>u,scan:s?z:O,getToken:()=>S,getTokenValue:()=>v,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>F}}e.$9m=R;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var A;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(A||(A={}));function k(i,s){const u=[],d=new Object;let v;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function F($,y,D,M){f.value=$,f.offset=y,f.length=D,f.type=M,f.colonOffset=void 0,v=f}try{a(i,{onObjectBegin:($,y)=>{if(s<=$)throw d;v=void 0,S=s>$,u.push("")},onObjectProperty:($,y,D)=>{if(s<y||(F($,y,D,"property"),u[u.length-1]=$,s<=y+D))throw d},onObjectEnd:($,y)=>{if(s<=$)throw d;v=void 0,u.pop()},onArrayBegin:($,y)=>{if(s<=$)throw d;v=void 0,u.push(0)},onArrayEnd:($,y)=>{if(s<=$)throw d;v=void 0,u.pop()},onLiteralValue:($,y,D)=>{if(s<y||(F($,y,D,h($)),s<=y+D))throw d},onSeparator:($,y,D)=>{if(s<=y)throw d;if($===":"&&v&&v.type==="property")v.colonOffset=y,S=!1,v=void 0;else if($===","){const M=u[u.length-1];typeof M=="number"?u[u.length-1]=M+1:(S=!0,u[u.length-1]=""),v=void 0}}})}catch($){if($!==d)throw $}return{path:u,previousNode:v,isAtPropertyKey:S,matches:$=>{let y=0;for(let D=0;y<$.length&&D<u.length;D++)if($[y]===u[D]||$[y]==="*")y++;else if($[y]!=="**")return!1;return y===$.length}}}e.$0m=k;function l(i,s=[],u=L.DEFAULT){let d=null,v=[];const f=[];function S($){Array.isArray(v)?v.push($):d!==null&&(v[d]=$)}return a(i,{onObjectBegin:()=>{const $={};S($),f.push(v),v=$,d=null},onObjectProperty:$=>{d=$},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const $=[];S($),f.push(v),v=$,d=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:S,onError:($,y,D)=>{s.push({error:$,offset:y,length:D})}},u),v[0]}e.$$m=l;function p(i,s=[],u=L.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v($){d.type==="property"&&(d.length=$-d.offset,d=d.parent)}function f($){return d.children.push($),$}a(i,{onObjectBegin:$=>{d=f({type:"object",offset:$,length:-1,parent:d,children:[]})},onObjectProperty:($,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:$,offset:y,length:D,parent:d})},onObjectEnd:($,y)=>{d.length=$+y-d.offset,d=d.parent,v($+y)},onArrayBegin:($,y)=>{d=f({type:"array",offset:$,length:-1,parent:d,children:[]})},onArrayEnd:($,y)=>{d.length=$+y-d.offset,d=d.parent,v($+y)},onLiteralValue:($,y,D)=>{f({type:h($),offset:y,length:D,parent:d,value:$}),v(y+D)},onSeparator:($,y,D)=>{d.type==="property"&&($===":"?d.colonOffset=y:$===","&&v(y))},onError:($,y,D)=>{s.push({error:$,offset:y,length:D})}},u);const F=d.children[0];return F&&delete F.parent,F}e.$_m=p;function b(i,s){if(!i)return;let u=i;for(const d of s)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],v=!0;break}if(!v)return}else{const v=d;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$an=b;function r(i){if(!i.parent||!i.parent.children)return[];const s=r(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.$bn=r;function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const s=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(s[u.children[0].value]=o(d))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$cn=o;function t(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.$dn=t;function n(i,s,u=!1){if(t(i,s,u)){const d=i.children;if(Array.isArray(d))for(let v=0;v<d.length&&d[v].offset<=s;v++){const f=n(d[v],s,u);if(f)return f}return i}}e.$en=n;function a(i,s,u=L.DEFAULT){const d=R(i,!1);function v(ie){return ie?()=>ie(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ie){return ie?ke=>ie(ke,d.getTokenOffset(),d.getTokenLength()):()=>!0}const S=v(s.onObjectBegin),F=f(s.onObjectProperty),$=v(s.onObjectEnd),y=v(s.onArrayBegin),D=v(s.onArrayEnd),M=f(s.onLiteralValue),O=f(s.onSeparator),W=v(s.onComment),z=f(s.onError),q=u&&u.disallowComments,C=u&&u.allowTrailingComma;function P(){for(;;){const ie=d.scan();switch(d.getTokenError()){case 4:J(14);break;case 5:J(15);break;case 3:J(13);break;case 1:q||J(11);break;case 2:J(12);break;case 6:J(16);break}switch(ie){case 12:case 13:q?J(10):W();break;case 16:J(1);break;case 15:case 14:break;default:return ie}}}function J(ie,ke=[],oe=[]){if(z(ie),ke.length+oe.length>0){let Y=d.getToken();for(;Y!==17;){if(ke.indexOf(Y)!==-1){P();break}else if(oe.indexOf(Y)!==-1)break;Y=P()}}}function ce(ie){const ke=d.getTokenValue();return ie?M(ke):F(ke),P(),!0}function me(){switch(d.getToken()){case 11:{let ie=0;try{ie=JSON.parse(d.getTokenValue()),typeof ie!="number"&&(J(2),ie=0)}catch{J(2)}M(ie);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return P(),!0}function be(){return d.getToken()!==10?(J(3,[],[2,5]),!1):(ce(!1),d.getToken()===6?(O(":"),P(),fe()||J(4,[],[2,5])):J(5,[],[2,5]),!0)}function Se(){S(),P();let ie=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ie||J(4,[],[]),O(","),P(),d.getToken()===2&&C)break}else ie&&J(6,[],[]);be()||J(4,[],[2,5]),ie=!0}return $(),d.getToken()!==2?J(7,[2],[]):P(),!0}function he(){y(),P();let ie=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ie||J(4,[],[]),O(","),P(),d.getToken()===4&&C)break}else ie&&J(6,[],[]);fe()||J(4,[],[4,5]),ie=!0}return D(),d.getToken()!==4?J(8,[4],[]):P(),!0}function fe(){switch(d.getToken()){case 3:return he();case 1:return Se();case 10:return ce(!0);default:return me()}}return P(),d.getToken()===17?u.allowEmptyContent?!0:(J(4,[],[]),!1):fe()?(d.getToken()!==17&&J(9,[],[]),!0):(J(4,[],[]),!1)}e.$fn=a;function c(i,s){const u=R(i),d=[];let v,f=0,S;do switch(S=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:f!==S&&d.push(i.substring(f,S)),s!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,s)),f=u.getPosition();break}while(v!==17);return d.join("")}e.$gn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$hn=h}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Pe,ae){for(var te=0;te<ae.length;te++){var Q=ae[te];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(Pe,Q.key,Q)}}function E(Pe,ae,te){return ae&&e(Pe.prototype,ae),te&&e(Pe,te),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function N(Pe,ae){if(Pe){if(typeof Pe=="string")return I(Pe,ae);var te=Object.prototype.toString.call(Pe).slice(8,-1);if(te==="Object"&&Pe.constructor&&(te=Pe.constructor.name),te==="Map"||te==="Set")return Array.from(Pe);if(te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(te))return I(Pe,ae)}}function I(Pe,ae){(ae==null||ae>Pe.length)&&(ae=Pe.length);for(var te=0,Q=new Array(ae);te<ae;te++)Q[te]=Pe[te];return Q}function L(Pe,ae){var te=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(te)return(te=te.call(Pe)).next.bind(te);if(Array.isArray(Pe)||(te=N(Pe))||ae&&Pe&&typeof Pe.length=="number"){te&&(Pe=te);var Q=0;return function(){return Q>=Pe.length?{done:!0}:{done:!1,value:Pe[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function m(Pe){ge.defaults=Pe}var g=/[&<>"']/,w=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},p=function(ae){return l[ae]};function b(Pe,ae){if(ae){if(g.test(Pe))return Pe.replace(w,p)}else if(A.test(Pe))return Pe.replace(k,p);return Pe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Pe){return Pe.replace(r,function(ae,te){return te=te.toLowerCase(),te==="colon"?":":te.charAt(0)==="#"?te.charAt(1)==="x"?String.fromCharCode(parseInt(te.substring(2),16)):String.fromCharCode(+te.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Pe,ae){Pe=typeof Pe=="string"?Pe:Pe.source,ae=ae||"";var te={replace:function(ee,$e){return $e=$e.source||$e,$e=$e.replace(t,"$1"),Pe=Pe.replace(ee,$e),te},getRegex:function(){return new RegExp(Pe,ae)}};return te}var a=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Pe,ae,te){if(Pe){var Q;try{Q=decodeURIComponent(o(te)).replace(a,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}ae&&!c.test(te)&&(te=v(ae,te));try{te=encodeURI(te).replace(/%25/g,"%")}catch{return null}return te}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Pe,ae){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=$(Pe,"/",!0)),Pe=i[" "+Pe];var te=Pe.indexOf(":")===-1;return ae.substring(0,2)==="//"?te?ae:Pe.replace(u,"$1")+ae:ae.charAt(0)==="/"?te?ae:Pe.replace(d,"$1")+ae:Pe+ae}var f={exec:function(){}};function S(Pe){for(var ae=1,te,Q;ae<arguments.length;ae++){te=arguments[ae];for(Q in te)Object.prototype.hasOwnProperty.call(te,Q)&&(Pe[Q]=te[Q])}return Pe}function F(Pe,ae){var te=Pe.replace(/\|/g,function($e,ve,Fe){for(var le=!1,we=ve;--we>=0&&Fe[we]==="\\";)le=!le;return le?"|":" |"}),Q=te.split(/ \|/),ee=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>ae)Q.splice(ae);else for(;Q.length<ae;)Q.push("");for(;ee<Q.length;ee++)Q[ee]=Q[ee].trim().replace(/\\\|/g,"|");return Q}function $(Pe,ae,te){var Q=Pe.length;if(Q===0)return"";for(var ee=0;ee<Q;){var $e=Pe.charAt(Q-ee-1);if($e===ae&&!te)ee++;else if($e!==ae&&te)ee++;else break}return Pe.slice(0,Q-ee)}function y(Pe,ae){if(Pe.indexOf(ae[1])===-1)return-1;for(var te=Pe.length,Q=0,ee=0;ee<te;ee++)if(Pe[ee]==="\\")ee++;else if(Pe[ee]===ae[0])Q++;else if(Pe[ee]===ae[1]&&(Q--,Q<0))return ee;return-1}function D(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(Pe,ae){if(ae<1)return"";for(var te="";ae>1;)ae&1&&(te+=Pe),ae>>=1,Pe+=Pe;return te+Pe}function O(Pe,ae,te,Q){var ee=ae.href,$e=ae.title?b(ae.title):null,ve=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){Q.state.inLink=!0;var Fe={type:"link",raw:te,href:ee,title:$e,text:ve,tokens:Q.inlineTokens(ve)};return Q.state.inLink=!1,Fe}return{type:"image",raw:te,href:ee,title:$e,text:b(ve)}}function W(Pe,ae){var te=Pe.match(/^(\s+)(?:```)/);if(te===null)return ae;var Q=te[1];return ae.split(`
`).map(function(ee){var $e=ee.match(/^\s+/);if($e===null)return ee;var ve=$e[0];return ve.length>=Q.length?ee.slice(Q.length):ee}).join(`
`)}var z=function(){function Pe(te){this.options=te||ge.defaults}var ae=Pe.prototype;return ae.space=function(Q){var ee=this.rules.block.newline.exec(Q);if(ee&&ee[0].length>0)return{type:"space",raw:ee[0]}},ae.code=function(Q){var ee=this.rules.block.code.exec(Q);if(ee){var $e=ee[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ee[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:$($e,`
`)}}},ae.fences=function(Q){var ee=this.rules.block.fences.exec(Q);if(ee){var $e=ee[0],ve=W($e,ee[3]||"");return{type:"code",raw:$e,lang:ee[2]?ee[2].trim():ee[2],text:ve}}},ae.heading=function(Q){var ee=this.rules.block.heading.exec(Q);if(ee){var $e=ee[2].trim();if(/#$/.test($e)){var ve=$($e,"#");(this.options.pedantic||!ve||/ $/.test(ve))&&($e=ve.trim())}return{type:"heading",raw:ee[0],depth:ee[1].length,text:$e,tokens:this.lexer.inline($e)}}},ae.hr=function(Q){var ee=this.rules.block.hr.exec(Q);if(ee)return{type:"hr",raw:ee[0]}},ae.blockquote=function(Q){var ee=this.rules.block.blockquote.exec(Q);if(ee){var $e=ee[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ee[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ae.list=function(Q){var ee=this.rules.block.list.exec(Q);if(ee){var $e,ve,Fe,le,we,T,K,H,U,Z,x,ye,Te=ee[1].trim(),We=Te.length>1,He={type:"list",raw:"",ordered:We,start:We?+Te.slice(0,-1):"",loose:!1,items:[]};Te=We?"\\d{1,9}\\"+Te.slice(-1):"\\"+Te,this.options.pedantic&&(Te=We?Te:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+Te+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(ye=!1,!(!(ee=Xe.exec(Q))||this.rules.block.hr.test(Q)));){if($e=ee[0],Q=Q.substring($e.length),H=ee[2].split(`
`,1)[0],U=Q.split(`
`,1)[0],this.options.pedantic?(le=2,x=H.trimLeft()):(le=ee[2].search(/[^ ]/),le=le>4?1:le,x=H.slice(le),le+=ee[1].length),T=!1,!H&&/^ *$/.test(U)&&($e+=U+`
`,Q=Q.substring(U.length+1),ye=!0),!ye)for(var rt=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,le-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,le-1)+"}#");Q&&(Z=Q.split(`
`,1)[0],H=Z,this.options.pedantic&&(H=H.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(H)||ot.test(H)||rt.test(H)||it.test(Q)));){if(H.search(/[^ ]/)>=le||!H.trim())x+=`
`+H.slice(le);else if(!T)x+=`
`+H;else break;!T&&!H.trim()&&(T=!0),$e+=Z+`
`,Q=Q.substring(Z.length+1)}He.loose||(K?He.loose=!0:/\n *\n *$/.test($e)&&(K=!0)),this.options.gfm&&(ve=/^\[[ xX]\] /.exec(x),ve&&(Fe=ve[0]!=="[ ] ",x=x.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:$e,task:!!ve,checked:Fe,loose:!1,text:x}),He.raw+=$e}He.items[He.items.length-1].raw=$e.trimRight(),He.items[He.items.length-1].text=x.trimRight(),He.raw=He.raw.trimRight();var at=He.items.length;for(we=0;we<at;we++){this.lexer.state.top=!1,He.items[we].tokens=this.lexer.blockTokens(He.items[we].text,[]);var ze=He.items[we].tokens.filter(function(X){return X.type==="space"}),pt=ze.every(function(X){for(var _=X.raw.split(""),pe=0,Be=L(_),Qe;!(Qe=Be()).done;){var tt=Qe.value;if(tt===`
`&&(pe+=1),pe>1)return!0}return!1});!He.loose&&ze.length&&pt&&(He.loose=!0,He.items[we].loose=!0)}return He}},ae.html=function(Q){var ee=this.rules.block.html.exec(Q);if(ee){var $e={type:"html",raw:ee[0],pre:!this.options.sanitizer&&(ee[1]==="pre"||ee[1]==="script"||ee[1]==="style"),text:ee[0]};if(this.options.sanitize){var ve=this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]);$e.type="paragraph",$e.text=ve,$e.tokens=this.lexer.inline(ve)}return $e}},ae.def=function(Q){var ee=this.rules.block.def.exec(Q);if(ee){ee[3]&&(ee[3]=ee[3].substring(1,ee[3].length-1));var $e=ee[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ee[0],href:ee[2],title:ee[3]}}},ae.table=function(Q){var ee=this.rules.block.table.exec(Q);if(ee){var $e={type:"table",header:F(ee[1]).map(function(K){return{text:K}}),align:ee[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ee[3]&&ee[3].trim()?ee[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ee[0];var ve=$e.align.length,Fe,le,we,T;for(Fe=0;Fe<ve;Fe++)/^ *-+: *$/.test($e.align[Fe])?$e.align[Fe]="right":/^ *:-+: *$/.test($e.align[Fe])?$e.align[Fe]="center":/^ *:-+ *$/.test($e.align[Fe])?$e.align[Fe]="left":$e.align[Fe]=null;for(ve=$e.rows.length,Fe=0;Fe<ve;Fe++)$e.rows[Fe]=F($e.rows[Fe],$e.header.length).map(function(K){return{text:K}});for(ve=$e.header.length,le=0;le<ve;le++)$e.header[le].tokens=this.lexer.inline($e.header[le].text);for(ve=$e.rows.length,le=0;le<ve;le++)for(T=$e.rows[le],we=0;we<T.length;we++)T[we].tokens=this.lexer.inline(T[we].text);return $e}}},ae.lheading=function(Q){var ee=this.rules.block.lheading.exec(Q);if(ee)return{type:"heading",raw:ee[0],depth:ee[2].charAt(0)==="="?1:2,text:ee[1],tokens:this.lexer.inline(ee[1])}},ae.paragraph=function(Q){var ee=this.rules.block.paragraph.exec(Q);if(ee){var $e=ee[1].charAt(ee[1].length-1)===`
`?ee[1].slice(0,-1):ee[1];return{type:"paragraph",raw:ee[0],text:$e,tokens:this.lexer.inline($e)}}},ae.text=function(Q){var ee=this.rules.block.text.exec(Q);if(ee)return{type:"text",raw:ee[0],text:ee[0],tokens:this.lexer.inline(ee[0])}},ae.escape=function(Q){var ee=this.rules.inline.escape.exec(Q);if(ee)return{type:"escape",raw:ee[0],text:b(ee[1])}},ae.tag=function(Q){var ee=this.rules.inline.tag.exec(Q);if(ee)return!this.lexer.state.inLink&&/^<a /i.test(ee[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ee[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]}},ae.link=function(Q){var ee=this.rules.inline.link.exec(Q);if(ee){var $e=ee[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var ve=$($e.slice(0,-1),"\\");if(($e.length-ve.length)%2===0)return}else{var Fe=y(ee[2],"()");if(Fe>-1){var le=ee[0].indexOf("!")===0?5:4,we=le+ee[1].length+Fe;ee[2]=ee[2].substring(0,Fe),ee[0]=ee[0].substring(0,we).trim(),ee[3]=""}}var T=ee[2],K="";if(this.options.pedantic){var H=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(T);H&&(T=H[1],K=H[3])}else K=ee[3]?ee[3].slice(1,-1):"";return T=T.trim(),/^</.test(T)&&(this.options.pedantic&&!/>$/.test($e)?T=T.slice(1):T=T.slice(1,-1)),O(ee,{href:T&&T.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},ee[0],this.lexer)}},ae.reflink=function(Q,ee){var $e;if(($e=this.rules.inline.reflink.exec(Q))||($e=this.rules.inline.nolink.exec(Q))){var ve=($e[2]||$e[1]).replace(/\s+/g," ");if(ve=ee[ve.toLowerCase()],!ve||!ve.href){var Fe=$e[0].charAt(0);return{type:"text",raw:Fe,text:Fe}}return O($e,ve,$e[0],this.lexer)}},ae.emStrong=function(Q,ee,$e){$e===void 0&&($e="");var ve=this.rules.inline.emStrong.lDelim.exec(Q);if(ve&&!(ve[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Fe=ve[1]||ve[2]||"";if(!Fe||Fe&&($e===""||this.rules.inline.punctuation.exec($e))){var le=ve[0].length-1,we,T,K=le,H=0,U=ve[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(U.lastIndex=0,ee=ee.slice(-1*Q.length+le);(ve=U.exec(ee))!=null;)if(we=ve[1]||ve[2]||ve[3]||ve[4]||ve[5]||ve[6],!!we){if(T=we.length,ve[3]||ve[4]){K+=T;continue}else if((ve[5]||ve[6])&&le%3&&!((le+T)%3)){H+=T;continue}if(K-=T,!(K>0)){if(T=Math.min(T,T+K+H),Math.min(le,T)%2){var Z=Q.slice(1,le+ve.index+T);return{type:"em",raw:Q.slice(0,le+ve.index+T+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}var x=Q.slice(2,le+ve.index+T-1);return{type:"strong",raw:Q.slice(0,le+ve.index+T+1),text:x,tokens:this.lexer.inlineTokens(x)}}}}}},ae.codespan=function(Q){var ee=this.rules.inline.code.exec(Q);if(ee){var $e=ee[2].replace(/\n/g," "),ve=/[^ ]/.test($e),Fe=/^ /.test($e)&&/ $/.test($e);return ve&&Fe&&($e=$e.substring(1,$e.length-1)),$e=b($e,!0),{type:"codespan",raw:ee[0],text:$e}}},ae.br=function(Q){var ee=this.rules.inline.br.exec(Q);if(ee)return{type:"br",raw:ee[0]}},ae.del=function(Q){var ee=this.rules.inline.del.exec(Q);if(ee)return{type:"del",raw:ee[0],text:ee[2],tokens:this.lexer.inlineTokens(ee[2])}},ae.autolink=function(Q,ee){var $e=this.rules.inline.autolink.exec(Q);if($e){var ve,Fe;return $e[2]==="@"?(ve=b(this.options.mangle?ee($e[1]):$e[1]),Fe="mailto:"+ve):(ve=b($e[1]),Fe=ve),{type:"link",raw:$e[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.url=function(Q,ee){var $e;if($e=this.rules.inline.url.exec(Q)){var ve,Fe;if($e[2]==="@")ve=b(this.options.mangle?ee($e[0]):$e[0]),Fe="mailto:"+ve;else{var le;do le=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(le!==$e[0]);ve=b($e[0]),$e[1]==="www."?Fe="http://"+ve:Fe=ve}return{type:"link",raw:$e[0],text:ve,href:Fe,tokens:[{type:"text",raw:ve,text:ve}]}}},ae.inlineText=function(Q,ee){var $e=this.rules.inline.text.exec(Q);if($e){var ve;return this.lexer.state.inRawBlock?ve=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):b($e[0]):$e[0]:ve=b(this.options.smartypants?ee($e[0]):$e[0]),{type:"text",raw:$e[0],text:ve}}},Pe}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=S({},q),q.gfm=S({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=S({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",q._label).getRegex(),C.nolink=n(C.nolink).replace("ref",q._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=S({},C),C.pedantic=S({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=S({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=S({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function P(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function J(Pe){var ae="",te,Q,ee=Pe.length;for(te=0;te<ee;te++)Q=Pe.charCodeAt(te),Math.random()>.5&&(Q="x"+Q.toString(16)),ae+="&#"+Q+";";return ae}var ce=function(){function Pe(te){this.tokens=[],this.tokens.links=Object.create(null),this.options=te||ge.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:C.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=C.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=C.breaks:Q.inline=C.gfm),this.tokenizer.rules=Q}Pe.lex=function(Q,ee){var $e=new Pe(ee);return $e.lex(Q)},Pe.lexInline=function(Q,ee){var $e=new Pe(ee);return $e.inlineTokens(Q)};var ae=Pe.prototype;return ae.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var ee;ee=this.inlineQueue.shift();)this.inlineTokens(ee.src,ee.tokens);return this.tokens},ae.blockTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(K,H,U){return H+"    ".repeat(U.length)});for(var ve,Fe,le,we;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(ve=K.call({lexer:$e},Q,ee))?(Q=Q.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.space(Q)){Q=Q.substring(ve.raw.length),ve.raw.length===1&&ee.length>0?ee[ee.length-1].raw+=`
`:ee.push(ve);continue}if(ve=this.tokenizer.code(Q)){Q=Q.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve);continue}if(ve=this.tokenizer.fences(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.heading(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.hr(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.blockquote(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.list(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.html(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.def(Q)){Q=Q.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&(Fe.type==="paragraph"||Fe.type==="text")?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.raw,this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):this.tokens.links[ve.tag]||(this.tokens.links[ve.tag]={href:ve.href,title:ve.title});continue}if(ve=this.tokenizer.table(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.lheading(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(le=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,H=Q.slice(1),U=void 0;$e.options.extensions.startBlock.forEach(function(Z){U=Z.call({lexer:this},H),typeof U=="number"&&U>=0&&(K=Math.min(K,U))}),K<1/0&&K>=0&&(le=Q.substring(0,K+1))}(),this.state.top&&(ve=this.tokenizer.paragraph(le))){Fe=ee[ee.length-1],we&&Fe.type==="paragraph"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve),we=le.length!==Q.length,Q=Q.substring(ve.raw.length);continue}if(ve=this.tokenizer.text(Q)){Q=Q.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=`
`+ve.raw,Fe.text+=`
`+ve.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Fe.text):ee.push(ve);continue}if(Q){var T="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(T);break}else throw new Error(T)}}return this.state.top=!0,ee},ae.inline=function(Q,ee){return ee===void 0&&(ee=[]),this.inlineQueue.push({src:Q,tokens:ee}),ee},ae.inlineTokens=function(Q,ee){var $e=this;ee===void 0&&(ee=[]);var ve,Fe,le,we=Q,T,K,H;if(this.tokens.links){var U=Object.keys(this.tokens.links);if(U.length>0)for(;(T=this.tokenizer.rules.inline.reflinkSearch.exec(we))!=null;)U.includes(T[0].slice(T[0].lastIndexOf("[")+1,-1))&&(we=we.slice(0,T.index)+"["+M("a",T[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(T=this.tokenizer.rules.inline.blockSkip.exec(we))!=null;)we=we.slice(0,T.index)+"["+M("a",T[0].length-2)+"]"+we.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(T=this.tokenizer.rules.inline.escapedEmSt.exec(we))!=null;)we=we.slice(0,T.index)+"++"+we.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(K||(H=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(x){return(ve=x.call({lexer:$e},Q,ee))?(Q=Q.substring(ve.raw.length),ee.push(ve),!0):!1}))){if(ve=this.tokenizer.escape(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.tag(Q)){Q=Q.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.link(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ve.raw.length),Fe=ee[ee.length-1],Fe&&ve.type==="text"&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(ve=this.tokenizer.emStrong(Q,we,H)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.codespan(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.br(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.del(Q)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(ve=this.tokenizer.autolink(Q,J)){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(!this.state.inLink&&(ve=this.tokenizer.url(Q,J))){Q=Q.substring(ve.raw.length),ee.push(ve);continue}if(le=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var x=1/0,ye=Q.slice(1),Te=void 0;$e.options.extensions.startInline.forEach(function(We){Te=We.call({lexer:this},ye),typeof Te=="number"&&Te>=0&&(x=Math.min(x,Te))}),x<1/0&&x>=0&&(le=Q.substring(0,x+1))}(),ve=this.tokenizer.inlineText(le,P)){Q=Q.substring(ve.raw.length),ve.raw.slice(-1)!=="_"&&(H=ve.raw.slice(-1)),K=!0,Fe=ee[ee.length-1],Fe&&Fe.type==="text"?(Fe.raw+=ve.raw,Fe.text+=ve.text):ee.push(ve);continue}if(Q){var Z="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Z);break}else throw new Error(Z)}}return ee},E(Pe,null,[{key:"rules",get:function(){return{block:q,inline:C}}}]),Pe}(),me=function(){function Pe(te){this.options=te||ge.defaults}var ae=Pe.prototype;return ae.code=function(Q,ee,$e){var ve=(ee||"").match(/\S*/)[0];if(this.options.highlight){var Fe=this.options.highlight(Q,ve);Fe!=null&&Fe!==Q&&($e=!0,Q=Fe)}return Q=Q.replace(/\n$/,"")+`
`,ve?'<pre><code class="'+this.options.langPrefix+b(ve,!0)+'">'+($e?Q:b(Q,!0))+`</code></pre>
`:"<pre><code>"+($e?Q:b(Q,!0))+`</code></pre>
`},ae.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},ae.html=function(Q){return Q},ae.heading=function(Q,ee,$e,ve){if(this.options.headerIds){var Fe=this.options.headerPrefix+ve.slug($e);return"<h"+ee+' id="'+Fe+'">'+Q+"</h"+ee+`>
`}return"<h"+ee+">"+Q+"</h"+ee+`>
`},ae.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ae.list=function(Q,ee,$e){var ve=ee?"ol":"ul",Fe=ee&&$e!==1?' start="'+$e+'"':"";return"<"+ve+Fe+`>
`+Q+"</"+ve+`>
`},ae.listitem=function(Q){return"<li>"+Q+`</li>
`},ae.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ae.paragraph=function(Q){return"<p>"+Q+`</p>
`},ae.table=function(Q,ee){return ee&&(ee="<tbody>"+ee+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+ee+`</table>
`},ae.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},ae.tablecell=function(Q,ee){var $e=ee.header?"th":"td",ve=ee.align?"<"+$e+' align="'+ee.align+'">':"<"+$e+">";return ve+Q+("</"+$e+`>
`)},ae.strong=function(Q){return"<strong>"+Q+"</strong>"},ae.em=function(Q){return"<em>"+Q+"</em>"},ae.codespan=function(Q){return"<code>"+Q+"</code>"},ae.br=function(){return this.options.xhtml?"<br/>":"<br>"},ae.del=function(Q){return"<del>"+Q+"</del>"},ae.link=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var ve='<a href="'+b(Q)+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=">"+$e+"</a>",ve},ae.image=function(Q,ee,$e){if(Q=h(this.options.sanitize,this.options.baseUrl,Q),Q===null)return $e;var ve='<img src="'+Q+'" alt="'+$e+'"';return ee&&(ve+=' title="'+ee+'"'),ve+=this.options.xhtml?"/>":">",ve},ae.text=function(Q){return Q},Pe}(),be=function(){function Pe(){}var ae=Pe.prototype;return ae.strong=function(Q){return Q},ae.em=function(Q){return Q},ae.codespan=function(Q){return Q},ae.del=function(Q){return Q},ae.html=function(Q){return Q},ae.text=function(Q){return Q},ae.link=function(Q,ee,$e){return""+$e},ae.image=function(Q,ee,$e){return""+$e},ae.br=function(){return""},Pe}(),Se=function(){function Pe(){this.seen={}}var ae=Pe.prototype;return ae.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ae.getNextSafeSlug=function(Q,ee){var $e=Q,ve=0;if(this.seen.hasOwnProperty($e)){ve=this.seen[Q];do ve++,$e=Q+"-"+ve;while(this.seen.hasOwnProperty($e))}return ee||(this.seen[Q]=ve,this.seen[$e]=0),$e},ae.slug=function(Q,ee){ee===void 0&&(ee={});var $e=this.serialize(Q);return this.getNextSafeSlug($e,ee.dryrun)},Pe}(),he=function(){function Pe(te){this.options=te||ge.defaults,this.options.renderer=this.options.renderer||new me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new Se}Pe.parse=function(Q,ee){var $e=new Pe(ee);return $e.parse(Q)},Pe.parseInline=function(Q,ee){var $e=new Pe(ee);return $e.parseInline(Q)};var ae=Pe.prototype;return ae.parse=function(Q,ee){ee===void 0&&(ee=!0);var $e="",ve,Fe,le,we,T,K,H,U,Z,x,ye,Te,We,He,Xe,rt,it,et,ot,at=Q.length;for(ve=0;ve<at;ve++){if(x=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(ot=this.options.extensions.renderers[x.type].call({parser:this},x),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(x.type))){$e+=ot||"";continue}switch(x.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(x.tokens),x.depth,o(this.parseInline(x.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(x.text,x.lang,x.escaped);continue}case"table":{for(U="",H="",we=x.header.length,Fe=0;Fe<we;Fe++)H+=this.renderer.tablecell(this.parseInline(x.header[Fe].tokens),{header:!0,align:x.align[Fe]});for(U+=this.renderer.tablerow(H),Z="",we=x.rows.length,Fe=0;Fe<we;Fe++){for(K=x.rows[Fe],H="",T=K.length,le=0;le<T;le++)H+=this.renderer.tablecell(this.parseInline(K[le].tokens),{header:!1,align:x.align[le]});Z+=this.renderer.tablerow(H)}$e+=this.renderer.table(U,Z);continue}case"blockquote":{Z=this.parse(x.tokens),$e+=this.renderer.blockquote(Z);continue}case"list":{for(ye=x.ordered,Te=x.start,We=x.loose,we=x.items.length,Z="",Fe=0;Fe<we;Fe++)Xe=x.items[Fe],rt=Xe.checked,it=Xe.task,He="",Xe.task&&(et=this.renderer.checkbox(rt),We?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=et+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=et+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:et}):He+=et),He+=this.parse(Xe.tokens,We),Z+=this.renderer.listitem(He,it,rt);$e+=this.renderer.list(Z,ye,Te);continue}case"html":{$e+=this.renderer.html(x.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(x.tokens));continue}case"text":{for(Z=x.tokens?this.parseInline(x.tokens):x.text;ve+1<at&&Q[ve+1].type==="text";)x=Q[++ve],Z+=`
`+(x.tokens?this.parseInline(x.tokens):x.text);$e+=ee?this.renderer.paragraph(Z):Z;continue}default:{var ze='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(ze);return}else throw new Error(ze)}}}return $e},ae.parseInline=function(Q,ee){ee=ee||this.renderer;var $e="",ve,Fe,le,we=Q.length;for(ve=0;ve<we;ve++){if(Fe=Q[ve],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Fe.type]&&(le=this.options.extensions.renderers[Fe.type].call({parser:this},Fe),le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Fe.type))){$e+=le||"";continue}switch(Fe.type){case"escape":{$e+=ee.text(Fe.text);break}case"html":{$e+=ee.html(Fe.text);break}case"link":{$e+=ee.link(Fe.href,Fe.title,this.parseInline(Fe.tokens,ee));break}case"image":{$e+=ee.image(Fe.href,Fe.title,Fe.text);break}case"strong":{$e+=ee.strong(this.parseInline(Fe.tokens,ee));break}case"em":{$e+=ee.em(this.parseInline(Fe.tokens,ee));break}case"codespan":{$e+=ee.codespan(Fe.text);break}case"br":{$e+=ee.br();break}case"del":{$e+=ee.del(this.parseInline(Fe.tokens,ee));break}case"text":{$e+=ee.text(Fe.text);break}default:{var T='Token with "'+Fe.type+'" type was not found.';if(this.options.silent){console.error(T);return}else throw new Error(T)}}}return $e},Pe}();function fe(Pe,ae,te){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ae=="function"&&(te=ae,ae=null),ae=S({},fe.defaults,ae||{}),D(ae),te){var Q=ae.highlight,ee;try{ee=ce.lex(Pe,ae)}catch(we){return te(we)}var $e=function(T){var K;if(!T)try{ae.walkTokens&&fe.walkTokens(ee,ae.walkTokens),K=he.parse(ee,ae)}catch(H){T=H}return ae.highlight=Q,T?te(T):te(null,K)};if(!Q||Q.length<3||(delete ae.highlight,!ee.length))return $e();var ve=0;fe.walkTokens(ee,function(we){we.type==="code"&&(ve++,setTimeout(function(){Q(we.text,we.lang,function(T,K){if(T)return $e(T);K!=null&&K!==we.text&&(we.text=K,we.escaped=!0),ve--,ve===0&&$e()})},0))}),ve===0&&$e();return}function Fe(we){if(we.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(we.message+"",!0)+"</pre>";throw we}try{var le=ce.lex(Pe,ae);if(ae.walkTokens){if(ae.async)return Promise.all(fe.walkTokens(le,ae.walkTokens)).then(function(){return he.parse(le,ae)}).catch(Fe);fe.walkTokens(le,ae.walkTokens)}return he.parse(le,ae)}catch(we){Fe(we)}}fe.options=fe.setOptions=function(Pe){return S(fe.defaults,Pe),m(fe.defaults),fe},fe.getDefaults=R,fe.defaults=ge.defaults,fe.use=function(){for(var Pe=arguments.length,ae=new Array(Pe),te=0;te<Pe;te++)ae[te]=arguments[te];var Q=S.apply(void 0,[{}].concat(ae)),ee=fe.defaults.extensions||{renderers:{},childTokens:{}},$e;ae.forEach(function(ve){if(ve.extensions&&($e=!0,ve.extensions.forEach(function(le){if(!le.name)throw new Error("extension name required");if(le.renderer){var we=ee.renderers?ee.renderers[le.name]:null;we?ee.renderers[le.name]=function(){for(var T=arguments.length,K=new Array(T),H=0;H<T;H++)K[H]=arguments[H];var U=le.renderer.apply(this,K);return U===!1&&(U=we.apply(this,K)),U}:ee.renderers[le.name]=le.renderer}if(le.tokenizer){if(!le.level||le.level!=="block"&&le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ee[le.level]?ee[le.level].unshift(le.tokenizer):ee[le.level]=[le.tokenizer],le.start&&(le.level==="block"?ee.startBlock?ee.startBlock.push(le.start):ee.startBlock=[le.start]:le.level==="inline"&&(ee.startInline?ee.startInline.push(le.start):ee.startInline=[le.start]))}le.childTokens&&(ee.childTokens[le.name]=le.childTokens)})),ve.renderer&&function(){var le=fe.defaults.renderer||new me,we=function(H){var U=le[H];le[H]=function(){for(var Z=arguments.length,x=new Array(Z),ye=0;ye<Z;ye++)x[ye]=arguments[ye];var Te=ve.renderer[H].apply(le,x);return Te===!1&&(Te=U.apply(le,x)),Te}};for(var T in ve.renderer)we(T);Q.renderer=le}(),ve.tokenizer&&function(){var le=fe.defaults.tokenizer||new z,we=function(H){var U=le[H];le[H]=function(){for(var Z=arguments.length,x=new Array(Z),ye=0;ye<Z;ye++)x[ye]=arguments[ye];var Te=ve.tokenizer[H].apply(le,x);return Te===!1&&(Te=U.apply(le,x)),Te}};for(var T in ve.tokenizer)we(T);Q.tokenizer=le}(),ve.walkTokens){var Fe=fe.defaults.walkTokens;Q.walkTokens=function(le){var we=[];return we.push(ve.walkTokens.call(this,le)),Fe&&(we=we.concat(Fe.call(this,le))),we}}$e&&(Q.extensions=ee),fe.setOptions(Q)})},fe.walkTokens=function(Pe,ae){for(var te=[],Q=function(){var Fe=$e.value;switch(te=te.concat(ae.call(fe,Fe)),Fe.type){case"table":{for(var le=L(Fe.header),we;!(we=le()).done;){var T=we.value;te=te.concat(fe.walkTokens(T.tokens,ae))}for(var K=L(Fe.rows),H;!(H=K()).done;)for(var U=H.value,Z=L(U),x;!(x=Z()).done;){var ye=x.value;te=te.concat(fe.walkTokens(ye.tokens,ae))}break}case"list":{te=te.concat(fe.walkTokens(Fe.items,ae));break}default:fe.defaults.extensions&&fe.defaults.extensions.childTokens&&fe.defaults.extensions.childTokens[Fe.type]?fe.defaults.extensions.childTokens[Fe.type].forEach(function(Te){te=te.concat(fe.walkTokens(Fe[Te],ae))}):Fe.tokens&&(te=te.concat(fe.walkTokens(Fe.tokens,ae)))}},ee=L(Pe),$e;!($e=ee()).done;)Q();return te},fe.parseInline=function(Pe,ae){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ae=S({},fe.defaults,ae||{}),D(ae);try{var te=ce.lexInline(Pe,ae);return ae.walkTokens&&fe.walkTokens(te,ae.walkTokens),he.parseInline(te,ae)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,ae.silent)return"<p>An error occurred:</p><pre>"+b(Q.message+"",!0)+"</pre>";throw Q}},fe.Parser=he,fe.parser=he.parse,fe.Renderer=me,fe.TextRenderer=be,fe.Lexer=ce,fe.lexer=ce.lex,fe.Tokenizer=z,fe.Slugger=Se,fe.parse=fe;var ie=fe.options,ke=fe.setOptions,oe=fe.use,Y=fe.walkTokens,V=fe.parseInline,ne=fe,Ie=he.parse,Ae=ce.lex;ge.Lexer=ce,ge.Parser=he,ge.Renderer=me,ge.Slugger=Se,ge.TextRenderer=be,ge.Tokenizer=z,ge.getDefaults=R,ge.lexer=Ae,ge.marked=fe,ge.options=ie,ge.parse=ne,ge.parseInline=V,ge.parser=Ie,ge.setOptions=ke,ge.use=oe,ge.walkTokens=Y,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[121],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=void 0;function E(r){const o=L(r);if(o&&o.length>0)return new Uint32Array(o)}e.$Nj=E;let N=0;const I=new Uint32Array(10);function L(r){if(N=0,R(r,k,4352),N>0||(R(r,l,4449),N>0)||(R(r,p,4520),N>0)||(R(r,b,12593),N))return I.subarray(0,N);if(r>=44032&&r<=55203){const o=r-44032,t=o%588,n=Math.floor(o/588),a=Math.floor(t/28),c=t%28-1;if(n<k.length?R(n,k,0):4352+n-12593<b.length&&R(4352+n,b,12593),a<l.length?R(a,l,0):4449+a-12593<b.length&&R(4449+a-12593,b,12593),c>=0&&(c<p.length?R(c,p,0):4520+c-12593<b.length&&R(4520+c-12593,b,12593)),N>0)return I.subarray(0,N)}}function R(r,o,t){r>=t&&r<t+o.length&&m(o[r-t])}function m(r){r!==0&&(I[N++]=r&255,r>>8&&(I[N++]=r>>8&255),r>>16&&(I[N++]=r>>16&255))}var g;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var w;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(w||(w={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),p=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),b=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[122],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=e.$5l=e.rot=e.$3l=void 0;function E(m,g,w){return Math.min(Math.max(m,g),w)}e.$3l=E;function N(m,g){return(g+m%g)%g}e.rot=N;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$5l=I;class L{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$6l=L;class R{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$7l=R}),function(){function ge(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function R(g){L.push(g,Date.now())}function m(){const g=[];for(let w=0;w<L.length;w+=2)g.push({name:L[w],startTime:L[w+1]});return g}return{mark:R,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(I+R.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function E(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=E(N))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var N in E)(typeof exports=="object"?exports:ge)[N]=E[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function E(N){if(e[N])return e[N].exports;var I=e[N]={i:N,l:!1,exports:{}};return ge[N].call(I.exports,I,I.exports,E),I.l=!0,I.exports}return E.m=ge,E.c=e,E.d=function(N,I,L){E.o(N,I)||Object.defineProperty(N,I,{enumerable:!0,get:L})},E.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},E.t=function(N,I){if(1&I&&(N=E(N)),8&I||4&I&&typeof N=="object"&&N&&N.__esModule)return N;var L=Object.create(null);if(E.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:N}),2&I&&typeof N!="string")for(var R in N)E.d(L,R,function(m){return N[m]}.bind(null,R));return L},E.n=function(N){var I=N&&N.__esModule?function(){return N.default}:function(){return N};return E.d(I,"a",I),I},E.o=function(N,I){return Object.prototype.hasOwnProperty.call(N,I)},E.p="",E(E.s=0)}([function(ge,e,E){(function(N){var I;e=ge.exports=oe,I=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var U=Array.prototype.slice.call(arguments,0);U.unshift("SEMVER"),console.log.apply(console,U)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],w=0,A=w++;g[A]="0|[1-9]\\d*";var k=w++;g[k]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var p=w++;g[p]="("+g[A]+")\\.("+g[A]+")\\.("+g[A]+")";var b=w++;g[b]="("+g[k]+")\\.("+g[k]+")\\.("+g[k]+")";var r=w++;g[r]="(?:"+g[A]+"|"+g[l]+")";var o=w++;g[o]="(?:"+g[k]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[r]+"(?:\\."+g[r]+")*))";var n=w++;g[n]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var a=w++;g[a]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[a]+"(?:\\."+g[a]+")*))";var h=w++,i="v?"+g[p]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var s="[v=\\s]*"+g[b]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+s+"$";var d=w++;g[d]="((?:<|>)?=?)";var v=w++;g[v]=g[k]+"|x|X|\\*";var f=w++;g[f]=g[A]+"|x|X|\\*";var S=w++;g[S]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var F=w++;g[F]="[v=\\s]*("+g[v]+")(?:\\.("+g[v]+")(?:\\.("+g[v]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var $=w++;g[$]="^"+g[d]+"\\s*"+g[S]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[F]+"$";var D=w++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=w++;g[M]="(?:~>?)";var O=w++;g[O]="(\\s*)"+g[M]+"\\s+",m[O]=new RegExp(g[O],"g");var W=w++;g[W]="^"+g[M]+g[S]+"$";var z=w++;g[z]="^"+g[M]+g[F]+"$";var q=w++;g[q]="(?:\\^)";var C=w++;g[C]="(\\s*)"+g[q]+"\\s+",m[C]=new RegExp(g[C],"g");var P=w++;g[P]="^"+g[q]+g[S]+"$";var J=w++;g[J]="^"+g[q]+g[F]+"$";var ce=w++;g[ce]="^"+g[d]+"\\s*("+s+")$|^$";var me=w++;g[me]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+s+"|"+g[S]+")",m[be]=new RegExp(g[be],"g");var Se=w++;g[Se]="^\\s*("+g[S]+")\\s+-\\s+("+g[S]+")\\s*$";var he=w++;g[he]="^\\s*("+g[F]+")\\s+-\\s+("+g[F]+")\\s*$";var fe=w++;g[fe]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)I(ie,g[ie]),m[ie]||(m[ie]=new RegExp(g[ie]));function ke(U,Z){if(U instanceof oe)return U;if(typeof U!="string"||U.length>L||!(Z?m[u]:m[h]).test(U))return null;try{return new oe(U,Z)}catch{return null}}function oe(U,Z){if(U instanceof oe){if(U.loose===Z)return U;U=U.version}else if(typeof U!="string")throw new TypeError("Invalid Version: "+U);if(U.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(U,Z);I("SemVer",U,Z),this.loose=Z;var x=U.trim().match(Z?m[u]:m[h]);if(!x)throw new TypeError("Invalid Version: "+U);if(this.raw=U,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var Te=+ye;if(Te>=0&&Te<R)return Te}return ye}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=ke,e.valid=function(U,Z){var x=ke(U,Z);return x?x.version:null},e.clean=function(U,Z){var x=ke(U.trim().replace(/^[=v]+/,""),Z);return x?x.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(U){return I("SemVer.compare",this.version,this.loose,U),U instanceof oe||(U=new oe(U,this.loose)),this.compareMain(U)||this.comparePre(U)},oe.prototype.compareMain=function(U){return U instanceof oe||(U=new oe(U,this.loose)),V(this.major,U.major)||V(this.minor,U.minor)||V(this.patch,U.patch)},oe.prototype.comparePre=function(U){if(U instanceof oe||(U=new oe(U,this.loose)),this.prerelease.length&&!U.prerelease.length)return-1;if(!this.prerelease.length&&U.prerelease.length)return 1;if(!this.prerelease.length&&!U.prerelease.length)return 0;var Z=0;do{var x=this.prerelease[Z],ye=U.prerelease[Z];if(I("prerelease compare",Z,x,ye),x===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(x===void 0)return-1;if(x!==ye)return V(x,ye)}while(++Z)},oe.prototype.inc=function(U,Z){switch(U){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+U)}return this.format(),this.raw=this.version,this},e.inc=function(U,Z,x,ye){typeof x=="string"&&(ye=x,x=void 0);try{return new oe(U,x).inc(Z,ye).version}catch{return null}},e.diff=function(U,Z){if(Pe(U,Z))return null;var x=ke(U),ye=ke(Z);if(x.prerelease.length||ye.prerelease.length){for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==ye[Te])return"pre"+Te;return"prerelease"}for(var Te in x)if((Te==="major"||Te==="minor"||Te==="patch")&&x[Te]!==ye[Te])return Te},e.compareIdentifiers=V;var Y=/^[0-9]+$/;function V(U,Z){var x=Y.test(U),ye=Y.test(Z);return x&&ye&&(U=+U,Z=+Z),x&&!ye?-1:ye&&!x?1:U<Z?-1:U>Z?1:0}function ne(U,Z,x){return new oe(U,x).compare(new oe(Z,x))}function Ie(U,Z,x){return ne(U,Z,x)>0}function Ae(U,Z,x){return ne(U,Z,x)<0}function Pe(U,Z,x){return ne(U,Z,x)===0}function ae(U,Z,x){return ne(U,Z,x)!==0}function te(U,Z,x){return ne(U,Z,x)>=0}function Q(U,Z,x){return ne(U,Z,x)<=0}function ee(U,Z,x,ye){var Te;switch(Z){case"===":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U===x;break;case"!==":typeof U=="object"&&(U=U.version),typeof x=="object"&&(x=x.version),Te=U!==x;break;case"":case"=":case"==":Te=Pe(U,x,ye);break;case"!=":Te=ae(U,x,ye);break;case">":Te=Ie(U,x,ye);break;case">=":Te=te(U,x,ye);break;case"<":Te=Ae(U,x,ye);break;case"<=":Te=Q(U,x,ye);break;default:throw new TypeError("Invalid operator: "+Z)}return Te}function $e(U,Z){if(U instanceof $e){if(U.loose===Z)return U;U=U.value}if(!(this instanceof $e))return new $e(U,Z);I("comparator",U,Z),this.loose=Z,this.parse(U),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(U,Z){return V(Z,U)},e.major=function(U,Z){return new oe(U,Z).major},e.minor=function(U,Z){return new oe(U,Z).minor},e.patch=function(U,Z){return new oe(U,Z).patch},e.compare=ne,e.compareLoose=function(U,Z){return ne(U,Z,!0)},e.rcompare=function(U,Z,x){return ne(Z,U,x)},e.sort=function(U,Z){return U.sort(function(x,ye){return e.compare(x,ye,Z)})},e.rsort=function(U,Z){return U.sort(function(x,ye){return e.rcompare(x,ye,Z)})},e.gt=Ie,e.lt=Ae,e.eq=Pe,e.neq=ae,e.gte=te,e.lte=Q,e.cmp=ee,e.Comparator=$e;var ve={};function Fe(U,Z){if(U instanceof Fe)return U.loose===Z?U:new Fe(U.raw,Z);if(U instanceof $e)return new Fe(U.value,Z);if(!(this instanceof Fe))return new Fe(U,Z);if(this.loose=Z,this.raw=U,this.set=U.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+U);this.format()}function le(U){return!U||U.toLowerCase()==="x"||U==="*"}function we(U,Z,x,ye,Te,We,He,Xe,rt,it,et,ot,at){return((Z=le(x)?"":le(ye)?">="+x+".0.0":le(Te)?">="+x+"."+ye+".0":">="+Z)+" "+(Xe=le(rt)?"":le(it)?"<"+(+rt+1)+".0.0":le(et)?"<"+rt+"."+(+it+1)+".0":ot?"<="+rt+"."+it+"."+et+"-"+ot:"<="+Xe)).trim()}function T(U,Z){for(var x=0;x<U.length;x++)if(!U[x].test(Z))return!1;if(Z.prerelease.length){for(x=0;x<U.length;x++)if(I(U[x].semver),U[x].semver!==ve&&U[x].semver.prerelease.length>0){var ye=U[x].semver;if(ye.major===Z.major&&ye.minor===Z.minor&&ye.patch===Z.patch)return!0}return!1}return!0}function K(U,Z,x){try{Z=new Fe(Z,x)}catch{return!1}return Z.test(U)}function H(U,Z,x,ye){var Te,We,He,Xe,rt;switch(U=new oe(U,ye),Z=new Fe(Z,ye),x){case">":Te=Ie,We=Q,He=Ae,Xe=">",rt=">=";break;case"<":Te=Ae,We=te,He=Ie,Xe="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(U,Z,ye))return!1;for(var it=0;it<Z.set.length;++it){var et=Z.set[it],ot=null,at=null;if(et.forEach(function(ze){ze.semver===ve&&(ze=new $e(">=0.0.0")),ot=ot||ze,at=at||ze,Te(ze.semver,ot.semver,ye)?ot=ze:He(ze.semver,at.semver,ye)&&(at=ze)}),ot.operator===Xe||ot.operator===rt||(!at.operator||at.operator===Xe)&&We(U,at.semver)||at.operator===rt&&He(U,at.semver))return!1}return!0}$e.prototype.parse=function(U){var Z=this.loose?m[ce]:m[me],x=U.match(Z);if(!x)throw new TypeError("Invalid comparator: "+U);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new oe(x[2],this.loose):this.semver=ve},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(U){return I("Comparator.test",U,this.loose),this.semver===ve||(typeof U=="string"&&(U=new oe(U,this.loose)),ee(U,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(U,Z){if(!(U instanceof $e))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new Fe(U.value,Z),K(this.value,x,Z);if(U.operator==="")return x=new Fe(this.value,Z),K(U.semver,x,Z);var ye=!(this.operator!==">="&&this.operator!==">"||U.operator!==">="&&U.operator!==">"),Te=!(this.operator!=="<="&&this.operator!=="<"||U.operator!=="<="&&U.operator!=="<"),We=this.semver.version===U.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||U.operator!==">="&&U.operator!=="<="),Xe=ee(this.semver,"<",U.semver,Z)&&(this.operator===">="||this.operator===">")&&(U.operator==="<="||U.operator==="<"),rt=ee(this.semver,">",U.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(U.operator===">="||U.operator===">");return ye||Te||We&&He||Xe||rt},e.Range=Fe,Fe.prototype.format=function(){return this.range=this.set.map(function(U){return U.join(" ").trim()}).join("||").trim(),this.range},Fe.prototype.toString=function(){return this.range},Fe.prototype.parseRange=function(U){var Z=this.loose;U=U.trim(),I("range",U,Z);var x=Z?m[he]:m[Se];U=U.replace(x,we),I("hyphen replace",U),U=U.replace(m[be],"$1$2$3"),I("comparator trim",U,m[be]),U=(U=(U=U.replace(m[O],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var ye=Z?m[ce]:m[me],Te=U.split(" ").map(function(We){return function(He,Xe){return I("comp",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){I("caret",ot,at);var ze=at?m[J]:m[P];return ot.replace(ze,function(pt,X,_,pe,Be){var Qe;return I("caret",ot,pt,X,_,pe,Be),le(X)?Qe="":le(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":le(pe)?Qe=X==="0"?">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":">="+X+"."+_+".0 <"+(+X+1)+".0.0":Be?(I("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+Be+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+Be+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+Be+" <"+(+X+1)+".0.0"):(I("no pr"),Qe=X==="0"?_==="0"?">="+X+"."+_+"."+pe+" <"+X+"."+_+"."+(+pe+1):">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0":">="+X+"."+_+"."+pe+" <"+(+X+1)+".0.0"),I("caret return",Qe),Qe})}(et,it)}).join(" ")}(He,Xe),I("caret",He),He=function(rt,it){return rt.trim().split(/\s+/).map(function(et){return function(ot,at){var ze=at?m[z]:m[W];return ot.replace(ze,function(pt,X,_,pe,Be){var Qe;return I("tilde",ot,pt,X,_,pe,Be),le(X)?Qe="":le(_)?Qe=">="+X+".0.0 <"+(+X+1)+".0.0":le(pe)?Qe=">="+X+"."+_+".0 <"+X+"."+(+_+1)+".0":Be?(I("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Qe=">="+X+"."+_+"."+pe+Be+" <"+X+"."+(+_+1)+".0"):Qe=">="+X+"."+_+"."+pe+" <"+X+"."+(+_+1)+".0",I("tilde return",Qe),Qe})}(et,it)}).join(" ")}(He,Xe),I("tildes",He),He=function(rt,it){return I("replaceXRanges",rt,it),rt.split(/\s+/).map(function(et){return function(ot,at){ot=ot.trim();var ze=at?m[y]:m[$];return ot.replace(ze,function(pt,X,_,pe,Be,Qe){I("xRange",ot,pt,X,_,pe,Be,Qe);var tt=le(_),nt=tt||le(pe),Ne=nt||le(Be);return X==="="&&Ne&&(X=""),tt?pt=X===">"||X==="<"?"<0.0.0":"*":X&&Ne?(nt&&(pe=0),Ne&&(Be=0),X===">"?(X=">=",nt?(_=+_+1,pe=0,Be=0):Ne&&(pe=+pe+1,Be=0)):X==="<="&&(X="<",nt?_=+_+1:pe=+pe+1),pt=X+_+"."+pe+"."+Be):nt?pt=">="+_+".0.0 <"+(+_+1)+".0.0":Ne&&(pt=">="+_+"."+pe+".0 <"+_+"."+(+pe+1)+".0"),I("xRange return",pt),pt})}(et,it)}).join(" ")}(He,Xe),I("xrange",He),He=function(rt,it){return I("replaceStars",rt,it),rt.trim().replace(m[fe],"")}(He,Xe),I("stars",He),He}(We,Z)}).join(" ").split(/\s+/);return this.loose&&(Te=Te.filter(function(We){return!!We.match(ye)})),Te=Te.map(function(We){return new $e(We,Z)})},Fe.prototype.intersects=function(U,Z){if(!(U instanceof Fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function(ye){return U.set.some(function(Te){return Te.every(function(We){return ye.intersects(We,Z)})})})})},e.toComparators=function(U,Z){return new Fe(U,Z).set.map(function(x){return x.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},Fe.prototype.test=function(U){if(!U)return!1;typeof U=="string"&&(U=new oe(U,this.loose));for(var Z=0;Z<this.set.length;Z++)if(T(this.set[Z],U))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(U,Z,x){var ye=null,Te=null;try{var We=new Fe(Z,x)}catch{return null}return U.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==-1||(Te=new oe(ye=He,x)))}),ye},e.minSatisfying=function(U,Z,x){var ye=null,Te=null;try{var We=new Fe(Z,x)}catch{return null}return U.forEach(function(He){We.test(He)&&(ye&&Te.compare(He)!==1||(Te=new oe(ye=He,x)))}),ye},e.validRange=function(U,Z){try{return new Fe(U,Z).range||"*"}catch{return null}},e.ltr=function(U,Z,x){return H(U,Z,"<",x)},e.gtr=function(U,Z,x){return H(U,Z,">",x)},e.outside=H,e.prerelease=function(U,Z){var x=ke(U,Z);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(U,Z,x){return U=new Fe(U,x),Z=new Fe(Z,x),U.intersects(Z)},e.coerce=function(U){if(U instanceof oe)return U;if(typeof U!="string")return null;var Z=U.match(m[D]);return Z==null?null:ke((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,E(1))},function(ge,e){var E,N,I=ge.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function m(o){if(E===setTimeout)return setTimeout(o,0);if((E===L||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:L}catch{E=L}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var g,w=[],A=!1,k=-1;function l(){A&&g&&(A=!1,g.length?w=g.concat(w):k=-1,w.length&&p())}function p(){if(!A){var o=m(l);A=!0;for(var t=w.length;t;){for(g=w,w=[];++k<t;)g&&g[k].run();k=-1,t=w.length}g=null,A=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(o)}}function b(o,t){this.fun=o,this.array=t}function r(){}I.nextTick=function(o){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new b(o,t)),w.length!==1||A||m(p)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[123],Re([1,0,11,6]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=void 0;function I(c){const h=c;return h?typeof h.read=="function":!1}e.$4d=I;function L(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$5d=L;function R(c){const h=c;return h?L(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$6d=R;function m(c,h){return new g(c,h)}e.$7d=m;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const u=s.indexOf(i);u>=0&&s.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let s;for(;(s=c.read())!==null;)i.push(s);return h(i)}e.$8d=w;function A(c,h,i){const s=[];let u;for(;(u=c.read())!==null&&s.length<i;)s.push(u);return u===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$9d=A;function k(c,h){return new Promise((i,s)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?s(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$0d=k;function l(c,h,i){c.on("error",s=>{i?.isCancellationRequested||h.onError(s)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",s=>{i?.isCancellationRequested||h.onData(s)})}e.$$d=l;function p(c,h){return new Promise((i,s)=>{const u=new N.$Rc,d=[],v=F=>{if(d.push(F),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=F=>(u.dispose(),s(F)),S=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,N.$Qc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,N.$Qc)(()=>c.removeListener("end",S))),c.on("end",S),u.add((0,N.$Qc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$_d=p;function b(c,h){const i=m(h);return i.end(c),i}e.$ae=b;function r(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$be=r;function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$ce=o;function t(c,h,i){const s=m(i);return l(c,{onData:u=>s.write(h.data(u)),onError:u=>s.error(h.error?h.error(u):u),onEnd:()=>s.end()}),s}e.$de=t;function n(c,h,i){let s=!1;return{read:()=>{const u=h.read();return s?u:(s=!0,u!==null?i([c,u]):c)}}}e.$ee=n;function a(c,h,i){let s=!1;const u=m(i);return l(h,{onData:d=>s?u.write(d):(s=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{s||(s=!0,u.write(c)),u.end()}}),u}e.$fe=a}),define(Ce[24],Re([1,0,39,123]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=void 0;const I=typeof Buffer<"u",L=new E.$V(()=>new Uint8Array(256));let R,m;class g{static alloc(D){return I?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,M){return!(M?.dontUseNodeBuffer||!1)&&I?new g(Buffer.from(D)):(R||(R=new TextEncoder),new g(R.encode(D)))}static fromByteArray(D){const M=g.alloc(D.length);for(let O=0,W=D.length;O<W;O++)M.buffer[O]=D[O];return M}static concat(D,M){if(typeof M>"u"){M=0;for(let z=0,q=D.length;z<q;z++)M+=D[z].byteLength}const O=g.alloc(M);let W=0;for(let z=0,q=D.length;z<q;z++){const C=D[z];O.set(C,W),W+=C.byteLength}return O}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(D,M){return new g(this.buffer.subarray(D,M))}set(D,M){if(D instanceof g)this.buffer.set(D.buffer,M);else if(D instanceof Uint8Array)this.buffer.set(D,M);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),M);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,M){p(this.buffer,D,M)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,M){r(this.buffer,D,M)}readUInt8(D){return o(this.buffer,D)}writeUInt8(D,M){t(this.buffer,D,M)}indexOf(D,M=0){return w(this.buffer,D instanceof g?D.buffer:D,M)}}e.$ge=g;function w(y,D,M=0){const O=D.byteLength,W=y.byteLength;if(O===0)return 0;if(O===1)return y.indexOf(D[0]);if(O>W-M)return-1;const z=L.value;z.fill(D.length);for(let J=0;J<D.length;J++)z[D[J]]=D.length-J-1;let q=M+D.length-1,C=q,P=-1;for(;q<W;)if(y[q]===D[C]){if(C===0){P=q;break}q--,C--}else q+=Math.max(D.length-C,z[y[q]]),C=D.length-1;return P}e.$he=w;function A(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$ie=A;function k(y,D,M){y[M+0]=D&255,D=D>>>8,y[M+1]=D&255}e.$je=k;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$ke=l;function p(y,D,M){y[M+3]=D,D=D>>>8,y[M+2]=D,D=D>>>8,y[M+1]=D,D=D>>>8,y[M]=D}e.$le=p;function b(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$me=b;function r(y,D,M){y[M+0]=D&255,D=D>>>8,y[M+1]=D&255,D=D>>>8,y[M+2]=D&255,D=D>>>8,y[M+3]=D&255}e.$ne=r;function o(y,D){return y[D]}e.$oe=o;function t(y,D,M){y[M]=D}e.$pe=t;function n(y){return N.$8d(y,D=>g.concat(D))}e.$qe=n;function a(y){return N.$ce(y)}e.$re=a;function c(y){return N.$0d(y,D=>g.concat(D))}e.$se=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$te=h;function i(y){return N.$ae(y,D=>g.concat(D))}e.$ue=i;function s(y){return N.$de(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$ve=s;function u(y){return N.$7d(D=>g.concat(D),y)}e.$we=u;function d(y,D){return N.$ee(y,D,M=>g.concat(M))}e.$xe=d;function v(y,D){return N.$fe(y,D,M=>g.concat(M))}e.$ye=v;function f(y){let D=0,M=0,O=0;const W=new Uint8Array(Math.floor(y.length/4*3)),z=C=>{switch(M){case 3:W[O++]=D|C,M=0;break;case 2:W[O++]=D|C>>>2,D=C<<6,M=3;break;case 1:W[O++]=D|C>>>4,D=C<<4,M=2;break;default:D=C<<2,M=1}};for(let C=0;C<y.length;C++){const P=y.charCodeAt(C);if(P>=65&&P<=90)z(P-65);else if(P>=97&&P<=122)z(P-97+26);else if(P>=48&&P<=57)z(P-48+52);else if(P===43||P===45)z(62);else if(P===47||P===95)z(63);else{if(P===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const q=O;for(;M>0;)z(0);return g.wrap(W).slice(0,q)}e.$ze=f;const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function $({buffer:y},D=!0,M=!1){const O=M?F:S;let W="";const z=y.byteLength%3;let q=0;for(;q<y.byteLength-z;q+=3){const C=y[q+0],P=y[q+1],J=y[q+2];W+=O[C>>>2],W+=O[(C<<4|P>>>4)&63],W+=O[(P<<2|J>>>6)&63],W+=O[J&63]}if(z===1){const C=y[q+0];W+=O[C>>>2],W+=O[C<<4&63],D&&(W+="==")}else if(z===2){const C=y[q+0],P=y[q+1];W+=O[C>>>2],W+=O[(C<<4|P>>>4)&63],W+=O[P<<2&63],D&&(W+="=")}return W}e.$Ae=$}),define(Ce[124],Re([1,0,28,121,12]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=e.$2j=e.FuzzyScore=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.or=void 0;function L(...le){return function(we,T){for(let K=0,H=le.length;K<H;K++){const U=le[K](we,T);if(U)return U}return null}}e.or=L,e.$Pj=R.bind(void 0,!1),e.$Qj=R.bind(void 0,!0);function R(le,we,T){if(!T||T.length<we.length)return null;let K;return le?K=I.$9e(T,we):K=T.indexOf(we)===0,K?we.length>0?[{start:0,end:we.length}]:[]:null}function m(le,we){const T=we.toLowerCase().indexOf(le.toLowerCase());return T===-1?null:[{start:T,end:T+le.length}]}e.$Rj=m;function g(le,we){return w(le.toLowerCase(),we.toLowerCase(),0,0)}e.$Sj=g;function w(le,we,T,K){if(T===le.length)return[];if(K===we.length)return null;if(le[T]===we[K]){let H=null;return(H=w(le,we,T+1,K+1))?c({start:K,end:K+1},H):null}return w(le,we,T,K+1)}function A(le){return 97<=le&&le<=122}function k(le){return 65<=le&&le<=90}e.$Tj=k;function l(le){return 48<=le&&le<=57}function p(le){return le===32||le===9||le===10||le===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>b.add(le.charCodeAt(0)));function r(le){return p(le)||b.has(le)}function o(le,we){return le===we||r(le)&&r(we)}const t=new Map;function n(le){if(t.has(le))return t.get(le);let we;const T=(0,N.$Nj)(le);return T&&(we=T),t.set(le,we),we}function a(le){return A(le)||k(le)||l(le)}function c(le,we){return we.length===0?we=[le]:le.end===we[0].start?we[0].start=le.start:we.unshift(le),we}function h(le,we){for(let T=we;T<le.length;T++){const K=le.charCodeAt(T);if(k(K)||l(K)||T>0&&!a(le.charCodeAt(T-1)))return T}return le.length}function i(le,we,T,K){if(T===le.length)return[];if(K===we.length)return null;if(le[T]!==we[K].toLowerCase())return null;{let H=null,U=K+1;for(H=i(le,we,T+1,K+1);!H&&(U=h(we,U))<we.length;)H=i(le,we,T+1,U),U++;return H===null?null:c({start:K,end:K+1},H)}}function s(le){let we=0,T=0,K=0,H=0,U=0;for(let We=0;We<le.length;We++)U=le.charCodeAt(We),k(U)&&we++,A(U)&&T++,a(U)&&K++,l(U)&&H++;const Z=we/le.length,x=T/le.length,ye=K/le.length,Te=H/le.length;return{upperPercent:Z,lowerPercent:x,alphaPercent:ye,numericPercent:Te}}function u(le){const{upperPercent:we,lowerPercent:T}=le;return T===0&&we>.6}function d(le){const{upperPercent:we,lowerPercent:T,alphaPercent:K,numericPercent:H}=le;return T>.2&&we<.8&&K>.6&&H<.2}function v(le){let we=0,T=0,K=0,H=0;for(let U=0;U<le.length;U++)K=le.charCodeAt(U),k(K)&&we++,A(K)&&T++,p(K)&&H++;return(we===0||T===0)&&H===0?le.length<=30:we<=5}function f(le,we){if(!we||(we=we.trim(),we.length===0)||!v(le)||we.length>60)return null;const T=s(we);if(!d(T)){if(!u(T))return null;we=we.toLowerCase()}let K=null,H=0;for(le=le.toLowerCase();H<we.length&&(K=i(le,we,0,H))===null;)H=h(we,H+1);return K}e.$Uj=f;function S(le,we,T=!1){if(!we||we.length===0)return null;let K=null,H=0;for(le=le.toLowerCase(),we=we.toLowerCase();H<we.length&&(K=F(le,we,0,H,T),K===null);)H=$(we,H+1);return K}e.$Vj=S;function F(le,we,T,K,H){let U=0;if(T===le.length)return[];if(K===we.length)return null;if(!o(le.charCodeAt(T),we.charCodeAt(K))){const ye=n(le.charCodeAt(T));if(!ye)return null;for(let Te=0;Te<ye.length;Te++)if(!o(ye[Te],we.charCodeAt(K+Te)))return null;U+=ye.length-1}let Z=null,x=K+U+1;if(Z=F(le,we,T+1,x,H),!H)for(;!Z&&(x=$(we,x))<we.length;)Z=F(le,we,T+1,x,H),x++;if(!Z)return null;if(le.charCodeAt(T)!==we.charCodeAt(K)){const ye=n(le.charCodeAt(T));if(!ye)return Z;for(let Te=0;Te<ye.length;Te++)if(ye[Te]!==we.charCodeAt(K+Te))return Z}return c({start:K,end:K+U+1},Z)}function $(le,we){for(let T=we;T<le.length;T++)if(r(le.charCodeAt(T))||T>0&&r(le.charCodeAt(T-1)))return T;return le.length}const y=L(e.$Qj,f,m),D=L(e.$Qj,f,g),M=new E.$Dc(1e4);function O(le,we,T=!1){if(typeof le!="string"||typeof we!="string")return null;let K=M.get(le);K||(K=new RegExp(I.$Re(le),"i"),M.set(le,K));const H=K.exec(we);return H?[{start:H.index,end:H.index+H[0].length}]:T?D(le,we):y(le,we)}e.$Wj=O;function W(le,we){const T=ae(le,le.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return T?q(T):null}e.$Xj=W;function z(le,we,T,K,H,U){const Z=Math.min(13,le.length);for(;T<Z;T++){const x=ae(le,we,T,K,H,U,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,U]}e.$Yj=z;function q(le){if(typeof le>"u")return[];const we=[],T=le[1];for(let K=le.length-1;K>1;K--){const H=le[K]+T,U=we[we.length-1];U&&U.end===H?U.end=H+1:we.push({start:H,end:H+1})}return we}e.$Zj=q;const C=128;function P(){const le=[],we=[];for(let T=0;T<=C;T++)we[T]=0;for(let T=0;T<=C;T++)le.push(we.slice(0));return le}function J(le){const we=[];for(let T=0;T<=le;T++)we[T]=0;return we}const ce=J(2*C),me=J(2*C),be=P(),Se=P(),he=P(),fe=!1;function ie(le,we,T,K,H){function U(x,ye,Te=" "){for(;x.length<ye;)x=Te+x;return x}let Z=` |   |${K.split("").map(x=>U(x,3)).join("|")}
`;for(let x=0;x<=T;x++)x===0?Z+=" |":Z+=`${we[x-1]}|`,Z+=le[x].slice(0,H+1).map(ye=>U(ye.toString(),3)).join("|")+`
`;return Z}function ke(le,we,T,K){le=le.substr(we),T=T.substr(K),console.log(ie(Se,le,le.length,T,T.length)),console.log(ie(he,le,le.length,T,T.length)),console.log(ie(be,le,le.length,T,T.length))}function oe(le,we){if(we<0||we>=le.length)return!1;const T=le.codePointAt(we);switch(T){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$of(T)}}function Y(le,we){if(we<0||we>=le.length)return!1;switch(le.charCodeAt(we)){case 32:case 9:return!0;default:return!1}}function V(le,we,T){return we[le]!==T[le]}function ne(le,we,T,K,H,U,Z=!1){for(;we<T&&H<U;)le[we]===K[H]&&(Z&&(ce[we]=H),we+=1),H+=1;return we===T}e.$1j=ne;var Ie;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(Ie||(Ie={}));var Ae;(function(le){le.Default=[-100,0];function we(T){return!T||T.length===2&&T[0]===-100&&T[1]===0}le.isDefault=we})(Ae||(e.FuzzyScore=Ae={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(we,T){this.firstMatchCanBeWeak=we,this.boostFullMatch=T}}e.$2j=Pe;function ae(le,we,T,K,H,U,Z=Pe.default){const x=le.length>C?C:le.length,ye=K.length>C?C:K.length;if(T>=x||U>=ye||x-T>ye-U||!ne(we,T,x,H,U,ye,!0))return;te(x,ye,T,U,we,H);let Te=1,We=1,He=T,Xe=U;const rt=[!1];for(Te=1,He=T;He<x;Te++,He++){const ze=ce[He],pt=me[He],X=He+1<x?me[He+1]:ye;for(We=ze-U+1,Xe=ze;Xe<X;We++,Xe++){let _=Number.MIN_SAFE_INTEGER,pe=!1;Xe<=pt&&(_=Q(le,we,He,T,K,H,Xe,ye,U,be[Te-1][We-1]===0,rt));let Be=0;_!==Number.MAX_SAFE_INTEGER&&(pe=!0,Be=_+Se[Te-1][We-1]);const Qe=Xe>ze,tt=Qe?Se[Te][We-1]+(be[Te][We-1]>0?-5:0):0,nt=Xe>ze+1&&be[Te][We-1]>0,Ne=nt?Se[Te][We-2]+(be[Te][We-2]>0?-5:0):0;if(nt&&(!Qe||Ne>=tt)&&(!pe||Ne>=Be))Se[Te][We]=Ne,he[Te][We]=3,be[Te][We]=0;else if(Qe&&(!pe||tt>=Be))Se[Te][We]=tt,he[Te][We]=2,be[Te][We]=0;else if(pe)Se[Te][We]=Be,he[Te][We]=1,be[Te][We]=be[Te-1][We-1]+1;else throw new Error("not possible")}}if(fe&&ke(le,T,K,U),!rt[0]&&!Z.firstMatchCanBeWeak)return;Te--,We--;const it=[Se[Te][We],U];let et=0,ot=0;for(;Te>=1;){let ze=We;do{const pt=he[Te][ze];if(pt===3)ze=ze-2;else if(pt===2)ze=ze-1;else break}while(ze>=1);et>1&&we[T+Te-1]===H[U+We-1]&&!V(ze+U-1,K,H)&&et+1>be[Te][ze]&&(ze=We),ze===We?et++:et=1,ot||(ot=ze),Te--,We=ze-1,it.push(We)}ye===x&&Z.boostFullMatch&&(it[0]+=2);const at=ot-x;return it[0]-=at,it}e.$3j=ae;function te(le,we,T,K,H,U){let Z=le-1,x=we-1;for(;Z>=T&&x>=K;)H[Z]===U[x]&&(me[Z]=x,Z--),x--}function Q(le,we,T,K,H,U,Z,x,ye,Te,We){if(we[T]!==U[Z])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return Z===T-K?He=le[T]===H[Z]?7:5:V(Z,H,U)&&(Z===0||!V(Z-1,H,U))?(He=le[T]===H[Z]?7:5,Xe=!0):oe(U,Z)&&(Z===0||!oe(U,Z-1))?He=5:(oe(U,Z-1)||Y(U,Z-1))&&(He=5,Xe=!0),He>1&&T===K&&(We[0]=!0),Xe||(Xe=V(Z,H,U)||oe(U,Z-1)||Y(U,Z-1)),T===K?Z>ye&&(He-=Xe?3:5):Te?He+=Xe?2:0:He+=Xe?0:1,Z+1===x&&(He-=Xe?3:5),He}function ee(le,we,T,K,H,U,Z){return ve(le,we,T,K,H,U,!0,Z)}e.$4j=ee;function $e(le,we,T,K,H,U,Z){return ve(le,we,T,K,H,U,!1,Z)}e.$5j=$e;function ve(le,we,T,K,H,U,Z,x){let ye=ae(le,we,T,K,H,U,x);if(ye&&!Z)return ye;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let We=T+1;We<Te;We++){const He=Fe(le,We);if(He){const Xe=ae(He,He.toLowerCase(),T,K,H,U,x);Xe&&(Xe[0]-=3,(!ye||Xe[0]>ye[0])&&(ye=Xe))}}}return ye}function Fe(le,we){if(we+1>=le.length)return;const T=le[we],K=le[we+1];if(T!==K)return le.slice(0,we)+K+T+le.slice(we+2)}}),define(Ce[31],Re([1,0,12]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(N||(N={})),function(I){const L="error",R="warning",m="warn",g="info",w="ignore";function A(l){return l?E.$8e(L,l)?I.Error:E.$8e(R,l)||E.$8e(m,l)?I.Warning:E.$8e(g,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(l){switch(l){case I.Error:return L;case I.Warning:return R;case I.Info:return g;default:return w}}I.toString=k}(N||(N={})),e.default=N}),define(Ce[125],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0,e.$Pd=Symbol("MicrotaskDelay")}),define(Ce[50],Re([1,0,18,12]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=void 0;class I{constructor(){this.b="",this.c=0}reset(p){return this.b=p,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(p){const b=p.charCodeAt(0),r=this.b.charCodeAt(this.c);return b-r}value(){return this.b[this.c]}}e.$4h=I;class L{constructor(p=!0){this.e=p}reset(p){return this.b=p,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let p=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(p)this.c++;else break;else p=!1;return this}cmp(p){return this.e?(0,N.$2e)(p,this.b,0,p.length,this.c,this.d):(0,N.$4e)(p,this.b,0,p.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$5h=L;class R{constructor(p=!0,b=!0){this.f=p,this.g=b}reset(p){this.d=0,this.e=0,this.b=p,this.c=p.length;for(let b=p.length-1;b>=0;b--,this.c--){const r=this.b.charCodeAt(b);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let p=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(p)this.d++;else break;else p=!1}return this}cmp(p){return this.g?(0,N.$2e)(p,this.b,0,p.length,this.d,this.e):(0,N.$4e)(p,this.b,0,p.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$6h=R;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor(p,b){this.f=p,this.g=b,this.d=[],this.e=0}reset(p){return this.c=p,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(p)),this.b.reset(p.path),this.b.value()&&this.d.push(3)),this.g(p)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(p){if(this.d[this.e]===1)return(0,N.$3e)(p,this.c.scheme);if(this.d[this.e]===2)return(0,N.$3e)(p,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(p);if(this.d[this.e]===4)return(0,N.$1e)(p,this.c.query);if(this.d[this.e]===5)return(0,N.$1e)(p,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$7h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const p=this.right;return this.right=p.left,p.left=this,this.updateHeight(),p.updateHeight(),p}rotateRight(){const p=this.left;return this.left=p.right,p.right=this,this.updateHeight(),p.updateHeight(),p}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris(p=()=>!1,b=()=>!1){return new k(new g(p,b))}static forPaths(p=!1){return new k(new R(void 0,!p))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new L)}constructor(p){this.b=p}clear(){this.c=void 0}fill(p,b){if(b){const r=b.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o,p)}else{const r=p.slice(0);(0,E.$Xb)(r);for(const o of r)this.set(o[0],o[1])}}set(p,b){const r=this.b.reset(p);let o;this.c||(this.c=new w,this.c.segment=r.value());const t=[];for(o=this.c;;){const a=r.cmp(o.segment);if(a>0)o.left||(o.left=new w,o.left.segment=r.value()),t.push([-1,o]),o=o.left;else if(a<0)o.right||(o.right=new w,o.right.segment=r.value()),t.push([1,o]),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new w,o.mid.segment=r.value()),t.push([0,o]),o=o.mid;else break}const n=o.value;o.value=b,o.key=p;for(let a=t.length-1;a>=0;a--){const c=t[a][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[a][0],s=t[a+1][0];if(i===1&&s===1)t[a][1]=c.rotateLeft();else if(i===-1&&s===-1)t[a][1]=c.rotateRight();else if(i===1&&s===-1)c.right=t[a+1][1]=t[a+1][1].rotateRight(),t[a][1]=c.rotateLeft();else if(i===-1&&s===1)c.left=t[a+1][1]=t[a+1][1].rotateLeft(),t[a][1]=c.rotateRight();else throw new Error;if(a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}return n}get(p){return this.d(p)?.value}d(p){const b=this.b.reset(p);let r=this.c;for(;r;){const o=b.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(b.hasNext())b.next(),r=r.mid;else break}return r}has(p){const b=this.d(p);return!(b?.value===void 0&&b?.mid===void 0)}delete(p){return this.e(p,!1)}deleteSuperstr(p){return this.e(p,!0)}e(p,b){const r=this.b.reset(p),o=[];let t=this.c;for(;t;){const n=r.cmp(t.segment);if(n>0)o.push([-1,t]),t=t.left;else if(n<0)o.push([1,t]),t=t.right;else if(r.hasNext())r.next(),o.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:a,value:c,segment:h}=n;this.e(n.key,!1),t.key=a,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(o.length>0){const[a,c]=o[o.length-1];switch(a){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=o.length-1;n>=0;n--){const a=o[n][1];a.updateHeight();const c=a.balanceFactor();if(c>1?(a.right.balanceFactor()>=0||(a.right=a.right.rotateRight()),o[n][1]=a.rotateLeft()):c<-1&&(a.left.balanceFactor()<=0||(a.left=a.left.rotateLeft()),o[n][1]=a.rotateRight()),n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}}f(p){for(;p.left;)p=p.left;return p}findSubstr(p){const b=this.b.reset(p);let r=this.c,o;for(;r;){const t=b.cmp(r.segment);if(t>0)r=r.left;else if(t<0)r=r.right;else if(b.hasNext())b.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(p){return this.g(p,!1)}g(p,b){const r=this.b.reset(p);let o=this.c;for(;o;){const t=r.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this.h(o.mid):b?o.value:void 0}}hasElementOrSubtree(p){return this.g(p,!0)!==void 0}forEach(p){for(const[b,r]of this)p(r,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(p){const b=[];return this.j(p,b),b[Symbol.iterator]()}j(p,b){p&&(p.left&&this.j(p.left,b),p.value&&b.push([p.key,p.value]),p.mid&&this.j(p.mid,b),p.right&&this.j(p.right,b))}_isBalanced(){const p=b=>{if(!b)return!0;const r=b.balanceFactor();return r<-1||r>1?!1:p(b.left)&&p(b.right)};return p(this.c)}}e.$8h=k}),define(Ce[45],Re([1,0,90]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$9j=e.ThemeColor=void 0;var N;(function(R){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}R.isThemeColor=m})(N||(e.ThemeColor=N={}));function I(R){return{id:R}}e.$9j=I;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function g(n){const a=m.exec(n.id);if(!a)return g(E.$8j.error);const[,c,h]=a,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}R.asClassNameArray=g;function w(n){return g(n).join(" ")}R.asClassName=w;function A(n){return"."+g(n).join(".")}R.asCSSSelector=A;function k(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}R.isThemeIcon=k;const l=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function p(n){const a=l.exec(n);if(!a)return;const[,c]=a;return{id:c}}R.fromString=p;function b(n){return{id:n}}R.fromId=b;function r(n,a){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),a&&(c=`${c}~${a}`),{id:c}}R.modify=r;function o(n){const a=n.id.lastIndexOf("~");if(a!==-1)return n.id.substring(a+1)}R.getModifier=o;function t(n,a){return n.id===a.id&&n.color?.id===a.color?.id}R.isEqual=t})(L||(e.ThemeIcon=L={}))}),define(Ce[126],Re([1,0,124,12,45]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=void 0;const L="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${R.source}`,"g");function g(t){return t.replace(m,(n,a)=>a?n:`\\${n}`)}e.$0j=g;const w=new RegExp(`\\\\${R.source}`,"g");function A(t){return t.replace(w,n=>`\\${n}`)}e.$$j=A;const k=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function l(t){return t.indexOf(L)===-1?t:t.replace(k,(n,a,c,h)=>c?n:a||h||"")}e.$_j=l;function p(t){return t?t.replace(/\$\((.*?)\)/g,(n,a)=>` ${a} `).trim():""}e.$ak=p;const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(t){b.lastIndex=0;let n="";const a=[];let c=0;for(;;){const h=b.lastIndex,i=b.exec(t),s=t.substring(h,i?.index);if(s.length>0){n+=s;for(let u=0;u<s.length;u++)a.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:a}}e.$bk=r;function o(t,n,a=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Wj)(t,c,a);const i=(0,N.$Pe)(c," "),s=c.length-i.length,u=(0,E.$Wj)(t,i,a);if(u)for(const d of u){const v=h[d.start+s]+s;d.start+=v,d.end+=v}return u}e.$ck=o}),define(Ce[33],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mg=e.$lg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(I){return E.test(I)}e.$lg=N,e.$mg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const L=new Uint8Array(16),R=[];for(let m=0;m<256;m++)R.push(m.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let g=0,w="";return w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+="-",w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w+=R[L[g++]],w}}()}),define(Ce[127],Re([1,0,18,67,33]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=e.$bt=e.$at=void 0;function L(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$at=L;function R(k,l,p){const b={id:(0,I.$mg)(),name:k,uri:l,data:p};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$bt=R;class m{constructor(){this.a=new Map}get size(){let l=0;for(const p of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const p=[...this.a.keys()];return N.Iterable.some(this,([b,r])=>r.asFile())&&p.push("files"),A(g(l),p)}get(l){return this.a.get(this.b(l))?.[0]}append(l,p){const b=this.a.get(l);b?b.push(p):this.a.set(this.b(l),[p])}replace(l,p){this.a.set(this.b(l),[p])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,p]of this.a)for(const b of p)yield[l,b]}b(l){return g(l)}}e.$ct=m;function g(k){return k.toLowerCase()}function w(k,l){return A(g(k),l.map(g))}e.$dt=w;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const p=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!p)return!1;const[b,r,o]=p;return o==="*"?l.some(t=>t.startsWith(r+"/")):!1}e.$et=Object.freeze({create:k=>(0,E.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$et.split(k).filter(l=>!l.startsWith("#"))})}),define(Ce[128],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=e.StringEOL=void 0;var E;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function N(I){let L=0,R=0,m=0,g=0;for(let w=0,A=I.length;w<A;w++){const k=I.charCodeAt(w);k===13?(L===0&&(R=w),L++,w+1<A&&I.charCodeAt(w+1)===10?(g|=2,w++):g|=3,m=w+1):k===10&&(g|=1,L===0&&(R=w),L++,m=w+1)}return L===0&&(R=I.length),[L,R,I.length-m,g]}e.$ht=N}),define(Ce[129],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$es={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[130],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=e.$Et=e.IndentAction=void 0;var E;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class N{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,w=m.notIn.length;g<w;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(g-2),A=m.getStandardTokenType(w);return this.isOK(A)}g(m,g){for(let w=m;w<=g;w++){const A=String.fromCharCode(w);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Et=N;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)L(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),L(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),L(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),L(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&L(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Ft=I;function L(R,m,g){R.has(m)?R.get(m).push(g):R.set(m,[g])}}),define(Ce[131],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=e.$FB=e.$EB=e.$DB=e.$CB=e.NodeColor=e.$BB=void 0;class E{constructor(o,t){this.piece=o,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$CB)return I(this.right);let o=this;for(;o.parent!==e.$CB&&o.parent.left!==o;)o=o.parent;return o.parent===e.$CB?e.$CB:o.parent}prev(){if(this.left!==e.$CB)return L(this.left);let o=this;for(;o.parent!==e.$CB&&o.parent.right!==o;)o=o.parent;return o.parent===e.$CB?e.$CB:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$BB=E;var N;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$CB=new E(null,0),e.$CB.parent=e.$CB,e.$CB.left=e.$CB,e.$CB.right=e.$CB,e.$CB.color=0;function I(r){for(;r.left!==e.$CB;)r=r.left;return r}e.$DB=I;function L(r){for(;r.right!==e.$CB;)r=r.right;return r}e.$EB=L;function R(r){return r===e.$CB?0:r.size_left+r.piece.length+R(r.right)}function m(r){return r===e.$CB?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function g(){e.$CB.parent=e.$CB}function w(r,o){const t=o.right;t.size_left+=o.size_left+(o.piece?o.piece.length:0),t.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=t.left,t.left!==e.$CB&&(t.left.parent=o),t.parent=o.parent,o.parent===e.$CB?r.root=t:o.parent.left===o?o.parent.left=t:o.parent.right=t,t.left=o,o.parent=t}e.$FB=w;function A(r,o){const t=o.left;o.left=t.right,t.right!==e.$CB&&(t.right.parent=o),t.parent=o.parent,o.size_left-=t.size_left+(t.piece?t.piece.length:0),o.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),o.parent===e.$CB?r.root=t:o===o.parent.right?o.parent.right=t:o.parent.left=t,t.right=o,o.parent=t}e.$GB=A;function k(r,o){let t,n;if(o.left===e.$CB?(n=o,t=n.right):o.right===e.$CB?(n=o,t=n.left):(n=I(o.right),t=n.right),n===r.root){r.root=t,t.color=0,o.detach(),g(),r.root.parent=e.$CB;return}const a=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===o?(t.parent=n.parent,b(r,t)):(n.parent===o?t.parent=n:t.parent=n.parent,b(r,t),n.left=o.left,n.right=o.right,n.parent=o.parent,n.color=o.color,o===r.root?r.root=n:o===o.parent.left?o.parent.left=n:o.parent.right=n,n.left!==e.$CB&&(n.left.parent=n),n.right!==e.$CB&&(n.right.parent=n),n.size_left=o.size_left,n.lf_left=o.lf_left,b(r,n)),o.detach(),t.parent.left===t){const h=R(t),i=m(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const s=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,p(r,t.parent,s,u)}}if(b(r,t.parent),a){g();return}let c;for(;t!==r.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(r,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,A(r,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(r,t.parent),t=r.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,A(r,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(r,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,A(r,t.parent),t=r.root));t.color=0,g()}e.$HB=k;function l(r,o){for(b(r,o);o!==r.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const t=o.parent.parent.right;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,w(r,o)),o.parent.color=0,o.parent.parent.color=1,A(r,o.parent.parent))}else{const t=o.parent.parent.left;t.color===1?(o.parent.color=0,t.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,A(r,o)),o.parent.color=0,o.parent.parent.color=1,w(r,o.parent.parent))}r.root.color=0}e.$IB=l;function p(r,o,t,n){for(;o!==r.root&&o!==e.$CB;)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}e.$JB=p;function b(r,o){let t=0,n=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,t=R(o.left)-o.size_left,n=m(o.left)-o.lf_left,o.size_left+=t,o.lf_left+=n;o!==r.root&&(t!==0||n!==0);)o.parent.left===o&&(o.parent.size_left+=t,o.parent.lf_left+=n),o=o.parent}}e.$KB=b}),define(Ce[91],Re([1,0,92,29,93,131,94]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VB=e.$UB=e.$TB=e.$SB=e.$RB=void 0;const m=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,a,c,h,i){this.lineStarts=n,this.cr=a,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function A(t,n=!0){const a=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const s=t.charCodeAt(h);s===13?h+1<i&&t.charCodeAt(h+1)===10?(a[c++]=h+2,h++):a[c++]=h+1:s===10&&(a[c++]=h+1)}return n?g(a):a}e.$RB=A;function k(t,n){t.length=0,t[0]=0;let a=1,c=0,h=0,i=0,s=!0;for(let d=0,v=n.length;d<v;d++){const f=n.charCodeAt(d);f===13?d+1<v&&n.charCodeAt(d+1)===10?(i++,t[a++]=d+2,d++):(c++,t[a++]=d+1):f===10?(h++,t[a++]=d+1):s&&f!==9&&(f<32||f>126)&&(s=!1)}const u=new w(g(t),c,h,i,s);return t.length=0,u}e.$SB=k;class l{constructor(n,a,c,h,i){this.bufferIndex=n,this.start=a,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$TB=l;class p{constructor(n,a){this.buffer=n,this.lineStarts=a}}e.$UB=p;class b{constructor(n,a){this.a=[],this.c=n,this.d=a,this.b=0,n.root!==L.$CB&&n.iterate(n.root,c=>(c!==L.$CB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(n){this.a=n,this.b=[]}get(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let a=this.b.length-1;a>=0;a--){const c=this.b[a];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let a=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,a=!0;continue}}if(a){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(n,a,c){this.create(n,a,c)}create(n,a,c){this.a=[new p("",[0])],this.g={line:0,column:0},this.root=L.$CB,this.b=1,this.c=0,this.d=a,this.e=a.length,this.f=c;let h=null;for(let i=0,s=n.length;i<s;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=A(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const a=m,c=a-Math.floor(a/3),h=c*2;let i="",s=0;const u=[];if(this.iterate(this.root,d=>{const v=this.R(d),f=v.length;if(s<=c||s+f<h)return i+=v,s+=f,!0;const S=i.replace(/\r\n|\r|\n/g,n);return u.push(new p(S,A(S))),i=v,s=f,!0}),s>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new p(d,A(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let a=0;return this.iterate(this.root,h=>{if(h===L.$CB)return!0;const i=this.R(h),s=i.length,u=n.G(a),d=n.G(a+s),v=n.getValueInRange2(u,d);return a+=s,i===v})}getOffsetAt(n,a){let c=0,h=this.root;for(;h!==L.$CB;)if(h.left!==L.$CB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+a-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let a=this.root,c=0;const h=n;for(;a!==L.$CB;)if(a.size_left!==0&&a.size_left>=n)a=a.left;else if(a.size_left+a.piece.length>=n){const i=this.A(a,n-a.size_left);if(c+=a.lf_left+i.index,i.index===0){const s=this.getOffsetAt(c+1,1),u=h-s;return new E.$Gs(c+1,u+1)}return new E.$Gs(c+1,i.remainder+1)}else if(n-=a.size_left+a.piece.length,c+=a.lf_left+a.piece.lineFeedCnt,a.right===L.$CB){const i=this.getOffsetAt(c+1,1),s=h-n-i;return new E.$Gs(c+1,s+1)}else a=a.right;return new E.$Gs(1,1)}getValueInRange(n,a){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return a?a!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,a):a===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,a):i}getValueInRange2(n,a){if(n.node===a.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(v+n.remainder,v+a.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let s=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==L.$CB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===a.node){s+=u.substring(d,d+a.remainder);break}else s+=u.substr(d,c.piece.length);c=c.next()}return s}getLinesContent(){const n=[];let a=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===L.$CB)return!0;const s=i.piece;let u=s.length;if(u===0)return!0;const d=this.a[s.bufferIndex].buffer,v=this.a[s.bufferIndex].lineStarts,f=s.start.line,S=s.end.line;let F=v[f]+s.start.column;if(h&&(d.charCodeAt(F)===10&&(F++,u--),n[a++]=c,c="",h=!1,u===0))return!0;if(f===S)return!this.f&&d.charCodeAt(F+u-1)===13?(h=!0,c+=d.substr(F,u-1)):c+=d.substr(F,u),!0;c+=this.f?d.substring(F,Math.max(F,v[f+1]-this.e)):d.substring(F,v[f+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;for(let $=f+1;$<S;$++)c=this.f?d.substring(v[$],v[$+1]-this.e):d.substring(v[$],v[$+1]).replace(/(\r\n|\r|\n)$/,""),n[a++]=c;return!this.f&&d.charCodeAt(v[S]+s.end.column-1)===13?(h=!0,s.end.column===0?a--:c=d.substr(v[S],s.end.column-1)):c=d.substr(v[S],s.end.column),!0}),h&&(n[a++]=c,c=""),n[a++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const a=n.node.next();if(!a)return 0;const c=this.a[a.piece.bufferIndex],h=this.u(a.piece.bufferIndex,a.piece.start);return c.buffer.charCodeAt(h)}else{const a=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return a.buffer.charCodeAt(h)}}getLineCharCode(n,a){const c=this.H(n,a+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const a=this.getOffsetAt(n,1);return this.getLength()-a}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const a=this.G(n);return this.l(a)}findMatchesInNode(n,a,c,h,i,s,u,d,v,f,S){const F=this.a[n.piece.bufferIndex],$=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,s);let M;const O={line:0,column:0};let W,z;a._wordSeparators?(W=F.buffer.substring(y,D),z=q=>q+y,a.reset(0)):(W=F.buffer,z=q=>q,a.reset(y));do if(M=a.next(W),M){if(z(M.index)>=D)return f;this.s(n,z(M.index)-$,O);const q=this.t(n.piece.bufferIndex,i,O),C=O.line===i.line?O.column-i.column+h:O.column+1,P=C+M[0].length;if(S[f++]=(0,R.$NB)(new N.$Hs(c+q,C,c+q,P),M,d),z(M.index)+M[0].length>=D||f>=v)return f}while(M);return f}findMatchesLineByLine(n,a,c,h){const i=[];let s=0;const u=new R.$QB(a.wordSeparators,a.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const v=this.H(n.endLineNumber,n.endColumn);if(v===null)return[];let f=this.s(d.node,d.remainder);const S=this.s(v.node,v.remainder);if(d.node===v.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,S,a,c,h,s,i),i;let F=n.startLineNumber,$=d.node;for(;$!==v.node;){const D=this.t($.piece.bufferIndex,f,$.piece.end);if(D>=1){const O=this.a[$.piece.bufferIndex].lineStarts,W=this.u($.piece.bufferIndex,$.piece.start),z=O[f.line+D],q=F===n.startLineNumber?n.startColumn:1;if(s=this.findMatchesInNode($,u,F,q,f,this.s($,z-W),a,c,h,s,i),s>=h)return i;F+=D}const M=F===n.startLineNumber?n.startColumn-1:0;if(F===n.endLineNumber){const O=this.getLineContent(F).substring(M,n.endColumn-1);return s=this.n(a,u,O,n.endLineNumber,M,s,i,c,h),i}if(s=this.n(a,u,this.getLineContent(F).substr(M),F,M,s,i,c,h),s>=h)return i;F++,d=this.H(F,1),$=d.node,f=this.s(d.node,d.remainder)}if(F===n.endLineNumber){const D=F===n.startLineNumber?n.startColumn-1:0,M=this.getLineContent(F).substring(D,n.endColumn-1);return s=this.n(a,u,M,n.endLineNumber,D,s,i,c,h),i}const y=F===n.startLineNumber?n.startColumn:1;return s=this.findMatchesInNode(v.node,u,F,y,f,S,a,c,h,s,i),i}n(n,a,c,h,i,s,u,d,v){const f=n.wordSeparators;if(!d&&n.simpleSearch){const F=n.simpleSearch,$=F.length,y=c.length;let D=-$;for(;(D=c.indexOf(F,D+$))!==-1;)if((!f||(0,R.$PB)(f,c,y,D,$))&&(u[s++]=new I.$Zu(new N.$Hs(h,D+1+i,h,D+1+$+i),null),s>=v))return s;return s}let S;a.reset(0);do if(S=a.next(c),S&&(u[s++]=(0,R.$NB)(new N.$Hs(h,S.index+1+i,h,S.index+1+S[0].length+i),S,d),s>=v))return s;while(S);return s}insert(n,a,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==L.$CB){const{node:h,remainder:i,nodeStartOffset:s}=this.G(n),u=h.piece,d=u.bufferIndex,v=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&s+u.length===n&&a.length<m){this.F(h,a),this.y();return}if(s===n)this.o(a,h),this.h.validate(n);else if(s+h.piece.length>n){const f=[];let S=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(d,u.end)-this.u(d,v));if(this.K()&&this.M(a)&&this.I(h,i)===10){const D={line:S.start.line+1,column:0};S=new l(S.bufferIndex,D,S.end,this.t(S.bufferIndex,D,S.end),S.length-1),a+=`
`}if(this.K()&&this.L(a))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),a="\r"+a,h.piece.length===0&&f.push(h)}else this.C(h,v);else this.C(h,v);const F=this.w(a);S.length>0&&this.S(h,S);let $=h;for(let y=0;y<F.length;y++)$=this.S($,F[y]);this.v(f)}else this.q(a,h)}else{const h=this.w(a);let i=this.T(null,h[0]);for(let s=1;s<h.length;s++)i=this.S(i,h[s])}this.y()}delete(n,a){if(this.j.lineNumber=0,this.j.value="",a<=0||this.root===L.$CB)return;const c=this.G(n),h=this.G(n+a),i=c.node,s=h.node;if(i===s){const F=this.s(i,c.remainder),$=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(a===i.piece.length){const y=i.next();(0,L.$HB)(this,i),this.N(y),this.y();return}this.D(i,$),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+a){this.C(i,F),this.O(i),this.y();return}this.E(i,F,$),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const v=this.s(s,h.remainder);this.D(s,v),s.piece.length===0&&u.push(s);const f=i.next();for(let F=f;F!==L.$CB&&F!==s;F=F.next())u.push(F);const S=i.piece.length===0?i.prev():i;this.v(u),this.O(S),this.y()}o(n,a){const c=[];if(this.K()&&this.M(n)&&this.L(a)){const s=a.piece,u={line:s.start.line+1,column:0},d=new l(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),s.length-1);a.piece=d,n+=`
`,(0,L.$JB)(this,a,-1,-1),a.piece.length===0&&c.push(a)}const h=this.w(n);let i=this.T(a,h[h.length-1]);for(let s=h.length-2;s>=0;s--)i=this.T(i,h[s]);this.N(i),this.v(c)}q(n,a){this.Q(n,a)&&(n+=`
`);const c=this.w(n),h=this.S(a,c[0]);let i=h;for(let s=1;s<c.length;s++)i=this.S(i,c[s]);this.N(h)}s(n,a,c){const h=n.piece,i=n.piece.bufferIndex,s=this.a[i].lineStarts,d=s[h.start.line]+h.start.column+a;let v=h.start.line,f=h.end.line,S=0,F=0,$=0;for(;v<=f&&(S=v+(f-v)/2|0,$=s[S],S!==f);)if(F=s[S+1],d<$)f=S-1;else if(d>=F)v=S+1;else break;return c?(c.line=S,c.column=d-$,null):{line:S,column:d-$}}t(n,a,c){if(c.column===0)return c.line-a.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-a.line;const i=h[c.line+1],s=h[c.line]+c.column;if(i>s+1)return c.line-a.line;const u=s-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-a.line+1:c.line-a.line}u(n,a){return this.a[n].lineStarts[a.line]+a.column}v(n){for(let a=0;a<n.length;a++)(0,L.$HB)(this,n[a])}w(n){if(n.length>m){const f=[];for(;n.length>m;){const F=n.charCodeAt(m-1);let $;F===13||F>=55296&&F<=56319?($=n.substring(0,m-1),n=n.substring(m-1)):($=n.substring(0,m),n=n.substring(m));const y=A($);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:$.length-y[y.length-1]},y.length-1,$.length)),this.a.push(new p($,y))}const S=A(n);return f.push(new l(this.a.length,{line:0,column:0},{line:S.length-1,column:n.length-S[S.length-1]},S.length-1,n.length)),this.a.push(new p(n,S)),f}let a=this.a[0].buffer.length;const c=A(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===a&&a!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=a+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,a+=1}else{if(a!==0)for(let f=0;f<c.length;f++)c[f]+=a;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,s=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[s],d={line:s,column:u},v=new l(0,h,d,this.t(0,h,d),i-a);return this.g=d,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,a=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const s=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+s,d+c.piece.length);else{const v=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+s,d+v-a)}}else{let s=0;const u=n;for(;c!==L.$CB;)if(c.left!==L.$CB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,S=this.u(c.piece.bufferIndex,c.piece.start);return s+=c.size_left,this.h.set({node:c,nodeStartOffset:s,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(S+d,S+v-a)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=v.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,s+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==L.$CB;){const s=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=s.substring(d,d+u-a),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=s.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,a=1,c=0;for(;n!==L.$CB;)a+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=a,this.c=c,this.h.validate(this.c)}A(n,a){const c=n.piece,h=this.s(n,a),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===a){const s=this.t(n.piece.bufferIndex,c.start,h);if(s!==i)return{index:s,remainder:0}}return{index:i,remainder:h.column}}B(n,a){if(a<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+a+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),s=a,u=this.u(c.bufferIndex,s),d=this.t(c.bufferIndex,c.start,s),v=d-h,f=u-i,S=c.length+f;n.piece=new l(c.bufferIndex,c.start,s,d,S),(0,L.$JB)(this,n,f,v)}D(n,a){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),s=a,u=this.t(c.bufferIndex,s,c.end),d=this.u(c.bufferIndex,s),v=u-h,f=i-d,S=c.length+f;n.piece=new l(c.bufferIndex,s,c.end,u,S),(0,L.$JB)(this,n,f,v)}E(n,a,c){const h=n.piece,i=h.start,s=h.end,u=h.length,d=h.lineFeedCnt,v=a,f=this.t(h.bufferIndex,h.start,v),S=this.u(h.bufferIndex,a)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,v,f,S),(0,L.$JB)(this,n,S-u,f-d);const F=new l(h.bufferIndex,c,s,this.t(h.bufferIndex,c,s),this.u(h.bufferIndex,s)-this.u(h.bufferIndex,c)),$=this.S(n,F);this.N($)}F(n,a){this.Q(a,n)&&(a+=`
`);const c=this.K()&&this.L(a)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=a;const i=A(a,!1);for(let $=0;$<i.length;$++)i[$]+=h;if(c){const $=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-$}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const s=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[s],d={line:s,column:u},v=n.piece.length+a.length,f=n.piece.lineFeedCnt,S=this.t(0,n.piece.start,d),F=S-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,S,v),this.g=d,(0,L.$JB)(this,n,a.length,F)}G(n){let a=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;a!==L.$CB;)if(a.size_left>n)a=a.left;else if(a.size_left+a.piece.length>=n){h+=a.size_left;const i={node:a,remainder:n-a.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=a.size_left+a.piece.length,h+=a.size_left+a.piece.length,a=a.right;return null}H(n,a){let c=this.root,h=0;for(;c!==L.$CB;)if(c.left!==L.$CB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),s=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+a-1,s),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+a-1<=c.piece.length)return{node:c,remainder:i+a-1,nodeStartOffset:h};a-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==L.$CB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),s=this.J(c);return{node:c,remainder:Math.min(a-1,i),nodeStartOffset:s}}else if(c.piece.length>=a-1){const i=this.J(c);return{node:c,remainder:a-1,nodeStartOffset:i}}else a-=c.piece.length;c=c.next()}return null}I(n,a){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+a;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let a=n.size_left;for(;n!==this.root;)n.parent.right===n&&(a+=n.parent.size_left+n.parent.piece.length),n=n.parent;return a}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===L.$CB||n.piece.lineFeedCnt===0)return!1;const a=n.piece,c=this.a[a.bufferIndex].lineStarts,h=a.start.line,i=c[h]+a.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[a.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===L.$CB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const a=n.prev();this.M(a)&&this.P(a,n)}}O(n){if(this.K()&&this.M(n)){const a=n.next();this.L(a)&&this.P(n,a)}}P(n,a){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const s=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,s),(0,L.$JB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:a.piece.start.line+1,column:0},v=a.piece.length-1,f=this.t(a.piece.bufferIndex,d,a.piece.end);a.piece=new l(a.piece.bufferIndex,d,a.piece.end,f,v),(0,L.$JB)(this,a,-1,-1),a.piece.length===0&&c.push(a);const S=this.w(`\r
`);this.S(n,S[0]);for(let F=0;F<c.length;F++)(0,L.$HB)(this,c[F])}Q(n,a){if(this.K()&&this.M(n)){const c=a.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,L.$HB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},s=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,s),(0,L.$JB)(this,c,-1,-1)}return!0}}return!1}iterate(n,a){if(n===L.$CB)return a(L.$CB);const c=this.iterate(n.left,a);return c&&a(n)&&this.iterate(n.right,a)}R(n){if(n===L.$CB)return"";const a=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return a.buffer.substring(h,i)}getPieceContent(n){const a=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return a.buffer.substring(c,h)}S(n,a){const c=new L.$BB(a,1);if(c.left=L.$CB,c.right=L.$CB,c.parent=L.$CB,c.size_left=0,c.lf_left=0,this.root===L.$CB)this.root=c,c.color=0;else if(n.right===L.$CB)n.right=c,c.parent=n;else{const i=(0,L.$DB)(n.right);i.left=c,c.parent=i}return(0,L.$IB)(this,c),c}T(n,a){const c=new L.$BB(a,1);if(c.left=L.$CB,c.right=L.$CB,c.parent=L.$CB,c.size_left=0,c.lf_left=0,this.root===L.$CB)this.root=c,c.color=0;else if(n.left===L.$CB)n.left=c,c.parent=n;else{const h=(0,L.$EB)(n.left);h.right=c,c.parent=h}return(0,L.$IB)(this,c),c}U(n){let a="";return this.iterate(n,c=>(a+=this.R(c),!0)),a}}e.$VB=o}),define(Ce[132],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_7=e.$$7=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.$$7=E;class N{constructor(L){this.identifier=L}}e.$_7=N}),define(Ce[133],Re([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[134],Re([1,0,5,6,133]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class L extends N.$Sc{constructor(l,p="",b="",r=!0,o){super(),this.h=this.B(new E.$Sd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=p,this.u=b,this.w=r,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,p){this.C&&await this.C(l)}}e.$Gi=L;class R extends N.$Sc{constructor(){super(...arguments),this.f=this.B(new E.$Sd),this.onWillRun=this.f.event,this.m=this.B(new E.$Sd),this.onDidRun=this.m.event}async run(l,p){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,p)}catch(r){b=r}this.m.fire({action:l,error:b})}async u(l,p){await l.run(p)}}e.$Hi=R;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let p=[];for(const b of l)b.length&&(p.length?p=[...p,new m,...b]:p=b);return p}static{this.ID="vs.actions.separator"}async run(){}}e.$Ii=m;class g{get actions(){return this.a}constructor(l,p,b,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=p,this.class=r,this.a=b}async run(){}}e.$Ji=g;class w extends L{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,I.localize(0,null),void 0,!1)}}e.$Ki=w;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked??!1,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Li=A}),define(Ce[135],Re([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[136],Re([1,0,135]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0;const N=60,I=N*60,L=I*24,R=L*7,m=L*30,g=L*365;function w(k,l,p,b){typeof k!="number"&&(k=k.getTime());const r=Math.round((new Date().getTime()-k)/1e3);if(r<-30)return(0,E.localize)(0,null,w(new Date().getTime()+r*1e3,!1));if(!b&&r<30)return(0,E.localize)(1,null);let o;return r<N?(o=r,l?o===1?p?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):p?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?p?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):p?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):r<I?(o=Math.floor(r/N),l?o===1?p?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):p?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?p?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):p?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):r<L?(o=Math.floor(r/I),l?o===1?p?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):p?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?p?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):p?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):r<R?(o=Math.floor(r/L),l?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):r<m?(o=Math.floor(r/R),l?o===1?p?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):p?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?p?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):p?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):r<g?(o=Math.floor(r/m),l?o===1?p?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):p?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?p?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):p?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(r/g),l?o===1?p?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):p?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?p?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):p?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$rm=w;function A(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$sm=A}),define(Ce[137],Re([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[40],Re([1,0,18,16,137]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=void 0;function L(k,l){return l&&(k.stack||k.stacktrace)?I.localize(0,null,m(k),R(k.stack)||R(k.stacktrace)):m(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function g(k=null,l=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const p=E.$Hb(k),b=g(p[0],l);return p.length>1?I.localize(4,null,b,p.length):b}if(N.$Ef(k))return k;if(k.detail){const p=k.detail;if(p.error)return L(p.error,l);if(p.exception)return L(p.exception,l)}return k.stack?L(k,l):k.message?k.message:I.localize(5,null)}e.$Mi=g;function w(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ni=w;function A(k,l){let p;return typeof k=="string"?p=new Error(k):p=k,p.actions=l,p}e.$Oi=A}),define(Ce[138],Re([1,0,39,19]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=e.$Fq=e.$Eq=e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=void 0;const I=new E.$V(()=>{const F=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:F,collatorIsNumeric:F.resolvedOptions().numeric}}),L=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new E.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(F,$,y=!1){const D=F||"",M=$||"",O=I.value.collator.compare(D,M);return I.value.collatorIsNumeric&&O===0&&D!==M?D<M?-1:1:O}e.$vq=m;function g(F,$){const y=L.value.collator;return F=F||"",$=$||"",c(y,F,$)}e.$wq=g;function w(F,$){const y=L.value.collator;return F=F||"",$=$||"",u(F,$)||c(y,F,$)}e.$xq=w;function A(F,$){const y=L.value.collator;return F=F||"",$=$||"",s(F,$)||c(y,F,$)}e.$yq=A;function k(F,$){return F=F||"",$=$||"",F===$?0:F<$?-1:1}e.$zq=k;function l(F,$){const[y,D]=n(F),[M,O]=n($);let W=I.value.collator.compare(D,O);if(W===0){if(I.value.collatorIsNumeric&&D!==O)return D<O?-1:1;if(W=I.value.collator.compare(y,M),I.value.collatorIsNumeric&&W===0&&y!==M)return y<M?-1:1}return W}e.$Aq=l;function p(F,$){F=F||"",$=$||"";const y=a(F),D=a($),M=L.value.collator,O=R.value.collator;return c(O,y,D)||c(M,F,$)}e.$Bq=p;function b(F,$){F=F||"",$=$||"";const y=a(F),D=a($),M=L.value.collator,O=R.value.collator;return c(O,y,D)||u(F,$)||c(M,F,$)}e.$Cq=b;function r(F,$){F=F||"",$=$||"";const y=a(F),D=a($),M=L.value.collator,O=R.value.collator;return c(O,y,D)||s(F,$)||c(M,F,$)}e.$Dq=r;function o(F,$){F=F||"",$=$||"";const y=a(F).toLowerCase(),D=a($).toLowerCase();return y!==D?y<D?-1:1:F!==$?F<$?-1:1:0}e.$Eq=o;const t=/^(.*?)(\.([^.]*))?$/;function n(F,$=!1){const y=F?t.exec(F):[];let D=[y&&y[1]||"",y&&y[3]||""];return $&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function a(F){const $=F?t.exec(F):[];return $&&$[1]&&$[1].charAt(0)!=="."&&$[3]||""}function c(F,$,y){const D=F.compare($,y);return D!==0?D:$.length!==y.length?$.length<y.length?-1:1:0}function h(F){const $=F.charAt(0);return $.toLocaleUpperCase()!==$}function i(F){const $=F.charAt(0);return $.toLocaleLowerCase()!==$}function s(F,$){return h(F)&&i($)?-1:i(F)&&h($)?1:0}function u(F,$){return i(F)&&h($)?-1:h(F)&&i($)?1:0}function d(F,$,y=!1){return y||(F=F&&F.toLowerCase(),$=$&&$.toLowerCase()),F===$?0:F<$?-1:1}function v(F,$,y=!1){const D=F.split(N.sep),M=$.split(N.sep),O=D.length-1,W=M.length-1;let z,q;for(let C=0;;C++){if(z=O===C,q=W===C,z&&q)return m(D[C],M[C],y);if(z)return-1;if(q)return 1;const P=d(D[C],M[C],y);if(P!==0)return P}}e.$Fq=v;function f(F,$,y){const D=F.toLowerCase(),M=$.toLowerCase(),O=S(F,$,y);if(O)return O;const W=D.endsWith(y),z=M.endsWith(y);if(W!==z)return W?-1:1;const q=m(D,M);return q!==0?q:D.localeCompare(M)}e.$Gq=f;function S(F,$,y){const D=F.toLowerCase(),M=$.toLowerCase(),O=D.startsWith(y),W=M.startsWith(y);if(O!==W)return O?-1:1;if(O&&W){if(D.length<M.length)return-1;if(D.length>M.length)return 1}return 0}e.$Hq=S}),define(Ce[46],Re([1,0,19,21,12,16]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function R(f){return f===47||f===92}e.$Wf=R;function m(f){return f.replace(/[\\/]/g,E.$gc.sep)}e.$Xf=m;function g(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Yf=g;function w(f,S=E.$gc.sep){if(!f)return"";const F=f.length,$=f.charCodeAt(0);if(R($)){if(R(f.charCodeAt(1))&&!R(f.charCodeAt(2))){let D=3;const M=D;for(;D<F&&!R(f.charCodeAt(D));D++);if(M!==D&&!R(f.charCodeAt(D+1))){for(D+=1;D<F;D++)if(R(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,S)}}return S}else if(t($)&&f.charCodeAt(1)===58)return R(f.charCodeAt(2))?f.slice(0,2)+S:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<F;y++)if(R(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Zf=w;function A(f){if(!N.$i||!f||f.length<5)return!1;let S=f.charCodeAt(0);if(S!==92||(S=f.charCodeAt(1),S!==92))return!1;let F=2;const $=F;for(;F<f.length&&(S=f.charCodeAt(F),S!==92);F++);return!($===F||(S=f.charCodeAt(F+1),isNaN(S)||S===92))}e.$1f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,p=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,S=N.$i){const F=S?k:l;return!(!f||f.length===0||/^\s+$/.test(f)||(F.lastIndex=0,F.test(f))||S&&p.test(f)||f==="."||f===".."||S&&f[f.length-1]==="."||S&&f.length!==f.trim().length||f.length>255)}e.$2f=b;function r(f,S,F){const $=f===S;return!F||$?$:!f||!S?!1:(0,I.$8e)(f,S)}e.$3f=r;function o(f,S,F,$=E.sep){if(f===S)return!0;if(!f||!S||S.length>f.length)return!1;if(F){if(!(0,I.$9e)(f,S))return!1;if(S.length===f.length)return!0;let D=S.length;return S.charAt(S.length-1)===$&&D--,f.charAt(D)===$}return S.charAt(S.length-1)!==$&&(S+=$),f.indexOf(S)===0}e.$4f=o;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$5f=t;function n(f,S){return N.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$ic)(f)||(f=(0,E.$jc)(S,f)),f=(0,E.$hc)(f),N.$i?(f=(0,I.$Qe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,I.$Qe)(f,E.sep),f||(f=E.sep)),f}e.$6f=n;function a(f){const S=(0,E.$hc)(f);return N.$i?f.length>3?!1:c(S)&&(f.length===2||S.charCodeAt(2)===92):S===E.$gc.sep}e.$7f=a;function c(f,S=N.$i){return S?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$8f=c;function h(f,S=N.$i){return c(f,S)?f[0]:void 0}e.$9f=h;function i(f,S,F){return S.length>f.length?-1:f===S?0:(F&&(f=f.toLowerCase(),S=S.toLowerCase()),f.indexOf(S))}e.$0f=i;function s(f){const S=f.split(":");let F,$,y;for(const D of S){const M=Number(D);(0,L.$If)(M)?$===void 0?$=M:y===void 0&&(y=M):F=F?[F,D].join(":"):D}if(!F)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:F,line:$!==void 0?$:void 0,column:y!==void 0?y:$!==void 0?1:void 0}}e.$$f=s;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,S,F=8){let $="";for(let D=0;D<F;D++){let M;D===0&&N.$i&&!S&&(F===3||F===4)?M=d:M=u,$+=M.charAt(Math.floor(Math.random()*M.length))}let y;return S?y=`${S}-${$}`:y=$,f?(0,E.$jc)(f,y):y}e.$_f=v}),define(Ce[68],Re([1,0,19]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=e.$4r=void 0,e.$4r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(A){const k=(0,E.$oc)(A),l=N[k.toLowerCase()];return l!==void 0?l:R(A)}e.$5r=L;function R(A){const k=(0,E.$oc)(A);return I[k.toLowerCase()]}e.$6r=R;function m(A){for(const k in I)if(I[k]===A)return k}e.$7r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function w(A,k){const l=g.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$8r=w}),define(Ce[51],Re([1,0,24,2]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=void 0;function I(g){return JSON.stringify(g,R)}e.$wh=I;function L(g){let w=JSON.parse(g);return w=m(w),w}e.$xh=L;function R(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return N.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$ge||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let A=0;A<g.length;++A)g[A]=m(g[A],w+1);else for(const A in g)Object.hasOwnProperty.call(g,A)&&(g[A]=m(g[A],w+1))}return g}e.$yh=m}),define(Ce[13],Re([1,0,11,21,12,2]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.Schemas=void 0;var R;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function m(l,p){return L.URI.isUri(l)?(0,I.$8e)(l.scheme,p):(0,I.$9e)(l,p+":")}e.$ag=m;function g(l,...p){return p.some(b=>m(l,b))}e.$bg=g,e.$cg="vscode-tkn",e.$dg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${R.vscodeRemoteResource}`}set(p,b,r){this.a[p]=b,this.b[p]=r}setConnectionToken(p,b){this.c[p]=b}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(a){return E.$1(a),p}const b=p.authority;let r=this.a[b];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const o=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent(p.path)}`;return typeof t=="string"&&(n+=`&${e.$dg}=${encodeURIComponent(t)}`),L.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${r}:${o}`,path:this.f,query:n})}}e.$eg=new w,e.$fg="vs/../../extensions",e.$gg="vs/../../node_modules",e.$hg="vs/../../node_modules.asar",e.$ig="vs/../../node_modules.asar.unpacked",e.$jg="vscode-app";class A{static{this.a=e.$jg}asBrowserUri(p){const b=this.b(p,ge);return this.uriToBrowserUri(b)}uriToBrowserUri(p){return p.scheme===R.vscodeRemote?e.$eg.rewrite(p):p.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${A.a}`)?p.with({scheme:R.vscodeFileResource,authority:p.authority||A.a,query:null,fragment:null}):p}asFileUri(p){const b=this.b(p,ge);return this.uriToFileUri(b)}uriToFileUri(p){return p.scheme===R.vscodeFileResource?p.with({scheme:R.file,authority:p.authority!==A.a?p.authority:null,query:null,fragment:null}):p}b(p,b){return L.URI.isUri(p)?p:L.URI.parse(b.toUrl(p))}}e.$kg=new A;var k;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const b="vscode-coi";function r(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:L.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const a=n?.get(b);if(a)return p.get(a)}l.getHeadersFromQuery=r;function o(t,n,a){if(!globalThis.crossOriginIsolated)return;const c=n&&a?"3":a?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=o})(k||(e.COI=k={}))}),define(Ce[25],Re([1,0,46,13,19,21,12,2]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ng=e.DataUri=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=void 0;function g(p){return(0,m.$wc)(p,!0)}e.$rg=g;class w{constructor(b){this.a=b}compare(b,r,o=!1){return b===r?0:(0,R.$1e)(this.getComparisonKey(b,o),this.getComparisonKey(r,o))}isEqual(b,r,o=!1){return b===r?!0:!b||!r?!1:this.getComparisonKey(b,o)===this.getComparisonKey(r,o)}getComparisonKey(b,r=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,r,o=!1){if(b.scheme===r.scheme){if(b.scheme===N.Schemas.file)return E.$4f(g(b),g(r),this.a(b))&&b.query===r.query&&(o||b.fragment===r.fragment);if((0,e.$Ig)(b.authority,r.authority))return E.$4f(b.path,r.path,this.a(b),"/")&&b.query===r.query&&(o||b.fragment===r.fragment)}return!1}joinPath(b,...r){return m.URI.joinPath(b,...r)}basenameOrAuthority(b){return(0,e.$Ag)(b)||b.authority}basename(b){return I.$gc.basename(b.path)}extname(b){return I.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let r;return b.scheme===N.Schemas.file?r=m.URI.file(I.$mc(g(b))).path:(r=I.$gc.dirname(b.path),b.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),r="/")),b.with({path:r})}normalizePath(b){if(!b.path.length)return b;let r;return b.scheme===N.Schemas.file?r=m.URI.file(I.$hc(g(b))).path:r=I.$gc.normalize(b.path),b.with({path:r})}relativePath(b,r){if(b.scheme!==r.scheme||!(0,e.$Ig)(b.authority,r.authority))return;if(b.scheme===N.Schemas.file){const n=I.$lc(g(b),g(r));return L.$i?E.$Xf(n):n}let o=b.path||"/";const t=r.path||"/";if(this.a(b)){let n=0;for(const a=Math.min(o.length,t.length);n<a&&!(o.charCodeAt(n)!==t.charCodeAt(n)&&o.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);o=t.substr(0,n)+o.substr(n)}return I.$gc.relative(o,t)}resolvePath(b,r){if(b.scheme===N.Schemas.file){const o=m.URI.file(I.$kc(g(b),r));return b.with({authority:o.authority,path:o.path})}return r=E.$Yf(r),b.with({path:I.$gc.resolve(b.path,r)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,r){return b===r||b!==void 0&&r!==void 0&&(0,R.$8e)(b,r)}hasTrailingPathSeparator(b,r=I.sep){if(b.scheme===N.Schemas.file){const o=g(b);return o.length>E.$Zf(o).length&&o[o.length-1]===r}else{const o=b.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,r=I.sep){return(0,e.$Jg)(b,r)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,r=I.sep){let o=!1;if(b.scheme===N.Schemas.file){const t=g(b);o=t!==void 0&&t.length===E.$Zf(t).length&&t[t.length-1]===r}else{r="/";const t=b.path;o=t.length===1&&t.charCodeAt(t.length-1)===47}return!o&&!(0,e.$Jg)(b,r)?b.with({path:b.path+"/"}):b}}e.$sg=w,e.$tg=new w(()=>!1),e.$ug=new w(p=>p.scheme===N.Schemas.file?!L.$k:!0),e.$vg=new w(p=>!0),e.$wg=e.$tg.isEqual.bind(e.$tg),e.$xg=e.$tg.isEqualOrParent.bind(e.$tg),e.$yg=e.$tg.getComparisonKey.bind(e.$tg),e.$zg=e.$tg.basenameOrAuthority.bind(e.$tg),e.$Ag=e.$tg.basename.bind(e.$tg),e.$Bg=e.$tg.extname.bind(e.$tg),e.$Cg=e.$tg.dirname.bind(e.$tg),e.$Dg=e.$tg.joinPath.bind(e.$tg),e.$Eg=e.$tg.normalizePath.bind(e.$tg),e.$Fg=e.$tg.relativePath.bind(e.$tg),e.$Gg=e.$tg.resolvePath.bind(e.$tg),e.$Hg=e.$tg.isAbsolutePath.bind(e.$tg),e.$Ig=e.$tg.isEqualAuthority.bind(e.$tg),e.$Jg=e.$tg.hasTrailingPathSeparator.bind(e.$tg),e.$Kg=e.$tg.removeTrailingPathSeparator.bind(e.$tg),e.$Lg=e.$tg.addTrailingPathSeparator.bind(e.$tg);function A(p,b){const r=[];for(let o=0;o<p.length;o++){const t=b(p[o]);p.some((n,a)=>a===o?!1:(0,e.$xg)(t,b(n)))||r.push(p[o])}return r}e.$Mg=A;var k;(function(p){p.META_DATA_LABEL="label",p.META_DATA_DESCRIPTION="description",p.META_DATA_SIZE="size",p.META_DATA_MIME="mime";function b(r){const o=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(a=>{const[c,h]=a.split(":");c&&h&&o.set(c,h)});const n=r.path.substring(0,r.path.indexOf(";"));return n&&o.set(p.META_DATA_MIME,n),o}p.parseMetaData=b})(k||(e.DataUri=k={}));function l(p,b,r){if(b){let o=p.path;return o&&o[0]!==I.$gc.sep&&(o=I.$gc.sep+o),p.with({scheme:r,authority:b,path:o})}return p.with({scheme:r})}e.$Ng=l}),define(Ce[14],Re([1,0,20,11,5,6,25,21,125,39]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.Promises=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=void 0;function A(ae){return!!ae&&typeof ae.then=="function"}e.$Og=A;function k(ae){const te=new E.$3d,Q=ae(te.token),ee=new Promise(($e,ve)=>{const Fe=te.token.onCancellationRequested(()=>{Fe.dispose(),te.dispose(),ve(new N.$5)});Promise.resolve(Q).then(le=>{Fe.dispose(),te.dispose(),$e(le)},le=>{Fe.dispose(),te.dispose(),ve(le)})});return new class{cancel(){te.cancel()}then($e,ve){return ee.then($e,ve)}catch($e){return this.then(void 0,$e)}finally($e){return ee.finally($e)}}}e.$Pg=k;function l(ae,te,Q){return new Promise((ee,$e)=>{const ve=te.onCancellationRequested(()=>{ve.dispose(),ee(Q)});ae.then(ee,$e).finally(()=>ve.dispose())})}e.$Qg=l;function p(ae,te){return new Promise((Q,ee)=>{const $e=te.onCancellationRequested(()=>{$e.dispose(),ee(new N.$5)});ae.then(Q,ee).finally(()=>$e.dispose())})}e.$Rg=p;async function b(ae){let te=-1;const Q=ae.map((ee,$e)=>ee.then(ve=>(te=$e,ve)));try{return await Promise.race(Q)}finally{ae.forEach((ee,$e)=>{$e!==te&&ee.cancel()})}}e.$Sg=b;function r(ae,te,Q){let ee;const $e=setTimeout(()=>{ee?.(void 0),Q?.()},te);return Promise.race([ae.finally(()=>clearTimeout($e)),new Promise(ve=>ee=ve)])}e.$Tg=r;function o(ae){return new Promise((te,Q)=>{const ee=ae();A(ee)?ee.then(te,Q):te(ee)})}e.$Ug=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(te){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=te,!this.b){const Q=()=>{if(this.b=null,this.f)return;const ee=this.queue(this.d);return this.d=null,ee};this.b=new Promise(ee=>{this.a.then(Q,Q).then(ee)})}return new Promise((Q,ee)=>{this.b.then(Q,ee)})}return this.a=te(),new Promise((Q,ee)=>{this.a.then($e=>{this.a=null,Q($e)},$e=>{this.a=null,ee($e)})})}dispose(){this.f=!0}}e.$Vg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(te){return this.a=this.a.then(()=>te(),()=>te())}}e.$Wg=n;class a{constructor(){this.a=new Map}queue(te,Q){const $e=(this.a.get(te)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(te)===$e&&this.a.delete(te)});return this.a.set(te,$e),$e}}e.$Xg=a;const c=(ae,te)=>{let Q=!0;const ee=setTimeout(()=>{Q=!1,te()},ae);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(ee),Q=!1}}},h=ae=>{let te=!0;return queueMicrotask(()=>{te&&(te=!1,ae())}),{isTriggered:()=>te,dispose:()=>{te=!1}}};class i{constructor(te){this.defaultDelay=te,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(te,Q=this.defaultDelay){this.g=te,this.h(),this.b||(this.b=new Promise(($e,ve)=>{this.d=$e,this.f=ve}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ee=()=>{this.a=null,this.d?.(null)};return this.a=Q===g.$Pd?h(ee):c(Q,ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Yg=i;class s{constructor(te){this.a=new i(te),this.b=new t}trigger(te,Q){return this.a.trigger(()=>this.b.queue(te),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Zg=s;class u{constructor(){this.a=!1,this.b=new Promise((te,Q)=>{this.d=te})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$1g=u;class d extends u{constructor(te){super(),this.f=setTimeout(()=>this.open(),te)}open(){clearTimeout(this.f),super.open()}}e.$2g=d;function v(ae,te){return te?new Promise((Q,ee)=>{const $e=setTimeout(()=>{ve.dispose(),Q()},ae),ve=te.onCancellationRequested(()=>{clearTimeout($e),ve.dispose(),ee(new N.$5)})}):k(Q=>v(ae,Q))}e.$3g=v;function f(ae,te=0,Q){const ee=setTimeout(()=>{ae(),Q&&$e.dispose()},te),$e=(0,L.$Qc)(()=>{clearTimeout(ee),Q?.deleteAndLeak($e)});return Q?.add($e),$e}e.$4g=f;function S(ae){const te=[];let Q=0;const ee=ae.length;function $e(){return Q<ee?ae[Q++]():null}function ve(Fe){Fe!=null&&te.push(Fe);const le=$e();return le?le.then(ve):Promise.resolve(te)}return Promise.resolve(null).then(ve)}e.$5g=S;function F(ae,te=ee=>!!ee,Q=null){let ee=0;const $e=ae.length,ve=()=>{if(ee>=$e)return Promise.resolve(Q);const Fe=ae[ee++];return Promise.resolve(Fe()).then(we=>te(we)?Promise.resolve(we):ve())};return ve()}e.$6g=F;function $(ae,te=ee=>!!ee,Q=null){if(ae.length===0)return Promise.resolve(Q);let ee=ae.length;const $e=()=>{ee=-1;for(const ve of ae)ve.cancel?.()};return new Promise((ve,Fe)=>{for(const le of ae)le.then(we=>{--ee>=0&&te(we)?($e(),ve(we)):ee===0&&ve(Q)}).catch(we=>{--ee>=0&&($e(),Fe(we))})})}e.$7g=$;class y{constructor(te){this.a=0,this.d=te,this.f=[],this.b=0,this.g=new I.$Sd}get onDrained(){return this.g.event}get size(){return this.a}queue(te){return this.a++,new Promise((Q,ee)=>{this.f.push({factory:te,c:Q,e:ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const te=this.f.shift();this.b++;const Q=te.factory();Q.then(te.c,te.e),Q.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$8g=y;class D extends y{constructor(){super(1)}}e.$9g=D;class M{constructor(){this.a=new Se,this.b=0}queue(te){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,te())):this.a.run(this.b++,te())}}e.$0g=M;class O{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const te=new ie;return this.b.add(te),te.p}g(){for(const[,te]of this.a)if(te.size>0)return!1;return!0}queueFor(te,Q=R.$tg){const ee=Q.getComparisonKey(te);let $e=this.a.get(ee);if(!$e){$e=new D;const ve=this.f++,Fe=I.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(ee),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new L.$2c),this.d.set(ve,Fe),this.a.set(ee,$e)}return $e}h(){this.g()&&this.j()}j(){for(const te of this.b)te.complete();this.b.clear()}dispose(){for(const[,te]of this.a)te.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$$g=O;class W{constructor(te,Q){this.a=-1,typeof te=="function"&&typeof Q=="number"&&this.setIfNotSet(te,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(te,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,te()},Q)}setIfNotSet(te,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,te()},Q))}}e.$_g=W;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(te,Q,ee=globalThis){this.cancel();const $e=ee.setInterval(()=>{te()},Q);this.d=(0,L.$Qc)(()=>{ee.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$ah=z;class q{constructor(te,Q){this.b=-1,this.a=te,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(te=this.d){this.cancel(),this.b=setTimeout(this.f,te)}get delay(){return this.d}set delay(te){this.d=te}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$bh=q;class C{constructor(te,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=te,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(te=this.b){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(te/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ch=C;class P extends q{constructor(te,Q){super(te,Q),this.j=[]}work(te){this.j.push(te),this.isScheduled()||this.schedule()}h(){const te=this.j;this.j=[],this.a?.(te)}dispose(){this.j=[],super.dispose()}}e.$dh=P;class J extends L.$Sc{constructor(te,Q){super(),this.g=te,this.h=Q,this.a=[],this.b=this.B(new L.$Tc),this.f=!1}get pending(){return this.a.length}work(te){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+te.length>this.g.maxBufferedWork)return!1}else if(this.pending+te.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of te)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$eh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$gh=(ae,te)=>{(0,m.$B)(()=>{if(Q)return;const ee=Date.now()+15;te(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ee-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$gh=(ae,te,Q)=>{const ee=ae.requestIdleCallback(te,typeof Q=="number"?{timeout:Q}:void 0);let $e=!1;return{dispose(){$e||($e=!0,ae.cancelIdleCallback(ee))}}},e.$fh=ae=>(0,e.$gh)(globalThis,ae)}();class ce{constructor(te,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(ee){this.l=ee}finally{this.g=!0}},this.f=(0,e.$gh)(te,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$hh=ce;class me extends ce{constructor(te){super(globalThis,te)}}e.$ih=me;async function be(ae,te,Q){let ee;for(let $e=0;$e<Q;$e++)try{return await ae()}catch(ve){ee=ve,await v(te)}throw ee}e.$jh=be;class Se{isRunning(te){return typeof te=="number"?this.a?.taskId===te:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(te,Q,ee){return this.a={taskId:te,cancel:()=>ee?.(),promise:Q},Q.then(()=>this.d(te),()=>this.d(te)),Q}d(te){this.a&&te===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const te=this.b;this.b=void 0,te.run().then(te.promiseResolve,te.promiseReject)}}queue(te){if(this.b)this.b.run=te;else{let Q,ee;const $e=new Promise((ve,Fe)=>{Q=ve,ee=Fe});this.b={run:te,promise:$e,promiseResolve:Q,promiseReject:ee}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$kh=Se;class he{constructor(te,Q=()=>Date.now()){this.d=te,this.f=Q,this.a=0,this.b=0}increment(){const te=this.f();return te-this.a>this.d&&(this.a=te,this.b=0),this.b++,this.b}}e.$lh=he;var fe;(function(ae){ae[ae.Resolved=0]="Resolved",ae[ae.Rejected=1]="Rejected"})(fe||(fe={}));class ie{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((te,Q)=>{this.a=te,this.b=Q})}complete(te){return new Promise(Q=>{this.a(te),this.d={outcome:0,value:te},Q()})}error(te){return new Promise(Q=>{this.b(te),this.d={outcome:1,value:te},Q()})}cancel(){return this.error(new N.$5)}}e.$mh=ie;var ke;(function(ae){async function te(ee){let $e;const ve=await Promise.all(ee.map(Fe=>Fe.then(le=>le,le=>{$e||($e=le)})));if(typeof $e<"u")throw $e;return ve}ae.settled=te;function Q(ee){return new Promise(async($e,ve)=>{try{await ee($e,ve)}catch(Fe){ve(Fe)}})}ae.withAsyncBody=Q})(ke||(e.Promises=ke={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(te){this.a=void 0,this.b=void 0,this.d=!1,this.promise=te.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$nh=oe;class Y{constructor(te){this.b=te,this.a=new w.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$oh=Y;var V;(function(ae){ae[ae.Initial=0]="Initial",ae[ae.DoneOK=1]="DoneOK",ae[ae.DoneError=2]="DoneError"})(V||(V={}));class ne{static fromArray(te){return new ne(Q=>{Q.emitMany(te)})}static fromPromise(te){return new ne(async Q=>{Q.emitMany(await te)})}static fromPromises(te){return new ne(async Q=>{await Promise.all(te.map(async ee=>Q.emitOne(await ee)))})}static merge(te){return new ne(async Q=>{await Promise.all(te.map(async ee=>{for await(const $e of ee)Q.emitOne($e)}))})}static{this.EMPTY=ne.fromArray([])}constructor(te){this.a=0,this.b=[],this.d=null,this.f=new I.$Sd,queueMicrotask(async()=>{const Q={emitOne:ee=>this.g(ee),emitMany:ee=>this.h(ee),reject:ee=>this.k(ee)};try{await Promise.resolve(te(Q)),this.j()}catch(ee){this.k(ee)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let te=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(te<this.b.length)return{done:!1,value:this.b[te++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(te,Q){return new ne(async ee=>{for await(const $e of te)ee.emitOne(Q($e))})}map(te){return ne.map(this,te)}static filter(te,Q){return new ne(async ee=>{for await(const $e of te)Q($e)&&ee.emitOne($e)})}filter(te){return ne.filter(this,te)}static coalesce(te){return ne.filter(te,Q=>!!Q)}coalesce(){return ne.coalesce(this)}static async toPromise(te){const Q=[];for await(const ee of te)Q.push(ee);return Q}toPromise(){return ne.toPromise(this)}g(te){this.a===0&&(this.b.push(te),this.f.fire())}h(te){this.a===0&&(this.b=this.b.concat(te),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(te){this.a===0&&(this.a=2,this.d=te,this.f.fire())}}e.$ph=ne;class Ie extends ne{constructor(te,Q){super(Q),this.l=te}cancel(){this.l.cancel()}}e.$qh=Ie;function Ae(ae){const te=new E.$3d,Q=ae(te.token);return new Ie(te,async ee=>{const $e=te.token.onCancellationRequested(()=>{$e.dispose(),te.dispose(),ee.reject(new N.$5)});try{for await(const ve of Q){if(te.token.isCancellationRequested)return;ee.emitOne(ve)}$e.dispose(),te.dispose()}catch(ve){$e.dispose(),te.dispose(),ee.reject(ve)}})}e.$rh=Ae;class Pe{constructor(){this.a=new ie,this.b=new ne(ee=>{if(te){ee.reject(te);return}return Q&&ee.emitMany(Q),this.d=$e=>ee.reject($e),this.f=$e=>ee.emitOne($e),this.a.p});let te,Q;this.f=ee=>{Q||(Q=[]),Q.push(ee)},this.d=ee=>{te||(te=ee)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(te){this.d(te),this.a.complete()}emitOne(te){this.f(te)}}e.$sh=Pe}),define(Ce[34],Re([1,0,18,14,46,28,19,21,12]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=void 0;function w(){return Object.create(null)}e.$Dj=w,e.$Ej="**",e.$Fj="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function p(me,be){switch(me){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${be?`|${A}${k}+`:""})*?`}}function b(me,be){if(!me)return[];const Se=[];let he=!1,fe=!1,ie="";for(const ke of me){switch(ke){case be:if(!he&&!fe){Se.push(ie),ie="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ie+=ke}return ie&&Se.push(ie),Se}e.$Gj=b;function r(me){if(!me)return"";let be="";const Se=b(me,e.$Fj);if(Se.every(he=>he===e.$Ej))be=".*";else{let he=!1;Se.forEach((fe,ie)=>{if(fe===e.$Ej){if(he)return;be+=p(2,ie===Se.length-1)}else{let ke=!1,oe="",Y=!1,V="";for(const ne of fe){if(ne!=="}"&&ke){oe+=ne;continue}if(Y&&(ne!=="]"||!V)){let Ie;ne==="-"?Ie=ne:(ne==="^"||ne==="!")&&!V?Ie="^":ne===e.$Fj?Ie="":Ie=(0,g.$Ke)(ne),V+=Ie;continue}switch(ne){case"{":ke=!0;continue;case"[":Y=!0;continue;case"}":{const Ae=`(?:${b(oe,",").map(Pe=>r(Pe)).join("|")})`;be+=Ae,ke=!1,oe="";break}case"]":{be+="["+V+"]",Y=!1,V="";break}case"?":be+=k;continue;case"*":be+=p(1);continue;default:be+=(0,g.$Ke)(ne)}}ie<Se.length-1&&(Se[ie+1]!==e.$Ej||ie+2<Se.length)&&(be+=A)}he=fe===e.$Ej})}return be}const o=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,a=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$Dc(1e4),s=function(){return!1},u=function(){return null};function d(me,be){if(!me)return u;let Se;typeof me!="string"?Se=me.pattern:Se=me,Se=Se.trim();const he=`${Se}_${!!be.trimForExclusions}`;let fe=i.get(he);if(fe)return v(fe,me);let ie;return o.test(Se)?fe=S(Se.substr(4),Se):(ie=t.exec(f(Se,be)))?fe=F(ie[1],Se):(be.trimForExclusions?a:n).test(Se)?fe=$(Se,be):(ie=c.exec(f(Se,be)))?fe=y(ie[1].substr(1),Se,!0):(ie=h.exec(f(Se,be)))?fe=y(ie[1],Se,!1):fe=D(Se),i.set(he,fe),v(fe,me)}function v(me,be){if(typeof be=="string")return me;const Se=function(he,fe){return(0,I.$4f)(he,be.base,!m.$k)?me((0,g.$Pe)(he.substr(be.base.length),R.sep),fe):null};return Se.allBasenames=me.allBasenames,Se.allPaths=me.allPaths,Se.basenames=me.basenames,Se.patterns=me.patterns,Se}function f(me,be){return be.trimForExclusions&&me.endsWith("/**")?me.substr(0,me.length-2):me}function S(me,be){return function(Se,he){return typeof Se=="string"&&Se.endsWith(me)?be:null}}function F(me,be){const Se=`/${me}`,he=`\\${me}`,fe=function(ke,oe){return typeof ke!="string"?null:oe?oe===me?be:null:ke===me||ke.endsWith(Se)||ke.endsWith(he)?be:null},ie=[me];return fe.basenames=ie,fe.patterns=[be],fe.allBasenames=ie,fe}function $(me,be){const Se=J(me.slice(1,-1).split(",").map(oe=>d(oe,be)).filter(oe=>oe!==u),me),he=Se.length;if(!he)return u;if(he===1)return Se[0];const fe=function(oe,Y){for(let V=0,ne=Se.length;V<ne;V++)if(Se[V](oe,Y))return me;return null},ie=Se.find(oe=>!!oe.allBasenames);ie&&(fe.allBasenames=ie.allBasenames);const ke=Se.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return ke.length&&(fe.allPaths=ke),fe}function y(me,be,Se){const he=R.sep===R.$gc.sep,fe=he?me:me.replace(l,R.sep),ie=R.sep+fe,ke=R.$gc.sep+me;let oe;return Se?oe=function(Y,V){return typeof Y=="string"&&(Y===fe||Y.endsWith(ie)||!he&&(Y===me||Y.endsWith(ke)))?be:null}:oe=function(Y,V){return typeof Y=="string"&&(Y===fe||!he&&Y===me)?be:null},oe.allPaths=[(Se?"*/":"./")+me],oe}function D(me){try{const be=new RegExp(`^${r(me)}$`);return function(Se){return be.lastIndex=0,typeof Se=="string"&&be.test(Se)?me:null}}catch{return u}}function M(me,be,Se){return!me||typeof be!="string"?!1:O(me)(be,void 0,Se)}e.$Hj=M;function O(me,be={}){if(!me)return s;if(typeof me=="string"||W(me)){const Se=d(me,be);if(Se===u)return s;const he=function(fe,ie){return!!Se(fe,ie)};return Se.allBasenames&&(he.allBasenames=Se.allBasenames),Se.allPaths&&(he.allPaths=Se.allPaths),he}return C(me,be)}e.$Ij=O;function W(me){const be=me;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Jj=W;function z(me){return me.allBasenames||[]}e.$Kj=z;function q(me){return me.allPaths||[]}e.$Lj=q;function C(me,be){const Se=J(Object.getOwnPropertyNames(me).map(oe=>P(oe,me[oe],be)).filter(oe=>oe!==u)),he=Se.length;if(!he)return u;if(!Se.some(oe=>!!oe.requiresSiblings)){if(he===1)return Se[0];const oe=function(ne,Ie){let Ae;for(let Pe=0,ae=Se.length;Pe<ae;Pe++){const te=Se[Pe](ne,Ie);if(typeof te=="string")return te;(0,N.$Og)(te)&&(Ae||(Ae=[]),Ae.push(te))}return Ae?(async()=>{for(const Pe of Ae){const ae=await Pe;if(typeof ae=="string")return ae}return null})():null},Y=Se.find(ne=>!!ne.allBasenames);Y&&(oe.allBasenames=Y.allBasenames);const V=Se.reduce((ne,Ie)=>Ie.allPaths?ne.concat(Ie.allPaths):ne,[]);return V.length&&(oe.allPaths=V),oe}const fe=function(oe,Y,V){let ne,Ie;for(let Ae=0,Pe=Se.length;Ae<Pe;Ae++){const ae=Se[Ae];ae.requiresSiblings&&V&&(Y||(Y=(0,R.$nc)(oe)),ne||(ne=Y.substr(0,Y.length-(0,R.$oc)(oe).length)));const te=ae(oe,Y,ne,V);if(typeof te=="string")return te;(0,N.$Og)(te)&&(Ie||(Ie=[]),Ie.push(te))}return Ie?(async()=>{for(const Ae of Ie){const Pe=await Ae;if(typeof Pe=="string")return Pe}return null})():null},ie=Se.find(oe=>!!oe.allBasenames);ie&&(fe.allBasenames=ie.allBasenames);const ke=Se.reduce((oe,Y)=>Y.allPaths?oe.concat(Y.allPaths):oe,[]);return ke.length&&(fe.allPaths=ke),fe}function P(me,be,Se){if(be===!1)return u;const he=d(me,Se);if(he===u)return u;if(typeof be=="boolean")return he;if(be){const fe=be.when;if(typeof fe=="string"){const ie=(ke,oe,Y,V)=>{if(!V||!he(ke,oe))return null;const ne=fe.replace("$(basename)",()=>Y),Ie=V(ne);return(0,N.$Og)(Ie)?Ie.then(Ae=>Ae?me:null):Ie?me:null};return ie.requiresSiblings=!0,ie}}return he}function J(me,be){const Se=me.filter(oe=>!!oe.basenames);if(Se.length<2)return me;const he=Se.reduce((oe,Y)=>{const V=Y.basenames;return V?oe.concat(V):oe},[]);let fe;if(be){fe=[];for(let oe=0,Y=he.length;oe<Y;oe++)fe.push(be)}else fe=Se.reduce((oe,Y)=>{const V=Y.patterns;return V?oe.concat(V):oe},[]);const ie=function(oe,Y){if(typeof oe!="string")return null;if(!Y){let ne;for(ne=oe.length;ne>0;ne--){const Ie=oe.charCodeAt(ne-1);if(Ie===47||Ie===92)break}Y=oe.substr(ne)}const V=he.indexOf(Y);return V!==-1?fe[V]:null};ie.basenames=he,ie.patterns=fe,ie.allBasenames=he;const ke=me.filter(oe=>!oe.basenames);return ke.push(ie),ke}function ce(me,be){return(0,E.$ub)(me,be,(Se,he)=>typeof Se=="string"&&typeof he=="string"?Se===he:typeof Se!="string"&&typeof he!="string"?Se.base===he.base&&Se.pattern===he.pattern:!1)}e.$Mj=ce}),define(Ce[52],Re([1,0,11,126,25,12,2]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(n="",a=!1){if(this.value=n,typeof this.value!="string")throw(0,E.$7)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(n,a=0){return this.value+=l(this.supportThemeIcons?(0,N.$0j)(n):n).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,a){return this.value+=`
${p(a,n)}
`,this}appendLink(n,a,c){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,a){const c=new RegExp((0,L.$Ke)(a),"g");return n.replace(c,(h,i)=>n.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$dk=g;function w(t){return A(t)?!t.value:Array.isArray(t)?t.every(w):!0}e.$ek=w;function A(t){return t instanceof g?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$fk=A;function k(t,n){return t===n?!0:!t||!n?!1:t.value===n.value&&t.isTrusted===n.isTrusted&&t.supportThemeIcons===n.supportThemeIcons&&t.supportHtml===n.supportHtml&&(t.baseUri===n.baseUri||!!t.baseUri&&!!n.baseUri&&(0,I.$wg)(R.URI.from(t.baseUri),R.URI.from(n.baseUri)))}e.$gk=k;function l(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$hk=l;function p(t,n){const a=t.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=a>=3?a+1:3;return[`${"`".repeat(c)}${n}`,t,`${"`".repeat(c)}`].join(`
`)}e.$ik=p;function b(t){return t.replace(/"/g,"&quot;")}e.$jk=b;function r(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$kk=r;function o(t){const n=[],a=t.split("|").map(h=>h.trim());t=a[0];const c=a[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),s=h?h[1]:"",u=i?i[1]:"",d=isFinite(parseInt(u)),v=isFinite(parseInt(s));d&&n.push(`width="${u}"`),v&&n.push(`height="${s}"`)}return{href:t,dimensions:n}}e.$lk=o}),define(Ce[95],Re([1,0,18,46,19,21,25,12]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=void 0;function g(d,v){const{os:f,tildify:S,relative:F}=v;if(F){const D=w(d,F,f);if(typeof D=="string")return D}let $=d.fsPath;if(f===1&&!L.$i?$=$.replace(/\//g,"\\"):f!==1&&L.$i&&($=$.replace(/\\/g,"/")),f!==1&&S?.userHome){const D=S.userHome.fsPath;let M;d.scheme!==S.userHome.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep?M=S.userHome.with({path:d.path}).fsPath:M=$,$=l(M,D,f)}return(f===1?I.$fc:I.$gc).normalize(A($,f===1))}e.$Hv=g;function w(d,v,f){const S=f===1?I.$fc:I.$gc,F=f===3?R.$tg:R.$vg,$=v.getWorkspace(),y=(0,E.$Ob)($.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===I.$gc.sep&&d.path[1]!==I.$gc.sep&&(d=y.uri.with({path:d.path}));const D=v.getWorkspaceFolder(d);if(!D)return;let M;if(F.isEqual(D.uri,d)?M="":M=F.relativePath(D.uri,d)??"",M&&(M=S.normalize(M)),$.folders.length>1&&!v.noPrefix){const O=D.name?D.name:F.basenameOrAuthority(D.uri);M=M?`${O} \u2022 ${M}`:O}return M}function A(d,v=L.$i){return(0,N.$8f)(d,v)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Iv=A;let k=Object.create(null);function l(d,v,f=L.OS){if(f===1||!d||!v)return d;let S=k.original===v?k.normalized:void 0;S||(S=v,L.$i&&(S=(0,N.$Xf)(S)),S=`${(0,m.$Qe)(S,I.$gc.sep)}${I.$gc.sep}`,k={original:v,normalized:S});let F=d;return L.$i&&(F=(0,N.$Xf)(F)),(f===3?F.startsWith(S):(0,m.$9e)(F,S))?`~/${F.substr(S.length)}`:d}e.$Jv=l;function p(d,v){return d.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Kv=p;const b="\u2026",r="\\\\",o="~";function t(d,v=I.sep){const f=new Array(d.length);let S=!1;for(let F=0;F<d.length;F++){const $=d[F];if($===""){f[F]=`.${v}`;continue}if(!$){f[F]=$;continue}S=!0;let y="",D=$;D.indexOf(r)===0?(y=D.substr(0,D.indexOf(r)+r.length),D=D.substr(D.indexOf(r)+r.length)):D.indexOf(v)===0?(y=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length)):D.indexOf(o)===0&&(y=D.substr(0,D.indexOf(o)+o.length),D=D.substr(D.indexOf(o)+o.length));const M=D.split(v);for(let O=1;S&&O<=M.length;O++)for(let W=M.length-O;S&&W>=0;W--){S=!1;let z=M.slice(W,W+O).join(v);for(let q=0;!S&&q<d.length;q++)if(q!==F&&d[q]&&d[q].indexOf(z)>-1){const C=W+O===M.length,P=W>0&&d[q].indexOf(v)>-1?v+z:z,J=d[q].endsWith(P);S=!C||J}if(!S){let q="";(M[0].endsWith(":")||y!=="")&&(W===1&&(W=0,O++,z=M[0]+v+z),W>0&&(q=M[0]+v),q=y+q),W>0&&(q=q+b+v),q=q+z,W+O<M.length&&(q=q+v+b),f[F]=q}}S&&(f[F]=$)}return f}e.$Lv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function a(d,v=Object.create(null)){const f=[];let S=!1,F="";for(const $ of d)if($==="$"||S&&$==="{")F&&f.push({value:F,type:n.TEXT}),F="",S=!0;else if($==="}"&&S){const y=v[F];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}F="",S=!1}else F+=$;return F&&!S&&f.push({value:F,type:n.TEXT}),f.filter(($,y)=>{if($.type===n.SEPARATOR){const D=f[y-1],M=f[y+1];return[D,M].every(O=>O&&(O.type===n.VARIABLE||O.type===n.TEXT)&&O.value.length>0)}return!0}).map($=>$.value).join("")}e.$Mv=a;function c(d,v){return L.$j||v?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Nv=c;function h(d,v){return L.$j||v?d.replace(/\(&&\w\)|&&/g,""):L.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Ov=h;function i(d){return d.replace(/&/g,"&&")}e.$Pv=i;function s(d){if(d.endsWith("]")){const v=d.lastIndexOf(" [",d.length-2);if(v!==-1){const f=u(d.substring(0,v));return{name:f.name,parentPath:f.parentPath+d.substring(v)}}}return u(d)}e.$Qv=s;function u(d){const v=d.indexOf("/")!==-1?I.$gc:I.$fc,f=v.basename(d),S=v.dirname(d);return f.length?{name:f,parentPath:S}:{name:S,parentPath:""}}}),define(Ce[139],Re([1,0,24,2]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=void 0;function I(k){return k.toJSON()}class L{constructor(l){this.a=l}transformIncoming(l){const p=this.a.transformIncoming(l);return p===l?l:I(N.URI.from(p))}transformOutgoing(l){const p=this.a.transformOutgoing(l);return p===l?l:I(N.URI.from(p))}transformOutgoingURI(l){const p=this.a.transformOutgoing(l);return p===l?l:N.URI.from(p)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Zm=L,e.$1m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function R(k,l,p){if(!k||p>200)return null;if(typeof k=="object"){if(k instanceof N.URI)return l.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const r=R(k[b],l,p+1);r!==null&&(k[b]=r)}}return null}function m(k,l){const p=R(k,l,0);return p===null?k:p}e.$2m=m;function g(k,l,p,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return p?N.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof E.$ge)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const o=g(k[r],l,p,b+1);o!==null&&(k[r]=o)}}return null}function w(k,l){const p=g(k,l,!1,0);return p===null?k:p}e.$3m=w;function A(k,l){const p=g(k,l,!0,0);return p===null?k:p}e.$4m=A}),define(Ce[140],Re([1,0,12,21,24]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=e.$Zs=void 0;let L;function R(){return L||(L=new TextDecoder("UTF-16LE")),L}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function A(){return w||(w=N.$D()?R():g()),w}e.$Zs=A;function k(b,r,o){const t=new Uint16Array(b.buffer,r,o);return o>0&&(t[0]===65279||t[0]===65534)?l(b,r,o):R().decode(t)}e.$1s=k;function l(b,r,o){const t=[];let n=0;for(let a=0;a<o;a++){const c=I.$ie(b,r);r+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class p{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||E.$_e(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let t=0;t<o;t++)this.b[this.d++]=r.charCodeAt(t)}}e.$2s=p}),define(Ce[141],Re([1,0,24,140]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=void 0;function I(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class L{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,A,k,l){this.oldPosition=w,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,A,k){const l=A.length;E.$le(w,l,k),k+=4;for(let p=0;p<l;p++)E.$je(w,A.charCodeAt(p),k),k+=2;return k}static d(w,A){const k=E.$ke(w,A);return A+=4,(0,N.$1s)(w,A,k)}writeSize(){return 4+4+L.a(this.oldText)+L.a(this.newText)}write(w,A){return E.$le(w,this.oldPosition,A),A+=4,E.$le(w,this.newPosition,A),A+=4,A=L.c(w,this.oldText,A),A=L.c(w,this.newText,A),A}static read(w,A,k){const l=E.$ke(w,A);A+=4;const p=E.$ke(w,A);A+=4;const b=L.d(w,A);A+=L.a(b);const r=L.d(w,A);return A+=L.a(r),k.push(new L(l,b,p,r)),A}}e.$3s=L;function R(g,w){return g===null||g.length===0?w:new m(g,w).compress()}e.$4s=R;class m{constructor(w,A){this.a=w,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,A=0,k=this.n(w),l=this.l(A);for(;w<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++w);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++w);continue}if(l.oldPosition<k.newPosition){const[t,n]=m.r(l,k.newPosition-l.oldPosition);this.k(t),l=n;continue}if(k.newPosition<l.oldPosition){const[t,n]=m.q(k,l.oldPosition-k.newPosition);this.m(t),k=n;continue}let r,o;if(l.oldEnd===k.newEnd)r=k,o=l,k=this.n(++w),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[t,n]=m.q(k,l.oldLength);r=t,o=l,k=n,l=this.l(++A)}else{const[t,n]=m.r(l,k.newLength);r=k,o=t,k=this.n(++w),l=n}this.d[this.e++]=new L(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const p=m.s(this.d);return m.t(p)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,A){return new L(A.oldPosition-w,A.oldText,A.newPosition,A.newText)}static p(w,A){return new L(A.oldPosition,A.oldText,A.newPosition+w,A.newText)}static q(w,A){const k=w.newText.substr(0,A),l=w.newText.substr(A);return[new L(w.oldPosition,w.oldText,w.newPosition,k),new L(w.oldEnd,"",w.newPosition+A,l)]}static r(w,A){const k=w.oldText.substr(0,A),l=w.oldText.substr(A);return[new L(w.oldPosition,k,w.newPosition,w.newText),new L(w.oldPosition+A,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const A=[];let k=0,l=w[0];for(let p=1;p<w.length;p++){const b=w[p];l.oldEnd===b.oldPosition?l=new L(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(A[k++]=l,l=b)}return A[k++]=l,A}static t(w){if(w.length===0)return w;const A=[];let k=0;for(let l=0;l<w.length;l++){const p=w[l];p.oldText!==p.newText&&(A[k++]=p)}return A}}}),define(Ce[142],Re([1,0,34,19]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ot=void 0;function I(L,R,m,g,w,A){if(Array.isArray(L)){let k=0;for(const l of L){const p=I(l,R,m,g,w,A);if(p===10)return p;p>k&&(k=p)}return k}else{if(typeof L=="string")return g?L==="*"?5:L===m?10:0:0;if(L){const{language:k,pattern:l,scheme:p,hasAccessToAllModels:b,notebookType:r}=L;if(!g&&!b)return 0;r&&w&&(R=w);let o=0;if(p)if(p===R.scheme)o=10;else if(p==="*")o=5;else return 0;if(k)if(k===m)o=10;else if(k==="*")o=Math.max(o,5);else return 0;if(r)if(r===A)o=10;else if(r==="*"&&A!==void 0)o=Math.max(o,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,N.$hc)(l.base)},t===R.fsPath||(0,E.$Hj)(t,R.fsPath))o=10;else return 0}return o}else return 0}}e.$ot=I}),define(Ce[143],Re([1,0,5,12,29,93,91,128,141,6]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WB=void 0;class A extends w.$Sc{constructor(l,p,b,r,o,t,n){super(),this.m=this.B(new E.$Sd),this.onDidChangeContent=this.m.event,this.f=p,this.j=!t,this.g=r,this.h=o,this.c=new R.$VB(l,b,n)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,p){return this.c.getOffsetAt(l,p)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,p){const b=l+p,r=this.getPositionAt(l),o=this.getPositionAt(b);return new I.$Hs(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(l,p=0){if(l.isEmpty())return"";const b=this.n(p);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,p=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const t=this.n(p),n=this.getEOL();if(t.length!==n.length){const a=t.length-n.length,c=l.endLineNumber-l.startLineNumber;o=a*c}return r-b+o}getCharacterCountInRange(l,p=0){if(this.j){let b=0;const r=l.startLineNumber,o=l.endLineNumber;for(let t=r;t<=o;t++){const n=this.getLineContent(t),a=t===r?l.startColumn-1:0,c=t===o?l.endColumn-1:n.length;for(let h=a;h<c;h++)N.$_e(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n(p).length*(o-r),b}return this.getValueLengthInRange(l,p)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,p){return this.c.getLineCharCode(l,p)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const p=N.$We(this.getLineContent(l));return p===-1?0:p+1}getLineLastNonWhitespaceColumn(l){const p=N.$Ye(this.getLineContent(l));return p===-1?0:p+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,p,b){let r=this.g,o=this.h,t=this.j,n=!0,a=[];for(let v=0;v<l.length;v++){const f=l[v];n&&f._isTracked&&(n=!1);const S=f.range;if(f.text){let M=!0;t||(M=!N.$kf(f.text),t=M),!r&&M&&(r=N.$jf(f.text)),!o&&M&&(o=N.$mf(f.text))}let F="",$=0,y=0,D=0;if(f.text){let M;[$,y,D,M]=(0,m.$ht)(f.text);const O=this.getEOL();M===0||M===(O===`\r
`?2:1)?F=f.text:F=f.text.replace(/\r\n|\r|\n/g,O)}a[v]={sortIndex:v,identifier:f.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:F,eolCount:$,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}a.sort(A.u);let c=!1;for(let v=0,f=a.length-1;v<f;v++){const S=a[v].range.getEndPosition(),F=a[v+1].range.getStartPosition();if(F.isBeforeOrEqual(S)){if(F.isBefore(S))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(a=this.s(a));const h=b||p?A._getInverseEditRanges(a):[],i=[];if(p)for(let v=0;v<a.length;v++){const f=a[v],S=h[v];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let F=S.startLineNumber;F<=S.endLineNumber;F++){let $="";F===S.startLineNumber&&($=this.getLineContent(f.range.startLineNumber),N.$We($)!==-1)||i.push({lineNumber:F,oldContent:$})}}let s=null;if(b){let v=0;s=[];for(let f=0;f<a.length;f++){const S=a[f],F=h[f],$=this.getValueInRange(S.range),y=S.rangeOffset+v;v+=S.text.length-$.length,s[f]={sortIndex:S.sortIndex,identifier:S.identifier,range:F,text:$,textChange:new g.$3s(S.rangeOffset,$,y,S.text)}}c||s.sort((f,S)=>f.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=t;const u=this.t(a);let d=null;if(p&&i.length>0){i.sort((v,f)=>f.lineNumber-v.lineNumber),d=[];for(let v=0,f=i.length;v<f;v++){const S=i[v].lineNumber;if(v>0&&i[v-1].lineNumber===S)continue;const F=i[v].oldContent,$=this.getLineContent(S);$.length===0||$===F||N.$We($)!==-1||d.push(S)}}return this.m.fire(),new L.$4u(s,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let p=!1;const b=l[0].range,r=l[l.length-1].range,o=new I.$Hs(b.startLineNumber,b.startColumn,r.endLineNumber,r.endColumn);let t=b.startLineNumber,n=b.startColumn;const a=[];for(let u=0,d=l.length;u<d;u++){const v=l[u],f=v.range;p=p||v.forceMoveMarkers,a.push(this.getValueInRange(new I.$Hs(t,n,f.startLineNumber,f.startColumn))),v.text.length>0&&a.push(v.text),t=f.endLineNumber,n=f.endColumn}const c=a.join(""),[h,i,s]=(0,m.$ht)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:s,forceMoveMarkers:p,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const p=[];for(let b=0;b<l.length;b++){const r=l[b],o=r.range.startLineNumber,t=r.range.startColumn,n=r.range.endLineNumber,a=r.range.endColumn;if(o===n&&t===a&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const c=new I.$Hs(o,t,n,a);p.push({range:c,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return p}findMatchesLineByLine(l,p,b,r){return this.c.findMatchesLineByLine(l,p,b,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,p){const b=l.startLineNumber,r=l.startColumn,[o,t,n]=(0,m.$ht)(p);let a;if(p.length>0){const c=o+1;c===1?a=new I.$Hs(b,r,b,r+t):a=new I.$Hs(b,r,b+c-1,n+1)}else a=new I.$Hs(b,r,b,r);return a}static _getInverseEditRanges(l){const p=[];let b=0,r=0,o=null;for(let t=0,n=l.length;t<n;t++){const a=l[t];let c,h;o?o.range.endLineNumber===a.range.startLineNumber?(c=b,h=r+(a.range.startColumn-o.range.endColumn)):(c=b+(a.range.startLineNumber-o.range.endLineNumber),h=a.range.startColumn):(c=a.range.startLineNumber,h=a.range.startColumn);let i;if(a.text.length>0){const s=a.eolCount+1;s===1?i=new I.$Hs(c,h,c,h+a.firstLineLength):i=new I.$Hs(c,h,c+s-1,a.lastLineLength+1)}else i=new I.$Hs(c,h,c,h);b=i.endLineNumber,r=i.endColumn,p.push(i),o=a}return p}static u(l,p){const b=I.$Hs.compareRangesUsingEnds(l.range,p.range);return b===0?l.sortIndex-p.sortIndex:b}static w(l,p){const b=I.$Hs.compareRangesUsingEnds(l.range,p.range);return b===0?p.sortIndex-l.sortIndex:-b}}e.$WB=A}),define(Ce[144],Re([1,0,12,91,143]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XB=void 0;class L{constructor(g,w,A,k,l,p,b,r,o){this.a=g,this.b=w,this.c=A,this.d=k,this.e=l,this.f=p,this.g=b,this.h=r,this.j=o}k(g){const w=this.c+this.d+this.e,A=this.c+this.e;return w===0?g===1?`
`:`\r
`:A>w/2?`\r
`:`
`}create(g){const w=this.k(g),A=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,p=A.length;l<p;l++){const b=A[l].buffer.replace(/\r\n|\r|\n/g,w),r=(0,N.$RB)(b);A[l]=new N.$UB(b,r)}const k=new I.$WB(A,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$sf(g)&&(this.b=E.$rf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,N.$SB)(this.e,g);this.a.push(new N.$UB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$jf(g)),this.k||(this.k=E.$mf(g)))}finish(g=!0){return this.o(),new L(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,N.$RB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$XB=R}),define(Ce[96],Re([1,0,24,21]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$=e.$h$=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function L(k){for(let l=0,p=k.length;l<p;l+=4){const b=k[l+0],r=k[l+1],o=k[l+2],t=k[l+3];k[l+0]=t,k[l+1]=o,k[l+2]=r,k[l+3]=b}}function R(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return N.$D()||L(l),E.$ge.wrap(l)}function m(k){const l=k.buffer;if(N.$D()||L(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const p=new Uint8Array(l.byteLength);return p.set(l),new Uint32Array(p.buffer,p.byteOffset,p.length/4)}}function g(k){const l=new Uint32Array(w(k));let p=0;if(l[p++]=k.id,k.type==="full")l[p++]=1,l[p++]=k.data.length,l.set(k.data,p),p+=k.data.length;else{l[p++]=2,l[p++]=k.deltas.length;for(const b of k.deltas)l[p++]=b.start,l[p++]=b.deleteCount,b.data?(l[p++]=b.data.length,l.set(b.data,p),p+=b.data.length):l[p++]=0}return R(l)}e.$h$=g;function w(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const p of k.deltas)p.data&&(l+=p.data.length)}return l}function A(k){const l=m(k);let p=0;const b=l[p++];if(l[p++]===1){const n=l[p++],a=l.subarray(p,p+n);return p+=n,{id:b,type:"full",data:a}}const o=l[p++],t=[];for(let n=0;n<o;n++){const a=l[p++],c=l[p++],h=l[p++];let i;h>0&&(i=l.subarray(p,p+h),p+=h),t[n]={start:a,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$i$=A}),define(Ce[145],Re([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[146],Re([1,0,18,26,21,129,147,145]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowAiIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=w;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}compute(_,pe,Be){return Be}}class l{constructor(_,pe){this.newValue=_,this.didChange=pe}}e.ApplyUpdateResult=l;function p(X,_){if(typeof X!="object"||typeof _!="object"||!X||!_)return new l(_,X!==_);if(Array.isArray(X)||Array.isArray(_)){const Be=Array.isArray(X)&&Array.isArray(_)&&E.$ub(X,_);return new l(_,!Be)}let pe=!1;for(const Be in _)if(_.hasOwnProperty(Be)){const Qe=p(X[Be],_[Be]);Qe.didChange&&(X[Be]=Qe.newValue,pe=!0)}return new l(X,pe)}class b{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,pe){return p(_,pe)}validate(_){return this.defaultValue}}class r{constructor(_,pe,Be,Qe){this.id=_,this.name=pe,this.defaultValue=Be,this.schema=Qe}applyUpdate(_,pe){return p(_,pe)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,pe,Be){return Be}}function o(X,_){return typeof X>"u"?_:X==="false"?!1:!!X}e.boolean=o;class t extends r{constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return o(_,this.defaultValue)}}function n(X,_,pe,Be){if(typeof X>"u")return _;let Qe=parseInt(X,10);return isNaN(Qe)?_:(Qe=Math.max(pe,Qe),Qe=Math.min(Be,Qe),Qe|0)}e.clampedInt=n;class a extends r{static clampedInt(_,pe,Be,Qe){return n(_,pe,Be,Qe)}constructor(_,pe,Be,Qe,tt,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=Be,nt.minimum=Qe,nt.maximum=tt),super(_,pe,Be,nt),this.minimum=Qe,this.maximum=tt}validate(_){return a.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function c(X,_,pe,Be){if(typeof X>"u")return _;const Qe=h.float(X,_);return h.clamp(Qe,pe,Be)}e.clampedFloat=c;class h extends r{static clamp(_,pe,Be){return _<pe?pe:_>Be?Be:_}static float(_,pe){if(typeof _=="number")return _;if(typeof _>"u")return pe;const Be=parseFloat(_);return isNaN(Be)?pe:Be}constructor(_,pe,Be,Qe,tt){typeof tt<"u"&&(tt.type="number",tt.default=Be),super(_,pe,Be,tt),this.validationFn=Qe}validate(_){return this.validationFn(h.float(_,this.defaultValue))}}class i extends r{static string(_,pe){return typeof _!="string"?pe:_}constructor(_,pe,Be,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Be),super(_,pe,Be,Qe)}validate(_){return i.string(_,this.defaultValue)}}function s(X,_,pe,Be){return typeof X!="string"?_:Be&&X in Be?Be[X]:pe.indexOf(X)===-1?_:X}e.stringSet=s;class u extends r{constructor(_,pe,Be,Qe,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Qe,tt.default=Be),super(_,pe,Be,tt),this.c=Qe}validate(_){return s(_,this.defaultValue,this.c)}}class d extends k{constructor(_,pe,Be,Qe,tt,nt,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=tt,Ne.default=Qe),super(_,pe,Be,Ne),this.c=tt,this.d=nt}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function v(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(_){switch(_){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(_,pe,Be){return Be===0?_.accessibilitySupport:Be}}class S extends k{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:m.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertSpace:o(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var F;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(F||(e.TextEditorCursorBlinkingStyle=F={}));function $(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(X){switch(X){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function M(X){switch(X){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class O extends b{constructor(){super(140)}compute(_,pe,Be){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),_.extraEditorClassName&&Qe.push(_.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class W extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(_,pe,Be){return Be&&_.emptySelectionClipboard}}class z extends k{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:m.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{cursorMoveOnType:o(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":s(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":s(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(pe.loop,this.defaultValue.loop)}}}class q extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?q.OFF:_==="true"?q.ON:_:_?q.ON:q.OFF}}e.EditorFontLigatures=q;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?C.OFF:_==="true"?C.TRANSLATE:_:_?C.TRANSLATE:C.OFF}compute(_,pe,Be){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class P extends b{constructor(){super(50)}compute(_,pe,Be){return _.fontInfo}}class J extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(_){const pe=h.float(_,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(pe,6,100)}compute(_,pe,Be){return _.fontInfo.fontSize}}class ce extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ce.d,maximum:ce.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ce.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(a.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,ce.d,ce.e))}}class me extends k{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{multiple:s(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??s(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??s(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??s(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??s(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??s(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends k{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:m.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),delay:a.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:o(pe.sticky,this.defaultValue.sticky),hidingDelay:a.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o(pe.above,this.defaultValue.above)}}}var Se;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(Se||(e.RenderMinimap=Se={}));class he extends b{constructor(){super(143)}compute(_,pe,Be){return he.computeLayout(pe,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const pe=_.height/_.lineHeight,Be=Math.floor(_.paddingTop/_.lineHeight);let Qe=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const tt=(Be+_.viewLineCount+Qe)/(_.pixelRatio*_.height),nt=Math.floor(_.viewLineCount/tt);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Qe,desiredRatio:tt,minimapLineCount:nt}}static c(_,pe){const Be=_.outerWidth,Qe=_.outerHeight,tt=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const nt=pe.stableMinimapLayoutInput,Ne=nt&&_.outerHeight===nt.outerHeight&&_.lineHeight===nt.lineHeight&&_.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&_.pixelRatio===nt.pixelRatio&&_.scrollBeyondLastLine===nt.scrollBeyondLastLine&&_.paddingTop===nt.paddingTop&&_.paddingBottom===nt.paddingBottom&&_.minimap.enabled===nt.minimap.enabled&&_.minimap.side===nt.minimap.side&&_.minimap.size===nt.minimap.size&&_.minimap.showSlider===nt.minimap.showSlider&&_.minimap.renderCharacters===nt.minimap.renderCharacters&&_.minimap.maxColumn===nt.minimap.maxColumn&&_.minimap.scale===nt.minimap.scale&&_.verticalScrollbarWidth===nt.verticalScrollbarWidth&&_.isViewportWrapping===nt.isViewportWrapping,It=_.lineHeight,Ft=_.typicalHalfwidthCharacterWidth,Kt=_.scrollBeyondLastLine,Ut=_.minimap.renderCharacters;let wt=tt>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const qt=_.minimap.maxColumn,Mt=_.minimap.size,Qt=_.minimap.side,Ot=_.verticalScrollbarWidth,Ct=_.viewLineCount,Ye=_.remainingWidth,Ht=_.isViewportWrapping,Gt=Ut?2:3;let ut=Math.floor(tt*Qe);const mt=ut/tt;let jt=!1,Bt=!1,Et=Gt*wt,ht=wt/tt,Pt=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Lt,extraLinesBeyondLastLine:Ee,desiredRatio:Me,minimapLineCount:de}=he.computeContainedMinimapLineCount({viewLineCount:Ct,scrollBeyondLastLine:Kt,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Qe,lineHeight:It,pixelRatio:tt});if(Ct/de>1)jt=!0,Bt=!0,wt=1,Et=1,ht=wt/tt;else{let Le=!1,Ue=wt+1;if(Mt==="fit"){const Ze=Math.ceil((Lt+Ct+Ee)*Et);Ht&&Ne&&Ye<=pe.stableFitRemainingWidth?(Le=!0,Ue=pe.stableFitMaxMinimapScale):Le=Ze>ut}if(Mt==="fill"||Le){jt=!0;const Ze=wt;Et=Math.min(It*tt,Math.max(1,Math.floor(1/Me))),Ht&&Ne&&Ye<=pe.stableFitRemainingWidth&&(Ue=pe.stableFitMaxMinimapScale),wt=Math.min(Ue,Math.max(1,Math.floor(Et/Gt))),wt>Ze&&(Pt=Math.min(2,wt/Ze)),ht=wt/tt/Pt,ut=Math.ceil(Math.max(ft,Lt+Ct+Ee)*Et),Ht?(pe.stableMinimapLayoutInput=_,pe.stableFitRemainingWidth=Ye,pe.stableFitMaxMinimapScale=wt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const Yt=Math.floor(qt*ht),Dt=Math.min(Yt,Math.max(0,Math.floor((Ye-Ot-2)*ht/(Ft+ht)))+e.MINIMAP_GUTTER_WIDTH);let qe=Math.floor(tt*Dt);const At=qe/tt;qe=Math.floor(qe*Pt);const Wt=Ut?1:2,Jt=Qt==="left"?0:Be-Dt-Ot;return{renderMinimap:Wt,minimapLeft:Jt,minimapWidth:Dt,minimapHeightIsEditorHeight:jt,minimapIsSampling:Bt,minimapScale:wt,minimapLineHeight:Et,minimapCanvasInnerWidth:qe,minimapCanvasInnerHeight:ut,minimapCanvasOuterWidth:At,minimapCanvasOuterHeight:mt}}static computeLayout(_,pe){const Be=pe.outerWidth|0,Qe=pe.outerHeight|0,tt=pe.lineHeight|0,nt=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,It=pe.maxDigitWidth,Ft=pe.pixelRatio,Kt=pe.viewLineCount,Ut=_.get(135),wt=Ut==="inherit"?_.get(134):Ut,qt=wt==="inherit"?_.get(130):wt,Mt=_.get(133),Qt=pe.isDominatedByLongLines,Ot=_.get(57),Ct=_.get(67).renderType!==0,Ye=_.get(68),Ht=_.get(104),Gt=_.get(83),ut=_.get(72),mt=_.get(102),jt=mt.verticalScrollbarSize,Bt=mt.verticalHasArrows,Et=mt.arrowSize,ht=mt.horizontalScrollbarSize,Pt=_.get(43),Yt=_.get(109)!=="never";let Dt=_.get(65);Pt&&Yt&&(Dt+=16);let qe=0;if(Ct){const _e=Math.max(nt,Ye);qe=Math.round(_e*It)}let At=0;Ot&&(At=tt*pe.glyphMarginDecorationLaneCount);let Wt=0,Jt=Wt+At,ft=Jt+qe,Lt=ft+Dt;const Ee=Be-At-qe-Dt;let Me=!1,de=!1,G=-1;wt==="inherit"&&Qt?(Me=!0,de=!0):qt==="on"||qt==="bounded"?de=!0:qt==="wordWrapColumn"&&(G=Mt);const Le=he.c({outerWidth:Be,outerHeight:Qe,lineHeight:tt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Ft,scrollBeyondLastLine:Ht,paddingTop:Gt.top,paddingBottom:Gt.bottom,minimap:ut,verticalScrollbarWidth:jt,viewLineCount:Kt,remainingWidth:Ee,isViewportWrapping:de},pe.memory||new A);Le.renderMinimap!==0&&Le.minimapLeft===0&&(Wt+=Le.minimapWidth,Jt+=Le.minimapWidth,ft+=Le.minimapWidth,Lt+=Le.minimapWidth);const Ue=Ee-Le.minimapWidth,Ze=Math.max(1,Math.floor((Ue-jt-2)/Ne)),Ve=Bt?Et:0;return de&&(G=Math.max(1,Ze),qt==="bounded"&&(G=Math.min(G,Mt))),{width:Be,height:Qe,glyphMarginLeft:Wt,glyphMarginWidth:At,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Jt,lineNumbersWidth:qe,decorationsLeft:ft,decorationsWidth:Dt,contentLeft:Lt,contentWidth:Ue,minimap:Le,viewportColumn:Ze,isWordWrapMinified:Me,isViewportWrapping:de,wrappingColumn:G,verticalScrollbarWidth:jt,horizontalScrollbarHeight:ht,overviewRuler:{top:Ve,width:jt,height:Qe-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=he;class fe extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(_){return s(_,"simple",["simple","advanced"])}compute(_,pe,Be){return pe.get(2)===2?"advanced":Be}}var ie;(function(X){X.Off="off",X.OnCode="onCode",X.On="on"})(ie||(e.ShowAiIconMode=ie={}));class ke extends k{constructor(){const _={enabled:!0,experimental:{showAiIcon:ie.Off}};super(64,"lightbulb",_,{"editor.lightbulb.enabled":{type:"boolean",default:_.enabled,description:m.localize(50,null)},"editor.lightbulb.experimental.showAiIcon":{type:"string",enum:[ie.Off,ie.OnCode,ie.On],default:_.experimental.showAiIcon,enumDescriptions:[m.localize(51,null),m.localize(52,null),m.localize(53,null)],description:m.localize(54,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),experimental:{showAiIcon:s(pe.experimental?.showAiIcon,this.defaultValue.experimental?.showAiIcon,[ie.Off,ie.OnCode,ie.On])}}}}class oe extends k{constructor(){const _={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:m.localize(55,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:10,description:m.localize(56,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:m.localize(57,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:m.localize(58,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),maxLineCount:a.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class Y extends k{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:m.localize(59,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(60,null),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(63,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:m.localize(64,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:m.localize(65,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:m.localize(66,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:s(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:a.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(pe.fontFamily,this.defaultValue.fontFamily),padding:o(pe.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):a.clampedInt(_,this.defaultValue,0,1e3)}compute(_,pe,Be){return Be<0?a.clampedInt(-Be*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class ne extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>h.clamp(_,0,150),{markdownDescription:m.localize(67,null)})}compute(_,pe,Be){return _.fontInfo.lineHeight}}class Ie extends k{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:m.localize(68,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:m.localize(69,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(70,null),m.localize(71,null),m.localize(72,null)],default:_.size,description:m.localize(73,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:m.localize(74,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:m.localize(75,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(76,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:m.localize(77,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:m.localize(78,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),autohide:o(pe.autohide,this.defaultValue.autohide),size:s(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(pe.side,this.defaultValue.side,["right","left"]),showSlider:s(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(pe.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(pe.scale,1,1,3),maxColumn:a.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ae(X){return X==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(80,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{top:a.clampedInt(pe.top,0,0,1e3),bottom:a.clampedInt(pe.bottom,0,0,1e3)}}}class ae extends k{constructor(){const _={enabled:!0,cycle:!0};super(85,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:m.localize(81,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:m.localize(82,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),cycle:o(pe.cycle,this.defaultValue.cycle)}}}class te extends b{constructor(){super(141)}compute(_,pe,Be){return _.pixelRatio}}class Q extends k{constructor(){const _={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(83,null),m.localize(84,null),m.localize(85,null)]}];super(88,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:_.strings,description:m.localize(86,null)},comments:{anyOf:pe,default:_.comments,description:m.localize(87,null)},other:{anyOf:pe,default:_.other,description:m.localize(88,null)}},default:_,markdownDescription:m.localize(89,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const Ft=_?"on":"off";return{comments:Ft,strings:Ft,other:Ft}}if(!_||typeof _!="object")return this.defaultValue;const{other:pe,comments:Be,strings:Qe}=_,tt=["on","inline","off"];let nt,Ne,It;return typeof pe=="boolean"?nt=pe?"on":"off":nt=s(pe,this.defaultValue.other,tt),typeof Be=="boolean"?Ne=Be?"on":"off":Ne=s(Be,this.defaultValue.comments,tt),typeof Qe=="boolean"?It=Qe?"on":"off":It=s(Qe,this.defaultValue.strings,tt),{other:nt,comments:Ne,strings:It}}}var ee;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class $e extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(90,null),m.localize(91,null),m.localize(92,null),m.localize(93,null)],default:"on",description:m.localize(94,null)})}validate(_){let pe=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(pe=4,Be=_):_==="interval"?pe=3:_==="relative"?pe=2:_==="on"?pe=1:pe=0),{renderType:pe,renderFn:Be}}}function ve(X){const _=X.get(97);return _==="editable"?X.get(90):_!=="on"}e.filterValidationDecorations=ve;class Fe extends k{constructor(){const _=[],pe={type:"number",description:m.localize(95,null)};super(101,"rulers",_,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(96,null),format:"color-hex"}}}]},default:_,description:m.localize(97,null)})}validate(_){if(Array.isArray(_)){const pe=[];for(const Be of _)if(typeof Be=="number")pe.push({column:a.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Qe=Be;pe.push({column:a.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Be,Qe)=>Be.column-Qe.column),pe}return this.defaultValue}}class le extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function we(X,_){if(typeof X!="string")return _;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class T extends k{constructor(){const _={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(102,null),m.localize(103,null),m.localize(104,null)],default:"auto",description:m.localize(105,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:m.localize(107,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:m.localize(108,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:m.localize(109,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_,Be=a.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=a.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:we(pe.vertical,this.defaultValue.vertical),horizontal:we(pe.horizontal,this.defaultValue.horizontal),useShadows:o(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:a.clampedInt(pe.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:a.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:o(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class K extends k{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:m.localize(114,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:m.localize(115,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:m.localize(116,null)}})}applyUpdate(_,pe){let Be=!1;pe.allowedCharacters&&_&&(N.$mn(_.allowedCharacters,pe.allowedCharacters)||(_={..._,allowedCharacters:pe.allowedCharacters},Be=!0)),pe.allowedLocales&&_&&(N.$mn(_.allowedLocales,pe.allowedLocales)||(_={..._,allowedLocales:pe.allowedLocales},Be=!0));const Qe=super.applyUpdate(_,pe);return Be?new l(Qe.newValue,!0):Qe}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{nonBasicASCII:x(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:x(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:x(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,pe){if(typeof _!="object"||!_)return pe;const Be={};for(const[Qe,tt]of Object.entries(_))tt===!0&&(Be[Qe]=!0);return Be}}class H extends k{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:m.localize(117,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(118,null),m.localize(119,null),m.localize(120,null)],description:m.localize(121,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:m.localize(122,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),mode:s(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o(pe.keepOnBlur,this.defaultValue.keepOnBlur)}}}class U extends k{constructor(){const _={enabled:L.$es.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$es.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Z extends k{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:_.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:_.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:_.highlightActiveIndentation,description:m.localize(138,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{bracketPairs:x(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:x(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:x(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function x(X,_,pe){const Be=pe.indexOf(X);return Be===-1?_:pe[Be]}class ye extends k{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:_.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:_.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{insertMode:s(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o(pe.showIcons,this.defaultValue.showIcons),showStatusBar:o(pe.showStatusBar,this.defaultValue.showStatusBar),preview:o(pe.preview,this.defaultValue.preview),previewMode:s(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(pe.showMethods,this.defaultValue.showMethods),showFunctions:o(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:o(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o(pe.showFields,this.defaultValue.showFields),showVariables:o(pe.showVariables,this.defaultValue.showVariables),showClasses:o(pe.showClasses,this.defaultValue.showClasses),showStructs:o(pe.showStructs,this.defaultValue.showStructs),showInterfaces:o(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:o(pe.showModules,this.defaultValue.showModules),showProperties:o(pe.showProperties,this.defaultValue.showProperties),showEvents:o(pe.showEvents,this.defaultValue.showEvents),showOperators:o(pe.showOperators,this.defaultValue.showOperators),showUnits:o(pe.showUnits,this.defaultValue.showUnits),showValues:o(pe.showValues,this.defaultValue.showValues),showConstants:o(pe.showConstants,this.defaultValue.showConstants),showEnums:o(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:o(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(pe.showKeywords,this.defaultValue.showKeywords),showWords:o(pe.showWords,this.defaultValue.showWords),showColors:o(pe.showColors,this.defaultValue.showColors),showFiles:o(pe.showFiles,this.defaultValue.showFiles),showReferences:o(pe.showReferences,this.defaultValue.showReferences),showFolders:o(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:o(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(pe.showSnippets,this.defaultValue.showSnippets),showUsers:o(pe.showUsers,this.defaultValue.showUsers),showIssues:o(pe.showIssues,this.defaultValue.showIssues)}}}class Te extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(_.selectSubwords,this.defaultValue.selectSubwords)}}}var We;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(We||(e.WrappingIndent=We={}));class He extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(_){switch(_){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(_,pe,Be){return pe.get(2)===2?0:Be}}class Xe extends b{constructor(){super(144)}compute(_,pe,Be){const Qe=pe.get(143);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class rt extends k{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),showDropSelector:s(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends k{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const pe=_;return{enabled:o(pe.enabled,this.defaultValue.enabled),showPasteSelector:s(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const et="Consolas, 'Courier New', monospace",ot="Menlo, Monaco, 'Courier New', monospace",at="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?ot:I.$k?at:et,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ze(X){return e.editorOptionsRegistry[X.id]=X,X}var pt;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.ariaRequired=5]="ariaRequired",X[X.autoClosingBrackets=6]="autoClosingBrackets",X[X.autoClosingComments=7]="autoClosingComments",X[X.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",X[X.autoClosingDelete=9]="autoClosingDelete",X[X.autoClosingOvertype=10]="autoClosingOvertype",X[X.autoClosingQuotes=11]="autoClosingQuotes",X[X.autoIndent=12]="autoIndent",X[X.automaticLayout=13]="automaticLayout",X[X.autoSurround=14]="autoSurround",X[X.bracketPairColorization=15]="bracketPairColorization",X[X.guides=16]="guides",X[X.codeLens=17]="codeLens",X[X.codeLensFontFamily=18]="codeLensFontFamily",X[X.codeLensFontSize=19]="codeLensFontSize",X[X.colorDecorators=20]="colorDecorators",X[X.colorDecoratorsLimit=21]="colorDecoratorsLimit",X[X.columnSelection=22]="columnSelection",X[X.comments=23]="comments",X[X.contextmenu=24]="contextmenu",X[X.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",X[X.cursorBlinking=26]="cursorBlinking",X[X.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",X[X.cursorStyle=28]="cursorStyle",X[X.cursorSurroundingLines=29]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",X[X.cursorWidth=31]="cursorWidth",X[X.disableLayerHinting=32]="disableLayerHinting",X[X.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",X[X.domReadOnly=34]="domReadOnly",X[X.dragAndDrop=35]="dragAndDrop",X[X.dropIntoEditor=36]="dropIntoEditor",X[X.emptySelectionClipboard=37]="emptySelectionClipboard",X[X.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",X[X.extraEditorClassName=39]="extraEditorClassName",X[X.fastScrollSensitivity=40]="fastScrollSensitivity",X[X.find=41]="find",X[X.fixedOverflowWidgets=42]="fixedOverflowWidgets",X[X.folding=43]="folding",X[X.foldingStrategy=44]="foldingStrategy",X[X.foldingHighlight=45]="foldingHighlight",X[X.foldingImportsByDefault=46]="foldingImportsByDefault",X[X.foldingMaximumRegions=47]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=49]="fontFamily",X[X.fontInfo=50]="fontInfo",X[X.fontLigatures=51]="fontLigatures",X[X.fontSize=52]="fontSize",X[X.fontWeight=53]="fontWeight",X[X.fontVariations=54]="fontVariations",X[X.formatOnPaste=55]="formatOnPaste",X[X.formatOnType=56]="formatOnType",X[X.glyphMargin=57]="glyphMargin",X[X.gotoLocation=58]="gotoLocation",X[X.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",X[X.hover=60]="hover",X[X.inDiffEditor=61]="inDiffEditor",X[X.inlineSuggest=62]="inlineSuggest",X[X.letterSpacing=63]="letterSpacing",X[X.lightbulb=64]="lightbulb",X[X.lineDecorationsWidth=65]="lineDecorationsWidth",X[X.lineHeight=66]="lineHeight",X[X.lineNumbers=67]="lineNumbers",X[X.lineNumbersMinChars=68]="lineNumbersMinChars",X[X.linkedEditing=69]="linkedEditing",X[X.links=70]="links",X[X.matchBrackets=71]="matchBrackets",X[X.minimap=72]="minimap",X[X.mouseStyle=73]="mouseStyle",X[X.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=75]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",X[X.multiCursorModifier=77]="multiCursorModifier",X[X.multiCursorPaste=78]="multiCursorPaste",X[X.multiCursorLimit=79]="multiCursorLimit",X[X.occurrencesHighlight=80]="occurrencesHighlight",X[X.overviewRulerBorder=81]="overviewRulerBorder",X[X.overviewRulerLanes=82]="overviewRulerLanes",X[X.padding=83]="padding",X[X.pasteAs=84]="pasteAs",X[X.parameterHints=85]="parameterHints",X[X.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",X[X.quickSuggestions=88]="quickSuggestions",X[X.quickSuggestionsDelay=89]="quickSuggestionsDelay",X[X.readOnly=90]="readOnly",X[X.readOnlyMessage=91]="readOnlyMessage",X[X.renameOnType=92]="renameOnType",X[X.renderControlCharacters=93]="renderControlCharacters",X[X.renderFinalNewline=94]="renderFinalNewline",X[X.renderLineHighlight=95]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=97]="renderValidationDecorations",X[X.renderWhitespace=98]="renderWhitespace",X[X.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",X[X.roundedSelection=100]="roundedSelection",X[X.rulers=101]="rulers",X[X.scrollbar=102]="scrollbar",X[X.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=104]="scrollBeyondLastLine",X[X.scrollPredominantAxis=105]="scrollPredominantAxis",X[X.selectionClipboard=106]="selectionClipboard",X[X.selectionHighlight=107]="selectionHighlight",X[X.selectOnLineNumbers=108]="selectOnLineNumbers",X[X.showFoldingControls=109]="showFoldingControls",X[X.showUnused=110]="showUnused",X[X.snippetSuggestions=111]="snippetSuggestions",X[X.smartSelect=112]="smartSelect",X[X.smoothScrolling=113]="smoothScrolling",X[X.stickyScroll=114]="stickyScroll",X[X.stickyTabStops=115]="stickyTabStops",X[X.stopRenderingLineAfter=116]="stopRenderingLineAfter",X[X.suggest=117]="suggest",X[X.suggestFontSize=118]="suggestFontSize",X[X.suggestLineHeight=119]="suggestLineHeight",X[X.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",X[X.suggestSelection=121]="suggestSelection",X[X.tabCompletion=122]="tabCompletion",X[X.tabIndex=123]="tabIndex",X[X.unicodeHighlighting=124]="unicodeHighlighting",X[X.unusualLineTerminators=125]="unusualLineTerminators",X[X.useShadowDOM=126]="useShadowDOM",X[X.useTabStops=127]="useTabStops",X[X.wordBreak=128]="wordBreak",X[X.wordSeparators=129]="wordSeparators",X[X.wordWrap=130]="wordWrap",X[X.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=133]="wordWrapColumn",X[X.wordWrapOverride1=134]="wordWrapOverride1",X[X.wordWrapOverride2=135]="wordWrapOverride2",X[X.wrappingIndent=136]="wrappingIndent",X[X.wrappingStrategy=137]="wrappingStrategy",X[X.showDeprecated=138]="showDeprecated",X[X.inlayHints=139]="inlayHints",X[X.editorClassName=140]="editorClassName",X[X.pixelRatio=141]="pixelRatio",X[X.tabFocusMode=142]="tabFocusMode",X[X.layoutInfo=143]="layoutInfo",X[X.wrappingInfo=144]="wrappingInfo",X[X.defaultColorDecorators=145]="defaultColorDecorators",X[X.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",X[X.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(pt||(e.EditorOption=pt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ze(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:ze(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:ze(new f),accessibilityPageSize:ze(new a(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:ze(new i(4,"ariaLabel",m.localize(206,null))),ariaRequired:ze(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ze(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:ze(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:ze(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:ze(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:ze(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:ze(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:ze(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:ze(new t(13,"automaticLayout",!1)),autoSurround:ze(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:ze(new U),bracketPairGuides:ze(new Z),stickyTabStops:ze(new t(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:ze(new t(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:ze(new i(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:ze(new a(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:ze(new t(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:ze(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:ze(new a(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:ze(new t(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:ze(new S),contextmenu:ze(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:ze(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:ze(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],$,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:ze(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:ze(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],M,{description:m.localize(248,null)})),cursorSurroundingLines:ze(new a(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:ze(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:ze(new a(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:ze(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:ze(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:ze(new t(34,"domReadOnly",!1)),dragAndDrop:ze(new t(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:ze(new W),dropIntoEditor:ze(new rt),stickyScroll:ze(new oe),experimentalWhitespaceRendering:ze(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:ze(new i(39,"extraEditorClassName","")),fastScrollSensitivity:ze(new h(40,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:m.localize(259,null)})),find:ze(new z),fixedOverflowWidgets:ze(new t(42,"fixedOverflowWidgets",!1)),folding:ze(new t(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:ze(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:ze(new t(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:ze(new t(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:ze(new a(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:ze(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:ze(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:ze(new P),fontLigatures2:ze(new q),fontSize:ze(new J),fontWeight:ze(new ce),fontVariations:ze(new C),formatOnPaste:ze(new t(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:ze(new t(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:ze(new t(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:ze(new me),hideCursorInOverviewRuler:ze(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:ze(new be),inDiffEditor:ze(new t(61,"inDiffEditor",!1)),letterSpacing:ze(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>h.clamp(X,-5,20),{description:m.localize(273,null)})),lightbulb:ze(new ke),lineDecorationsWidth:ze(new V),lineHeight:ze(new ne),lineNumbers:ze(new $e),lineNumbersMinChars:ze(new a(68,"lineNumbersMinChars",5,1,300)),linkedEditing:ze(new t(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:ze(new t(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:ze(new u(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:ze(new Ie),mouseStyle:ze(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ze(new h(74,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:ze(new t(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(278,null)})),multiCursorMergeOverlapping:ze(new t(76,"multiCursorMergeOverlapping",!0,{description:m.localize(279,null)})),multiCursorModifier:ze(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ae,{markdownEnumDescriptions:[m.localize(280,null),m.localize(281,null)],markdownDescription:m.localize(282,null)})),multiCursorPaste:ze(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null)],markdownDescription:m.localize(285,null)})),multiCursorLimit:ze(new a(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(286,null)})),occurrencesHighlight:ze(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(287,null),m.localize(288,null),m.localize(289,null)],markdownDescription:m.localize(290,null)})),overviewRulerBorder:ze(new t(81,"overviewRulerBorder",!0,{description:m.localize(291,null)})),overviewRulerLanes:ze(new a(82,"overviewRulerLanes",3,0,3)),padding:ze(new Pe),pasteAs:ze(new it),parameterHints:ze(new ae),peekWidgetDefaultFocus:ze(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(292,null),m.localize(293,null)],description:m.localize(294,null)})),definitionLinkOpensInPeek:ze(new t(87,"definitionLinkOpensInPeek",!1,{description:m.localize(295,null)})),quickSuggestions:ze(new Q),quickSuggestionsDelay:ze(new a(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(296,null)})),readOnly:ze(new t(90,"readOnly",!1)),readOnlyMessage:ze(new le),renameOnType:ze(new t(92,"renameOnType",!1,{description:m.localize(297,null),markdownDeprecationMessage:m.localize(298,null)})),renderControlCharacters:ze(new t(93,"renderControlCharacters",!0,{description:m.localize(299,null),restricted:!0})),renderFinalNewline:ze(new u(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(300,null)})),renderLineHighlight:ze(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(301,null)],description:m.localize(302,null)})),renderLineHighlightOnlyWhenFocus:ze(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(303,null)})),renderValidationDecorations:ze(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ze(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(304,null),m.localize(305,null),m.localize(306,null),""],description:m.localize(307,null)})),revealHorizontalRightPadding:ze(new a(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ze(new t(100,"roundedSelection",!0,{description:m.localize(308,null)})),rulers:ze(new Fe),scrollbar:ze(new T),scrollBeyondLastColumn:ze(new a(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(309,null)})),scrollBeyondLastLine:ze(new t(104,"scrollBeyondLastLine",!0,{description:m.localize(310,null)})),scrollPredominantAxis:ze(new t(105,"scrollPredominantAxis",!0,{description:m.localize(311,null)})),selectionClipboard:ze(new t(106,"selectionClipboard",!0,{description:m.localize(312,null),included:I.$k})),selectionHighlight:ze(new t(107,"selectionHighlight",!0,{description:m.localize(313,null)})),selectOnLineNumbers:ze(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:ze(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(314,null),m.localize(315,null),m.localize(316,null)],description:m.localize(317,null)})),showUnused:ze(new t(110,"showUnused",!0,{description:m.localize(318,null)})),showDeprecated:ze(new t(138,"showDeprecated",!0,{description:m.localize(319,null)})),inlayHints:ze(new Y),snippetSuggestions:ze(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(320,null),m.localize(321,null),m.localize(322,null),m.localize(323,null)],description:m.localize(324,null)})),smartSelect:ze(new Te),smoothScrolling:ze(new t(113,"smoothScrolling",!1,{description:m.localize(325,null)})),stopRenderingLineAfter:ze(new a(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ze(new ye),inlineSuggest:ze(new H),inlineCompletionsAccessibilityVerbose:ze(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(326,null)})),suggestFontSize:ze(new a(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(327,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ze(new a(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ze(new t(120,"suggestOnTriggerCharacters",!0,{description:m.localize(329,null)})),suggestSelection:ze(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabCompletion:ze(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),tabIndex:ze(new a(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:ze(new K),unusualLineTerminators:ze(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(338,null),m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),useShadowDOM:ze(new t(126,"useShadowDOM",!0)),useTabStops:ze(new t(127,"useTabStops",!0,{description:m.localize(342,null)})),wordBreak:ze(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null)],description:m.localize(345,null)})),wordSeparators:ze(new i(129,"wordSeparators",R.$fs,{description:m.localize(346,null)})),wordWrap:ze(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(347,null),m.localize(348,null),m.localize(349,null),m.localize(350,null)],description:m.localize(351,null)})),wordWrapBreakAfterCharacters:ze(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ze(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ze(new a(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(352,null)})),wordWrapOverride1:ze(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ze(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ze(new O),defaultColorDecorators:ze(new t(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(353,null)})),pixelRatio:ze(new te),tabFocusMode:ze(new t(142,"tabFocusMode",!1,{markdownDescription:m.localize(354,null)})),layoutInfo:ze(new he),wrappingInfo:ze(new Xe),wrappingIndent:ze(new He),wrappingStrategy:ze(new fe)}}),define(Ce[148],Re([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[149],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[150],Re([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[151],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[152],Re([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[153],Re([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[154],Re([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[155],Re([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[156],Re([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[157],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ce[158],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[159],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[160],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[161],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[162],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[163],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[164],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[165],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[166],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[167],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[168],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[169],Re([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[170],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[171],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[172],Re([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[173],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[174],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[175],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[176],Re([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[177],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[178],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[179],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[180],Re([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[181],Re([1,0,11,150]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.TokenType=void 0;var I;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...w){switch(w.length){case 1:return(0,N.localize)(0,null,w[0]);case 2:return(0,N.localize)(1,null,w[0],w[1]);case 3:return(0,N.localize)(2,null,w[0],w[1],w[2]);default:return}}const R=(0,N.localize)(3,null),m=(0,N.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,E.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),p={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push(p)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=g.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const b=this.c.charCodeAt(A);if(k)k=!1;else if(b===47&&!l){A++;break}else b===91?l=!0:b===92?k=!0:b===93&&(l=!1);A++}for(;A<this.c.length&&g.a.has(this.c.charCodeAt(A));)A++;this.e=A;const p=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$Wi=g}),define(Ce[182],Re([1,0,25,31,152,294]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=e.$Zo=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||R.test(t)}e.$Zo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(R);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$1o=w;function A(t){if(!t)return null;const n=t.majorBase,a=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let s=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),s=!1);let u=0;if(t.preRelease){const d=m.exec(t.preRelease);if(d){const[,v,f,S]=d;u=Date.UTC(Number(v),Number(f)-1,Number(S))}}return{majorBase:n,majorMustEqual:a,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:s,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$2o=A;function k(t,n,a){let c;typeof t=="string"?c=A(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof a=="string"?i=A(w(a)):i=a,!c||!i)return!1;const s=c.majorBase,u=c.minorBase,d=c.patchBase;let v=i.majorBase,f=i.minorBase,S=i.patchBase;const F=i.notBefore;let $=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?s>v?!0:s<v?!1:u>f?!0:u<f||h&&h<F?!1:d>=S:(s===1&&v===0&&(!$||!y||!D)&&(v=1,f=0,S=0,$=!0,y=!1,D=!1),s<v?!1:s>v?!$:u<f?!1:u>f?!y:d<S?!1:d>S?!D:!(h&&h<F))}e.$3o=k;function l(t,n,a,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,I.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,I.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,I.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,I.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([N.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([N.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,I.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,I.localize(9,null,"main")]),i;{const d=(0,E.$Dg)(a,c.main);(0,E.$xg)(d,a)||i.push([N.default.Warning,I.localize(10,null,d.path,a.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,I.localize(11,null,"browser")]),i;{const d=(0,E.$Dg)(a,c.browser);(0,E.$xg)(d,a)||i.push([N.default.Warning,I.localize(12,null,d.path,a.path)])}}if(!L.valid(c.version))return i.push([N.default.Error,I.localize(13,null)]),i;const s=[];if(!p(t,n,c,h,s))for(const d of s)i.push([N.default.Error,d]);return i}e.$4o=l;function p(t,n,a,c,h){return c||typeof a.main>"u"&&typeof a.browser>"u"?!0:r(t,n,a.engines.vscode,h)}e.$5o=p;function b(t,n,a){return t==="*"||r(n,a,t)}e.$6o=b;function r(t,n,a,c=[]){const h=A(w(a));if(!h)return c.push(I.localize(14,null,a)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(I.localize(15,null,a)),!1}else if(!h.majorMustEqual)return c.push(I.localize(16,null,a)),!1;return k(t,n,h)?!0:(c.push(I.localize(17,null,t,a)),!1)}function o(t){if(!Array.isArray(t))return!1;for(let n=0,a=t.length;n<a;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Ce[69],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=void 0;class E{constructor(I,L=[],R=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.$Yh=E}),define(Ce[70],Re([1,0,69]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.InstantiationType=void 0;const N=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L(m,g,w){g instanceof E.$Yh||(g=new E.$Yh(g,[],!!w)),N.push([m,g])}e.$Kr=L;function R(){return N}e.$Lr=R}),define(Ce[183],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0;class E{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$pq=E;class N{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const m=this.lookupOrInsertNode(L),g=this.lookupOrInsertNode(R);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const m of this.a.values())m.outgoing.delete(R),m.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let m=this.a.get(R);return m||(m=new E(R,L),this.a.set(R,m)),m}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,m]of this.a)L.push(`${R}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const m=new Set([L]),g=this.c(R,m);if(g)return g}}c(L,R){for(const[m,g]of L.outgoing){if(R.has(m))return[...R,m].join(" -> ");R.add(m);const w=this.c(g,R);if(w)return w;R.delete(m)}}}e.$qq=N}),define(Ce[4],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=e.$2h=e.$1h=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=m})(E||(e._util=E={})),e.$1h=I("instantiationService");function N(R,m,g){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:R,index:g}):(m[E.DI_DEPENDENCIES]=[{id:R,index:g}],m[E.DI_TARGET]=m)}function I(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const m=function(g,w,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(m,g,A)};return m.toString=()=>R,E.serviceIds.set(R,m),m}e.$2h=I;function L(R){return R}e.$3h=L}),define(Ce[41],Re([1,0,16,2,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.ConfigurationTarget=e.$xi=e.$wi=e.$vi=void 0,e.$vi=(0,I.$2h)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof N.URI)}e.$wi=L;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof N.URI)}e.$xi=R;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$yi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$zi=w;function A(t,n){const a=Object.create(null);for(const c in t)k(a,c,t[c],n);return a}e.$Ai=A;function k(t,n,a,c){const h=n.split("."),i=h.pop();let s=t;for(let u=0;u<h.length;u++){const d=h[u];let v=s[d];switch(typeof v){case"undefined":v=s[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}s=v}if(typeof s=="object"&&s!==null)try{s[i]=a}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$Bi=k;function l(t,n){const a=n.split(".");p(t,a)}e.$Ci=l;function p(t,n){const a=n.shift();if(n.length===0){delete t[a];return}if(Object.keys(t).indexOf(a)!==-1){const c=t[a];typeof c=="object"&&!Array.isArray(c)&&(p(c,n),Object.keys(c).length===0&&delete t[a])}}function b(t,n,a){function c(s,u){let d=s;for(const v of u){if(typeof d!="object"||d===null)return;d=d[v]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?a:i}e.$Di=b;function r(t,n,a){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Gf(t[c])&&E.$Gf(n[c])?r(t[c],n[c],a):a&&(t[c]=n[c]):t[c]=n[c])})}e.$Ei=r;function o(t){return t.replace(/[\[\]]/g,"")}e.$Fi=o}),define(Ce[35],Re([1,0,21,12,181,4,149,11]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.ContextKeyExprType=e.$Xi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(Y,V){if(g.get(Y)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(Y,V)}e.$Xi=w;const A=Object.prototype.hasOwnProperty;var k;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},p=(0,R.localize)(0,null),b=(0,R.localize)(1,null),r=(0,R.localize)(2,null),o=(0,R.localize)(3,null),t=(0,R.localize)(4,null),n=(0,R.localize)(5,null),a=(0,R.localize)(6,null),c=(0,R.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$Wi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ie=this.D(),Ae=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:I.$Wi.getLexeme(Ie),additionalInfo:Ae}),h.c}return ne}catch(ne){if(ne!==h.c)throw ne;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ne=this.o();V.push(ne)}return V.length===1?V[0]:i.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ne=this.s();V.push(ne)}return V.length===1?V[0]:i.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,o),ne?.negate()}case 17:return this.z(),M.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const ne=this.l();return this.A(1,o),ne}case 17:{const ne=V.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Pe=Ae.lexeme,ae=Pe.lastIndexOf("/"),te=ae===Pe.length-1?void 0:this.w(Pe.substring(ae+1));let Q;try{Q=new RegExp(Pe.substring(1,ae),te)}catch{throw this.B("REGEX",Ae)}return P.create(ne,Q)}switch(Ae.type){case 10:case 19:{const Pe=[Ae.lexeme];this.z();let ae=this.D(),te=0;for(let Fe=0;Fe<Ae.lexeme.length;Fe++)Ae.lexeme.charCodeAt(Fe)===40?te++:Ae.lexeme.charCodeAt(Fe)===41&&te--;for(;!this.E()&&ae.type!==15&&ae.type!==16;){switch(ae.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let Fe=0;Fe<ae.lexeme.length;Fe++)ae.lexeme.charCodeAt(Fe)===40?te++:Ae.lexeme.charCodeAt(Fe)===41&&te--}if(te<0)break;Pe.push(I.$Wi.getLexeme(ae)),this.z(),ae=this.D()}const Q=Pe.join(""),ee=Q.lastIndexOf("/"),$e=ee===Q.length-1?void 0:this.w(Q.substring(ee+1));let ve;try{ve=new RegExp(Q.substring(1,ee),$e)}catch{throw this.B("REGEX",Ae)}return i.regex(ne,ve)}case 18:{const Pe=Ae.lexeme;this.z();let ae=null;if(!(0,N.$Ge)(Pe)){const te=Pe.indexOf("/"),Q=Pe.lastIndexOf("/");if(te!==Q&&te>=0){const ee=Pe.slice(te+1,Q),$e=Pe[Q+1]==="i"?"i":"";try{ae=new RegExp(ee,$e)}catch{throw this.B("REGEX",Ae)}}}if(ae===null)throw this.B("REGEX",Ae);return P.create(ne,ae)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Ae=this.u();return i.notIn(ne,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(ne,Ae);switch(Ae){case"true":return i.has(ne);case"false":return i.not(ne);default:return i.equals(ne,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(ne,Ae);switch(Ae){case"true":return i.not(ne);case"false":return i.has(ne);default:return i.notEquals(ne,Ae)}}case 5:return this.z(),q.create(ne,this.u());case 6:return this.z(),C.create(ne,this.u());case 7:return this.z(),W.create(ne,this.u());case 8:return this.z(),z.create(ne,this.u());case 13:return this.z(),i.in(ne,this.u());default:return i.has(ne)}}case 20:throw this.h.push({message:a,offset:V.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ne){if(this.C(V))return this.z();throw this.B(ne,this.D())}B(V,ne,Ie){const Ae=(0,R.localize)(8,null,V,I.$Wi.getLexeme(ne)),Pe=ne.offset,ae=I.$Wi.getLexeme(ne);return this.h.push({message:Ae,offset:Pe,lexeme:ae,additionalInfo:Ie}),h.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Yi=h;class i{static false(){return v.INSTANCE}static true(){return f.INSTANCE}static has(V){return S.create(V)}static equals(V,ne){return F.create(V,ne)}static notEquals(V,ne){return D.create(V,ne)}static regex(V,ne){return P.create(V,ne)}static in(V,ne){return $.create(V,ne)}static notIn(V,ne){return y.create(V,ne)}static not(V){return M.create(V)}static and(...V){return me.create(V,null,!0)}static or(...V){return be.create(V,null,!0)}static greater(V,ne){return W.create(V,ne)}static greaterEquals(V,ne){return z.create(V,ne)}static smaller(V,ne){return q.create(V,ne)}static smallerEquals(V,ne){return C.create(V,ne)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$Zi=i;function s(Y){const V=new h({regexParsingWithErrorRecovery:!1});return Y.map(ne=>(V.parse(ne),V.lexingErrors.length>0?V.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,R.localize)(9,null,Ie.additionalInfo):(0,R.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$1i=s;function u(Y,V){const ne=Y?Y.substituteConstants():void 0,Ie=V?V.substituteConstants():void 0;return!ne&&!Ie?!0:!ne||!Ie?!1:ne.equals(Ie)}e.$2i=u;function d(Y,V){return Y.cmp(V)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return f.INSTANCE}}e.$3i=v;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return v.INSTANCE}}e.$4i=f;class S{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?f.INSTANCE:v.INSTANCE:new S(V,ne)}constructor(V,ne){this.key=V,this.c=ne,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:he(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=g.get(this.key);return typeof V=="boolean"?V?f.INSTANCE:v.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$5i=S;class F{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?S.create(V,Ie):M.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?f.INSTANCE:v.INSTANCE:new F(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?f.INSTANCE:v.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$6i=F;class ${static create(V,ne){return new $(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.f),Ie=V.getValue(this.d);return Array.isArray(ne)?ne.includes(Ie):typeof Ie=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$7i=$;class y{static create(V,ne){return new y(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=11,this.c=$.create(V,ne)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$8i=y;class D{static create(V,ne,Ie=null){if(typeof ne=="boolean")return ne?M.create(V,Ie):S.create(V,Ie);const Ae=g.get(V);return typeof Ae=="boolean"?ne===(Ae?"true":"false")?v.INSTANCE:f.INSTANCE:new D(V,ne,Ie)}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=g.get(this.c);if(typeof V=="boolean"){const ne=V?"true":"false";return this.d===ne?v.INSTANCE:f.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$9i=D;class M{static create(V,ne=null){const Ie=g.get(V);return typeof Ie=="boolean"?Ie?v.INSTANCE:f.INSTANCE:new M(V,ne)}constructor(V,ne){this.c=V,this.d=ne,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:he(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=g.get(this.c);return typeof V=="boolean"?V?v.INSTANCE:f.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=S.create(this.c,this)),this.d}}e.$0i=M;function O(Y,V){if(typeof Y=="string"){const ne=parseFloat(Y);isNaN(ne)||(Y=ne)}return typeof Y=="string"||typeof Y=="number"?V(Y):v.INSTANCE}class W{static create(V,ne,Ie=null){return O(ne,Ae=>new W(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$$i=W;class z{static create(V,ne,Ie=null){return O(ne,Ae=>new z(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$_i=z;class q{static create(V,ne,Ie=null){return O(ne,Ae=>new q(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$aj=q;class C{static create(V,ne,Ie=null){return O(ne,Ae=>new C(V,Ae,Ie))}constructor(V,ne,Ie){this.c=V,this.d=ne,this.f=Ie,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:fe(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$bj=C;class P{static create(V,ne){return new P(V,ne)}constructor(V,ne){this.d=V,this.f=ne,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return ne<Ie?-1:ne>Ie?1:0}equals(V){if(V.type===this.type){const ne=this.f?this.f.source:"",Ie=V.f?V.f.source:"";return this.d===V.d&&ne===Ie}return!1}substituteConstants(){return this}evaluate(V){const ne=V.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=J.create(this)),this.c}}e.$cj=P;class J{static create(V){return new J(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new J(this.c.map(V))}negate(){return this.c}}e.$dj=J;function ce(Y){let V=null;for(let ne=0,Ie=Y.length;ne<Ie;ne++){const Ae=Y[ne].substituteConstants();if(Y[ne]!==Ae&&V===null){V=[];for(let Pe=0;Pe<ne;Pe++)V[Pe]=Y[Pe]}V!==null&&(V[ne]=Ae)}return V===null?Y:V}class me{static create(V,ne,Ie){return me.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],V.expr[ne]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ce(this.expr);return V===this.expr?this:me.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].evaluate(V))return!1;return!0}static d(V,ne,Ie){const Ae=[];let Pe=!1;for(const ae of V)if(ae){if(ae.type===1){Pe=!0;continue}if(ae.type===0)return v.INSTANCE;if(ae.type===6){Ae.push(...ae.expr);continue}Ae.push(ae)}if(Ae.length===0&&Pe)return f.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(d);for(let ae=1;ae<Ae.length;ae++)Ae[ae-1].equals(Ae[ae])&&(Ae.splice(ae,1),ae--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const ae=Ae[Ae.length-1];if(ae.type!==9)break;Ae.pop();const te=Ae.pop(),Q=Ae.length===0,ee=be.create(ae.expr.map($e=>me.create([$e,te],null,Ie)),null,Q);ee&&(Ae.push(ee),Ae.sort(d))}if(Ae.length===1)return Ae[0];if(Ie){for(let ae=0;ae<Ae.length;ae++)for(let te=ae+1;te<Ae.length;te++)if(Ae[ae].negate().equals(Ae[te]))return v.INSTANCE;if(Ae.length===1)return Ae[0]}return new me(Ae,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new me(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());this.c=be.create(V,this,!0)}return this.c}}e.$ej=me;class be{static create(V,ne,Ie){return be.d(V,ne,Ie)}constructor(V,ne){this.expr=V,this.c=ne,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++){const Ae=d(this.expr[ne],V.expr[ne]);if(Ae!==0)return Ae}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(!this.expr[ne].equals(V.expr[ne]))return!1;return!0}return!1}substituteConstants(){const V=ce(this.expr);return V===this.expr?this:be.create(V,this.c,!1)}evaluate(V){for(let ne=0,Ie=this.expr.length;ne<Ie;ne++)if(this.expr[ne].evaluate(V))return!0;return!1}static d(V,ne,Ie){let Ae=[],Pe=!1;if(V){for(let ae=0,te=V.length;ae<te;ae++){const Q=V[ae];if(Q){if(Q.type===0){Pe=!0;continue}if(Q.type===1)return f.INSTANCE;if(Q.type===9){Ae=Ae.concat(Q.expr);continue}Ae.push(Q)}}if(Ae.length===0&&Pe)return v.INSTANCE;Ae.sort(d)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let ae=1;ae<Ae.length;ae++)Ae[ae-1].equals(Ae[ae])&&(Ae.splice(ae,1),ae--);if(Ae.length===1)return Ae[0];if(Ie){for(let ae=0;ae<Ae.length;ae++)for(let te=ae+1;te<Ae.length;te++)if(Ae[ae].negate().equals(Ae[te]))return f.INSTANCE;if(Ae.length===1)return Ae[0]}return new be(Ae,ne)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ne of this.expr)V.push(...ne.keys());return V}map(V){return new be(this.expr.map(ne=>ne.map(V)),null)}negate(){if(!this.c){const V=[];for(const ne of this.expr)V.push(ne.negate());for(;V.length>1;){const ne=V.shift(),Ie=V.shift(),Ae=[];for(const Pe of oe(ne))for(const ae of oe(Ie))Ae.push(me.create([Pe,ae],null,!1));V.unshift(be.create(Ae,null,!1))}this.c=be.create(V,this,!0)}return this.c}}e.$fj=be;class Se extends S{static{this.d=[]}static all(){return Se.d.values()}constructor(V,ne,Ie){super(V,null),this.f=ne,typeof Ie=="object"?Se.d.push({...Ie,key:V}):Ie!==!0&&Se.d.push({key:V,description:Ie,type:ne!=null?typeof ne:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return F.create(this.key,V)}notEqualsTo(V){return D.create(this.key,V)}}e.$gj=Se,e.$hj=(0,L.$2h)("contextKeyService");function he(Y,V){return Y<V?-1:Y>V?1:0}function fe(Y,V,ne,Ie){return Y<ne?-1:Y>ne?1:V<Ie?-1:V>Ie?1:0}function ie(Y,V){if(Y.type===0||V.type===1)return!0;if(Y.type===9)return V.type===9?ke(Y.expr,V.expr):!1;if(V.type===9){for(const ne of V.expr)if(ie(Y,ne))return!0;return!1}if(Y.type===6){if(V.type===6)return ke(V.expr,Y.expr);for(const ne of Y.expr)if(ie(ne,V))return!0;return!1}return Y.equals(V)}e.$ij=ie;function ke(Y,V){let ne=0,Ie=0;for(;ne<Y.length&&Ie<V.length;){const Ae=Y[ne].cmp(V[Ie]);if(Ae<0)return!1;Ae===0&&ne++,Ie++}return ne===Y.length}function oe(Y){return Y.type===9?Y.expr:[Y]}}),define(Ce[184],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=void 0,e.$9h=(0,E.$2h)("environmentService"),e.$0h=(0,E.$3h)(e.$9h)}),define(Ce[97],Re([1,0,151,4]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$lo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0,e.$_n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$ao=new RegExp(e.$_n),e.$bo="__web_extension",e.$co="skipWalkthrough",e.$do="extensionsSync",e.$eo="dependecyOrPackExtensionInstall";function I(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$fo=I;function L(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$go=L;function R(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$ho=R;function m(t,n){return n==="web"&&!t.includes("web")}e.$io=m;function g(t,n,a){return m(n,a)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===a}e.$jo=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$ko=w;var A;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var p;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$lo=(0,N.$2h)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var r;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class o extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$mo=o,e.$no=(0,N.$2h)("extensionManagementService"),e.$oo="extensionsIdentifiers/disabled",e.$po="extensionsIdentifiers/enabled",e.$qo=(0,N.$2h)("IGlobalExtensionEnablementService"),e.$ro=(0,N.$2h)("IExtensionTipsService"),e.$so=(0,E.localize)(0,null),e.$to={value:e.$so,original:"Extensions"},e.$uo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Ce[42],Re([1,0,50,19,12,16,2,153,4,21,13,39]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.FileKind=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.FileOperationResult=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.FileChangeType=e.$Ek=e.FileOperation=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileSystemProviderErrorCode=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.FileSystemProviderCapabilities=e.$ok=e.FilePermission=e.FileType=e.$nk=e.$mk=void 0,e.$mk=(0,g.$2h)("fileService");function l(ie){return ie.create===!0}e.$nk=l;var p;(function(ie){ie[ie.Unknown=0]="Unknown",ie[ie.File=1]="File",ie[ie.Directory=2]="Directory",ie[ie.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var b;(function(ie){ie[ie.Readonly=1]="Readonly",ie[ie.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function r(ie){const ke=ie;return!!ke&&typeof ke.onDidChange=="function"}e.$ok=r;var o;(function(ie){ie[ie.None=0]="None",ie[ie.FileReadWrite=2]="FileReadWrite",ie[ie.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ie[ie.FileReadStream=16]="FileReadStream",ie[ie.FileFolderCopy=8]="FileFolderCopy",ie[ie.PathCaseSensitive=1024]="PathCaseSensitive",ie[ie.Readonly=2048]="Readonly",ie[ie.Trash=4096]="Trash",ie[ie.FileWriteUnlock=8192]="FileWriteUnlock",ie[ie.FileAtomicRead=16384]="FileAtomicRead",ie[ie.FileAtomicWrite=32768]="FileAtomicWrite",ie[ie.FileAtomicDelete=65536]="FileAtomicDelete",ie[ie.FileClone=131072]="FileClone"})(o||(e.FileSystemProviderCapabilities=o={}));function t(ie){return!!(ie.capabilities&2)}e.$pk=t;function n(ie){return!!(ie.capabilities&8)}e.$qk=n;function a(ie){return!!(ie.capabilities&131072)}e.$rk=a;function c(ie){return!!(ie.capabilities&4)}e.$sk=c;function h(ie){return!!(ie.capabilities&16)}e.$tk=h;function i(ie){return t(ie)?!!(ie.capabilities&16384):!1}e.$uk=i;function s(ie){return t(ie)?!!(ie.capabilities&32768):!1}e.$vk=s;function u(ie){return!!(ie.capabilities&65536)}e.$wk=u;function d(ie){return!!(ie.capabilities&2048)}e.$xk=d;var v;(function(ie){ie.FileExists="EntryExists",ie.FileNotFound="EntryNotFound",ie.FileNotADirectory="EntryNotADirectory",ie.FileIsADirectory="EntryIsADirectory",ie.FileExceedsStorageQuota="EntryExceedsStorageQuota",ie.FileTooLarge="EntryTooLarge",ie.FileWriteLocked="EntryWriteLocked",ie.NoPermissions="NoPermissions",ie.Unavailable="Unavailable",ie.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(ke,oe){const Y=new f(ke.toString(),oe);return $(Y,oe),Y}constructor(ke,oe){super(ke),this.code=oe}}e.$yk=f;function S(ie,ke){return f.create(ie,ke)}e.$zk=S;function F(ie){return ie||S((0,m.localize)(0,null),v.Unknown)}e.$Ak=F;function $(ie,ke){return ie.name=ke?`${ke} (FileSystemError)`:"FileSystemError",ie}e.$Bk=$;function y(ie){if(!ie)return v.Unknown;if(ie instanceof f)return ie.code;const ke=/^(.+) \(FileSystemError\)$/.exec(ie.name);if(!ke)return v.Unknown;switch(ke[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$Ck=y;function D(ie){if(ie instanceof C)return ie.fileOperationResult;switch(y(ie)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$Dk=D;var M;(function(ie){ie[ie.CREATE=0]="CREATE",ie[ie.DELETE=1]="DELETE",ie[ie.MOVE=2]="MOVE",ie[ie.COPY=3]="COPY",ie[ie.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class O{constructor(ke,oe,Y){this.resource=ke,this.operation=oe,this.target=Y}isOperation(ke){return this.operation===ke}}e.$Ek=O;var W;(function(ie){ie[ie.UPDATED=0]="UPDATED",ie[ie.ADDED=1]="ADDED",ie[ie.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class z{static{this.a=null}constructor(ke,oe){this.c=oe,this.b=void 0,this.d=new k.$V(()=>{const Y=E.$8h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(V=>[V,!0])),Y}),this.f=new k.$V(()=>{const Y=E.$8h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(V=>[V,!0])),Y}),this.g=new k.$V(()=>{const Y=E.$8h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(V=>[V,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ke){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==z.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ke,...oe){return this.h(ke,{includeChildren:!1},...oe)}affects(ke,...oe){return this.h(ke,{includeChildren:!0},...oe)}h(ke,oe,...Y){if(!ke)return!1;const V=Y.length>0;return!!((!V||Y.includes(1))&&(this.d.value.get(ke)||oe.includeChildren&&this.d.value.findSuperstr(ke))||(!V||Y.includes(0))&&(this.f.value.get(ke)||oe.includeChildren&&this.f.value.findSuperstr(ke))||(!V||Y.includes(2))&&(this.g.value.findSubstr(ke)||oe.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$Fk=z;function q(ie,ke,oe){return!ie||!ke||ie===ke||ke.length>ie.length?!1:(ke.charAt(ke.length-1)!==N.sep&&(ke+=N.sep),oe?(0,I.$9e)(ie,ke):ie.indexOf(ke)===0)}e.$Gk=q;class C extends Error{constructor(ke,oe,Y){super(ke),this.fileOperationResult=oe,this.options=Y}}e.$Hk=C;class P extends C{constructor(ke,oe,Y,V){super(ke,oe,V),this.fileOperationResult=oe,this.size=Y}}e.$Ik=P;class J extends C{constructor(ke,oe,Y){super(ke,2,Y),this.stat=oe}}e.$Jk=J;var ce;(function(ie){ie[ie.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ie[ie.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ie[ie.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ie[ie.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ie[ie.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ie[ie.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ie[ie.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ie[ie.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ie[ie.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ie[ie.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ie[ie.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$Kk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Lk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Mk="files.associations",e.$Nk="files.exclude",e.$Ok="files.readonlyInclude",e.$Pk="files.readonlyExclude",e.$Qk="files.readonlyFromPermissions";var me;(function(ie){ie[ie.FILE=0]="FILE",ie[ie.FOLDER=1]="FOLDER",ie[ie.ROOT_FOLDER=2]="ROOT_FOLDER"})(me||(e.FileKind=me={})),e.$Rk="";function be(ie){if(!(typeof ie.size!="number"||typeof ie.mtime!="number"))return ie.mtime.toString(29)+ie.size.toString(31)}e.$Sk=be;async function Se(ie,ke){if(!ke.hasProvider(R.URI.from({scheme:ie.scheme})))return new Promise(oe=>{const Y=ke.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===ie.scheme&&V.added&&(Y.dispose(),oe())})})}e.$Tk=Se;class he{static{this.KB=1024}static{this.MB=he.KB*he.KB}static{this.GB=he.MB*he.KB}static{this.TB=he.GB*he.KB}static formatSize(ke){return(0,L.$If)(ke)||(ke=0),ke<he.KB?(0,m.localize)(1,null,ke.toFixed(0)):ke<he.MB?(0,m.localize)(2,null,(ke/he.KB).toFixed(2)):ke<he.GB?(0,m.localize)(3,null,(ke/he.MB).toFixed(2)):ke<he.TB?(0,m.localize)(4,null,(ke/he.GB).toFixed(2)):(0,m.localize)(5,null,(ke/he.TB).toFixed(2))}}e.$Uk=he;function fe(ie){const ke=typeof ie=="string"||ie?.scheme===A.Schemas.vscodeRemote;return typeof ie!="string"&&ie?.scheme===A.Schemas.file?1024*he.MB:ke?10*he.MB:w.$o?50*he.MB:1024*he.MB}e.$Vk=fe}),define(Ce[71],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=void 0;class E{constructor(...I){this.a=new Map;for(const[L,R]of I)this.set(L,R)}set(I,L){const R=this.a.get(I);return this.a.set(I,L),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$Zh=E}),define(Ce[185],Re([1,0,14,11,6,69,183,4,71,186]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;const A=!1;class k extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$Zh,t=!1,n,a=A){this.f=o,this.g=t,this.h=n,this.i=a,this.o=new Set,this.f.set(m.$1h,this),this._globalGraph=a?n?._globalGraph??new R.$qq(c=>c):void 0}createChild(o){return new l(o,this.g,this,this.i)}invokeFunction(o,...t){const n=b.traceInvocation(this.i,o);let a=!1;try{return o({get:h=>{if(a)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{a=!0,n.stop()}}createInstance(o,...t){let n,a;return o instanceof L.$Yh?(n=b.traceCreation(this.i,o.ctor),a=this.j(o.ctor,o.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,o),a=this.j(o,t,n)),n.stop(),a}j(o,t=[],n){const a=m._util.getServiceDependencies(o).sort((i,s)=>i.index-s.index),c=[];for(const i of a){const s=this.m(i.id,n);s||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(s)}const h=a.length>0?a[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(o,t.concat(c))}k(o,t){if(this.f.get(o)instanceof L.$Yh)this.f.set(o,t);else if(this.h)this.h.k(o,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const t=this.f.get(o);return!t&&this.h?this.h.l(o):t}m(o,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const n=this.l(o);return n instanceof L.$Yh?this.q(o,n,t.branch(o,!0)):(t.branch(o,!1),n)}q(o,t,n){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,t,n)}finally{this.o.delete(o)}}r(o,t,n){const a=new R.$qq(i=>i.id.toString());let c=0;const h=[{id:o,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(a.lookupOrInsertNode(i),c++>1e3)throw new k(a);for(const s of m._util.getServiceDependencies(i.desc.ctor)){const u=this.l(s.id);if(u||this.u(`[createInstance] ${o} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),u instanceof L.$Yh){const d={id:s.id,desc:u,_trace:i._trace.branch(s.id,!0)};a.insertEdge(i,d),h.push(d)}}}for(;;){const i=a.roots();if(i.length===0){if(!a.isEmpty())throw new k(a);break}for(const{data:s}of i){if(this.l(s.id)instanceof L.$Yh){const d=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,d)}a.removeNode(s)}}return this.l(o)}s(o,t,n=[],a,c){if(this.f.get(o)instanceof L.$Yh)return this.t(o,t,n,a,c);if(this.h)return this.h.s(o,t,n,a,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(o,t,n=[],a,c){if(a){const h=new l(void 0,this.g,this,this.i);h.c=String(o);const i=new Map,s=new E.$ih(()=>{const u=h.j(t,n,c);for(const[d,v]of i){const f=u[d];if(typeof f=="function")for(const S of v)f.apply(u,S)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!s.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let S=i.get(d);return S||(S=new w.$3c,i.set(d,S)),($,y,D)=>{const M=S.push([$,y,D]);return(0,I.$Qc)(M)}}if(d in u)return u[d];const v=s.value;let f=v[d];return typeof f!="function"||(f=f.bind(v),u[d]=f),f},set(u,d,v){return s.value[d]=v,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(o,t){if(t&&console.warn(o),this.g)throw new Error(o)}}e.$rq=l;var p;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(p||(p={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,t){return o?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(o,t){return o?new b(1,t.name):b.c}static{this.f=0}constructor(o,t){this.type=o,this.name=t,this.g=Date.now(),this.h=[]}branch(o,t){const n=new b(3,o.toString());return this.h.push([o,t,n]),n}stop(){const o=Date.now()-this.g;b.f+=o;let t=!1;function n(c,h){const i=[],s=new Array(c+1).join("	");for(const[u,d,v]of h.h)if(d&&v){t=!0,i.push(`${s}CREATES -> ${u}`);const f=n(c+1,v);f&&i.push(f)}else i.push(`${s}uses -> ${u}`);return i.join(`
`)}const a=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(o>2||t)&&b.all.add(a.join(`
`))}}e.$sq=b}),define(Ce[15],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.log=e.$mj=e.LogLevel=e.$lj=e.$kj=e.$jj=void 0,e.$jj=(0,l.$2h)("logService"),e.$kj=(0,l.$2h)("loggerService");function p(){return new Date().toISOString()}function b($){return(0,w.$If)($)}e.$lj=b;var r;(function($){$[$.Off=0]="Off",$[$.Trace=1]="Trace",$[$.Debug=2]="Debug",$[$.Info=3]="Info",$[$.Warning=4]="Warning",$[$.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$mj=r.Info;function o($,y,D){switch(y){case r.Trace:$.trace(D);break;case r.Debug:$.debug(D);break;case r.Info:$.info(D);break;case r.Warning:$.warn(D);break;case r.Error:$.error(D);break;case r.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=o;function t($,y=!1){let D="";for(let M=0;M<$.length;M++){let O=$[M];if(O instanceof Error&&(O=(0,E.$Mi)(O,y)),typeof O=="object")try{O=JSON.stringify(O)}catch{}D+=(M>0?" ":"")+O}return D}class n extends L.$Sc{constructor(){super(...arguments),this.b=e.$mj,this.c=this.B(new N.$Sd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==r.Off&&this.b<=y}}e.$oj=n;class a extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(r.Trace)&&this.g(r.Trace,t([y,...D],!0))}debug(y,...D){this.f(r.Debug)&&this.g(r.Debug,t([y,...D]))}info(y,...D){this.f(r.Info)&&this.g(r.Info,t([y,...D]))}warn(y,...D){this.f(r.Warning)&&this.g(r.Warning,t([y,...D]))}error(y,...D){if(this.f(r.Error))if(y instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=y.stack,this.g(r.Error,t(M))}else this.g(r.Error,t([y,...D]))}flush(){}}e.$pj=a;class c extends n{constructor(y=e.$mj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...D){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,y,...D):console.log(`[main ${p()}]`,y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,y,...D):console.warn(`[main ${p()}]`,y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,y,...D):console.error(`[main ${p()}]`,y,...D))}dispose(){}flush(){}}e.$qj=c;class h extends n{constructor(y=e.$mj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}dispose(){}flush(){}}e.$rj=h;class i extends n{constructor(y,D=e.$mj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(y),...D])}debug(y,...D){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(y),...D])}info(y,...D){this.f(r.Info)&&this.g.log(r.Info,[this.h(y),...D])}warn(y,...D){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(y),...D])}error(y,...D){this.f(r.Error)&&this.g.log(r.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Mi)(y,this.f(r.Trace))}dispose(){}flush(){}}e.$sj=i;class s extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const M of this.g)M.trace(y,...D)}debug(y,...D){for(const M of this.g)M.debug(y,...D)}info(y,...D){for(const M of this.g)M.info(y,...D)}warn(y,...D){for(const M of this.g)M.warn(y,...D)}error(y,...D){for(const M of this.g)M.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$tj=s;class u extends L.$Sc{constructor(y,D,M){if(super(),this.h=y,this.j=D,this.b=new R.$Ac,this.c=this.B(new N.$Sd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Sd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Sd),this.onDidChangeVisibility=this.g.event,M)for(const O of M)this.b.set(O.resource,{logger:void 0,info:O})}m(y){return(0,w.$Ef)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const M=this.n(y),O=(0,w.$Ef)(y)?y:D?.id??(0,I.$Pi)(M.toString()).toString(16);let W=this.b.get(M)?.logger;const z=D?.logLevel==="always"?r.Trace:D?.logLevel;W||(W=this.s(M,z??this.getLogLevel(M)??this.h,{...D,id:O}));const q={logger:W,info:{resource:M,id:O,logLevel:z,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(q.info),this.b.set(M,q),W}n(y){return(0,w.$Ef)(y)?(0,g.$Dg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(A.URI.isUri(y)){const M=y,O=D,W=this.b.get(M);W&&O!==W.info.logLevel&&(W.info.logLevel=O===this.h?void 0:O,W.logger?.setLevel(O),this.b.set(W.info.resource,W),this.f.fire([M,O]))}else{this.h=y;for(const[M,O]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&O.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const M=this.m(y);M&&D!==!M.info.hidden&&(M.info.hidden=!D,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$uj=u;class d{constructor(){this.onDidChangeLogLevel=new N.$Sd().event}setLevel(y){}getLevel(){return r.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$vj=d;class v extends d{}e.$wj=v;function f($){if($.verbose)return r.Trace;if(typeof $.logLevel=="string"){const y=F($.logLevel.toLowerCase());if(y!==void 0)return y}return e.$mj}e.$xj=f;function S($){switch($){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$yj=S;function F($){switch($){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$zj=F,e.$Aj=new k.$gj("logLevel",S(r.Info))}),define(Ce[187],Re([1,0,6,15]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dO=void 0;class I extends E.$Sc{constructor(R,m=[]){super(),this.a=new N.$tj([R,...m]),this.B(R.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...m){this.a.trace(R,...m)}debug(R,...m){this.a.debug(R,...m)}info(R,...m){this.a.info(R,...m)}warn(R,...m){this.a.warn(R,...m)}error(R,...m){this.a.error(R,...m)}flush(){this.a.flush()}}e.$dO=I}),define(Ce[99],Re([1,0,31,154,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(g){function w(b,r){return r-b}g.compare=w;const A=Object.create(null);A[g.Error]=(0,N.localize)(0,null),A[g.Warning]=(0,N.localize)(1,null),A[g.Info]=(0,N.localize)(2,null);function k(b){return A[b]||""}g.toString=k;function l(b){switch(b){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function p(b){switch(b){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=p}(R||(e.MarkerSeverity=R={}));var m;(function(g){const w="";function A(l){return k(l,!0)}g.makeKey=A;function k(l,p){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(R.toString(l.severity)):b.push(w),l.message&&p?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}g.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$nt=(0,I.$2h)("markerService")}),define(Ce[188],Re([1,0,5,31,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ev=e.$dv=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cv=e.Severity=void 0,e.Severity=N.default,e.$cv=(0,I.$2h)("notificationService");var L;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var m;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.$dv=g;class w{infinite(){}done(){}total(k){}worked(k){}}e.$ev=w}),define(Ce[189],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=void 0,e.$Bj=(0,E.$2h)("productService"),e.$Cj="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(ge,e,E,N){var I=arguments.length,L=I<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,E):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ge,e,E,N);else for(var m=ge.length-1;m>=0;m--)(R=ge[m])&&(L=(I<3?R(L):I>3?R(e,E,L):R(e,E))||L);return I>3&&L&&Object.defineProperty(e,E,L),L},Ke=this&&this.__param||function(ge,e){return function(E,N){e(E,N,ge)}};define(Ce[72],Re([1,0,14,20,6,4]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=e.$gv=e.ProgressLocation=e.$fv=void 0,e.$fv=(0,L.$2h)("progressService");var R;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$gv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$hv=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const p=this.d;this.d=()=>{p?.(),l()}}):Promise.resolve()}}e.$iv=g;let w=class extends I.$Sc{constructor(l,p){super(),this.a=new E.$mh,p.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$Qc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$jv=w,e.$jv=w=Ge([Ke(1,e.$fv)],w);class A extends I.$Sc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Rc)}start(l){this.stop();const p=++this.a,b=new N.$3d;return this.f=setTimeout(()=>{p===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Qc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Qc)(()=>b.cancel())),this.b.add((0,I.$Qc)(()=>this.c?this.c.done():void 0)),{id:p,token:b.token,stop:()=>this.h(p),isCurrent:()=>this.a===p}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$kv=A,e.$lv=(0,L.$2h)("editorProgressService")}),define(Ce[30],Re([1,0,53,16]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=void 0;class I{constructor(){this.a=new Map}add(R,m){E.ok(N.$Ef(R)),E.ok(N.$Gf(m)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,m)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$un=new I}),define(Ce[73],Re([1,0,5,30]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class L{constructor(){this.b=new E.$Sd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[I(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;N.$un.add(e.$vn.JSONContribution,R)}),define(Ce[54],Re([1,0,18,5,16,148,41,73,30]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.ConfigurationScope=e.$zn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$zn={Configuration:"base.contributions.configuration"};var A;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn="vscode://schemas/settings/resourceLanguage",e.$Hn="vscode://schemas/settings/configurationDefaults";const k=g.$un.as(m.$vn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new N.$Sd,this.onDidSchemaChange=this.i.event,this.j=new N.$Sd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Gn,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const u=new Set;this.n(i,s,u),k.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const s=new Set;this.o(i,s),k.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const u=new Set;this.o(s,u),this.n(i,!1,u),k.registerSchema(e.$Gn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const u=[];for(const{overrides:d,source:v}of i)for(const f in d)if(s.add(f),e.$Jn.test(f)){const S=this.a.get(f),F=S?.valuesSources??new Map;if(v)for(const M of Object.keys(d[f]))F.set(M,v);const $={...S?.value||{},...d[f]};this.a.set(f,{source:v,value:$,valuesSources:F});const y=(0,R.$Fi)(f),D={type:"object",default:$,description:L.localize(1,null,y),$ref:e.$Gn,defaultDefaultValue:$,source:I.$Ef(v)?void 0:v,defaultValueSource:v};u.push(...r(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:v});const S=this.d[f];S&&(this.w(f,S),this.r(f,S))}this.m(u)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:u,source:d}of i)for(const v in u){const f=this.a.get(v),S=I.$Ef(d)?d:d?.id,F=I.$Ef(f?.source)?f?.source:f?.source?.id;if(S===F)if(s.add(v),this.a.delete(v),e.$Jn.test(v))delete this.d[v],delete this.b.properties[v];else{const $=this.d[v];$&&(this.w(v,$),this.r(v,$))}}this.u()}deltaConfiguration(i){let s=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,u){i.forEach(d=>{this.p(d,s,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,s){const u=d=>{if(d.properties)for(const v in d.properties){s.add(v);const f=this.d[v];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[v],this.s(v,d.properties[v])}d.allOf?.forEach(v=>u(v))};for(const d of i){u(d);const v=this.c.indexOf(d);v!==-1&&this.c.splice(v,1)}}p(i,s=!0,u,d,v=3,f){v=I.$Nf(i.scope)?v:i.scope;const S=i.properties;if(S)for(const $ in S){const y=S[$];if(s&&a($,y)){delete S[$];continue}if(y.source=u,y.defaultDefaultValue=S[$].default,this.w($,y),e.$Jn.test($)?y.scope=void 0:(y.scope=I.$Nf(y.scope)?v:y.scope,y.restricted=I.$Nf(y.restricted)?!!d?.includes($):y.restricted),S[$].hasOwnProperty("included")&&!S[$].included){this.f[$]=S[$],delete S[$];continue}else this.d[$]=S[$],S[$].policy?.name&&this.e.set(S[$].policy.name,$);!S[$].deprecationMessage&&S[$].markdownDeprecationMessage&&(S[$].deprecationMessage=S[$].markdownDeprecationMessage),f.add($)}const F=i.allOf;if(F)for(const $ of F)this.p($,s,u,d,v,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(s)};s(i)}r(i,s){switch(e.$An.properties[i]=s,s.scope){case 1:e.$Bn.properties[i]=s;break;case 2:e.$Cn.properties[i]=s;break;case 6:e.$Dn.properties[i]=s;break;case 3:e.$En.properties[i]=s;break;case 4:e.$Fn.properties[i]=s;break;case 5:e.$Fn.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.$An.properties[i],s.scope){case 1:delete e.$Bn.properties[i];break;case 2:delete e.$Cn.properties[i];break;case 6:delete e.$Dn.properties[i];break;case 3:delete e.$En.properties[i];break;case 4:case 5:delete e.$Fn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,u={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$Gn};this.w(s,u),e.$An.properties[s]=u,e.$Bn.properties[s]=u,e.$Cn.properties[s]=u,e.$Dn.properties[s]=u,e.$En.properties[s]=u,e.$Fn.properties[s]=u}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$Gn};e.$An.patternProperties[e.$In]=i,e.$Bn.patternProperties[e.$In]=i,e.$Cn.patternProperties[e.$In]=i,e.$Dn.patternProperties[e.$In]=i,e.$En.patternProperties[e.$In]=i,e.$Fn.patternProperties[e.$In]=i,this.i.fire()}w(i,s){const u=this.a.get(i);let d=u?.value,v=u?.source;I.$Lf(d)&&(d=s.defaultDefaultValue,v=void 0),I.$Lf(d)&&(d=t(s.type)),s.default=d,s.defaultValueSource=v}}const p="\\[([^\\]]+)\\]",b=new RegExp(p,"g");e.$In=`^(${p})+$`,e.$Jn=new RegExp(e.$In);function r(h){const i=[];if(e.$Jn.test(h)){let s=b.exec(h);for(;s?.length;){const u=s[1].trim();u&&i.push(u),s=b.exec(h)}}return(0,E.$Mb)(i)}e.$Kn=r;function o(h){return h.reduce((i,s)=>`${i}[${s}]`,"")}e.$Ln=o;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Mn=t;const n=new l;g.$un.add(e.$zn.Configuration,n);function a(h,i){return h.trim()?e.$Jn.test(h)?L.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?L.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$Nn=a;function c(){const h=[],i=n.getConfigurationProperties();for(const s of Object.keys(i))h.push([s,i[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$On=c}),define(Ce[190],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=void 0;function p(s){return Object.isFrozen(s)?s:m.$jn(s)}class b{constructor(u={},d=[],v=[],f){this.b=u,this.c=d,this.d=v,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof b)return d;const v=new r("");return v.parseRaw(d),v.configurationModel});this.f=u.reduce((d,v)=>v===d?v:d.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,A.$Di)(this.contents,u):this.contents}inspect(u,d){const v=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,S=d?this.rawConfiguration.override(d).getValue(u):v;return{value:v,override:f,merged:S}}getOverrideValue(u,d){const v=this.i(d);return v?u?(0,A.$Di)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const v of this.overrides)v.identifiers.includes(u)&&d.push(...v.keys);return E.$Mb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Mb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=m.$in(this.contents),v=m.$in(this.overrides),f=[...this.keys],S=this.raw?.length?[...this.raw]:[this];for(const F of u)if(S.push(...F.raw?.length?F.raw:[F]),!F.isEmpty()){this.h(d,F.contents);for(const $ of F.overrides){const[y]=v.filter(D=>E.$ub(D.identifiers,$.identifiers));y?(this.h(y.contents,$.contents),y.keys.push(...$.keys),y.keys=E.$Mb(y.keys)):v.push(m.$in($))}for(const $ of F.keys)f.indexOf($)===-1&&f.push($)}return new b(d,f,v,S.every(F=>F instanceof b)?void 0:S)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const v={};for(const f of E.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let S=this.contents[f];const F=d[f];F&&(typeof S=="object"&&typeof F=="object"?(S=m.$in(S),this.h(S,F)):S=F),v[f]=S}return new b(v,this.keys,this.overrides)}h(u,d){for(const v of Object.keys(d)){if(v in u&&g.$Gf(u[v])&&g.$Gf(d[v])){this.h(u[v],d[v]);continue}u[v]=m.$in(d[v])}}i(u){let d=null,v=null;const f=S=>{S&&(v?this.h(v,S):v=m.$in(S))};for(const S of this.overrides)S.identifiers.length===1&&S.identifiers[0]===u?d=S.contents:S.identifiers.includes(u)&&f(S.contents);return f(d),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,A.$Ci)(this.contents,u),k.$Jn.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>E.$ub(v.identifiers,(0,k.$Kn)(u))),1))}j(u,d,v){(0,A.$Bi)(this.contents,u,d,f=>console.error(f)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),k.$Jn.test(u)&&this.overrides.push({identifiers:(0,k.$Kn)(u),keys:Object.keys(this.contents[u]),contents:(0,A.$Ai)(this.contents[u],f=>console.error(f))})}}e.$Pn=b;class r{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Nf(u)){const v=this.g(u);this.parseRaw(v,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:v,keys:f,overrides:S,restricted:F,hasExcludedProperties:$}=this.h(u,d);this.b=new b(v,f,S,$?[u]:void 0),this.c=F||[]}g(u){let d={},v=null,f=[];const S=[],F=[];function $(D){Array.isArray(f)?f.push(D):v!==null&&(f[v]=D)}const y={onObjectBegin:()=>{const D={};$(D),S.push(f),f=D,v=null},onObjectProperty:D=>{v=D},onObjectEnd:()=>{f=S.pop()},onArrayBegin:()=>{const D=[];$(D),S.push(f),f=D,v=null},onArrayEnd:()=>{f=S.pop()},onLiteralValue:$,onError:(D,M,O)=>{F.push({error:D,offset:M,length:O})}};if(u)try{I.$fn(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const v=l.$un.as(k.$zn.Configuration).getConfigurationProperties(),f=this.i(u,v,!0,d);u=f.raw;const S=(0,A.$Ai)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),F=Object.keys(u),$=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:S,keys:F,overrides:$,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,v,f){let S=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:S};const F={},$=[];for(const y in u)if(k.$Jn.test(y)&&v){const D=this.i(u[y],d,!1,f);F[y]=D.raw,S=S||D.hasExcludedProperties,$.push(...D.restricted)}else{const D=d[y],M=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&$.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(M===void 0||f.scopes===void 0||f.scopes.includes(M))&&!(f.skipRestricted&&D?.restricted))?F[y]=u[y]:S=!0}return{raw:F,restricted:$,hasExcludedProperties:S}}j(u,d){const v=[];for(const f of Object.keys(u))if(k.$Jn.test(f)){const S={};for(const F in u[f])S[F]=u[f][F];v.push({identifiers:(0,k.$Kn)(f),keys:Object.keys(S),contents:(0,A.$Ai)(S,d)})}return v}}e.$Qn=r;class o extends L.$Sc{constructor(u,d,v,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new N.$Sd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&v.isEqual(S.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Rn=o;class t{constructor(u,d,v,f,S,F,$,y,D,M,O,W,z){this.a=u,this.b=d,this.c=v,this.overrideIdentifiers=f,this.d=S,this.f=F,this.g=$,this.h=y,this.i=D,this.j=M,this.k=O,this.l=W,this.m=z}get value(){return p(this.c)}n(u,d,v){const f=u.inspect(d,v);return{get value(){return p(f.value)},get override(){return p(f.override)},get merged(){return p(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,v,f,S=new b,F=new b,$=new R.$Ac,y=new b,D=new R.$Ac){this.c=u,this.d=d,this.f=v,this.g=f,this.h=S,this.i=F,this.j=$,this.l=y,this.m=D,this.a=null,this.b=new R.$Ac,this.n=null}getValue(u,d,v){return this.p(u,d,v).getValue(u)}updateValue(u,d,v={}){let f;v.resource?(f=this.m.get(v.resource),f||(f=new b,this.m.set(v.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),v.resource||(this.a=null)}inspect(u,d,v){const f=this.p(u,d,v),S=this.t(d.resource,v),F=d.resource?this.m.get(d.resource)||this.l:this.l,$=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&$.add(D);return new t(u,d,f.getValue(u),$.size?[...$]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,S||void 0,F)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const v=[];if(!d){const{added:f,updated:S,removed:F}=h(this.c,u);d=[...f,...S,...F]}for(const f of d)for(const S of(0,k.$Kn)(f)){const F=this.c.getKeysForOverrideIdentifier(S),$=u.getKeysForOverrideIdentifier(S),y=[...$.filter(D=>F.indexOf(D)===-1),...F.filter(D=>$.indexOf(D)===-1),...F.filter(D=>!m.$mn(this.c.override(S).getValue(D),u.override(S).getValue(D)))];v.push([S,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:v,removed:f}=h(this.d,u),S=[...d,...v,...f];return S.length&&this.updatePolicyConfiguration(u),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:v,removed:f,overrides:S}=h(this.applicationConfiguration,u),F=[...d,...v,...f];return F.length&&this.updateApplicationConfiguration(u),{keys:F,overrides:S}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:v,removed:f,overrides:S}=h(this.localUserConfiguration,u),F=[...d,...v,...f];return F.length&&this.updateLocalUserConfiguration(u),{keys:F,overrides:S}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:v,removed:f,overrides:S}=h(this.remoteUserConfiguration,u),F=[...d,...v,...f];return F.length&&this.updateRemoteUserConfiguration(u),{keys:F,overrides:S}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:v,removed:f,overrides:S}=h(this.workspaceConfiguration,u),F=[...d,...v,...f];return F.length&&this.updateWorkspaceConfiguration(u),{keys:F,overrides:S}}compareAndUpdateFolderConfiguration(u,d){const v=this.folderConfigurations.get(u),{added:f,updated:S,removed:F,overrides:$}=h(v,d),y=[...f,...S,...F];return(y.length||!v)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:$}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:f,removed:S,overrides:F}=h(d,void 0);return{keys:[...v,...f,...S],overrides:F}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,v){let f=this.q(d,v);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let v=this.r();if(d&&u){const f=d.getFolder(u);f&&(v=this.s(f.uri)||v);const S=this.m.get(u);S&&(v=v.merge(S))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const v=this.r(),f=this.j.get(u);f?(d=v.merge(f),this.b.set(u,d)):d=v}return d}t(u,d){if(d&&u){const v=d.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:v,overrides:f,keys:S}=this.j.get(d);return u.push([d,{contents:v,overrides:f,keys:S}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),v=this.w(u.policy),f=this.w(u.application),S=this.w(u.user),F=this.w(u.workspace),$=u.folders.reduce((y,D)=>(y.set(w.URI.revive(D[0]),this.w(D[1])),y),new R.$Ac);return new n(d,v,f,S,new b,F,$,new b,new R.$Ac)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$Sn=n;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,d=new Map;for(const f of s)f.keys.forEach(S=>u.add(S)),f.overrides.forEach(([S,F])=>{const $=(0,R.$xc)(d,S,new Set);F.forEach(y=>$.add(y))});const v=[];return d.forEach((f,S)=>v.push([S,[...f.values()]])),{keys:[...u.values()],overrides:v}}e.$Tn=a;class c{constructor(u,d,v,f){this.change=u,this.f=d,this.g=v,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const S of u.keys)this.affectedKeys.add(S);for(const[,S]of u.overrides)for(const F of S)this.affectedKeys.add(F);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const v=this.a+u,f=this.d.indexOf(v);if(f<0)return!1;const S=f+v.length;if(S>=this.d.length)return!1;const F=this.d.charCodeAt(S);if(F!==this.b&&F!==this.c)return!1;if(d){const $=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!m.$mn($,y)}return!0}}e.$Un=c;function h(s,u){const{added:d,removed:v,updated:f}=i(u?.rawConfiguration,s?.rawConfiguration),S=[],F=s?.getAllOverrideIdentifiers()||[],$=u?.getAllOverrideIdentifiers()||[];if(u){const y=$.filter(D=>!F.includes(D));for(const D of y)S.push([D,u.getKeysForOverrideIdentifier(D)])}if(s){const y=F.filter(D=>!$.includes(D));for(const D of y)S.push([D,s.getKeysForOverrideIdentifier(D)])}if(u&&s){for(const y of F)if($.includes(y)){const D=i({contents:s.getOverrideValue(void 0,y)||{},keys:s.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});S.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:v,updated:f,overrides:S}}function i(s,u){const d=s?u?s.keys.filter(S=>u.keys.indexOf(S)===-1):[...s.keys]:[],v=u?s?u.keys.filter(S=>s.keys.indexOf(S)===-1):[...u.keys]:[],f=[];if(s&&u){for(const S of u.keys)if(s.keys.indexOf(S)!==-1){const F=(0,A.$Di)(u.contents,S),$=(0,A.$Di)(s.contents,S);m.$mn(F,$)||f.push(S)}}return{added:d,removed:v,updated:f}}}),define(Ce[100],Re([1,0,11,4]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.RemoteAuthorityResolverErrorCode=e.$6k=e.$5k=e.RemoteConnectionType=e.$4k=void 0,e.$4k=(0,N.$2h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class L{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$5k=L;class R{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$6k=R;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends E.$bb{static isNotAvailable(k){return k instanceof g&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof g&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof g&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof g&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof g&&k.isHandled}constructor(k,l=m.Unknown,p){super(k),this._message=k,this._code=l,this._detail=p,this.isHandled=l===m.NotAvailable&&p===!0,Object.setPrototypeOf(this,g.prototype)}}e.$7k=g;function w(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$8k=w}),define(Ce[55],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0;function N(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$9k=N;function I(w){if(!w)return;const A=w.indexOf("+");return A<0?w:w.substr(0,A)}e.$0k=I;function L(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$$k=L;function R(w){const{host:A,port:k}=g(w);if(typeof k>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$_k=R;function m(w,A){let{host:k,port:l}=g(w);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$al=m;function g(w){const A=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=w.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Ce[22],Re([1,0,12,4,55]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=e.TargetPlatform=e.ExtensionType=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=void 0,e.$bm="extensions.user.cache",e.$cm="extensions.builtin.cache",e.$dm="undefined_publisher",e.$em=["ui","workspace","web"];function L(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$fm=L,e.$gm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(R||(e.ExtensionType=R={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,t){if(typeof o>"u"||o===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof o=="string"||typeof t=="string"){const n=typeof o=="string"?o:o.value,a=typeof t=="string"?t:t.value;return E.$8e(n,a)}return o._lower===t._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$hm=g;class w{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const t of o)this.add(t)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$im=w;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,t){this.c.set(g.toKey(o),t)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$jm=A;function k(r){return l(r)}e.$km=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$lm=l;function p(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$mm=p;function b(r,o){if(o){const t=`onResolveRemoteAuthority:${(0,I.$0k)(o)}`;return!!r.activationEvents?.includes(t)}return!1}e.$nm=b,e.$om=(0,N.$2h)("IBuiltinExtensionsScannerService")}),define(Ce[101],Re([1,0,11,22]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=e.$3E=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,m){this.a.set(R,m)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const m=Object.create(null);for(const g of R){const w=this.readActivationEvents(g);w.length>0&&(m[N.$hm.toKey(g.identifier)]=w)}return m}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const m=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${N.$hm.toKey(R.identifier)}`);if(!R.contributes)return m;for(const g in R.contributes){const w=this.a.get(g);if(!w)continue;const A=R.contributes[g],k=Array.isArray(A)?A:[A];try{w(k,m)}catch(l){(0,E.$1)(l)}}return m}}e.$3E=I,e.$4E=new I}),define(Ce[191],Re([1,0,21,74,33]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=void 0;function L(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function R(g,w,A,k,l,p,b,r,o){const t=Object.create(null);t["common.machineId"]=p,t["common.sqmId"]=b,t.sessionID=(0,I.$mg)()+Date.now(),t.commitHash=k,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=N.$dc,t["common.nodeArch"]=A,t["common.product"]=o||"desktop",r&&(t["common.msftInternal"]=r);let n=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=L(w);return c&&(t["common.platformDetail"]=c),t}e.$vo=R;function m(g){const w=N.env.USERDNSDOMAIN;if(!w)return!1;const A=w.toLowerCase();return g.some(k=>A===k)}e.$wo=m}),define(Ce[192],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=void 0,e.$ql=(0,E.$2h)("telemetryService"),e.$rl=(0,E.$2h)("customEndpointTelemetryService"),e.$sl="telemetry.currentSessionDate",e.$tl="telemetry.firstSessionDate",e.$ul="telemetry.lastSessionDate",e.$vl="telemetry.machineId",e.$wl="telemetry.sqmId",e.$xl="telemetry",e.$yl="telemetry.telemetryLevel",e.$zl="telemetry.enableCrashReporter",e.$Al="telemetry.enableTelemetry";var N;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ce[56],Re([1,0,26,16,5,41,55,191,192]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=void 0;class w{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$xo=w;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$yo=A,e.$zo=new A;class k{async publicLog(v,f,S){}async publicLogError(v,f,S){}}e.$Ao=k,e.$Bo="telemetry",e.$Co="extensionTelemetryLog",e.$Do={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,v){return I.Event.debounce(v.onDidChangeConfiguration,(S,F)=>{const $=S?new Set([...S.affectedKeys,...F.affectedKeys]):F.affectedKeys;return{...F,affectedKeys:$}},1e3,!0)(S=>{S.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,L.$yi)(S.source),configurationKeys:Array.from(S.affectedKeys)})})}e.$Eo=l;function p(d,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!d.enableTelemetry)}e.$Fo=p;function b(d,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Go=b;function r(d){const v=d.getValue(g.$yl),f=d.getValue(g.$zl);if(d.getValue(g.$Al)===!1||f===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Ho=r;function o(d){const v={},f={},S={};a(d,S);for(let F in S){F=F.length>150?F.substr(F.length-149):F;const $=S[F];typeof $=="number"?f[F]=$:typeof $=="boolean"?f[F]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${F} has been trimmed to 8192, the original length is ${$.length}`),v[F]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(v[F]=$)}return{properties:v,measurements:f}}e.$Io=o;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const v=(0,R.$0k)(d);return t.has(v)?v:"other"}e.$Jo=n;function a(d,v,f=0,S){if(d)for(const F of Object.getOwnPropertyNames(d)){const $=d[F],y=S?S+F:F;Array.isArray($)?v[y]=(0,E.$nn)($):$ instanceof Date?v[y]=$.toISOString():(0,N.$Gf)($)?f<2?a($,v,f+1,y+"."):v[y]=(0,E.$nn)($):v[y]=$}}function c(d,v){const f=d.msftInternalDomains||[],S=v.getValue("telemetry.internalTesting");return(0,m.$wo)(f)||S}e.$Ko=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Lo=h;function i(d,v){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const S=[];for(const D of v)for(;;){const M=D.exec(d);if(!M)break;S.push([M.index,D.lastIndex])}const F=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=$.exec(d);if(!D)break;const M=S.some(([O,W])=>D.index<W&&O<$.lastIndex);!F.test(D[0])&&!M&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=$.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function s(d){if(!d)return d;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of v)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,v){return(0,E.$kn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let S=f.replaceAll("%20"," ");S=i(S,v);for(const F of v)S=S.replace(F,"");return S=s(S),S}})}e.$Mo=u}),define(Ce[193],Re([1,0,12,97,22,21,2,11,74,56]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;function A(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$3e)(u.id,d.id)===0}e.$No=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const v=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,v,f)}static parse(d){const v=k.exec(d);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(d,v,f="undefined"){this.version=v,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Oo=l;const p=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const d=p.exec(u);return d&&d[1]?[o(d[1]),d[2]]:[o(u),void 0]}e.$Po=b;function r(u,d){return`${u}.${d}`}e.$Qo=r;function o(u){return u.toLowerCase()}e.$Ro=o;function t(u,d){return o(r(u??I.$dm,d))}e.$So=t;function n(u,d){const v=[],f=S=>{for(const F of v)if(F.some($=>A(d($),d(S))))return F;return null};for(const S of u){const F=f(S);F?F.push(S):v.push([S])}return v}e.$To=n;function a(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Uo=a;function c(u){return{id:new w.$xo(u.identifier.id),name:new w.$xo(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Vo=c,e.$Wo=new I.$hm("pprice.better-merge");function h(u,d){const v=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const S=f.shift();if(S&&v.every(F=>!A(F.identifier,{id:S}))){const F=u.filter($=>A($.identifier,{id:S}));F.length===1&&(v.push(F[0]),f.push(...F[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$Xo=h;async function i(u,d){if(!L.$k)return!1;let v;try{v=(await u.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){d.debug("Error while getting the os-release file.",(0,m.$0)(S))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(u,d){const v=await i(u,d),f=(0,N.$ho)(v?"alpine":L.$u,g.$ec);return d.debug("ComputeTargetPlatform:",f),f}e.$Yo=s}),define(Ce[194],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0;function E(g){return[...g.entries()]}e.$yr=E;function N(g){return g?[...g.entries()]:[]}e.$zr=N;function I(g){return new Map(g)}e.$Ar=I;function L(g){return new Map(g??[])}e.$Br=L;function R(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),N(w[1].descriptionMap)])}e.$Cr=R;function m(g){return new Map(g.map(w=>[w[0],{map:I(w[1]),descriptionMap:L(w[2])}]))}e.$Dr=m}),define(Ce[195],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zrb=void 0;class E{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,L,R=5){const m=L(g=>{const w=typeof g=="string"?g:g.data;let A=this.a.get(I);if(A){A.data.push(w);return}const k=setTimeout(()=>this.flushBuffer(I),R);A={data:[w],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),m.dispose()}},this.a.set(I,A)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const L=this.a.get(I);L&&(this.a.delete(I),this.b(I,L.data.join("")))}}e.$zrb=E}),define(Ce[196],Re([1,0,14,90,45,5,16,2,155,73,30]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.$lw=e.$kw=e.$jw=e.IconFontDefinition=e.IconContribution=e.$iw=void 0,e.$iw={IconContribution:"base.contributions.icons"};var k;(function(c){function h(i,s){let u=i.defaults;for(;I.ThemeIcon.isThemeIcon(u);){const d=b.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(k||(e.IconContribution=k={}));var l;(function(c){function h(s){return{weight:s.weight,style:s.style,src:s.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(s){const u=d=>(0,R.$Ef)(d)?d:void 0;if(s&&Array.isArray(s.src)&&s.src.every(d=>(0,R.$Ef)(d.format)&&(0,R.$Ef)(d.location)))return{weight:u(s.weight),style:u(s.style),src:s.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class p{constructor(){this.a=new L.$Sd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,s,u){const d=this.b[h];if(d){if(s&&!d.description){d.description=s,this.d.properties[h].markdownDescription=`${s} $(${h})`;const S=this.e.enum.indexOf(h);S!==-1&&(this.e.enumDescriptions[S]=s),this.a.fire()}return d}const v={id:h,description:s,defaults:i,deprecationMessage:u};this.b[h]=v;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),s&&(f.markdownDescription=`${s}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const s=this.f[h];return s||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,v)=>d.id.localeCompare(v.id),i=d=>{for(;I.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(v=>!!v.description).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|${I.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const d of u.filter(v=>!I.ThemeIcon.isThemeIcon(v.defaults)).sort(h))s.push(`|<i class="${i(d)}"></i>|${d.id}|`);return s.join(`
`)}}const b=new p;A.$un.add(e.$iw.IconContribution,b);function r(c,h,i,s){return b.registerIcon(c,h,i,s)}e.$jw=r;function o(){return b}e.$kw=o;function t(){const c=(0,N.$6j)();for(const h in c){const i="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:i})}}t(),e.$lw="vscode://schemas/icons";const n=A.$un.as(w.$vn.JSONContribution);n.registerSchema(e.$lw,b.getIconSchema());const a=new E.$bh(()=>n.notifySchemaChanged(e.$lw),200);b.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.$mw=r("widget-close",N.$8j.close,(0,g.localize)(2,null)),e.$nw=r("goto-previous-location",N.$8j.arrowUp,(0,g.localize)(3,null)),e.$ow=r("goto-next-location",N.$8j.arrowDown,(0,g.localize)(4,null)),e.$pw=I.ThemeIcon.modify(N.$8j.sync,"spin"),e.$qw=I.ThemeIcon.modify(N.$8j.loading,"spin")}),define(Ce[197],Re([1,0,5,41,4,15]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.$tv=e.$sv=e.$rv=e.$qv=e.$pv=e.ProvidedOnAutoForward=e.$ov=e.TunnelPrivacyId=e.TunnelProtocol=e.$nv=e.$mv=void 0,e.$mv=(0,I.$2h)("tunnelService"),e.$nv=(0,I.$2h)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var m;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(o){return!!o.forwardPort}e.$ov=g;var w;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function A(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(t)return{address:t[1],port:+t[2]}}e.$pv=A,e.$qv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(o){return e.$qv.indexOf(o)>=0}e.$rv=k,e.$sv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(o){return e.$sv.indexOf(o)>=0}e.$tv=l;function p(o,t,n,a){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(c?.length===4&&parseInt(c[1])>=18)return!1}return o<1024}e.$uv=p;class b{constructor(t,n,a){this.remoteAddress=t,this.localAddress=n,this.b=a,this.a=new E.$Sd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$vv=b;let r=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Sd,this.onTunnelOpened=this.a.event,this.b=new E.$Sd,this.onTunnelClosed=this.b.event,this.c=new E.$Sd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const a of n){const c=Array.from(a.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(a=>typeof a!="string"?a?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,a,c,h){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:a,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||k(t))&&(t=e.$qv[0]);const a=this.r(t,n);if(a)return++a.refcount,a.value}openTunnel(t,n,a,c,h,i=!1,s,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${a} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(a)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(d,n,a,c,h,i,s,u);return v?v.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,a),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,a);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==a)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&f.privacy!==s&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const a=n.get(t.tunnelRemotePort);a&&(a.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,a))}}}}async o(t,n,a){if(a.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=a.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const a=this.e.get(t);if(a&&a.has(n)){const c=a.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,a){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:a})}async q(t,n){const a=this.e.get(t);if(a){const c=a.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&a.delete(n),a.size===0&&this.e.delete(t)}}r(t,n){const a=[t];k(t)?(a.push(...e.$qv),a.push(...e.$sv)):l(t)&&a.push(...e.$sv);const c=a.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!A(t)}t(t,n,a,c,h,i,s){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${a} on local port ${c}.`);const u=a;this.i.add(u);const d=c===void 0?a:c,v={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:a},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:s},S=t.forwardPort(f,v);return S?(this.p(n,a,S),S.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),S}};e.$wv=r,e.$wv=r=Ge([Ke(0,L.$jj),Ke(1,N.$vi)],r)}),define(Ce[198],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$xv=void 0,e.$xv=(0,E.$2h)("editSessionIdentityService");var N;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ce[199],Re([1,0,13]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=void 0;function N(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$lK=N;function I(g){if(g.folders.length)return g.folders.every(w=>N(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&N(g.configuration))return g.configuration}e.$mK=I;function L(g){return I(g)?.scheme}e.$nK=L;function R(g){return I(g)?.authority}e.$oK=R;function m(g){return I(g)!==void 0}e.$pK=m}),define(Ce[47],Re([1,0,156,19,50,25,2,4,13]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.WorkbenchState=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=void 0,e.$$h=(0,m.$2h)("contextService");function w(d){const v=d;return typeof v?.id=="string"&&R.URI.isUri(v.uri)}e.$_h=w;function A(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$ai=A,e.$bi={id:"ext-dev"},e.$ci={id:"empty-window"};function k(d,v){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,N.$nc)(d)}:v?e.$bi:e.$ci;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$di=k;function l(d){const v=d;return typeof v?.id=="string"&&R.URI.isUri(v.configPath)}e.$ei=l;function p(d){const v=d;if(v?.uri)return{id:v.id,uri:R.URI.revive(v.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:R.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$fi=p;var b;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function r(d){const v=d;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$gi=r;function o(d){const v=d;return!!(v&&typeof v=="object"&&R.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$hi=o;class t{constructor(v,f,S,F,$){this.h=v,this.j=S,this.k=F,this.l=$,this.c=I.$8h.forUris(this.l,()=>!0),this.folders=f}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=I.$8h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ii=t;class n{constructor(v,f){this.raw=f,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,L.$Dg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ji=n;function a(d){return new n({uri:d,index:0,name:(0,L.$zg)(d)},{uri:d.toString()})}e.$ki=a,e.$li="code-workspace",e.$mi=`.${e.$li}`,e.$ni=[{name:(0,E.localize)(0,null),extensions:[e.$li]}],e.$oi="workspace.json";function c(d,v){return L.$ug.isEqualOrParent(d,v.untitledWorkspacesHome)}e.$pi=c;function h(d){let v;return R.URI.isUri(d)?v=d:v=d.configuration,v?.scheme===g.Schemas.tmp}e.$qi=h,e.$ri="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$ri}e.$si=i;function s(d,v){return!c(d,v)&&!h(d)}e.$ti=s;function u(d){return(typeof d=="string"?(0,N.$oc)(d):(0,L.$Bg)(d))===e.$mi}e.$ui=u}),define(Ce[75],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=void 0;class E{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const L=this.c++;return this.b.set(L,I),this.e(),L}get(I,L){return this.b.has(I)?this.b.get(I)[L]:void 0}delete(I){this.b.delete(I),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$_ec=E}),define(Ce[43],Re([1,0,13,25,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dfc=e.$cfc=void 0;class L{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new N.$sg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$cfc=L,e.$dfc=(0,I.$2h)("IExtHostFileSystemInfo")}),define(Ce[27],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0,e.$9M=(0,E.$2h)("IExtHostInitDataService")}),define(Ce[200],Re([1,0,161,15,187,27]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jhc=void 0;let R=class extends I.$dO{constructor(g,w,A){const k=A.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=A.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(k,{name:l}))}};e.$jhc=R,e.$jhc=R=Ge([Ke(1,N.$kj),Ke(2,L.$9M)],R)}),define(Ce[201],Re([1,0,14]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yfc=e.$Xfc=void 0;class N{constructor(R,m,g){this.h=new Map,this.a=R,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$bh(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of w.values())A.complete()}catch(A){for(const k of w.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,m){let g=this.f[R];return typeof g>"u"&&(g=m),g}update(R,m){this.f[R]=m;const g=this.h.get(R);if(g!==void 0)return g.p;const w=new E.$mh;return this.h.set(R,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$Xfc=N;class I extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,m){super(R.identifier.value,!0,m),this.j=R}}e.$Yfc=I}),define(Ce[202],Re([1,0,5,2]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=void 0;class I{constructor(R){this.c=R,this.a=new E.$Sd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Sd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,m,g,w){const k=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(m.value,g,w);this.b.fire(k)}$acceptDirtyStateChanged(R,m){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(m)}$acceptModelSaved(R){const m=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(m.apiNotebook)}}e.$Lgc=I}),define(Ce[17],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TM=e.$SM=void 0,e.$SM=(0,E.$2h)("IExtHostRpcService");class N{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$TM=N}),define(Ce[203],Re([1,0,22,5]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;class I{#e;constructor(R,m){this.b=new N.$Sd,this.onDidChange=this.b.event,this.a=E.$hm.toKey(R.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(R){return this.#e.get(this.a,R)}store(R,m){return this.#e.store(this.a,R,m)}delete(R){return this.#e.delete(this.a,R)}}e.$6fc=I}),define(Ce[57],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=e.$vfc=void 0,e.$vfc=(0,E.$2h)("IURITransformerService");class N{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$wfc=N}),define(Ce[204],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kb=e.$4kb=void 0;class N{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function I(m,g){if(g.serializeBuffersForPostMessage){const w=new N,k=JSON.stringify(m,(p,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const r=L(b);if(r)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:r,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map(p=>{const b=new Uint8Array(p);return E.$ge.wrap(b)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$4kb=I;function L(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(m,g){const w=g.map(l=>{const p=new ArrayBuffer(l.byteLength);return new Uint8Array(p).set(l.buffer),p}),A=g.length?(l,p)=>{if(p&&typeof p=="object"&&p.$$vscode_array_buffer_reference$$){const b=p,{index:r}=b,o=w[r];if(b.view)switch(b.view.type){case 1:return new Int8Array(o,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return p}:void 0;return{message:JSON.parse(m,A),arrayBuffers:w}}e.$5kb=R}),define(Ce[102],Re([1,0,171,16,2,6,4,30,42,13,40,134,31]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=e.$ME=e.$LE=e.EditorsOrder=e.$KE=e.CloseDirection=e.$JE=e.$IE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.EditorInputCapabilities=e.$zE=e.SaveReason=e.Verbosity=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.$sE=e.$rE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=void 0,e.$mE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$nE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$oE="workbench.editor.sidebysideEditor",e.$pE="workbench.editors.textDiffEditor",e.$qE="workbench.editors.binaryResourceDiffEditor";var p;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(p||(e.EditorPaneSelectionChangeReason=p={}));var b;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function r(oe){const Y=oe;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$rE=r;function o(oe,Y,V){for(const ne of V.visibleEditorPanes)if(ne.group.id===Y&&oe.matches(ne.input))return ne.getViewState()}e.$sE=o;function t(oe){if(S(oe))return!1;const Y=oe;return I.URI.isUri(Y?.resource)}e.$tE=t;function n(oe){if(S(oe))return!1;const Y=oe;return Y?.original!==void 0&&Y.modified!==void 0}e.$uE=n;function a(oe){if(S(oe))return!1;const Y=oe;return Array.isArray(Y?.resources)}e.$vE=a;function c(oe){if(S(oe)||n(oe))return!1;const Y=oe;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$wE=c;function h(oe){if(S(oe))return!1;const Y=oe;return Y?Y.resource===void 0||Y.resource.scheme===w.Schemas.untitled||Y.forceUntitled===!0:!1}e.$xE=h;function i(oe){if(S(oe))return!1;const Y=oe;return I.URI.isUri(Y?.base?.resource)&&I.URI.isUri(Y?.input1?.resource)&&I.URI.isUri(Y?.input2?.resource)&&I.URI.isUri(Y?.result?.resource)}e.$yE=i;var s;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(s||(e.Verbosity=s={}));var u;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(Y,V){let ne=this.a.get(Y);return ne||(ne={source:Y,label:V},this.a.set(Y,ne)),ne.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$zE=new d;var v;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class f extends L.$Sc{}e.$AE=f;function S(oe){return oe instanceof f}e.$BE=S;function F(oe){const Y=oe;return I.URI.isUri(Y?.preferredResource)}function $(oe){const Y=oe;return S(Y?.primary)&&S(Y?.secondary)}e.$CE=$;function y(oe){const Y=oe;return S(Y?.modified)&&S(Y?.original)}e.$DE=y;function D(oe,Y,V,ne,Ie){return ke(ne,[(0,k.$Li)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...V,limits:{size:Number.MAX_VALUE}};oe.openEditor(Y,Ae)}}),(0,k.$Li)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$EE=D;function M(oe){return S(oe?.editor)}e.$FE=M;function O(oe){const Y=oe;return M(oe)&&Y?.group!==void 0}e.$GE=O;function W(oe){const Y=oe;return typeof Y?.groupId=="number"&&S(Y.editor)}e.$HE=W;var z;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var q;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var C;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class P{getOriginalUri(Y,V){if(!Y)return;if(i(Y))return e.$JE.getOriginalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Y);if(Ie&&Ae){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===C.PRIMARY?Ie:Ae}}if(n(Y)||a(Y)||c(Y)||i(Y))return;const ne=F(Y)?Y.preferredResource:Y.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}a(Y){return $(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:y(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,V){if(!Y)return;if(i(Y))return e.$JE.getCanonicalUri(Y.result,V);if(V?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Y);if(Ie&&Ae){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:V.filterByScheme});Y=V.supportSideBySide===C.PRIMARY?Ie:Ae}}if(n(Y)||a(Y)||c(Y)||i(Y))return;const ne=Y.resource;return!ne||!V||!V.filterByScheme?ne:this.b(ne,V.filterByScheme)}b(Y,V){if(Array.isArray(V)){if(V.some(ne=>Y.scheme===ne))return Y}else if(V===Y.scheme)return Y}}var J;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(J||(e.EditorCloseMethod=J={}));function ce(oe,Y,V,ne){if(!oe.isSticky(Y))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return V===J.MOUSE||V===J.KEYBOARD;case"mouse":return V===J.MOUSE;case"keyboard":return V===J.KEYBOARD}return!1}e.$IE=ce,e.$JE=new P;var me;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(me||(e.CloseDirection=me={}));class be{constructor(){this.c=new Map,this.d=new Map}start(Y){const V=this.a=Y.get(R.$1h);for(const[ne,Ie]of this.c)this.e(ne,Ie,V);this.c.clear()}e(Y,V,ne){const Ie=ne.createInstance(V);this.d.set(Y,Ie)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,N.$Pf)(this.b)}registerEditorSerializer(Y,V){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,V,this.a):this.c.set(Y,V),(0,L.$Qc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}m.$un.add(e.$mE.EditorFactory,new be);async function Se(oe,Y,V){return!oe||!oe.length?[]:await Promise.all(oe.map(async ne=>{const Ie=I.URI.revive(ne.fileUri);if(!Ie){V.info("Cannot resolve the path because it is not valid.",ne);return}if(!await Y.canHandleResource(Ie)){V.info("Cannot resolve the path because it cannot be handled",ne);return}let Pe=ne.exists,ae=ne.type;if(typeof Pe!="boolean"||typeof ae!="number")try{ae=(await Y.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Pe=!0}catch(Q){V.error(Q),Pe=!1}if(!Pe&&ne.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ne);return}if(ae===g.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ne);return}const te={...ne.options,pinned:!0};return Pe?{resource:Ie,options:te}:{resource:Ie,options:te,forceUntitled:!0}}))}e.$KE=Se;var he;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function fe(oe){const Y=oe;if(!Y)return!1;const V=Y;if(V.modified)return fe(V.modified);const ne=Y;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$LE=fe;function ie(oe){return(0,A.$Ni)(oe)}e.$ME=ie;function ke(oe,Y,V){const ne=(0,A.$Oi)(oe,Y);return ne.forceMessage=V?.forceMessage,ne.forceSeverity=V?.forceSeverity,ne.allowDialog=V?.allowDialog,ne}e.$NE=ke}),define(Ce[205],Re([1,0,5,172,4,6,28,30,18,26,90,196]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WE=e.$VE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$UE=e.$TE=e.ViewContentGroups=e.$SE=e.$RE=e.ViewContainerLocation=e.Extensions=e.$QE=e.$PE=e.$OE=void 0,e.$OE="views",e.$PE=(0,N.localize)(0,null),e.$QE=(0,k.$jw)("default-view-icon",A.$8j.window,(0,N.localize)(1,null));var l;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var p;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel",s[s.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$RE=[0,1,2];function b(s){switch(s){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$SE=b;class r extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Sd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(u,d,v){const f=this.get(u.id);if(f)return f;const S=u;return S.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:S.openCommandActionDescriptor??{id:S.id},(0,R.$xc)(this.g,d,[]).push(S),v?.isDefault&&this.h.push(S),this.c.fire({viewContainer:S,viewContainerLocation:d}),S}deregisterViewContainer(u){for(const d of this.g.keys()){const v=this.g.get(d),f=v?.indexOf(u);if(f!==-1){v?.splice(f,1),v.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}m.$un.add(l.ViewContainersRegistry,new r);var o;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(o||(e.ViewContentGroups=o={}));function t(s,u){const d=s.group??o.More,v=u.group??o.More;return d!==v?d.localeCompare(v):(s.order??5)-(u.order??5)}class n extends L.$Sc{constructor(){super(...arguments),this.c=this.B(new E.$Sd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Sd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Sd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Sd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:v})=>this.r(d,v)),this.c.fire(u)}deregisterViews(u,d){const v=this.s(u,d);v.length&&this.f.fire({views:v,viewContainer:d})}moveViews(u,d){for(const v of this.m.keys())if(v!==d){const f=this.s(u,v);f.length&&(this.r(f,d),this.g.fire({views:f,from:v,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const v=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,L.$Qc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const v=new Map;for(const[f,S]of d)this.n.add(u,S),v.set(f,(0,L.$Qc)(()=>{this.n.delete(u,S),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,v=>d.push(v)),d.sort(t)}r(u,d){let v=this.m.get(d);v||(v=[],this.m.set(d,v),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,N.localize)(2,null,f.id));v.push(f)}}s(u,d){const v=this.m.get(d);if(!v)return[];const f=[],S=[];for(const F of v)u.includes(F)?f.push(F):S.push(F);return f.length&&(S.length?this.m.set(d,S):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}m.$un.add(l.ViewsRegistry,new n),e.$TE=(0,I.$2h)("viewsService"),e.$UE=(0,I.$2h)("viewDescriptorService");var a;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(a||(e.ViewVisibilityState=a={}));var c;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$ln)(this,u),this.d=!!d,this.resolve=async v=>{if(d&&!this.c){const f=await d(v);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$VE=h;class i extends Error{constructor(u){super((0,N.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$WE=i}),define(Ce[206],Re([1,0,2,29,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$NF=e.$MF=void 0;function L(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(N.$Hs.isIRange)}e.$MF=L;function R(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(L)}e.$NF=R;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.ChatAgentCopyKind=g={})),e.$OF=(0,I.$2h)("IChatService")}),define(Ce[207],Re([1,0,5,14,173]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xlb=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new E.$Sd,this.n=new E.$Sd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,w,A){const k={command:m};if(g&&Object.keys(g).length>0&&(k.arguments=g),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const p=this.f.get(k.seq);if(p){this.f.delete(k.seq);const b={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,I.localize)(0,null,A,m)};p(b)}},A)}return w&&this.f.set(k.seq,w),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,N.$3g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,w)=>m.set(w,g)),await(0,N.$3g)(500),m.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$xlb=L}),define(Ce[208],Re([1,0,174,35,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$xH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$wH=e.MemoryRangeType=e.$vH=e.State=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=void 0,e.$sG="workbench.view.debug",e.$tG="workbench.debug.variablesView",e.$uG="workbench.debug.watchExpressionsView",e.$vG="workbench.debug.callStackView",e.$wG="workbench.debug.loadedScriptsView",e.$xG="workbench.debug.breakPointsView",e.$yG="workbench.debug.disassemblyView",e.$zG="workbench.panel.repl",e.$AG="workbench.panel.repl.view",e.$BG=new N.$gj("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$CG=new N.$gj("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$DG=new N.$gj("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$EG="debugUx",e.$FG=new N.$gj(e.$EG,"default",{type:"string",description:E.localize(3,null)}),e.$GG=new N.$gj("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$HG=new N.$gj("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$IG=new N.$gj("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$JG=new N.$gj("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$KG=new N.$gj("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$LG=new N.$gj("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$MG=new N.$gj("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$NG=new N.$gj("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$OG=new N.$gj("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$PG=new N.$gj("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$QG=new N.$gj("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$RG=new N.$gj("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$SG=new N.$gj("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$TG=new N.$gj("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$UG=new N.$gj("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$VG=new N.$gj("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$WG=new N.$gj("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$XG=new N.$gj("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$YG=new N.$gj("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$ZG=new N.$gj("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$1G=new N.$gj("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$2G=new N.$gj("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$3G=new N.$gj("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$4G=new N.$gj("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$5G=new N.$gj("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$6G=new N.$gj("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$7G=new N.$gj("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$8G=new N.$gj("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$9G=new N.$gj("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$0G=new N.$gj("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$$G=new N.$gj("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$_G=new N.$gj("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$aH=new N.$gj("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$bH=new N.$gj("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$cH=new N.$gj("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$dH=new N.$gj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$eH=new N.$gj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$fH=new N.$gj("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$gH=new N.$gj("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$hH=new N.$gj("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$iH=new N.$gj("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$jH=new N.$gj("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$kH=new N.$gj("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$lH=new N.$gj("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$mH=new N.$gj("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$nH=new N.$gj("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$oH=new N.$gj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$pH=new N.$gj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const L=l=>E.localize(52,null,l);e.$qH=L,e.$rH="editor.contrib.debug",e.$sH="editor.contrib.breakpoint",e.$tH="debug",e.$uH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var R;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(R||(e.State=R={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$vH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$wH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var A;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$xH=(0,I.$2h)("debugService");var k;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ce[209],Re([1,0,12,2,19,26,13,29,20,18]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.$UF=e.$TF=void 0;const A=/{([^}]+)}/g;function k(F,$,y){return F.replace(A,function(D,M){return $&&M.length>0&&M[0]!=="_"?D:y&&y.hasOwnProperty(M)?y[M]:D})}e.$TF=k;function l(F){const $={};for(const y of Object.keys(F))y.startsWith("!")||($[y]=F[y]);return $}e.$UF=l;function p(F){return F.configuration.request==="attach"&&!b(F)&&(!F.parentSession||p(F.parentSession))}e.$VF=p;function b(F){let $=F.configuration.type;if($)return $==="vslsShare"&&($=F.configuration.adapterProxy.configuration.type),(0,E.$8e)($,"extensionhost")||(0,E.$8e)($,"pwa-extensionhost")?F:F.parentSession?b(F.parentSession):void 0}e.$WF=b;function r(F){return F.type&&(F.label||F.program||F.runtime)}e.$XF=r;function o(F,$,y){let D,M=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=O.exec(F);){const z=W.index+1,q=z+W[0].length;if(z<=$&&q>=y){D=W[0],M=z;break}}if(D){const z=/\w+/g;let q=null;for(;(q=z.exec(D))&&!(q.index+1+M+q[0].length>=y););q&&(D=D.substring(0,z.lastIndex))}return D?{start:M,end:M+D.length-1}:{start:0,end:0}}e.$YF=o;async function t(F,$,y,D){if(F.evaluatableExpressionProvider.has($)){const M=F.evaluatableExpressionProvider.ordered($),O=(0,w.$Hb)(await Promise.all(M.map(async W=>{try{return await W.provideEvaluatableExpression($,y,D??g.CancellationToken.None)}catch{return}})));if(O.length>0){let W=O[0].expression;const z=O[0].range;return W||(W=$.getLineContent(y.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:W}}}else{const M=$.getLineContent(y.lineNumber),{start:O,end:W}=o(M,y.column,y.column),z=M.substring(O-1,W);return{matchingExpression:z,range:new m.$Hs(y.lineNumber,O,y.lineNumber,O+z.length)}}return null}e.$ZF=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(F){return!!(F&&F.match(n))}e.$1F=a;function c(F){if(typeof F.path=="string"&&!(typeof F.sourceReference=="number"&&F.sourceReference>0)){if(a(F.path))return N.URI.parse(F.path);if((0,I.$ic)(F.path))return N.URI.file(F.path)}return F.path}function h(F){if(typeof F.path=="object"){const $=N.URI.revive(F.path);if($)return $.scheme===R.Schemas.file?$.fsPath:$.toString()}return F.path}function i(F,$){const y=$?c:h,D=(0,L.$in)(F);return u(D,(M,O)=>{M&&O&&(O.path=y(O))}),D}e.$2F=i;function s(F,$){const y=$?c:h,D=(0,L.$in)(F);return u(D,(M,O)=>{!M&&O&&(O.path=y(O))}),D}e.$3F=s;function u(F,$){switch(F.type){case"event":{const y=F;switch(y.event){case"output":$(!1,y.body.source);break;case"loadedSource":$(!1,y.body.source);break;case"breakpoint":$(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=F;switch(y.command){case"setBreakpoints":$(!0,y.arguments.source);break;case"breakpointLocations":$(!0,y.arguments.source);break;case"source":$(!0,y.arguments.source);break;case"gotoTargets":$(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>$(!1,D));break;default:break}break}case"response":{const y=F;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>$(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>$(!1,D));break;case"scopes":y.body.scopes.forEach(D=>$(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>$(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>$(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(M=>$(!1,M.location));break;default:break}break}}}function d(F){return F.filter($=>!$.presentation?.hidden).sort(($,y)=>$.presentation?y.presentation?$.presentation.group?y.presentation.group?$.presentation.group!==y.presentation.group?$.presentation.group.localeCompare(y.presentation.group):v($.presentation.order,y.presentation.order):-1:y.presentation.group?1:v($.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$4F=d;function v(F,$){return typeof F!="number"?typeof $!="number"?0:1:typeof $!="number"?-1:F-$}async function f(F,$){const y=F.getValue("debug.saveBeforeStart",{overrideIdentifier:$.activeTextEditorLanguageId});if(y!=="none"&&(await $.saveAll(),y==="allEditorsInActiveGroup")){const D=$.activeEditorPane;D&&D.input.resource?.scheme===R.Schemas.untitled&&await $.save({editor:D.input,groupId:D.group.id})}await F.reloadConfiguration()}e.$5F=f;const S=(F,$)=>!F||!$?F===$:F.name===$.name&&F.path===$.path&&F.sourceReference===$.sourceReference;e.$6F=S}),define(Ce[76],Re([1,0,24,34,67,68,13,19,21,35]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UI=e.$TI=e.$SI=e.$RI=e.CellStatusbarAlignment=e.$QI=e.$PI=e.$OI=e.NotebookEditorPriority=e.$NI=e.$MI=e.$LI=e.$KI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$JI=e.$II=e.$HI=e.$GI=e.CellKind=e.$FI=e.$EI=e.$DI=void 0,e.$DI="workbench.editor.notebook",e.$EI="workbench.editor.notebookTextDiffEditor",e.$FI="workbench.editor.interactive";var A;(function(P){P[P.Markup=1]="Markup",P[P.Code=2]="Code"})(A||(e.CellKind=A={})),e.$GI=["application/json","application/javascript","text/html","image/svg+xml",L.$4r.latex,L.$4r.markdown,"image/png","image/jpeg",L.$4r.text],e.$HI=[L.$4r.latex,L.$4r.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$4r.text],e.$II=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$JI="_notAvailable";var k;(function(P){P[P.Running=1]="Running",P[P.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var l;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var p;(function(P){P[P.Unconfirmed=1]="Unconfirmed",P[P.Pending=2]="Pending",P[P.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var b;(function(P){P[P.WithHardKernelDependency=0]="WithHardKernelDependency",P[P.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",P[P.Pure=2]="Pure",P[P.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var r;(function(P){P.Always="always",P.Never="never",P.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var o;(function(P){P[P.ModelChange=1]="ModelChange",P[P.Move=2]="Move",P[P.ChangeCellLanguage=5]="ChangeCellLanguage",P[P.Initialize=6]="Initialize",P[P.ChangeCellMetadata=7]="ChangeCellMetadata",P[P.Output=8]="Output",P[P.OutputItem=9]="OutputItem",P[P.ChangeCellContent=10]="ChangeCellContent",P[P.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",P[P.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",P[P.ChangeCellMime=13]="ChangeCellMime",P[P.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var t;(function(P){P[P.Handle=0]="Handle",P[P.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(P){P[P.Replace=1]="Replace",P[P.Output=2]="Output",P[P.Metadata=3]="Metadata",P[P.CellLanguage=4]="CellLanguage",P[P.DocumentMetadata=5]="DocumentMetadata",P[P.Move=6]="Move",P[P.OutputItems=7]="OutputItems",P[P.PartialMetadata=8]="PartialMetadata",P[P.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var a;(function(P){P.scheme=R.Schemas.vscodeNotebookCell;const J=["W","X","Y","Z","a","b","c","d","e","f"],ce=new RegExp(`^[${J.join("")}]+`),me=7;function be(oe,Y){const V=Y.toString(me),Ie=`${V.length<J.length?J[V.length-1]:"z"}${V}s${(0,E.$Ae)(E.$ge.fromString(oe.scheme),!0,!0)}`;return oe.with({scheme:P.scheme,fragment:Ie})}P.generate=be;function Se(oe){if(oe.scheme!==P.scheme)return;const Y=oe.fragment.indexOf("s");if(Y<0)return;const V=parseInt(oe.fragment.substring(0,Y).replace(ce,""),me),ne=(0,E.$ze)(oe.fragment.substring(Y+1)).toString();if(!isNaN(V))return{handle:V,notebook:oe.with({scheme:ne,fragment:null})}}P.parse=Se;function he(oe,Y){return oe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${oe.scheme!==R.Schemas.file?oe.scheme:""}`})}P.generateCellOutputUri=he;function fe(oe){if(oe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!Y)return;const V=Y[1]&&Y[1]!==""?Y[1]:void 0,ne=Y[2];return{outputId:V,notebook:oe.with({scheme:ne||R.Schemas.file,fragment:null})}}P.parseCellOutputUri=fe;function ie(oe,Y,V){return P.generate(oe,Y).with({scheme:V})}P.generateCellPropertyUri=ie;function ke(oe,Y){if(oe.scheme===Y)return P.parse(oe.with({scheme:P.scheme}))}P.parseCellPropertyUri=ke})(a||(e.CellUri=a={}));const c=P=>g.$i?P.replace(/\//g,"\\"):P;class h{constructor(J=[],ce=e.$GI){this.e=ce,this.d=[...new Set(J)].map(me=>({pattern:me,matches:N.$Ij(c(me))}))}sort(J){const ce=new Map(I.Iterable.map(J,be=>[be,c(be)]));let me=[];for(const{matches:be}of this.d)for(const[Se,he]of ce)if(be(he)){me.push(Se),ce.delete(Se);break}return ce.size&&(me=me.concat([...ce.keys()].sort((be,Se)=>this.e.indexOf(be)-this.e.indexOf(Se)))),me}prioritize(J,ce){const me=this.f(J);if(me===-1){this.d.unshift({pattern:J,matches:N.$Ij(c(J))});return}const be=new Set(ce.map(he=>this.f(he,me)));be.delete(-1);const Se=Array.from(be).sort();this.d.splice(me+1,0,...Se.map(he=>this.d[he]));for(let he=Se.length-1;he>=0;he--)this.d.splice(Se[he],1)}toArray(){return this.d.map(J=>J.pattern)}f(J,ce=this.d.length){const me=c(J);for(let be=0;be<ce;be++)if(this.d[be].matches(me))return be;return-1}}e.$KI=h;function i(P,J,ce,me=(be,Se)=>be===Se){const be=[];function Se(ie,ke,oe){if(ke===0&&oe.length===0)return;const Y=be[be.length-1];Y&&Y.start+Y.deleteCount===ie?(Y.deleteCount+=ke,Y.toInsert.push(...oe)):be.push({start:ie,deleteCount:ke,toInsert:oe})}let he=0,fe=0;for(;;){if(he===P.length){Se(he,0,J.slice(fe));break}if(fe===J.length){Se(he,P.length-he,[]);break}const ie=P[he],ke=J[fe];if(me(ie,ke)){he+=1,fe+=1;continue}ce(ke)?(Se(he,1,[]),he+=1):(Se(he,0,[ke]),fe+=1)}return be}e.$LI=i,e.$MI=new w.$gj("notebookEditorCursorAtBoundary","none"),e.$NI=new w.$gj("notebookEditorCursorAtLineBoundary","none");var s;(function(P){P.default="default",P.option="option"})(s||(e.NotebookEditorPriority=s={}));function u(P){const J=P;return!!((typeof J.include=="string"||N.$Jj(J.include))&&(typeof J.exclude=="string"||N.$Jj(J.exclude)))}e.$OI=u;function d(P,J,ce){if(Array.isArray(P.viewType)&&P.viewType.indexOf(J)>=0||P.viewType===J)return!0;if(P.filenamePattern){const me=u(P.filenamePattern)?P.filenamePattern.include:P.filenamePattern,be=u(P.filenamePattern)?P.filenamePattern.exclude:void 0;if(N.$Hj(me,(0,m.$nc)(ce.fsPath).toLowerCase()))return!(be&&N.$Hj(be,(0,m.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$PI=d,e.$QI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var v;(function(P){P[P.Left=1]="Left",P[P.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class f{static{this.d="notebook/"}static create(J){return`${f.d}${J}`}static parse(J){if(J.startsWith(f.d))return J.substring(f.d.length)}}e.$RI=f;function S(P){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(P)}e.$SI=S;const F=new TextDecoder;function $(P){const J=[];let ce=!1;for(const he of P)(J.length===0||ce)&&(J.push(he),ce=!0);let me=M(J);const be=E.$ge.concat(J.map(he=>E.$ge.wrap(he))),Se=C(be);return me=me||Se.byteLength!==be.byteLength,{data:Se,didCompression:me}}e.$TI=$,e.$UI=`${String.fromCharCode(27)}[A`;const y=e.$UI.split("").map(P=>P.charCodeAt(0)),D=10;function M(P){let J=!1;return P.forEach((ce,me)=>{if(me===0||ce.length<e.$UI.length)return;const be=P[me-1],Se=ce.subarray(0,e.$UI.length);if(Se[0]===y[0]&&Se[1]===y[1]&&Se[2]===y[2]){const he=be.lastIndexOf(D);if(he===-1)return;J=!0,P[me-1]=be.subarray(0,he),P[me]=ce.subarray(e.$UI.length)}}),J}function O(P){let J=P;do P=J,J=P.replace(/[^\n]\x08/gm,"");while(J.length<P.length);return P}function W(P){for(P=P.replace(/\r+\n/gm,`
`);P.search(/\r[^$]/g)>-1;){const J=P.match(/^(.*)\r+/m)[1];let ce=P.match(/\r+(.*)$/m)[1];ce=ce+J.slice(ce.length,J.length),P=P.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return P}const z="\b".charCodeAt(0),q="\r".charCodeAt(0);function C(P){return!P.buffer.includes(z)&&!P.buffer.includes(q)?P:E.$ge.fromString(W(O(F.decode(P.buffer))))}}),define(Ce[7],Re([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b){"use strict";var r,o,t,n,a,c,h,i,s,u,d,v,f,S,F,$,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$HM=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$GM=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.$wM=e.$vM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TestRunProfileKind=e.TestResultState=e.$mM=e.$lM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$kM=e.NotebookVariablesRequestKind=e.$jM=e.$iM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$hM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.ColorThemeKind=e.$bM=e.$aM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$_L=e.DebugConsoleMode=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$6L=e.$5L=e.FileChangeType=e.$4L=e.$3L=e.$2L=e.$1L=e.InlineCompletionTriggerKind=e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.ConfigurationTarget=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$DL=e.ViewBadge=e.ProgressLocation=e.$CL=e.$BL=e.TaskScope=e.ShellQuoting=e.$AL=e.$zL=e.$yL=e.TaskPanelKind=e.TaskRevealKind=e.$xL=e.TerminalLocation=e.$wL=e.$vL=e.$uL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$tL=e.$sL=e.$rL=e.$qL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$pL=e.StatusBarAlignment=e.ViewColumn=e.$oL=e.$nL=e.$mL=e.$lL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$kL=e.$jL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.LanguageStatusSeverity=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.CodeActionTriggerKind=e.$0K=e.$9K=e.SymbolTag=e.SymbolKind=e.$8K=e.$7K=e.DocumentHighlightKind=e.$6K=e.$5K=e.$4K=e.$3K=e.DiagnosticSeverity=e.DiagnosticTag=e.$2K=e.$1K=e.FileEditType=e.$ZK=e.$YK=e.$XK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$WK=e.$VK=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(B){return Object.assign(B,{apply:function(...se){if(se.length===0)return Reflect.construct(B,[]);{const De=se.length===1?[]:se[1];return Reflect.construct(B,De,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(B,[]);{const[De,...Je]=se;return Reflect.construct(B,Je,De.constructor)}}})}var M;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var O;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(O||(e.TerminalQuickFixType=O={}));let W=r=class{static from(...j){let se=j;return new r(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(j){this.#e=j}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$QK=W,e.$QK=W=r=Ge([D],W);let z=o=class{static Min(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let De=1;De<j.length;De++){const Je=j[De];Je.isBefore(se)&&(se=Je)}return se}static Max(...j){if(j.length===0)throw new TypeError;let se=j[0];for(let De=1;De<j.length;De++){const Je=j[De];Je.isAfter(se)&&(se=Je)}return se}static isPosition(j){if(!j)return!1;if(j instanceof o)return!0;const{line:se,character:De}=j;return typeof se=="number"&&typeof De=="number"}static of(j){if(j instanceof o)return j;if(this.isPosition(j))return new o(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,se){if(j<0)throw(0,N.$7)("line must be non-negative");if(se<0)throw(0,N.$7)("character must be non-negative");this.c=j,this.e=se}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,se=0){if(j===null||se===null)throw(0,N.$7)();let De;return typeof j>"u"?De=0:typeof j=="number"?De=j:(De=typeof j.lineDelta=="number"?j.lineDelta:0,se=typeof j.characterDelta=="number"?j.characterDelta:0),De===0&&se===0?this:new o(this.line+De,this.character+se)}with(j,se=this.character){if(j===null||se===null)throw(0,N.$7)();let De;return typeof j>"u"?De=this.line:typeof j=="number"?De=j:(De=typeof j.line=="number"?j.line:this.line,se=typeof j.character=="number"?j.character:this.character),De===this.line&&se===this.character?this:new o(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.$RK=z,e.$RK=z=o=Ge([D],z);let q=t=class{static isRange(j){return j instanceof t?!0:j?z.isPosition(j.start)&&z.isPosition(j.end):!1}static of(j){if(j instanceof t)return j;if(this.isRange(j))return new t(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,se,De,Je){let xe,ct;if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new z(j,se),ct=new z(De,Je)):z.isPosition(j)&&z.isPosition(se)&&(xe=z.of(j),ct=z.of(se)),!xe||!ct)throw new Error("Invalid arguments");xe.isBefore(ct)?(this.c=xe,this.e=ct):(this.c=ct,this.e=xe)}contains(j){return t.isRange(j)?this.contains(j.start)&&this.contains(j.end):z.isPosition(j)?!(z.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const se=z.Max(j.start,this.c),De=z.Min(j.end,this.e);if(!se.isAfter(De))return new t(se,De)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const se=z.Min(j.start,this.c),De=z.Max(j.end,this.end);return new t(se,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,se=this.end){if(j===null||se===null)throw(0,N.$7)();let De;return j?z.isPosition(j)?De=j:(De=j.start||this.start,se=j.end||this.end):De=this.start,De.isEqual(this.c)&&se.isEqual(this.end)?this:new t(De,se)}toJSON(){return[this.start,this.end]}};e.$SK=q,e.$SK=q=t=Ge([D],q);let C=n=class extends q{static isSelection(j){return j instanceof n?!0:j?q.isRange(j)&&z.isPosition(j.anchor)&&z.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,se,De,Je){let xe,ct;if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(xe=new z(j,se),ct=new z(De,Je)):z.isPosition(j)&&z.isPosition(se)&&(xe=z.of(j),ct=z.of(se)),!xe||!ct)throw new Error("Invalid arguments");super(xe,ct),this.f=xe,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$TK=C,e.$TK=C=n=Ge([D],C);const P=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class J{static isResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.host=="string"&&typeof j.port=="number"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se,De){if(typeof j!="string"||j.length===0)throw(0,N.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,N.$7)("port");typeof De<"u"&&P(De),this.host=j,this.port=Math.round(se),this.connectionToken=De}}e.$UK=J;class ce{static isManagedResolvedAuthority(j){return j&&typeof j=="object"&&typeof j.makeConnection=="function"&&(j.connectionToken===void 0||typeof j.connectionToken=="string")}constructor(j,se){this.makeConnection=j,this.connectionToken=se,typeof se<"u"&&P(se)}}e.$VK=ce;class me extends Error{static NotAvailable(j,se){return new me(j,p.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(j){return new me(j,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,se=p.RemoteAuthorityResolverErrorCode.Unknown,De){super(j),this._message=j,this._code=se,this._detail=De,Object.setPrototypeOf(this,me.prototype)}}e.$WK=me;var be;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var Se;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Se||(e.EnvironmentVariableMutatorType=Se={}));let he=a=class{static isTextEdit(j){return j instanceof a?!0:j?q.isRange(j)&&typeof j.newText=="string":!1}static replace(j,se){return new a(j,se)}static insert(j,se){return a.replace(new q(j,j),se)}static delete(j){return a.replace(j,"")}static setEndOfLine(j){const se=new a(new q(new z(0,0),new z(0,0)),"");return se.newEol=j,se}get range(){return this.c}set range(j){if(j&&!q.isRange(j))throw(0,N.$7)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,N.$7)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,N.$7)("newEol");this.f=j}constructor(j,se){this.c=j,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$XK=he,e.$XK=he=a=Ge([D],he);let fe=c=class{static isNotebookCellEdit(j){return j instanceof c?!0:j?_t.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,se){return new c(j,se)}static insertCells(j,se){return new c(new _t(j,j),se)}static deleteCells(j){return new c(j,[])}static updateCellMetadata(j,se){const De=new c(new _t(j,j),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(j){const se=new c(new _t(0,0),[]);return se.newNotebookMetadata=j,se}constructor(j,se){this.range=j,this.newCells=se}};e.$YK=fe,e.$YK=fe=c=Ge([D],fe);class ie{static isSnippetTextEdit(j){return j instanceof ie?!0:j?q.isRange(j.range)&&Y.isSnippetString(j.snippet):!1}static replace(j,se){return new ie(j,se)}static insert(j,se){return ie.replace(new q(j,j),se)}constructor(j,se){this.range=j,this.snippet=se}}e.$ZK=ie;var ke;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ke||(e.FileEditType=ke={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,se,De,Je){this.c.push({_type:1,from:j,to:se,options:De,metadata:Je})}createFile(j,se,De){this.c.push({_type:1,from:void 0,to:j,options:se,metadata:De})}deleteFile(j,se,De){this.c.push({_type:1,from:j,to:void 0,options:se,metadata:De})}e(j,se,De){this.c.push({_type:3,metadata:De,uri:j,edit:{editType:5,metadata:se},notebookMetadata:se})}f(j,se,De,Je){const xe=se.start,ct=se.end;(xe!==ct||De.length>0)&&this.c.push({_type:5,uri:j,index:xe,count:ct-xe,cells:De,metadata:Je})}g(j,se,De,Je){this.c.push({_type:3,metadata:Je,uri:j,edit:{editType:3,index:se,metadata:De}})}replace(j,se,De,Je){this.c.push({_type:2,uri:j,edit:new he(se,De),metadata:Je})}insert(j,se,De,Je){this.replace(j,new q(se,se),De,Je)}delete(j,se,De){this.replace(j,se,"",De)}has(j){return this.c.some(se=>se._type===2&&se.uri.toString()===j.toString())}set(j,se){if(se)for(const De of se){if(!De)continue;let Je,xe;Array.isArray(De)?(Je=De[0],xe=De[1]):Je=De,fe.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(j,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(j,Je.newNotebookMetadata,xe):this.f(j,Je.range,Je.newCells,xe):ie.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:j,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:j,edit:Je,metadata:xe})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===j.toString()&&(this.c[De]=void 0);break}}(0,E.$Ib)(this.c)}}get(j){const se=[];for(const De of this.c)De._type===2&&De.uri.toString()===j.toString()&&se.push(De.edit);return se}entries(){const j=new L.$Ac;for(const se of this.c)if(se._type===2){let De=j.get(se.uri);De||(De=[se.uri,[]],j.set(se.uri,De)),De[1].push(se.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$1K=oe,e.$1K=oe=Ge([D],oe);let Y=h=class{static isSnippetString(j){return j instanceof h?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=h.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,se=this.e++){if(typeof j=="function"){const De=new h;De.e=this.e,j(De),this.e=De.e,j=De.value}else j=h.c(j);return this.value+="${",this.value+=se,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,se=this.e++){const De=j.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(j,se){if(typeof se=="function"){const De=new h;De.e=this.e,se(De),this.e=De.e,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$2K=Y,e.$2K=Y=h=Ge([D],Y);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ne;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let Ie=i=class{static isLocation(j){return j instanceof i?!0:j?q.isRange(j.range)&&w.URI.isUri(j.uri):!1}constructor(j,se){if(this.uri=j,se)if(q.isRange(se))this.range=q.of(se);else if(z.isPosition(se))this.range=new q(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$3K=Ie,e.$3K=Ie=i=Ge([D],Ie);let Ae=class{static is(j){return j?typeof j.message=="string"&&j.location&&q.isRange(j.location.range)&&w.URI.isUri(j.location.uri):!1}constructor(j,se){this.location=j,this.message=se}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.location.range.isEqual(se.location.range)&&j.location.uri.toString()===se.location.uri.toString()}};e.$4K=Ae,e.$4K=Ae=Ge([D],Ae);let Pe=class{constructor(j,se,De=ne.Error){if(!q.isRange(j))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=j,this.message=se,this.severity=De}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,se){return j===se?!0:!j||!se?!1:j.message===se.message&&j.severity===se.severity&&j.code===se.code&&j.severity===se.severity&&j.source===se.source&&j.range.isEqual(se.range)&&(0,E.$ub)(j.tags,se.tags)&&(0,E.$ub)(j.relatedInformation,se.relatedInformation,Ae.isEqual)}};e.$5K=Pe,e.$5K=Pe=Ge([D],Pe);let ae=class{constructor(j,se){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=se}};e.$6K=ae,e.$6K=ae=Ge([D],ae);var te;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(te||(e.DocumentHighlightKind=te={}));let Q=class{constructor(j,se=te.Text){this.range=j,this.kind=se}toJSON(){return{range:this.range,kind:te[this.kind]}}};e.$7K=Q,e.$7K=Q=Ge([D],Q);let ee=class{constructor(j,se){this.uri=j,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(j=>j.toJSON())}}};e.$8K=ee,e.$8K=ee=Ge([D],ee);var $e;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})($e||(e.SymbolKind=$e={}));var ve;(function(B){B[B.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let Fe=s=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,se,De,Je,xe){this.name=j,this.kind=se,this.containerName=xe,typeof De=="string"&&(this.containerName=De),Je instanceof Ie?this.location=Je:De instanceof q&&(this.location=new Ie(Je,De)),s.validate(this)}toJSON(){return{name:this.name,kind:$e[this.kind],location:this.location,containerName:this.containerName}}};e.$9K=Fe,e.$9K=Fe=s=Ge([D],Fe);let le=u=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(u.validate)}constructor(j,se,De,Je,xe){this.name=j,this.detail=se,this.kind=De,this.range=Je,this.selectionRange=xe,this.children=[],u.validate(this)}};e.$0K=le,e.$0K=le=u=Ge([D],le);var we;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let T=class{constructor(j,se){this.title=j,this.kind=se}};e.$$K=T,e.$$K=T=Ge([D],T);let K=class{static{d=this}static{this.c="."}constructor(j){this.value=j}append(j){return new d(this.value?this.value+d.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+d.c)}};e.$_K=K,e.$_K=K=d=Ge([D],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let H=class{constructor(j,se){if(this.range=j,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$aL=H,e.$aL=H=Ge([D],H);class U{constructor(j,se,De,Je,xe,ct){this.kind=j,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$bL=U;class Z{constructor(j,se){this.fromRanges=se,this.from=j}}e.$cL=Z;class x{constructor(j,se){this.fromRanges=se,this.to=j}}e.$dL=x;var ye;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ye||(e.LanguageStatusSeverity=ye={}));let Te=class{constructor(j,se){this.range=j,this.command=se}get isResolved(){return!!this.command}};e.$eL=Te,e.$eL=Te=Ge([D],Te);let We=v=class{#e;static isMarkdownString(j){return j instanceof v?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,se=!1){this.#e=new I.$dk(j,{supportThemeIcons:se})}get value(){return this.#e.value}set value(j){this.#e.value=j}get isTrusted(){return this.#e.isTrusted}set isTrusted(j){this.#e.isTrusted=j}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(j){this.#e.supportThemeIcons=j}get supportHtml(){return this.#e.supportHtml}set supportHtml(j){this.#e.supportHtml=j}get baseUri(){return this.#e.baseUri}set baseUri(j){this.#e.baseUri=j}appendText(j){return this.#e.appendText(j),this}appendMarkdown(j){return this.#e.appendMarkdown(j),this}appendCodeblock(j,se){return this.#e.appendCodeblock(se??"",j),this}};e.$fL=We,e.$fL=We=v=Ge([D],We);let He=class{constructor(j,se){this.label=j,this.documentation=se}};e.$gL=He,e.$gL=He=Ge([D],He);let Xe=class{constructor(j,se){this.label=j,this.documentation=se,this.parameters=[]}};e.$hL=Xe,e.$hL=Xe=Ge([D],Xe);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$iL=rt,e.$iL=rt=Ge([D],rt);var it;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var et;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(et||(e.InlayHintKind=et={}));let ot=class{constructor(j){this.value=j}};e.$jL=ot,e.$jL=ot=Ge([D],ot);let at=class{constructor(j,se,De){this.position=j,this.label=se,this.kind=De}};e.$kL=at,e.$kL=at=Ge([D],at);var ze;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze||(e.CompletionTriggerKind=ze={}));var pt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(pt||(e.CompletionItemKind=pt={}));var X;(function(B){B[B.Deprecated=1]="Deprecated"})(X||(e.CompletionItemTag=X={}));let _=class{constructor(j,se){this.label=j,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&pt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$lL=_,e.$lL=_=Ge([D],_);let pe=class{constructor(j=[],se=!1){this.items=j,this.isIncomplete=se}};e.$mL=pe,e.$mL=pe=Ge([D],pe);let Be=class{constructor(j,se,De){this.insertText=j,this.range=se,this.command=De}};e.$nL=Be,e.$nL=Be=Ge([D],Be);let Qe=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.$oL=Qe,e.$oL=Qe=Ge([D],Qe);var tt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(tt||(e.ViewColumn=tt={}));var nt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Ne(B,j){return`${k.$hm.toKey(B)}.${j}`}e.$pL=Ne;var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(It||(e.TextEditorLineNumbersStyle=It={}));var Ft;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Ft||(e.TextDocumentSaveReason=Ft={}));var Kt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Kt||(e.TextEditorRevealType=Kt={}));var Ut;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var wt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(wt||(e.TextDocumentChangeReason=wt={}));var qt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(B){function j(se){switch(se){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=j}(Ut||(e.TextEditorSelectionChangeKind=Ut={}));var Mt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Mt||(e.SyntaxTokenType=Mt={})),function(B){function j(se){switch(se){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=j}(Mt||(e.SyntaxTokenType=Mt={}));let Qt=class{constructor(j,se){if(se&&!w.URI.isUri(se))throw(0,N.$7)("target");if(!q.isRange(j)||j.isEmpty)throw(0,N.$7)("range");this.range=j,this.target=se}};e.$qL=Qt,e.$qL=Qt=Ge([D],Qt);let Ot=class{constructor(j,se,De,Je){this.red=j,this.green=se,this.blue=De,this.alpha=Je}};e.$rL=Ot,e.$rL=Ot=Ge([D],Ot);let Ct=class{constructor(j,se){if(se&&!(se instanceof Ot))throw(0,N.$7)("color");if(!q.isRange(j)||j.isEmpty)throw(0,N.$7)("range");this.range=j,this.color=se}};e.$sL=Ct,e.$sL=Ct=Ge([D],Ct);let Ye=class{constructor(j){if(!j||typeof j!="string")throw(0,N.$7)("label");this.label=j}};e.$tL=Ye,e.$tL=Ye=Ge([D],Ye);var Ht;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ht||(e.ColorFormat=Ht={}));var Gt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(Gt||(e.SourceControlInputBoxValidationType=Gt={}));var ut;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class mt{constructor(j,se,De){if(this.startIndex=j,this.length=se,this.tooltip=De,typeof j!="number"||j<0)throw(0,N.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$uL=mt;class jt{constructor(j){this.uri=j}}e.$vL=jt;class Bt{constructor(j){this.terminalCommand=j}}e.$wL=Bt;var Et;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Et||(e.TerminalLocation=Et={}));class ht{constructor(j){if(this.options=j,typeof j!="object")throw(0,N.$7)("options")}}e.$xL=ht;var Pt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Yt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(Yt||(e.TaskPanelKind=Yt={}));let Dt=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(j){switch(j){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(j,se){if(this.label=se,typeof j!="string"||typeof se!="string")throw(0,N.$7)("name");this.c=j}get id(){return this.c}};e.$yL=Dt,e.$yL=Dt=f=Ge([D],Dt);function qe(B){let j="";for(let se=0;se<B.length;se++)j+=B[se].replace(/,/g,",,")+",";return j}let At=class{constructor(j,se,De){if(typeof j!="string")throw(0,N.$7)("process");this.e=[],this.c=j,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=De):this.f=se)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,N.$7)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const se of this.e)j.push(se);return qe(j)}};e.$zL=At,e.$zL=At=Ge([D],At);let Wt=class{constructor(j,se,De){if(this.f=[],Array.isArray(se)){if(!j)throw(0,N.$7)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,N.$7)("command");this.e=j,this.f=se,this.g=De}else{if(typeof j!="string")throw(0,N.$7)("commandLine");this.c=j,this.g=se}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,N.$7)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,N.$7)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)j.push(typeof se=="string"?se:se.value);return qe(j)}};e.$AL=Wt,e.$AL=Wt=Ge([D],Wt);var Jt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Jt||(e.ShellQuoting=Jt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Lt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,A.$mg)()}set callback(j){this.c=j}get callback(){return this.c}}e.$BL=Lt;let Ee=class{static{S=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(j,se,De,Je,xe,ct){this.k=!1,this.l=this.definition=j;let dt;typeof se=="string"?(this.n=this.name=se,this.u=this.source=De,this.execution=Je,dt=xe,this.k=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,dt=ct):(this.target=se,this.n=this.name=De,this.u=this.source=Je,this.execution=xe,dt=ct),typeof dt=="string"?(this.q=[dt],this.r=!0):Array.isArray(dt)?(this.q=dt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(j){this.j=j}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof At?this.l={type:S.e,id:this.o.computeId()}:this.o instanceof Wt?this.l={type:S.f,id:this.o.computeId()}:this.o instanceof Lt?this.l={type:S.c,id:this.o.computeId()}:this.l={type:S.g,id:(0,A.$mg)()}}get definition(){return this.l}set definition(j){if(j==null)throw(0,N.$7)("Kind can't be undefined or null");this.A(),this.l=j}get scope(){return this.m}set target(j){this.A(),this.m=j}get name(){return this.n}set name(j){if(typeof j!="string")throw(0,N.$7)("name");this.A(),this.n=j}get execution(){return this.o}set execution(j){j===null&&(j=void 0),this.A(),this.o=j;const se=this.l.type;(S.g===se||S.e===se||S.f===se||S.c===se)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(j){if(Array.isArray(j))this.A(),this.q=j,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.A(),this.t=j}get source(){return this.u}set source(j){if(typeof j!="string"||j.length===0)throw(0,N.$7)("source must be a string of length > 0");this.A(),this.u=j}get group(){return this.w}set group(j){j===null&&(j=void 0),this.A(),this.w=j}get detail(){return this.z}set detail(j){j===null&&(j=void 0),this.z=j}get presentationOptions(){return this.x}set presentationOptions(j){j==null&&(j=Object.create(null)),this.A(),this.x=j}get runOptions(){return this.y}set runOptions(j){j==null&&(j=Object.create(null)),this.A(),this.y=j}};e.$CL=Ee,e.$CL=Ee=S=Ge([D],Ee);var Me;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Me||(e.ProgressLocation=Me={}));var de;(function(B){function j(se){const De=se;return(0,g.$If)(De.value)?De.tooltip&&!(0,g.$Ef)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=j})(de||(e.ViewBadge=de={}));let G=F=class{static isTreeItem(j,se){const De=j;if(De.checkboxState!==void 0){const Je=(0,g.$If)(De.checkboxState)?De.checkboxState:(0,g.$Gf)(De.checkboxState)&&(0,g.$If)(De.checkboxState.state)?De.checkboxState.state:void 0,xe=!(0,g.$If)(De.checkboxState)&&(0,g.$Gf)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Ue.Checked&&Je!==Ue.Unchecked||xe!==void 0&&!(0,g.$Ef)(xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(j instanceof F)return!0;if(De.label!==void 0&&!(0,g.$Ef)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$Ef)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$Ef)(De.iconPath)&&!w.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$Ef)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,g.$Ef)(Je.light)&&!w.URI.isUri(Je.light)&&!(0,g.$Ef)(Je.dark)&&!w.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$Ef)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!w.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$Ef)(De.tooltip)&&!(De.tooltip instanceof We)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Le.None&&De.collapsibleState>Le.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$Ef)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(j,se=Le.None){this.collapsibleState=se,w.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.$DL=G,e.$DL=G=F=Ge([D],G);var Le;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Le||(e.TreeItemCollapsibleState=Le={}));var Ue;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Ue||(e.TreeItemCheckboxState=Ue={}));let Ze=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j){this.value=j}};e.$EL=Ze,e.$EL=Ze=Ge([D],Ze);class Ve extends Ze{}e.$FL=Ve;class _e extends Ve{#e;constructor(j){super(""),this.#e=j}asFile(){return this.#e}}e.$GL=_e;class gt{constructor(j,se,De,Je){this.name=j,this.uri=se,this._itemId=De,this.c=Je}data(){return this.c()}}e.$HL=gt;let zt=class{#e=new Map;constructor(j){for(const[se,De]of j??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(De):this.#e.set(this.#t(se),[De])}}get(j){return this.#e.get(this.#t(j))?.[0]}set(j,se){this.#e.set(this.#t(j),[se])}forEach(j,se){for(const[De,Je]of this.#e)for(const xe of Je)j.call(se,xe,De,this)}*[Symbol.iterator](){for(const[j,se]of this.#e)for(const De of se)yield[j,De]}#t(j){return j.toLowerCase()}};e.$IL=zt,e.$IL=zt=Ge([D],zt);let yt=class{constructor(j){this.insertText=j}};e.$JL=yt,e.$JL=yt=Ge([D],yt);let St=class{constructor(j,se){this.label=se,this.insertText=j}};e.$KL=St,e.$KL=St=Ge([D],St);let bt=class{constructor(j,se){this.id=j,this.color=se}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.$LL=bt,e.$LL=bt=Ge([D],bt),bt.File=new bt("file"),bt.Folder=new bt("folder");let fi=class{constructor(j){this.id=j}};e.$ML=fi,e.$ML=fi=Ge([D],fi);var Rt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Rt||(e.ConfigurationTarget=Rt={}));let Si=class{get base(){return this.c}set base(j){this.c=j,this.e=w.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,se){if(typeof j!="string"&&(!j||!w.URI.isUri(j)&&!w.URI.isUri(j.uri)))throw(0,N.$7)("base");if(typeof se!="string")throw(0,N.$7)("pattern");typeof j=="string"?this.baseUri=w.URI.file(j):w.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$NL=Si,e.$NL=Si=Ge([D],Si);const Vi=new WeakMap;function kt(B,j){Vi.set(B,j)}e.$OL=kt;let ni=class{constructor(j,se,De,Je){this.enabled=typeof j=="boolean"?j:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,A.$mg)()),this.c}};e.$PL=ni,e.$PL=ni=Ge([D],ni);let gi=class extends ni{constructor(j,se,De,Je,xe){if(super(se,De,Je,xe),j===null)throw(0,N.$7)("location");this.location=j}};e.$QL=gi,e.$QL=gi=Ge([D],gi);let ai=class extends ni{constructor(j,se,De,Je,xe){super(se,De,Je,xe),this.functionName=j}};e.$RL=ai,e.$RL=ai=Ge([D],ai);let ki=class extends ni{constructor(j,se,De,Je,xe,ct,dt){if(super(Je,xe,ct,dt),!se)throw(0,N.$7)("dataId");this.label=j,this.dataId=se,this.canPersist=De}};e.$SL=ki,e.$SL=ki=Ge([D],ki);let Ii=class{constructor(j,se,De){this.command=j,this.args=se||[],this.options=De}};e.$TL=Ii,e.$TL=Ii=Ge([D],Ii);let Tt=class{constructor(j,se){this.port=j,this.host=se}};e.$UL=Tt,e.$UL=Tt=Ge([D],Tt);let mi=class{constructor(j){this.path=j}};e.$VL=mi,e.$VL=mi=Ge([D],mi);let Ci=class{constructor(j){this.implementation=j}};e.$WL=Ci,e.$WL=Ci=Ge([D],Ci);let ci=class{constructor(j,se,De){this.session=j,this.threadId=se,this.frameId=De}};e.$XL=ci,e.$XL=ci=Ge([D],ci);let ui=class{constructor(j,se){this.session=j,this.threadId=se}};e.$YL=ui,e.$YL=ui=Ge([D],ui);let lt=class{constructor(j,se){this.range=j,this.expression=se}};e.$ZL=lt,e.$ZL=lt=Ge([D],lt);var qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let xt=class{constructor(j,se){this.range=j,this.text=se}};e.$1L=xt,e.$1L=xt=Ge([D],xt);let ri=class{constructor(j,se,De=!0){this.range=j,this.variableName=se,this.caseSensitiveLookup=De}};e.$2L=ri,e.$2L=ri=Ge([D],ri);let $i=class{constructor(j,se){this.range=j,this.expression=se}};e.$3L=$i,e.$3L=$i=Ge([D],$i);let Pi=class{constructor(j,se){this.frameId=j,this.stoppedLocation=se}};e.$4L=Pi,e.$4L=Pi=Ge([D],Pi);var Ki;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ri=$=class extends Error{static FileExists(j){return new $(j,l.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(j){return new $(j,l.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(j){return new $(j,l.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(j){return new $(j,l.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(j){return new $(j,l.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(j){return new $(j,l.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(j,se=l.FileSystemProviderErrorCode.Unknown,De){super(w.URI.isUri(j)?j.toString(!0):j),this.code=De?.name??"Unknown",(0,l.$Bk)(this,se),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$5L=Ri,e.$5L=Ri=$=Ge([D],Ri);let pi=class{constructor(j,se,De){this.start=j,this.end=se,this.kind=De}};e.$6L=pi,e.$6L=pi=Ge([D],pi);var Hi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var li;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var vi;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Li{constructor(j,se=[]){this.tokenTypes=j,this.tokenModifiers=se}}e.$7L=Li;function cn(B){return typeof B>"u"||(0,g.$Ff)(B)}class Fi{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,j){this.m=!0;for(let se=0,De=j.tokenTypes.length;se<De;se++)this.k.set(j.tokenTypes[se],se);for(let se=0,De=j.tokenModifiers.length;se<De;se++)this.l.set(j.tokenModifiers[se],se)}}push(j,se,De,Je,xe){if(typeof j=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.o(j,se,De,Je,xe);if(q.isRange(j)&&typeof se=="string"&&cn(De))return this.n(j,se,De);throw(0,N.$7)()}n(j,se,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=j.start.line,xe=j.start.character,ct=j.end.character-j.start.character,dt=this.k.get(se);let Vt=0;if(De)for(const Xt of De){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Xt);Vt|=1<<ti>>>0}this.o(Je,xe,ct,dt,Vt)}o(j,se,De,Je,xe){if(this.f&&(j<this.c||j===this.c&&se<this.e)){this.f=!1;const Vt=this.g.length/5|0;let Xt=0,ti=0;for(let ii=0;ii<Vt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Xt,Bi+=ti):oi+=Xt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Xt=oi,ti=Bi}}let ct=j,dt=se;this.f&&this.j>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=dt,this.g[this.j++]=De,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=j,this.e=se}static q(j){const se=[],De=j.length/5|0;for(let dt=0;dt<De;dt++)se[dt]=dt;se.sort((dt,Vt)=>{const Xt=j[5*dt],ti=j[5*Vt];if(Xt===ti){const ii=j[5*dt+1],oi=j[5*Vt+1];return ii-oi}return Xt-ti});const Je=new Uint32Array(j.length);let xe=0,ct=0;for(let dt=0;dt<De;dt++){const Vt=5*se[dt],Xt=j[Vt+0],ti=j[Vt+1],ii=j[Vt+2],oi=j[Vt+3],Bi=j[Vt+4],Sn=Xt-xe,On=Sn===0?ti-ct:ti,Wi=5*dt;Je[Wi+0]=Sn,Je[Wi+1]=On,Je[Wi+2]=ii,Je[Wi+3]=oi,Je[Wi+4]=Bi,xe=Xt,ct=ti}return Je}build(j){return this.f?new si(new Uint32Array(this.g),j):new si(Fi.q(this.g),j)}}e.$8L=Fi;class si{constructor(j,se){this.resultId=se,this.data=j}}e.$9L=si;class un{constructor(j,se,De){this.start=j,this.deleteCount=se,this.data=De}}e.$0L=un;class ln{constructor(j,se){this.resultId=se,this.edits=j}}e.$$L=ln;var Ji;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let di=class{static{this.Back={iconPath:new bt("arrow-left")}}constructor(){}};e.$_L=di,e.$_L=di=Ge([D],di);var Qi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var bi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(bi||(e.ExtensionKind=bi={}));class Xi{static validate(j){if(typeof j.badge=="string"){let se=(0,m.$ff)(j.badge,0);if(se<j.badge.length&&(se+=(0,m.$ff)(j.badge,se)),j.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!bt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,se,De){this.badge=j,this.tooltip=se,this.color=De}}e.$aM=Xi;let Mi=class{constructor(j){this.kind=j}};e.$bM=Mi,e.$bM=Mi=Ge([D],Mi);var Ti;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(j){return j instanceof _t?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,se){if(j<0)throw(0,N.$7)("start must be positive");if(se<0)throw(0,N.$7)("end must be positive");j<=se?(this.c=j,this.e=se):(this.c=se,this.e=j)}with(j){let se=this.c,De=this.e;return j.start!==void 0&&(se=j.start),j.end!==void 0&&(De=j.end),se===this.c&&De===this.e?this:new _t(se,De)}}e.$cM=_t;class wi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(se=>wi.isNotebookCellData(se))}static isNotebookCellData(j){return!0}constructor(j,se,De,Je,xe,ct,dt){this.kind=j,this.value=se,this.languageId=De,this.mime=Je,this.outputs=xe??[],this.metadata=ct,this.executionSummary=dt,wi.validate(this)}}e.$dM=wi;class hn{constructor(j){this.cells=j}}e.$eM=hn;class Zt{static isNotebookCellOutputItem(j){return j instanceof Zt?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const se={name:j.name,message:j.message,stack:j.stack};return Zt.json(se,"application/vnd.code.notebook.error")}static stdout(j){return Zt.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Zt.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,se="application/octet-stream"){return new Zt(j,se)}static#e=new TextEncoder;static text(j,se=R.$4r.text){const De=Zt.#e.encode(String(j));return new Zt(De,se)}static json(j,se="text/x-json"){const De=JSON.stringify(j,void 0,"	");return Zt.text(De,se)}constructor(j,se){this.data=j,this.mime=se;const De=(0,R.$8r)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$fM=Zt;class yi{static isNotebookCellOutput(j){return j instanceof yi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,se=!1){const De=new Set,Je=new Set;for(let xe=0;xe<j.length;xe++){const ct=j[xe],dt=(0,R.$8r)(ct.mime);if(!De.has(dt)||(0,b.$SI)(dt)){De.add(dt);continue}Je.add(xe),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Je.size===0?j:j.filter((xe,ct)=>!Je.has(ct))}constructor(j,se,De){this.items=yi.ensureUniqueMimeTypes(j,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,A.$mg)(),this.metadata=se??De)}}e.$gM=yi;var Ei;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Ni;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Ni||(e.NotebookCellExecutionState=Ni={}));var je;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(je||(e.NotebookCellStatusBarAlignment=je={}));var ei;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Yi{constructor(j,se){this.text=j,this.alignment=se}}e.$hM=Yi;var $t;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var xi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(j,se=[]){this.uri=j,this.provides=(0,E.$3b)(se)}}e.$iM=dn;class _i{constructor(j){this.label=j}}e.$jM=_i;var en;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(j,se){this.label=j,this.timestamp=se}};e.$kM=hi,e.$kM=hi=Ge([D],hi);var tn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(j,se){this.ranges=j,this.wordPattern=se}}e.$lM=sn;class fn{constructor(j){this.c=j}get autoForwardAction(){return this.c}}e.$mM=fn;var on;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Oi=class{constructor(j=void 0,se=void 0,De=void 0,Je=!1){this.include=j,this.exclude=se,this.profile=De,this.continuous=Je}};e.$nM=Oi,e.$nM=Oi=Ge([D],Oi);let ji=y=class{static diff(j,se,De){const Je=new y(j);return Je.expectedOutput=se,Je.actualOutput=De,Je}constructor(j){this.message=j}};e.$oM=ji,e.$oM=ji=y=Ge([D],ji);let zi=class{constructor(j){this.id=j}};e.$pM=zi,e.$pM=zi=Ge([D],zi);class Di{constructor(j,se){this.covered=j,this.total=se}}e.$qM=Di;class Ui{static fromDetails(j,se){const De=new Di(0,0),Je=new Di(0,0),xe=new Di(0,0);for(const dt of se)if("branches"in dt){De.total+=1,De.covered+=dt.executionCount>0?1:0;for(const Vt of dt.branches)Je.total+=1,Je.covered+=Vt.executionCount>0?1:0}else xe.total+=1,xe.covered+=dt.executionCount>0?1:0;const ct=new Ui(j,De,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ct.detailedCoverage=se,ct}constructor(j,se,De,Je){this.uri=j,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Je}}e.$rM=Ui;class gn{constructor(j,se,De=[]){this.executionCount=j,this.location=se,this.branches=De}}e.$sM=gn;class mn{constructor(j,se){this.executionCount=j,this.location=se}}e.$tM=mn;class re{constructor(j,se,De){this.name=j,this.executionCount=se,this.location=De}}e.$uM=re;var ue;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(ue||(e.ExternalUriOpenerPriority=ue={}));var Oe;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(Oe||(e.WorkspaceTrustState=Oe={}));var st;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class vt{constructor(j,se,De,Je,xe,ct){this.kind=j,this.name=se,this.detail=De,this.uri=Je,this.range=xe,this.selectionRange=ct}}e.$vM=vt;class Nt{constructor(j){this.uri=j}}e.$wM=Nt;class kn{constructor(j,se){this.original=j,this.modified=se}}e.$xM=kn;class In{constructor(j,se,De,Je){this.base=j,this.input1=se,this.input2=De,this.result=Je}}e.$yM=In;class Cn{constructor(j,se){this.uri=j,this.viewType=se}}e.$zM=Cn;class Pn{constructor(j){this.viewType=j}}e.$AM=Pn;class Rn{constructor(j,se){this.uri=j,this.notebookType=se}}e.$BM=Rn;class An{constructor(j,se,De){this.original=j,this.modified=se,this.notebookType=De}}e.$CM=An;class Ln{constructor(){}}e.$DM=Ln;class Fn{constructor(j,se){this.uri=j,this.inputBoxUri=se}}e.$EM=Fn;class Mn{constructor(j){this.providerId=j}}e.$FM=Mn;var $n;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(pn||(e.ChatAgentCopyKind=pn={}));var vn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(j,se){this.label=j,this.values=se}}e.$GM=Tn;var bn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(bn||(e.InteractiveEditorResponseFeedbackKind=bn={}));var wn;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant",B[B.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));class Nn{constructor(j,se){this.role=j,this.content=se}}e.$HM=Nn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Dn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Ce[103],Re([1,0,53,13,12,295,147,7,18]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=void 0;const w=new Map;function A(b,r){r?w.set(b,r):w.delete(b)}e.$UM=A;function k(b){return w.get(b)}class l extends L.$$u{constructor(r,o,t,n,a,c,h,i){super(o,t,n,a),this.c=r,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,g.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===N.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,t){return r.y(o,t)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,E.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,E.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const t=this.g,n=o.start.line,a=o.end.line,c=[];c.push(this.f[n].substring(o.start.character));for(let h=n+1;h<a;h++)c.push(this.f[h]);return c.push(this.f[a].substring(0,o.end.character)),c.join(t)}t(r){let o;if(r instanceof m.$RK?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new p(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),t=this.f[o.index].length;return new m.$RK(o.index,Math.min(o.remainder,t))}w(r){if(!(r instanceof m.$SK))throw new Error("Invalid argument");const o=this.x(r.start),t=this.x(r.end);return o===r.start&&t===r.end?r:new m.$SK(o.line,o.character,t.line,t.character)}x(r){if(!(r instanceof m.$RK))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:t}=r,n=!1;if(o<0)o=0,t=0,n=!0;else if(o>=this.f.length)o=this.f.length-1,t=this.f[o].length,n=!0;else{const a=this.f[o].length;t<0?(t=0,n=!0):t>a&&(t=a,n=!0)}return n?new m.$RK(o,t):r}y(r,o){const t=this.x(r);if(!o)o=k(this.m);else if((0,I.$Ue)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const n=(0,R.$js)(t.character+1,(0,R.$hs)(o),this.f[t.line],0);if(n)return new m.$SK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$VM=l;class p{constructor(r,o,t){this.a=r,this.b=o,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$SK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$SK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$WM=p}),define(Ce[210],Re([1,0,7,17,5]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;let L=class{constructor(m){this.a=new E.$bM(E.ColorThemeKind.Dark),this.b=new I.$Sd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$bM(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$0gc=L,e.$0gc=L=Ge([Ke(0,N.$SM)],L)}),define(Ce[211],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WI=e.CellExecutionUpdateType=void 0;var N;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$WI=(0,E.$2h)("INotebookExecutionService")}),define(Ce[212],Re([1,0,6,29,144,94]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Pb=void 0;class R extends E.$Sc{constructor(g,w,A){super(),this._source=g,this.b=w,this.c=A,this.a=void 0}f(g){const w=g.getLineCount();return new N.$Hs(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new I.$XB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:A,disposable:k}=w.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new I.$XB;w.acceptChunk(g);const A=w.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(g){const A=new L.$LB(g,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(g){const A=new L.$LB(g,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$0Pb=R}),define(Ce[48],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(L){L.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var N;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class I{static fromExtHostTestItem(R,m,g=R.parent){if(R._isRoot)return new I([m]);const w=[R.id];for(let A=g;A&&A.id!==m;A=A.parent)w.push(A.id);return w.push(m),new I(w.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const m=R.indexOf("\0");return m===-1?R:R.slice(0,m)}static fromString(R){return new I(R.split("\0"))}static join(R,m){return new I([...R.path,m])}static joinToString(R,m){return R.toString()+"\0"+m}static parentId(R){const m=R.lastIndexOf("\0");return m===-1?void 0:R.slice(0,m)}static localId(R){const m=R.lastIndexOf("\0");return m===-1?R:R.slice(m+1)}static isChild(R,m){return m.startsWith(R)&&m[R.length]==="\0"}static compare(R,m){return R===m?0:I.isChild(R,m)?2:I.isChild(m,R)?3:1}constructor(R,m=R.length){if(this.path=R,this.d=m,R.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let m=0;m<R.d&&m<this.d;m++)if(R.path[m]!==this.path[m])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$GJ=I}),define(Ce[58],Re([1,0,2,92,29,48]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$NJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$MJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$LJ=e.$KJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$JJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$IJ=e.$HJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$HJ=[2,4,8,16,32,64];const w=C=>"runId"in C;e.$IJ=w;var A;(function(C){C.serialize=P=>({range:P.range.toJSON(),uri:P.uri.toJSON()}),C.deserialize=(P,J)=>({range:I.$Hs.lift(J.range),uri:P.asCanonicalUri(E.URI.revive(J.uri))})})(A||(e.IRichLocation=A={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=P=>({message:P.message,type:0,expected:P.expected,actual:P.actual,contextValue:P.contextValue,location:P.location&&A.serialize(P.location)}),C.deserialize=(P,J)=>({message:J.message,type:0,expected:J.expected,actual:J.actual,contextValue:J.contextValue,location:J.location&&A.deserialize(P,J.location)})})(l||(e.ITestErrorMessage=l={}));const p=(C,P)=>`${P?"s":"e"}${C}`;e.$JJ=p;var b;(function(C){C.serialize=P=>({message:P.message,type:1,offset:P.offset,length:P.length,location:P.location&&A.serialize(P.location)}),C.deserialize=(P,J)=>({message:J.message,type:1,offset:J.offset,length:J.length,location:J.location&&A.deserialize(P,J.location)})})(b||(e.ITestOutputMessage=b={}));var r;(function(C){C.serialize=P=>P.type===0?l.serialize(P):b.serialize(P),C.deserialize=(P,J)=>J.type===0?l.deserialize(P,J):b.deserialize(P,J)})(r||(e.ITestMessage=r={}));var o;(function(C){C.serializeWithoutMessages=P=>({state:P.state,duration:P.duration,messages:[]}),C.serialize=P=>({state:P.state,duration:P.duration,messages:P.messages.map(r.serialize)}),C.deserialize=(P,J)=>({state:J.state,duration:J.duration,messages:J.messages.map(ce=>r.deserialize(P,ce))})})(o||(e.ITestTaskState=o={}));const t="\0",n=(C,P)=>C+t+P;e.$KJ=n;const a=C=>{const P=C.indexOf(t);return{ctrlId:C.slice(0,P),tagId:C.slice(P+1)}};e.$LJ=a;var c;(function(C){C.serialize=P=>({extId:P.extId,label:P.label,tags:P.tags,busy:P.busy,children:void 0,uri:P.uri?.toJSON(),range:P.range?.toJSON()||null,description:P.description,error:P.error,sortText:P.sortText}),C.deserialize=(P,J)=>({extId:J.extId,label:J.label,tags:J.tags,busy:J.busy,children:void 0,uri:J.uri?P.asCanonicalUri(E.URI.revive(J.uri)):void 0,range:J.range?I.$Hs.lift(J.range):null,description:J.description,error:J.error,sortText:J.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(C){C.serialize=P=>({expand:P.expand,item:c.serialize(P.item)}),C.deserialize=(P,J)=>({controllerId:L.$GJ.root(J.item.extId),expand:J.expand,item:c.deserialize(P,J.item)})})(i||(e.InternalTestItem=i={}));var s;(function(C){C.serialize=P=>{let J;return P.item&&(J={},P.item.label!==void 0&&(J.label=P.item.label),P.item.tags!==void 0&&(J.tags=P.item.tags),P.item.busy!==void 0&&(J.busy=P.item.busy),P.item.uri!==void 0&&(J.uri=P.item.uri?.toJSON()),P.item.range!==void 0&&(J.range=P.item.range?.toJSON()),P.item.description!==void 0&&(J.description=P.item.description),P.item.error!==void 0&&(J.error=P.item.error),P.item.sortText!==void 0&&(J.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:J}},C.deserialize=P=>{let J;return P.item&&(J={},P.item.label!==void 0&&(J.label=P.item.label),P.item.tags!==void 0&&(J.tags=P.item.tags),P.item.busy!==void 0&&(J.busy=P.item.busy),P.item.range!==void 0&&(J.range=P.item.range?I.$Hs.lift(P.item.range):null),P.item.description!==void 0&&(J.description=P.item.description),P.item.error!==void 0&&(J.error=P.item.error),P.item.sortText!==void 0&&(J.sortText=P.item.sortText)),{extId:P.extId,expand:P.expand,item:J}}})(s||(e.ITestItemUpdate=s={}));const u=(C,P)=>{P.expand!==void 0&&(C.expand=P.expand),P.item!==void 0&&(C.item=C.item?Object.assign(C.item,P.item):P.item)};e.$MJ=u;var d;(function(C){C.serializeWithoutMessages=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serializeWithoutMessages)}),C.serialize=P=>({...i.serialize(P),ownComputedState:P.ownComputedState,computedState:P.computedState,tasks:P.tasks.map(o.serialize)}),C.deserialize=(P,J)=>({...i.deserialize(P,J),ownComputedState:J.ownComputedState,computedState:J.computedState,tasks:J.tasks.map(ce=>o.deserialize(P,ce)),retired:!0})})(d||(e.TestResultItem=d={}));var v;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(P,J)=>{P.covered+=J.covered,P.total+=J.total}})(v||(e.ICoveredCount=v={}));var f;(function(C){C.serialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.serialize),uri:P.uri.toJSON()}),C.deserialize=P=>({statement:P.statement,branch:P.branch,function:P.function,details:P.details?.map(y.deserialize),uri:E.URI.from(P.uri)})})(f||(e.IFileCoverage=f={}));function S(C){return{...C,location:C.location?.toJSON()}}function F(C){return C.location=C.location?N.$Gs.isIPosition(C.location)?N.$Gs.lift(C.location):I.$Hs.lift(C.location):void 0,C}e.$NJ=3;var $;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})($||(e.DetailType=$={}));var y;(function(C){C.serialize=P=>P.type===0?M.serialize(P):O.serialize(P),C.deserialize=P=>P.type===0?M.deserialize(P):O.deserialize(P)})(y||(e.CoverageDetails=y={}));var D;(function(C){C.serialize=S,C.deserialize=F})(D||(e.IBranchCoverage=D={}));var M;(function(C){C.serialize=S,C.deserialize=F})(M||(e.IFunctionCoverage=M={}));var O;(function(C){C.serialize=P=>({...S(P),branches:P.branches?.map(D.serialize)}),C.deserialize=P=>({...F(P),branches:P.branches?.map(D.deserialize)})})(O||(e.IStatementCoverage=O={}));var W;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var z;(function(C){C.deserialize=(P,J)=>J.op===0?{op:J.op,item:i.deserialize(P,J.item)}:J.op===1?{op:J.op,item:s.deserialize(J.item)}:J.op===2?{op:J.op,uri:P.asCanonicalUri(E.URI.revive(J.uri)),docv:J.docv}:J,C.serialize=P=>P.op===0?{op:P.op,item:i.serialize(P.item)}:P.op===1?{op:P.op,item:s.serialize(P.item)}:P})(z||(e.TestsDiffOp=z={}));class q{constructor(P){this.k=P,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(P){const J=this.v();for(const ce of P)switch(ce.op){case 0:this.l(i.deserialize(this.k,ce.item),J);break;case 1:this.o(s.deserialize(ce.item),J);break;case 3:this.p(ce.itemId,J);break;case 5:this.q(ce.itemId);break;case 4:this.updatePendingRoots(ce.amount);break;case 6:this.c.set(ce.tag.id,ce.tag);break;case 7:this.c.delete(ce.id);break}J.complete?.()}l(P,J){const ce=L.$GJ.parentId(P.item.extId)?.toString();let me;if(!ce)me=this.w(P),this.g.add(me),this.f.set(P.item.extId,me);else if(this.f.has(ce)){const be=this.f.get(ce);be.children.add(P.item.extId),me=this.w(P,be),this.f.set(P.item.extId,me)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(P)}`);return}return J.add?.(me),P.expand===2&&this.h++,me}o(P,J){const ce=this.f.get(P.extId);if(ce)return P.expand!==void 0&&(ce.expand===2&&this.h--,P.expand===2&&this.h++),(0,e.$MJ)(ce,P),J.update?.(ce),ce}p(P,J){const ce=this.f.get(P);if(!ce)return;const me=L.$GJ.parentId(ce.item.extId)?.toString();me?this.f.get(me).children.delete(ce.item.extId):this.g.delete(ce);const be=[[P]];for(;be.length;)for(const Se of be.pop()){const he=this.f.get(Se);he&&(be.push(he.children),this.f.delete(Se),J.remove?.(he,he!==ce),he.expand===2&&this.h--)}}q(P){}updatePendingRoots(P){this.j+=P}v(){return{}}}e.$OJ=q}),define(Ce[77],Re([1,0,14,5,6,53,58,48]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,a)=>n===a,k=Object.entries({range:(n,a)=>n===a?!0:!n||!a?!1:n.equalsRange(a),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,a)=>!(n.length!==a.length||n.some(c=>!a.includes(c)))}),l=(n,a)=>{let c;for(const[h,i]of k)i(n[h],a[h])||(c?c[h]=a[h]:c={[h]:a[h]});return c};class p extends I.$Sc{get root(){return this.s.root}constructor(a){super(),this.s=a,this.f=this.B(new E.$bh(()=>this.flushDiff(),200)),this.g=this.B(new N.$Sd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(a){this.h=a;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const a=this.m;return this.m=[],a}pushDiff(a){switch(a.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===a.uri){c.docv=a.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===a.item.extId){(0,R.$MJ)(c.item,a.item);return}if(c.op===0&&c.item.item.extId===a.item.extId){(0,R.$MJ)(c.item,a.item);return}}break}}this.m.push(a),this.f.isScheduled()||this.f.schedule()}expand(a,c){const h=this.tree.get(a);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const a of this.tree.values())this.s.getApiFor(a.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(a,c){switch(c.op){case 3:this.O(m.$GJ.joinToString(a.fullId,c.id));break;case 0:this.z(c.item,a);break;case 5:for(const h of c.ops)this.w(a,h);break;case 1:this.C(c.new,c.old,a.fullId.toString());break;case 2:this.J(a);break;case 4:this.pushDiff({op:1,item:{extId:a.fullId.toString(),item:c.update}});break;case 6:this.y(a.actual.uri);break;default:(0,L.$5c)(c)}}y(a){a&&this.pushDiff({op:2,uri:a,docv:this.s.getDocumentVersion(a)})}z(a,c){const h=m.$GJ.fromExtHostTestItem(a,this.root.id,c?.actual),i=this.s.getApiFor(a);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(a.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:a,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},a.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(a,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(a)}}),this.I(a,s,c);return}if(s.actual===a){this.H(a,s,c);return}if(s.actual.uri?.toString()!==a.uri?.toString())return this.O(h.toString()),this.z(a,c);const u=this.s.getChildren(s.actual),d=s.actual,v=l(this.s.toITestItem(d),this.s.toITestItem(a));this.s.getApiFor(d).listener=void 0,s.actual=a,s.expand=0,v&&(v.hasOwnProperty("tags")&&(this.C(a.tags,d.tags,h.toString()),delete v.tags),this.w(s,{op:4,update:v})),this.I(a,s,c);for(const[f,S]of u)this.s.getChildren(a).get(S.id)||this.O(m.$GJ.joinToString(h,S.id));this.y(s.actual.uri)}C(a,c,h){const i=new Set(c.map(s=>s.id));for(const s of a)i.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:a.map(s=>(0,R.$KJ)(this.s.controllerId,s.id))}}}),i.forEach(this.F,this)}D(a){const c=this.j.get(a.id);c?c.refCount++:(this.j.set(a.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$KJ)(this.s.controllerId,a.id)}}))}F(a){const c=this.j.get(a);c&&!--c.refCount&&(this.j.delete(a),this.pushDiff({op:7,id:(0,R.$KJ)(this.s.controllerId,a)}))}G(a,c){this.s.getApiFor(a).parent=c&&c.actual!==this.root?c.actual:void 0}H(a,c,h){this.G(a,h);const i=this.s.getApiFor(a);i.parent=h?.actual,i.listener=s=>this.w(c,s),this.J(c)}I(a,c,h){this.H(a,c,h);for(const[i,s]of this.s.getChildren(a))this.z(s,c)}J(a){let c;this.h?a.resolveBarrier?c=a.resolveBarrier.isOpen()?3:2:c=a.actual.canResolveChildren?1:0:c=0,c!==a.expand&&(a.expand=c,this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:c}}),c===1&&a.expandLevels!==void 0&&this.M(a))}L(a,c){if(c<0)return;const h=[];for(const[i,s]of this.s.getChildren(a.actual)){const u=this.expand(m.$GJ.joinToString(a.fullId,s.id),c);(0,E.$Og)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}M(a){if(a.resolveBarrier)return a.resolveBarrier;if(!this.h){const s=new E.$1g;return s.open(),s}a.expand=2,this.N(a);const c=a.resolveBarrier=new E.$1g,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let i;try{i=this.h(a.actual===this.root?void 0:a.actual)}catch(s){h(s)}return(0,E.$Og)(i)?i.catch(h).then(()=>{c.open(),this.J(a)}):(c.open(),this.J(a)),a.resolveBarrier}N(a){this.pushDiff({op:1,item:{extId:a.fullId.toString(),expand:a.expand}})}O(a){const c=this.tree.get(a);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:a});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.F(s.id);this.tree.delete(i.fullId.toString());for(const[s,u]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$GJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const a=this.collectDiff();a.length&&this.g.fire(a)}}e.$IM=p;class b extends Error{constructor(a){super(`Attempted to insert a duplicate test item ID ${a}`)}}e.$JM=b;class r extends Error{constructor(a){super(`TestItem with ID "${a}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$KM=r;class o extends Error{constructor(a,c,h){super(`TestItem with ID "${a}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$LM=o;const t=(n,a,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,s){for(const u of h.values())i.call(s,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const s=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const v of i){if(!(v instanceof c))throw new r(v.id);const f=a(v).controllerId;if(f!==n.controllerId)throw new o(v.id,f,n.controllerId);if(s.has(v.id))throw new b(v.id);s.set(v.id,v),u.delete(v.id),d.ops.push({op:0,item:v})}for(const v of u.keys())d.ops.push({op:3,id:v});n.listener?.(d),h=s},add(i){if(!(i instanceof c))throw new r(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$MM=t}),define(Ce[104],Re([1,0,77]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=void 0;const N=new WeakMap,I=(R,m)=>{const g={controllerId:m};return N.set(R,g),g};e.$NM=I;const L=R=>{const m=N.get(R);if(!m)throw new E.$KM(R?.id||"<unknown>");return m};e.$OM=L}),define(Ce[78],Re([1,0,13,2]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mvb=e.$lvb=e.$kvb=e.$jvb=e.$ivb=void 0,e.$ivb="vscode-cdn.net",e.$jvb=`vscode-resource.${e.$ivb}`,e.$kvb=`'self' https://*.${e.$ivb}`;function I(m,g){return m.scheme===E.Schemas.http||m.scheme===E.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===E.Schemas.file&&(m=N.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:m.path})),N.URI.from({scheme:E.Schemas.https,authority:`${m.scheme}+${L(m.authority)}.${e.$jvb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$lvb=I;function L(m){return m.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function R(m){return m.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$mvb=R}),define(Ce[213],Re([1,0,5,6,78]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=void 0;class L{constructor(m,g,w){this.d=m,this.e=g,this.f=w,this.a=0,this.b=new N.$Rc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const A=g.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,w,A,k){let l;for(const a of this.e.getVisibleTextEditors(!0))if(a.value===m){l=a;break}if(!l)throw new Error("not a visible editor");const p=this,b=this.a++,r=new E.$Sd,o=new E.$Sd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(a){return(0,I.$lvb)(a,p.f)}get cspSource(){return I.$kvb}set options(a){this.b=a,p.d.$setOptions(b,a)}get options(){return this.b}set html(a){this.a=a,p.d.$setHtml(b,a)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(a){return p.d.$postMessage(b,a)}},n=new class{constructor(){this.editor=m,this.line=g,this.height=w,this.webview=t,this.onDidDispose=o.event}dispose(){p.c.has(b)&&(p.c.delete(b),p.d.$disposeEditorInset(b),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,g+1,w,A||{},k.identifier,k.extensionLocation),this.c.set(b,{editor:m,inset:n,onDidReceiveMessage:r}),n}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$tfc=L}),define(Ce[214],Re([1,0,4]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.VariableKind=e.$EN=void 0,e.$EN=(0,E.$2h)("configurationResolverService");var N;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(N||(e.VariableKind=N={}));class I extends Error{constructor(R,m){super(m),this.variable=R}}e.$FN=I}),define(Ce[215],Re([1,0,19,74,16,26,21,95,177,214,12]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(p,b,r,o){this.h=new Map,this.a=p,this.b=b,this.g=r,o&&(this.c=o.then(t=>this.i(t)))}i(p){if(R.$i){const b=Object.create(null);return Object.keys(p).forEach(r=>{b[r.toLowerCase()]=p[r]}),b}return p}resolveWithEnvironment(p,b,r){return this.l({env:this.i(p),userHome:void 0},b?b.uri:void 0,r)}async resolveAsync(p,b){const r={env:await this.c,userHome:await this.g};return this.l(r,p?p.uri:void 0,b)}async j(p,b,r,o){const t=L.$in(b);R.$i&&t.windows?Object.keys(t.windows).forEach(a=>t[a]=t.windows[a]):R.$j&&t.osx?Object.keys(t.osx).forEach(a=>t[a]=t.osx[a]):R.$k&&t.linux&&Object.keys(t.linux).forEach(a=>t[a]=t.linux[a]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,p?p.uri:void 0,t,r,o)}async resolveAnyAsync(p,b,r){return this.j(p,b,r)}async resolveAnyMap(p,b,r){const o=new Map;return{newConfig:await this.j(p,b,r,o),resolvedVariables:o}}resolveWithInteractionReplace(p,b,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(p,b,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(p,b){if(this.h.has(p))throw new Error("Variable "+p+" is contributed twice.");this.h.set(p,b)}async l(p,b,r,o,t){if(I.$Ef(r))return this.m(p,b,r,o,t);if(Array.isArray(r))return Promise.all(r.map(n=>this.l(p,b,n,o,t)));if(I.$Gf(r)){const n=Object.create(null),a=await Promise.all(Object.keys(r).map(async c=>[await this.m(p,b,c,o,t),await this.l(p,b,r[c],o,t)]));for(const[c,h]of a)n[c]=h;return n}return r}m(p,b,r,o,t){return(0,A.$Ze)(r,k.VARIABLE_REGEXP,async(n,a)=>{if(a.includes(k.VARIABLE_LHS))return n;let c=await this.o(p,n,a,b,o);return t?.set(a,c),c!==n&&I.$Ef(c)&&c.match(k.VARIABLE_REGEXP)&&(c=await this.m(p,b,c,o,t)),c})}n(p){return this.b?this.b.getUriLabel(p,{noPrefix:!0}):p.fsPath}async o(p,b,r,o,t){let n;const a=r.split(":");a.length>1&&(r=a[0],n=a[1]);const c=s=>{const u=this.a.getFilePath();if(u)return(0,m.$Iv)(u);throw new w.$FN(s,(0,g.localize)(0,null,b))},h=s=>{const u=c(s);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,m.$Iv)(d)}throw new w.$FN(s,(0,g.localize)(1,null,b,E.$nc(u)))},i=s=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$FN(s,(0,g.localize)(2,null,b,n))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new w.$FN(s,(0,g.localize)(3,null,b)):new w.$FN(s,(0,g.localize)(4,null,b))};switch(r){case"env":if(n){if(p.env){const s=p.env[R.$i?n.toLowerCase():n];if(I.$Ef(s))return s}return""}throw new w.$FN(w.VariableKind.Env,(0,g.localize)(5,null,b));case"config":if(n){const s=this.a.getConfigurationValue(o,n);if(I.$Nf(s))throw new w.$FN(w.VariableKind.Config,(0,g.localize)(6,null,b,n));if(I.$Gf(s))throw new w.$FN(w.VariableKind.Config,(0,g.localize)(7,null,b,n));return s}throw new w.$FN(w.VariableKind.Config,(0,g.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,t,"command");case"input":return this.p(w.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const s=await this.a.getExtension(n);if(!s)throw new w.$FN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,b,n));return this.n(s.extensionLocation)}throw new w.$FN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,b));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$Iv)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return o||n?(0,m.$Iv)(this.n(i(w.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Iv)(E.$nc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(p.userHome)return p.userHome;throw new w.$FN(w.VariableKind.UserHome,(0,g.localize)(11,null,b))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new w.$FN(w.VariableKind.LineNumber,(0,g.localize)(12,null,b))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new w.$FN(w.VariableKind.SelectedText,(0,g.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$nc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||n?E.$lc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const s=E.$mc(c(w.VariableKind.RelativeFileDirname));if(o||n){const u=E.$lc(this.n(i(w.VariableKind.RelativeFileDirname)),s);return u.length===0?".":u}return s}case"fileDirname":return E.$mc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$oc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$nc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=E.$nc(c(w.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-E.$oc(s).length)}case"fileDirnameBasename":return E.$nc(E.$mc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||b}case"execInstallFolder":{const s=this.a.getAppRoot();return s||b}case"pathSeparator":return E.sep;default:try{const s=n?`${r}:${n}`:r;return this.p(w.VariableKind.Unknown,b,s,t,void 0)}catch{return b}}}}p(p,b,r,o,t){if(r&&o){const n=t===void 0?o[r]:o[t+":"+r];if(typeof n=="string")return n;throw new w.$FN(p,(0,g.localize)(14,null,b))}return b}}e.$TN=k}),define(Ce[105],Re([1,0,4,102]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=e.$TC=e.OpenEditorContext=e.GroupsOrder=e.$SC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$RC=void 0,e.$RC=(0,E.$2h)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var L;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var m;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(b){const r=b;return(0,N.$BE)(r?.editor)&&(0,N.$BE)(r?.replacement)}e.$SC=w;var A;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(b){const r=b;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$TC=l;function p(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$UC=p}),define(Ce[216],Re([1,0,4,105]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC=(0,E.$2h)("editorService"),e.$WC=-1,e.$XC=-2,e.$YC=-3;function I(L){const R=L;return typeof L=="number"||(0,N.$TC)(R)}e.$ZC=I}),define(Ce[217],Re([1,0,4,184]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=void 0,e.$_J=(0,E.$3h)(N.$9h)}),define(Ce[106],Re([1,0,22,5,19,6]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=e.$l7b=e.$k7b=void 0;class R{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$k7b=R;class m{static isHostExtension(t,n,a){if(n.getExtensionDescription(t))return!1;const c=a.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new N.$Sd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$jm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const a of n)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=r(this.e,n),this.e=this.e.concat(t);const a=m.l(this.e);return this.e=r(this.e,a.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,a)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(s){this.d.has(s)||(this.d.add(s),this.e.push(s))}addArc(s,u){this.addNode(s),this.addNode(u),this.c.has(s)?this.c.get(s).push(u):this.c.set(s,[u])}getArcs(s){return this.c.has(s)?this.c.get(s):[]}hasOnlyGoodArcs(s,u){const d=n.getArcs(s);for(let v=0;v<d.length;v++)if(!u.has(d[v]))return!1;return!0}getNodes(){return this.e}},a=new E.$jm;for(const s of t)if(a.set(s.identifier,s),s.extensionDependencies)for(const u of s.extensionDependencies)n.addArc(E.$hm.toKey(s.identifier),E.$hm.toKey(u));const c=new Set;n.getNodes().filter(s=>n.getArcs(s).length===0).forEach(s=>c.add(s));const h=n.getNodes().filter(s=>!c.has(s));let i;do{i=!1;for(let s=0;s<h.length;s++){const u=h[s];n.hasOnlyGoodArcs(u,c)&&(h.splice(s,1),s--,c.add(u),i=!0)}}while(i);return h.map(s=>a.get(s))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$l7b=m;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$m7b=g;class w{constructor(t){this.d=new l,this.c=new m(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new A(this,n)}deltaExtensions(t,n,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$n7b=w;class A extends L.$Sc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$o7b=A;class k{constructor(t){this.name=t,this.promise=new Promise((n,a)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new k(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const a=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(a),n=!1,this.d=!1,this.e())};t.resolve((0,L.$Qc)(c))}}var p;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(p||(p={}));function b(o,t){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==a)return n-a;const c=I.$gc.basename(o.extensionLocation.path),h=I.$gc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function r(o,t){const n=new E.$im(t);return o.filter(a=>!n.has(a.identifier))}}),define(Ce[79],Re([1,0,24]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$qm=e.$pm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(N||(e.UIKind=N={}));var I;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var L;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(w){const A=E.$ge.alloc(1);switch(w){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$pm=R;function m(w,A){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$qm=m;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Ce[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,165]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=e.$$M=e.$0M=void 0;let p=class extends k.$Sc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new N.$Sd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Sd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$Co,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(a=>{(0,I.$lj)(a)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,a){const c=this.getTelemetryDetails(),h=new b(n,a,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,a){this.f=t,this.g=n,this.c=a??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:n["common.uikind"]="web";break;case R.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$0k)((0,g.$Jo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((a,c)=>{const h=a.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(a=>{for(const c of a)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$0M=p,e.$0M=p=Ge([Ke(0,L.$9M),Ke(1,I.$kj)],p);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,a,c,h,i,s){this.g=a,this.h=c,this.i=h,this.j=i,this.a=new N.$Sd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Mo)(n,[]),this.c&&(n=(0,w.$ln)(n,this.c)),this.b||(n=(0,w.$ln)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const a={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Mo)(a,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$$M=b;function r(o){const t=Date.now()-new Date(o).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$_M=r,e.$aN=(0,E.$2h)("IExtHostTelemetry")}),define(Ce[23],Re([1,0,5,2,193,101,22,4]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rF=e.$qF=e.$pF=e.ActivationKind=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.ExtensionHostStartup=e.$jF=e.$iF=e.$hF=e.$gF=void 0,e.$gF=Object.freeze({identifier:new R.$hm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$hF="extensions.webWorker",e.$iF=(0,m.$2h)("extensionService");class g{constructor(h){this.dependency=h}}e.$jF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,s){this.c=h,this.d=i.slice(0),this.e=s.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:L.$4E.createActivationEventsMap(this.d)}}set(h,i,s){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],v=[],f=[],S=k(this.d),F=k(i),$=(W,z)=>W.extensionLocation.toString()===z.extensionLocation.toString()||W.isBuiltin===z.isBuiltin||W.isUserBuiltin===z.isUserBuiltin||W.isUnderDevelopment===z.isUnderDevelopment;for(const W of this.d){const z=F.get(W.identifier);if(!z){u.push(W.identifier),S.delete(W.identifier);continue}if(!$(W,z)){u.push(W.identifier),S.delete(W.identifier);continue}}for(const W of i){const z=S.get(W.identifier);if(!z){d.push(W);continue}if(!$(z,W)){u.push(z.identifier),S.delete(z.identifier);continue}}const y=new R.$im(this.e),D=new R.$im(s);for(const W of this.e)D.has(W)||v.push(W);for(const W of s)y.has(W)||f.push(W);const M=L.$4E.createActivationEventsMap(d),O={versionId:h,toRemove:u,toAdd:d,addActivationEvents:M,myToRemove:v,myToAdd:f};return this.delta(O),O}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:s,myToRemove:u,myToAdd:d}=h,v=new R.$im(i),f=new R.$im(u);for(let S=0;S<this.d.length;S++)v.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)f.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of s)this.d.push(S);for(const S of d)this.e.push(S);return this.f=null,h}containsExtension(h){for(const i of this.e)if(R.$hm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const s=L.$4E.readActivationEvents(i);for(const u of s)h.add(u)}return h}}e.$kF=A;function k(c){const h=new R.$jm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$lF=l;function p(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$mF=p;class b{constructor(h,i,s,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=s,this.activationReason=u}}e.$nF=b;class r{constructor(h,i){this.description=h,this.value=i}}e.$oF=r;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,I.$So)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$pF=t;function n(c,h){return{identifier:new R.$hm((0,I.$Qo)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$qF=n;class a{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$rF=a}),define(Ce[218],Re([1,0,11,106,22,23,15,14]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ufc=e.$Tfc=e.$Sfc=e.$Rfc=e.$Qfc=e.$Pfc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,a,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=a,this.activateResolvedTime=c}}e.$Pfc=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Qfc=w;class A{constructor(t,n,a,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=a,this.module=c,this.exports=h,this.subscriptions=i}}e.$Rfc=A;class k extends A{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Sfc=k;class l extends A{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Tfc=l;class p extends A{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,a,c){this.g=c,this.a=t,this.b=n,this.c=a,this.d=new I.$jm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,a]of this.d)t.push(a.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const a=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(a.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const a=this.a.getExtensionDescription(t);if(!a)throw new Error(`Extension '${t}' is not known`);return this.h([{id:a.identifier,reason:n}])}async h(t){const n=t.filter(a=>!this.isActivated(a.id)).map(a=>this.j(a));await Promise.all(n.map(a=>a.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new p(h));return this.c.onExtensionActivationError(t.id,h,new L.$jF(t.id.value)),i}const a=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){a.push(i);continue}if(this.l(h)){a.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const s=this.a.getExtensionDescription(h);if(s){if(!s.main&&!s.browser)continue;a.push(this.j({id:s.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),v=this.k(t,n.displayName,[],new p(d));return this.c.onExtensionActivationError(n.identifier,d,new L.$jF(h)),v}return this.k(t,n.displayName,a,null)}k(t,n,a,c){const h=new r(t.id,n,t.reason,a,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return N.$l7b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$Ufc=b,e.$Ufc=b=Ge([Ke(3,R.$jj)],b);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,a,c,h,i,s){this.c=t,this.d=n,this.f=a,this.g=c,this.h=h,this.j=i,this.k=s,this.a=new m.$1g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const a=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);a.detail=n.value.activationFailedError,this.h=new p(a),this.j.onExtensionActivationError(this.c,a,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new p(n),this.b&&E.$4(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};r=Ge([Ke(6,R.$jj)],r)}),define(Ce[8],Re([1,0,18,24,127,219,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,216,7,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$RM=e.$QM=e.MarkdownString=e.$PM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(Ee){function Me(G){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:Ze,positionColumn:Ve}=G,_e=new s.$RK(Le-1,Ue-1),gt=new s.$RK(Ze-1,Ve-1);return new s.$TK(_e,gt)}Ee.to=Me;function de(G){const{anchor:Le,active:Ue}=G;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Ee.from=de})(d||(e.Selection=d={}));var v;(function(Ee){function Me(G){if(!G)return;const{start:Le,end:Ue}=G;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Ee.from=Me;function de(G){if(!G)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:Ze,endColumn:Ve}=G;return new s.$SK(Le-1,Ue-1,Ze-1,Ve-1)}Ee.to=de})(v||(e.Range=v={}));var f;(function(Ee){function Me(de){switch(de){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ee.to=Me})(f||(e.TokenType=f={}));var S;(function(Ee){function Me(G){return new s.$RK(G.lineNumber-1,G.column-1)}Ee.to=Me;function de(G){return{lineNumber:G.line+1,column:G.character+1}}Ee.from=de})(S||(e.Position=S={}));var F;(function(Ee){function Me(Le,Ue,Ze){return(0,E.$Hb)((0,E.$3b)(Le).map(Ve=>de(Ve,Ue,Ze)))}Ee.from=Me;function de(Le,Ue,Ze){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:Ze?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:G(Le.scheme,Ue),pattern:X.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:Ze?.isBuiltin}}function G(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(F||(e.DocumentSelector=F={}));var $;(function(Ee){function Me(G){switch(G){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ee.from=Me;function de(G){switch(G){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ee.to=de})($||(e.DiagnosticTag=$={}));var y;(function(Ee){function Me(G){let Le;return G.code&&((0,l.$Ef)(G.code)||(0,l.$If)(G.code)?Le=String(G.code):Le={value:String(G.code.value),target:G.code.target}),{...v.from(G.range),message:G.message,source:G.source,code:Le,severity:M.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(D.from),tags:Array.isArray(G.tags)?(0,E.$Hb)(G.tags.map($.from)):void 0}}Ee.from=Me;function de(G){const Le=new s.$5K(v.to(G),G.message,M.to(G.severity));return Le.source=G.source,Le.code=(0,l.$Ef)(G.code)?G.code:G.code?.value,Le.relatedInformation=G.relatedInformation&&G.relatedInformation.map(D.to),Le.tags=G.tags&&(0,E.$Hb)(G.tags.map($.to)),Le}Ee.to=de})(y||(e.Diagnostic=y={}));var D;(function(Ee){function Me(G){return{...v.from(G.location.range),message:G.message,resource:G.location.uri}}Ee.from=Me;function de(G){return new s.$4K(new s.$3K(G.resource,v.to(G)),G.message)}Ee.to=de})(D||(e.DiagnosticRelatedInformation=D={}));var M;(function(Ee){function Me(G){switch(G){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Ee.from=Me;function de(G){switch(G){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ee.to=de})(M||(e.DiagnosticSeverity=M={}));var O;(function(Ee){function Me(G){return typeof G=="number"&&G>=s.ViewColumn.One?G-1:G===s.ViewColumn.Beside?i.$XC:i.$WC}Ee.from=Me;function de(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=de})(O||(e.ViewColumn=O={}));function W(Ee){return typeof Ee.range<"u"}function z(Ee){return Ee.length===0?!0:!!W(Ee[0])}e.$PM=z;var q;(function(Ee){function Me(Ve){return Ve.map(Ee.from)}Ee.fromMany=Me;function de(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function G(Ve){let _e;if(de(Ve)){const{language:St,value:bt}=Ve;_e={value:"```"+St+`
`+bt+"\n```\n"}}else s.$fL.isMarkdownString(Ve)?_e={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?_e={value:Ve}:_e={value:""};const gt=Object.create(null);_e.uris=gt;const zt=St=>{try{let bt=p.URI.parse(St,!0);bt=bt.with({query:Le(bt.query,gt)}),gt[St]=bt}catch{}return""},yt=new g.marked.Renderer;return yt.link=zt,yt.image=St=>typeof St=="string"?zt(R.$lk(St).href):"",(0,g.marked)(_e.value,{renderer:yt}),_e}Ee.from=G;function Le(Ve,_e){if(!Ve)return Ve;let gt;try{gt=(0,w.$xh)(Ve)}catch{}if(!gt)return Ve;let zt=!1;return gt=(0,k.$kn)(gt,yt=>{if(p.URI.isUri(yt)){const St=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[St]=yt,zt=!0,St}else return}),zt?JSON.stringify(gt):Ve}function Ue(Ve){const _e=new s.$fL(Ve.value,Ve.supportThemeIcons);return _e.isTrusted=Ve.isTrusted,_e.supportHtml=Ve.supportHtml,_e.baseUri=Ve.baseUri?p.URI.from(Ve.baseUri):void 0,_e}Ee.to=Ue;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:Ee.from(Ve)}Ee.fromStrict=Ze})(q||(e.MarkdownString=q={}));function C(Ee){return z(Ee)?Ee.map(Me=>({range:v.from(Me.range),hoverMessage:Array.isArray(Me.hoverMessage)?q.fromMany(Me.hoverMessage):Me.hoverMessage?q.from(Me.hoverMessage):void 0,renderOptions:Me.renderOptions})):Ee.map(Me=>({range:v.from(Me)}))}e.$QM=C;function P(Ee){return typeof Ee>"u"?Ee:typeof Ee=="string"?p.URI.file(Ee):Ee}e.$RM=P;var J;(function(Ee){function Me(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?P(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Ee.from=Me})(J||(e.ThemableDecorationAttachmentRenderOptions=J={}));var ce;(function(Ee){function Me(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?P(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Ee.from=Me})(ce||(e.ThemableDecorationRenderOptions=ce={}));var me;(function(Ee){function Me(de){if(typeof de>"u")return de;switch(de){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Me})(me||(e.DecorationRangeBehavior=me={}));var be;(function(Ee){function Me(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?me.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?ce.from(de.light):void 0,dark:de.dark?ce.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?P(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?J.from(de.before):void 0,after:de.after?J.from(de.after):void 0}}Ee.from=Me})(be||(e.DecorationRenderOptions=be={}));var Se;(function(Ee){function Me(G){return{text:G.newText,eol:G.newEol&&et.from(G.newEol),range:v.from(G.range)}}Ee.from=Me;function de(G){const Le=new s.$XK(v.to(G.range),G.text);return Le.newEol=typeof G.eol>"u"?void 0:et.to(G.eol),Le}Ee.to=de})(Se||(e.TextEdit=Se={}));var he;(function(Ee){function Me(G,Le){const Ue={edits:[]};if(G instanceof s.$1K){const Ze=new m.$Bc;for(const Ve of G._allEntries())Ve._type===1&&p.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of G._allEntries())if(Ve._type===1){let _e;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?_e={type:"base64",value:(0,N.$Ae)(N.$ge.wrap(Ve.options.contents))}:_e={type:"dataTransferItem",id:Ve.options.contents._itemId}),Ue.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:_e},metadata:Ve.metadata})}else Ve._type===2?Ue.edits.push({resource:Ve.uri,textEdit:Se.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?Ue.edits.push({resource:Ve.uri,textEdit:{range:v.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Le?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&Ue.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Le?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(It.from)}})}return Ue}Ee.from=Me;function de(G){const Le=new s.$1K,Ue=new m.$Ac;for(const Ze of G.edits)if(Ze.textEdit){const Ve=Ze,_e=p.URI.revive(Ve.resource),gt=v.to(Ve.textEdit.range),zt=Ve.textEdit.text,yt=Ve.textEdit.insertAsSnippet;let St;yt?St=s.$ZK.replace(gt,new s.$2K(zt)):St=s.$XK.replace(gt,zt);const bt=Ue.get(_e);bt?bt.push(St):Ue.set(_e,[St])}else Le.renameFile(p.URI.revive(Ze.oldResource),p.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of Ue)Le.set(Ze,Ve);return Le}Ee.to=de})(he||(e.WorkspaceEdit=he={}));var fe;(function(Ee){const Me=Object.create(null);Me[s.SymbolKind.File]=0,Me[s.SymbolKind.Module]=1,Me[s.SymbolKind.Namespace]=2,Me[s.SymbolKind.Package]=3,Me[s.SymbolKind.Class]=4,Me[s.SymbolKind.Method]=5,Me[s.SymbolKind.Property]=6,Me[s.SymbolKind.Field]=7,Me[s.SymbolKind.Constructor]=8,Me[s.SymbolKind.Enum]=9,Me[s.SymbolKind.Interface]=10,Me[s.SymbolKind.Function]=11,Me[s.SymbolKind.Variable]=12,Me[s.SymbolKind.Constant]=13,Me[s.SymbolKind.String]=14,Me[s.SymbolKind.Number]=15,Me[s.SymbolKind.Boolean]=16,Me[s.SymbolKind.Array]=17,Me[s.SymbolKind.Object]=18,Me[s.SymbolKind.Key]=19,Me[s.SymbolKind.Null]=20,Me[s.SymbolKind.EnumMember]=21,Me[s.SymbolKind.Struct]=22,Me[s.SymbolKind.Event]=23,Me[s.SymbolKind.Operator]=24,Me[s.SymbolKind.TypeParameter]=25;function de(Le){return typeof Me[Le]=="number"?Me[Le]:6}Ee.from=de;function G(Le){for(const Ue in Me)if(Me[Ue]===Le)return Number(Ue);return s.SymbolKind.Property}Ee.to=G})(fe||(e.SymbolKind=fe={}));var ie;(function(Ee){function Me(G){switch(G){case s.SymbolTag.Deprecated:return 1}}Ee.from=Me;function de(G){switch(G){case 1:return s.SymbolTag.Deprecated}}Ee.to=de})(ie||(e.SymbolTag=ie={}));var ke;(function(Ee){function Me(G){return{name:G.name,kind:fe.from(G.kind),tags:G.tags&&G.tags.map(ie.from),containerName:G.containerName,location:Ie.from(G.location)}}Ee.from=Me;function de(G){const Le=new s.$9K(G.name,fe.to(G.kind),G.containerName,Ie.to(G.location));return Le.tags=G.tags&&G.tags.map(ie.to),Le}Ee.to=de})(ke||(e.WorkspaceSymbol=ke={}));var oe;(function(Ee){function Me(G){const Le={name:G.name||"!!MISSING: name!!",detail:G.detail,range:v.from(G.range),selectionRange:v.from(G.selectionRange),kind:fe.from(G.kind),tags:G.tags?.map(ie.from)??[]};return G.children&&(Le.children=G.children.map(Me)),Le}Ee.from=Me;function de(G){const Le=new s.$0K(G.name,G.detail,fe.to(G.kind),v.to(G.range),v.to(G.selectionRange));return(0,E.$Lb)(G.tags)&&(Le.tags=G.tags.map(ie.to)),G.children&&(Le.children=G.children.map(de)),Le}Ee.to=de})(oe||(e.DocumentSymbol=oe={}));var Y;(function(Ee){function Me(G){const Le=new s.$bL(fe.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),v.to(G.range),v.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ee.to=Me;function de(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:G.name,detail:G.detail,kind:fe.from(G.kind),uri:G.uri,range:v.from(G.range),selectionRange:v.from(G.selectionRange),tags:G.tags?.map(ie.from)}}Ee.from=de})(Y||(e.CallHierarchyItem=Y={}));var V;(function(Ee){function Me(de){return new s.$cL(Y.to(de.from),de.fromRanges.map(G=>v.to(G)))}Ee.to=Me})(V||(e.CallHierarchyIncomingCall=V={}));var ne;(function(Ee){function Me(de){return new s.$dL(Y.to(de.to),de.fromRanges.map(G=>v.to(G)))}Ee.to=Me})(ne||(e.CallHierarchyOutgoingCall=ne={}));var Ie;(function(Ee){function Me(G){return{range:G.range&&v.from(G.range),uri:G.uri}}Ee.from=Me;function de(G){return new s.$3K(p.URI.revive(G.uri),v.to(G.range))}Ee.to=de})(Ie||(e.location=Ie={}));var Ae;(function(Ee){function Me(G){const Le=G,Ue=G;return{originSelectionRange:Le.originSelectionRange?v.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:v.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?v.from(Le.targetSelectionRange):void 0}}Ee.from=Me;function de(G){return{targetUri:p.URI.revive(G.uri),targetRange:v.to(G.range),targetSelectionRange:G.targetSelectionRange?v.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?v.to(G.originSelectionRange):void 0}}Ee.to=de})(Ae||(e.DefinitionLink=Ae={}));var Pe;(function(Ee){function Me(G){return{range:v.from(G.range),contents:q.fromMany(G.contents)}}Ee.from=Me;function de(G){return new s.$6K(G.contents.map(q.to),v.to(G.range))}Ee.to=de})(Pe||(e.Hover=Pe={}));var ae;(function(Ee){function Me(G){return{range:v.from(G.range),expression:G.expression}}Ee.from=Me;function de(G){return new s.$ZL(v.to(G.range),G.expression)}Ee.to=de})(ae||(e.EvaluatableExpression=ae={}));var te;(function(Ee){function Me(G){if(G instanceof s.$1L)return{type:"text",range:v.from(G.range),text:G.text};if(G instanceof s.$2L)return{type:"variable",range:v.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof s.$3L)return{type:"expression",range:v.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Me;function de(G){switch(G.type){case"text":return{range:v.to(G.range),text:G.text};case"variable":return{range:v.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:v.to(G.range),expression:G.expression}}}Ee.to=de})(te||(e.InlineValue=te={}));var Q;(function(Ee){function Me(G){return{frameId:G.frameId,stoppedLocation:v.from(G.stoppedLocation)}}Ee.from=Me;function de(G){return new s.$4L(G.frameId,v.to(G.stoppedLocation))}Ee.to=de})(Q||(e.InlineValueContext=Q={}));var ee;(function(Ee){function Me(G){return{range:v.from(G.range),kind:G.kind}}Ee.from=Me;function de(G){return new s.$7K(v.to(G.range),G.kind)}Ee.to=de})(ee||(e.DocumentHighlight=ee={}));var $e;(function(Ee){function Me(G){return{uri:G.uri,highlights:G.highlights.map(ee.from)}}Ee.from=Me;function de(G){return new s.$8K(p.URI.revive(G.uri),G.highlights.map(ee.to))}Ee.to=de})($e||(e.MultiDocumentHighlight=$e={}));var ve;(function(Ee){function Me(de){switch(de){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ee.to=Me})(ve||(e.CompletionTriggerKind=ve={}));var Fe;(function(Ee){function Me(de){return{triggerKind:ve.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Ee.to=Me})(Fe||(e.CompletionContext=Fe={}));var le;(function(Ee){function Me(G){switch(G){case s.CompletionItemTag.Deprecated:return 1}}Ee.from=Me;function de(G){switch(G){case 1:return s.CompletionItemTag.Deprecated}}Ee.to=de})(le||(e.CompletionItemTag=le={}));var we;(function(Ee){const Me=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function de(Ue){return Me.get(Ue)??9}Ee.from=de;const G=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Le(Ue){return G.get(Ue)??s.CompletionItemKind.Property}Ee.to=Le})(we||(e.CompletionItemKind=we={}));var T;(function(Ee){function Me(de,G){const Le=new s.$lL(de.label);return Le.insertText=de.insertText,Le.kind=we.to(de.kind),Le.tags=de.tags?.map(le.to),Le.detail=de.detail,Le.documentation=R.$fk(de.documentation)?q.to(de.documentation):de.documentation,Le.sortText=de.sortText,Le.filterText=de.filterText,Le.preselect=de.preselect,Le.commitCharacters=de.commitCharacters,b.$Hs.isIRange(de.range)?Le.range=v.to(de.range):typeof de.range=="object"&&(Le.range={inserting:v.to(de.range.insert),replacing:v.to(de.range.replace)}),Le.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Le.insertText=new s.$2K(de.insertText):(Le.insertText=de.insertText,Le.textEdit=Le.range instanceof s.$SK?new s.$XK(Le.range,Le.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Le.additionalTextEdits=de.additionalTextEdits.map(Ue=>Se.to(Ue))),Le.command=G&&de.command?G.fromInternal(de.command):void 0,Le}Ee.to=Me})(T||(e.CompletionItem=T={}));var K;(function(Ee){function Me(G){if(typeof G.label!="string"&&!Array.isArray(G.label))throw new TypeError("Invalid label");return{label:G.label,documentation:q.fromStrict(G.documentation)}}Ee.from=Me;function de(G){return{label:G.label,documentation:R.$fk(G.documentation)?q.to(G.documentation):G.documentation}}Ee.to=de})(K||(e.ParameterInformation=K={}));var H;(function(Ee){function Me(G){return{label:G.label,documentation:q.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(K.from):[],activeParameter:G.activeParameter}}Ee.from=Me;function de(G){return{label:G.label,documentation:R.$fk(G.documentation)?q.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(K.to):[],activeParameter:G.activeParameter}}Ee.to=de})(H||(e.SignatureInformation=H={}));var U;(function(Ee){function Me(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.from):[]}}Ee.from=Me;function de(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(H.to):[]}}Ee.to=de})(U||(e.SignatureHelp=U={}));var Z;(function(Ee){function Me(de,G){const Le=new s.$kL(S.to(G.position),typeof G.label=="string"?G.label:G.label.map(x.to.bind(void 0,de)),G.kind&&ye.to(G.kind));return Le.textEdits=G.textEdits&&G.textEdits.map(Se.to),Le.tooltip=R.$fk(G.tooltip)?q.to(G.tooltip):G.tooltip,Le.paddingLeft=G.paddingLeft,Le.paddingRight=G.paddingRight,Le}Ee.to=Me})(Z||(e.InlayHint=Z={}));var x;(function(Ee){function Me(de,G){const Le=new s.$jL(G.label);return Le.tooltip=R.$fk(G.tooltip)?q.to(G.tooltip):G.tooltip,r.Command.is(G.command)&&(Le.command=de.fromInternal(G.command)),G.location&&(Le.location=Ie.to(G.location)),Le}Ee.to=Me})(x||(e.InlayHintLabelPart=x={}));var ye;(function(Ee){function Me(G){return G}Ee.from=Me;function de(G){return G}Ee.to=de})(ye||(e.InlayHintKind=ye={}));var Te;(function(Ee){function Me(G){return{range:v.from(G.range),url:G.target,tooltip:G.tooltip}}Ee.from=Me;function de(G){let Le;if(G.url)try{Le=typeof G.url=="string"?p.URI.parse(G.url,!0):p.URI.revive(G.url)}catch{}return new s.$qL(v.to(G.range),Le)}Ee.to=de})(Te||(e.DocumentLink=Te={}));var We;(function(Ee){function Me(G){const Le=new s.$tL(G.label);return G.textEdit&&(Le.textEdit=Se.to(G.textEdit)),G.additionalTextEdits&&(Le.additionalTextEdits=G.additionalTextEdits.map(Ue=>Se.to(Ue))),Le}Ee.to=Me;function de(G){return{label:G.label,textEdit:G.textEdit?Se.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Le=>Se.from(Le)):void 0}}Ee.from=de})(We||(e.ColorPresentation=We={}));var He;(function(Ee){function Me(G){return new s.$rL(G[0],G[1],G[2],G[3])}Ee.to=Me;function de(G){return[G.red,G.green,G.blue,G.alpha]}Ee.from=de})(He||(e.Color=He={}));var Xe;(function(Ee){function Me(G){return{range:v.from(G.range)}}Ee.from=Me;function de(G){return new s.$aL(v.to(G.range))}Ee.to=de})(Xe||(e.SelectionRange=Xe={}));var rt;(function(Ee){function Me(de){switch(de){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ee.to=Me})(rt||(e.TextDocumentSaveReason=rt={}));var it;(function(Ee){function Me(G){switch(G){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Me;function de(G){switch(G){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ee.to=de})(it||(e.TextEditorLineNumbersStyle=it={}));var et;(function(Ee){function Me(G){if(G===s.EndOfLine.CRLF)return 1;if(G===s.EndOfLine.LF)return 0}Ee.from=Me;function de(G){if(G===1)return s.EndOfLine.CRLF;if(G===0)return s.EndOfLine.LF}Ee.to=de})(et||(e.EndOfLine=et={}));var ot;(function(Ee){function Me(de){if(typeof de=="object")return de.viewId;switch(de){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Me})(ot||(e.ProgressLocation=ot={}));var at;(function(Ee){function Me(G){const Le={start:G.start+1,end:G.end+1};return G.kind&&(Le.kind=ze.from(G.kind)),Le}Ee.from=Me;function de(G){const Le={start:G.start-1,end:G.end-1};return G.kind&&(Le.kind=ze.to(G.kind)),Le}Ee.to=de})(at||(e.FoldingRange=at={}));var ze;(function(Ee){function Me(G){if(G)switch(G){case s.FoldingRangeKind.Comment:return r.$xt.Comment;case s.FoldingRangeKind.Imports:return r.$xt.Imports;case s.FoldingRangeKind.Region:return r.$xt.Region}}Ee.from=Me;function de(G){if(G)switch(G.value){case r.$xt.Comment.value:return s.FoldingRangeKind.Comment;case r.$xt.Imports.value:return s.FoldingRangeKind.Imports;case r.$xt.Region.value:return s.FoldingRangeKind.Region}}Ee.to=de})(ze||(e.FoldingRangeKind=ze={}));var pt;(function(Ee){function Me(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?v.from(de.selection):void 0,override:typeof de.override=="boolean"?n.$nE.id:void 0}}Ee.from=Me})(pt||(e.TextEditorOpenOptions=pt={}));var X;(function(Ee){function Me(Ue){return Ue instanceof s.$NL?Ue.toJSON():typeof Ue=="string"?Ue:de(Ue)||G(Ue)?new s.$NL(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Ee.from=Me;function de(Ue){const Ze=Ue;return Ze?p.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function G(Ue){const Ze=Ue;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new s.$NL(p.URI.revive(Ue.baseUri),Ue.pattern)}Ee.to=Le})(X||(e.GlobPattern=X={}));var _;(function(Ee){function Me(de){if(de){if(Array.isArray(de))return de.map(Me);if(typeof de=="string")return de;{const G=de;return{language:G.language,scheme:G.scheme,pattern:X.from(G.pattern),exclusive:G.exclusive,notebookType:G.notebookType}}}else return}Ee.from=Me})(_||(e.LanguageSelector=_={}));var pe;(function(Ee){function Me(G){return!!G&&typeof G=="object"&&"documents"in G&&Array.isArray(G.documents)&&G.documents.every(Le=>Array.isArray(Le)&&Le.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&p.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ze=>Ze instanceof s.$SK)))}Ee.is=Me;function de(G){return{documents:G.documents.map(Le=>Le.map(Ue=>({uri:p.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ze=>v.from(Ze))})))}}Ee.from=de})(pe||(e.MappedEditsContext=pe={}));var Be;(function(Ee){function Me(G){return{start:G.start,end:G.end}}Ee.from=Me;function de(G){return new s.$cM(G.start,G.end)}Ee.to=de})(Be||(e.NotebookRange=Be={}));var Qe;(function(Ee){function Me(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}Ee.to=Me;function de(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}Ee.from=de})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var tt;(function(Ee){function Me(de){if(de===a.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(de===a.NotebookCellExecutionState.Pending)return;if(de===a.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Ee.to=Me})(tt||(e.NotebookCellExecutionState=tt={}));var nt;(function(Ee){function Me(G){switch(G){case s.NotebookCellKind.Markup:return a.CellKind.Markup;case s.NotebookCellKind.Code:default:return a.CellKind.Code}}Ee.from=Me;function de(G){switch(G){case a.CellKind.Markup:return s.NotebookCellKind.Markup;case a.CellKind.Code:default:return s.NotebookCellKind.Code}}Ee.to=de})(nt||(e.NotebookCellKind=nt={}));var Ne;(function(Ee){function Me(G){const Le={metadata:G.metadata??Object.create(null),cells:[]};for(const Ue of G.cells)s.$dM.validate(Ue),Le.cells.push(It.from(Ue));return Le}Ee.from=Me;function de(G){const Le=new s.$eM(G.cells.map(It.to));return(0,l.$Rf)(G.metadata)||(Le.metadata=G.metadata),Le}Ee.to=de})(Ne||(e.NotebookData=Ne={}));var It;(function(Ee){function Me(G){return{cellKind:nt.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Qe.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(Kt.from):[]}}Ee.from=Me;function de(G){return new s.$dM(nt.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(Kt.to):void 0,G.metadata,G.internalMetadata?Qe.to(G.internalMetadata):void 0)}Ee.to=de})(It||(e.NotebookCellData=It={}));var Ft;(function(Ee){function Me(G){return{mime:G.mime,valueBytes:N.$ge.wrap(G.data)}}Ee.from=Me;function de(G){return new s.$fM(G.valueBytes.buffer,G.mime)}Ee.to=de})(Ft||(e.NotebookCellOutputItem=Ft={}));var Kt;(function(Ee){function Me(G){return{outputId:G.id,items:G.items.map(Ft.from),metadata:G.metadata}}Ee.from=Me;function de(G){const Le=G.items.map(Ft.to);return new s.$gM(Le,G.outputId,G.metadata)}Ee.to=de})(Kt||(e.NotebookCellOutput=Kt={}));var Ut;(function(Ee){function Me(Le){return G(Le)?{include:X.from(Le.include)??void 0,exclude:X.from(Le.exclude)??void 0}:X.from(Le)??void 0}Ee.from=Me;function de(Le){return G(Le)?{include:X.to(Le.include),exclude:X.to(Le.exclude)}:X.to(Le)}Ee.to=de;function G(Le){const Ue=Le;return Ue?!(0,l.$Nf)(Ue.include)&&!(0,l.$Nf)(Ue.exclude):!1}})(Ut||(e.NotebookExclusiveDocumentPattern=Ut={}));var wt;(function(Ee){function Me(de,G,Le){const Ue=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ue,Le),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Ee.from=Me})(wt||(e.NotebookStatusBarItem=wt={}));var qt;(function(Ee){function Me(de,G,Le){const Ue=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:G.toInternal(Ue,Le),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Ee.from=Me})(qt||(e.NotebookKernelSourceAction=qt={}));var Mt;(function(Ee){function Me(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Ee.from=Me})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Qt;(function(Ee){function Me(G){return{uri:G.uri,provides:G.provides}}Ee.from=Me;function de(G){return new s.$iM(p.URI.revive(G.uri),G.provides)}Ee.to=de})(Qt||(e.NotebookRendererScript=Qt={}));var Ot;(function(Ee){function Me(G){return{message:q.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,contextValue:G.contextValue,location:G.location&&{range:v.from(G.location.range),uri:G.location.uri}}}Ee.from=Me;function de(G){const Le=new s.$oM(typeof G.message=="string"?G.message:q.to(G.message));return Le.actualOutput=G.actual,Le.expectedOutput=G.expected,Le.contextValue=G.contextValue,Le.location=G.location?Ie.to(G.location):void 0,Le}Ee.to=de})(Ot||(e.TestMessage=Ot={}));var Ct;(function(Ee){Ee.namespace=h.$KJ,Ee.denamespace=h.$LJ})(Ct||(e.TestTag=Ct={}));var Ye;(function(Ee){function Me(G){const Le=(0,t.$OM)(G).controllerId;return{extId:c.$GJ.fromExtHostTestItem(G,Le).toString(),label:G.label,uri:p.URI.revive(G.uri),busy:G.busy,tags:G.tags.map(Ue=>Ct.namespace(Le,Ue.id)),range:b.$Hs.lift(v.from(G.range)),description:G.description||null,sortText:G.sortText||null,error:G.error&&q.fromStrict(G.error)||null}}Ee.from=Me;function de(G){return{parent:void 0,error:void 0,id:c.$GJ.fromString(G.extId).localId,label:G.label,uri:p.URI.revive(G.uri),tags:(G.tags||[]).map(Le=>{const{tagId:Ue}=Ct.denamespace(Le);return new s.$pM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(G.range||void 0),canResolveChildren:!1,busy:G.busy,description:G.description||void 0,sortText:G.sortText||void 0}}Ee.toPlain=de})(Ye||(e.TestItem=Ye={})),function(Ee){function Me(G){return{id:G.id}}Ee.from=Me;function de(G){return new s.$pM(G.id)}Ee.to=de}(Ct||(e.TestTag=Ct={}));var Ht;(function(Ee){const Me=(G,Le)=>{const Ue=[];for(const[Ve,_e]of Le)c.$GJ.compare(_e.item.extId,Ve)===2&&(Le.delete(Ve),Ue.push(_e));const Ze={...Ye.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(_e=>_e.type===0).map(Ot.to)})),children:Ue.map(Ve=>Me(Ve,Le))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function de(G){const Le=[],Ue=new Map;for(const Ze of G.items){Ue.set(Ze.item.extId,Ze);const Ve=c.$GJ.root(Ze.item.extId);G.request.targets.some(_e=>_e.controllerId===Ve&&_e.testIds.includes(Ze.item.extId))&&Le.push(Ze)}return{completedAt:G.completedAt,results:Le.map(Ze=>Me(Ze,Ue))}}Ee.to=de})(Ht||(e.TestResults=Ht={}));var Gt;(function(Ee){function Me(Ue){return{covered:Ue.covered,total:Ue.total}}function de(Ue){return"line"in Ue?S.from(Ue):v.from(Ue)}function G(Ue){return"branches"in Ue?{count:Ue.executionCount,location:de(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&de(Ze.location)})):void 0}:{type:0,name:Ue.name,count:Ue.executionCount,location:de(Ue.location)}}Ee.fromDetailed=G;function Le(Ue){return{uri:Ue.uri,statement:Me(Ue.statementCoverage),branch:Ue.branchCoverage&&Me(Ue.branchCoverage),function:Ue.functionCoverage&&Me(Ue.functionCoverage),details:Ue.detailedCoverage?.map(G)}}Ee.fromFile=Le})(Gt||(e.TestCoverage=Gt={}));var ut;(function(Ee){function Me(de){switch(de){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ee.to=Me})(ut||(e.CodeActionTriggerKind=ut={}));var mt;(function(Ee){function Me(G){const Le=new s.$vM(fe.to(G.kind),G.name,G.detail||"",p.URI.revive(G.uri),v.to(G.range),v.to(G.selectionRange));return Le._sessionId=G._sessionId,Le._itemId=G._itemId,Le}Ee.to=Me;function de(G,Le,Ue){if(Le=Le??G._sessionId,Ue=Ue??G._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:fe.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:v.from(G.range),selectionRange:v.from(G.selectionRange),tags:G.tags?.map(ie.from)}}Ee.from=de})(mt||(e.TypeHierarchyItem=mt={}));var jt;(function(Ee){function Me(de){if(de)return{value:de.value,tooltip:de.tooltip}}Ee.from=Me})(jt||(e.ViewBadge=jt={}));var Bt;(function(Ee){function Me(Ue,Ze,Ve){const _e=Ze.fileData;return _e?new s.$GL(new s.$HL(_e.name,p.URI.revive(_e.uri),_e.id,(0,L.$db)(()=>Ve(_e.id)))):Ue===A.$4r.uriList&&Ze.uriListData?new s.$FL(Le(Ze.uriListData)):new s.$FL(Ze.asString)}Ee.to=Me;async function de(Ue,Ze){const Ve=await Ze.asString();if(Ue===A.$4r.uriList)return{asString:Ve,fileData:void 0,uriListData:G(Ve)};const _e=Ze.asFile();return{asString:Ve,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ee.from=de;function G(Ue){return I.$et.split(Ue).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return p.URI.parse(Ze)}catch{}return Ze})}function Le(Ue){return I.$et.create(Ue.map(Ze=>typeof Ze=="string"?Ze:p.URI.revive(Ze)))}})(Bt||(e.DataTransferItem=Bt={}));var Et;(function(Ee){function Me(G,Le){const Ue=G.items.map(([Ze,Ve])=>[Ze,Bt.to(Ze,Ve,Le)]);return new s.$IL(Ue)}Ee.toDataTransfer=Me;async function de(G){const Le={items:[]},Ue=[];for(const[Ze,Ve]of G)Ue.push((async()=>{Le.items.push([Ze,await Bt.from(Ze,Ve)])})());return await Promise.all(Ue),Le}Ee.from=de})(Et||(e.DataTransfer=Et={}));var ht;(function(Ee){function Me(de){return{kind:"reply",message:de.message,title:de.title,tooltip:de.tooltip}}Ee.from=Me})(ht||(e.ChatReplyFollowup=ht={}));var Pt;(function(Ee){function Me(de){return typeof de=="string"?{title:de,message:de,kind:"reply"}:"commandId"in de?{kind:"command",title:de.title??"",commandId:de.commandId??"",when:de.when??"",args:de.args}:ht.from(de)}Ee.from=Me})(Pt||(e.ChatFollowup=Pt={}));var Yt;(function(Ee){function Me(G){const Le=new s.$HM(Dt.to(G.role),G.content);return Le.name=G.name,Le}Ee.to=Me;function de(G){return{role:Dt.from(G.role),content:G.content,name:G.name}}Ee.from=de})(Yt||(e.ChatMessage=Yt={}));var Dt;(function(Ee){function Me(G){switch(G){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Ee.to=Me;function de(G){switch(G){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Ee.from=de})(Dt||(e.ChatMessageRole=Dt={}));var qe;(function(Ee){function Me(Le){const Ue={};for(const Ze of Object.keys(Le))Ue[Ze]=Le[Ze].map(Ee.to);return Ue}Ee.objectTo=Me;function de(Le){return{level:At.to(Le.level),kind:Le.kind,value:(0,w.$yh)(Le.value),description:Le.description}}Ee.to=de;function G(Le){return{level:At.from(Le.level),kind:Le.kind,value:Le.value,description:Le.description}}Ee.from=G})(qe||(e.ChatVariable=qe={}));var At;(function(Ee){function Me(G){switch(G){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Ee.to=Me;function de(G){switch(G){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Ee.from=de})(At||(e.ChatVariableLevel=At={}));var Wt;(function(Ee){function Me(de){switch(de){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Ee.to=Me})(Wt||(e.InteractiveEditorResponseFeedbackKind=Wt={}));var Jt;(function(Ee){function Me(de,G){return"placeholder"in G&&"resolvedContent"in G?{content:G.placeholder,kind:"asyncContent"}:"markdownContent"in G?((0,u.$mF)(de,"chatAgents2Additions"),{content:q.from(G.markdownContent),kind:"markdownContent"}):"content"in G?"vulnerabilities"in G&&G.vulnerabilities?((0,u.$mF)(de,"chatAgents2Additions"),{content:G.content,vulnerabilities:G.vulnerabilities,kind:"vulnerability"}):typeof G.content=="string"?{content:G.content,kind:"content"}:((0,u.$mF)(de,"chatAgents2Additions"),{content:q.from(G.content),kind:"markdownContent"}):"documents"in G?{documents:G.documents.map(Le=>({uri:Le.uri,version:Le.version,ranges:Le.ranges.map(Ue=>v.from(Ue))})),kind:"usedContext"}:"reference"in G?{reference:"uri"in G.reference?{uri:G.reference.uri,range:v.from(G.reference.range)}:G.reference,kind:"reference"}:"inlineReference"in G?{inlineReference:"uri"in G.inlineReference?{uri:G.inlineReference.uri,range:v.from(G.inlineReference.range)}:G.inlineReference,name:G.title,kind:"inlineReference"}:"agentName"in G?((0,u.$mF)(de,"chatAgents2Additions"),{agentName:G.agentName,command:G.command,kind:"agentDetection"}):"treeData"in G?{treeData:G.treeData,kind:"treeData"}:"message"in G?{content:G.message,kind:"progressMessage"}:void 0}Ee.from=Me})(Jt||(e.ChatResponseProgress=Jt={}));var ft;(function(Ee){function Me(de){return{label:de.label,values:de.values.map(qe.from),insertText:de.insertText,detail:de.detail,documentation:de.documentation}}Ee.from=Me})(ft||(e.ChatAgentCompletionItem=ft={}));var Lt;(function(Ee){function Me(de,G,Le){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:G.toInternal(de,Le)}Ee.from=Me})(Lt||(e.TerminalQuickFix=Lt={}))}),define(Ce[220],Re([1,0,2,11,7,8,186]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class m{constructor(w,A,k,l={timeout:1500,errors:3}){this.c=w,this.d=A,this.f=k,this.g=l,this.a=new R.$3c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(A,k,l)=>{const b={dispose:this.a.push([A,k,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,A){const k=E.URI.revive(w);let l=!1;const p=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const r of[...this.a]){if(l)break;const o=this.d.getDocument(k),t=await this.h(r,{document:o,reason:L.TextDocumentSaveReason.to(A)});b.push(t)}}finally{clearTimeout(p)}return b}h([w,A,k],l){const p=this.b.get(w);return typeof p=="number"&&p>this.g.errors?Promise.resolve(!1):this.i(k,w,A,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const r=this.b.get(w);this.b.set(w,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,A,k,l){const p=[],b=Date.now(),{document:r,reason:o}=l,{version:t}=r,n=Object.freeze({document:r,reason:o,waitUntil(a){if(Object.isFrozen(p))throw(0,N.$8)("waitUntil can not be called async");p.push(Promise.resolve(a))}});try{A.apply(k,[n])}catch(a){return Promise.reject(a)}return Object.freeze(p),new Promise((a,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all(p).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),a(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(a=>{const c={edits:[]};for(const h of a)if(Array.isArray(h)&&h.every(i=>i instanceof I.$XK))for(const{newText:i,newEol:s,range:u}of h)c.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:u&&L.Range.from(u),text:i,eol:s&&L.EndOfLine.from(s)}});if(c.edits.length!==0)return t===r.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$ogc=m}),define(Ce[221],Re([1,0,13,2,8,7,76]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ugc=e.$tgc=void 0;class m{constructor(k,l,p,b){this.start=k,this.deletedCount=l,this.deletedItems=p,this.items=b}asApiEvent(){return{range:new L.$cM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,p){this.notebook=k,this.h=l,this.j=p,this.handle=p.handle,this.uri=N.URI.revive(p.uri),this.cellKind=p.cellKind,this.a=p.outputs.map(I.NotebookCellOutput.to),this.e=p.internalMetadata??{},this.b=Object.freeze(p.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(p.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const p={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(b){k.g=b},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(p)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,l,p){const b=p.map(I.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===k);if(r&&(l||(r.items.length=0),r.items.push(...b),r.items.length>1&&r.items.every(o=>R.$SI(o.mime)))){const o=new Map,t=[];r.items.forEach(n=>{let a;o.has(n.mime)?a=o.get(n.mime):(a=[],o.set(n.mime,a),t.push(n.mime)),a.push(n.data)}),r.items.length=0,t.forEach(n=>{const a=R.$TI(o.get(n));r.items.push({mime:n,data:a.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$tgc=g;class w{static{this.a=0}constructor(k,l,p,b,r){this.k=k,this.l=l,this.m=p,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===E.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(p){return p=k.n(p),k.b[p].apiCell},getCells(p){return(p?k.p(p):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,p){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:p});const b={notebook:this.apiNotebook,metadata:p,cellChanges:[],contentChanges:[]},r=[];for(const t of k.rawEvents)t.kind===R.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===R.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===R.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),r.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===R.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),r.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),r.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const o=new Map;for(let t=0;t<r.length;t++){const n=r[t],a=o.get(n.cell);if(a===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});o.set(n.cell,c-1)}else b.cellChanges[a]={...b.cellChanges[a],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,p=k.end|0;return l<0&&(l=0),p>this.b.length&&(p=this.b.length),k.with({start:l,end:p})}p(k){k=this.o(k);const l=[];for(let p=k.start;p<k.end;p++)l.push(this.b[p]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,p){if(this.j)return;const b=[],r=[],o=[];if(k.reverse().forEach(t=>{const a=t[2].map(i=>{const s=new g(this,this.l,i);return l||r.push(g.asModelAddData(this.apiNotebook,i)),s}),c=new m(t[0],t[1],[],a),h=this.b.splice(t[0],t[1],...a);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),p)for(const t of b)p.push(t.asApiEvent())}s(k,l,p,b){const r=this.b.splice(k,l);this.b.splice(p,0,...r);const o=[new m(k,l,r.map(t=>t.apiCell),[]),new m(p,0,[],r)];for(const t of o)b.push(t.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,p,b){this.b[k].setOutputItems(l,p,b)}v(k,l){const p=this.b[k];p.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(p.uri,l)}w(k,l){const p=this.b[k];p.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$ugc=w}),define(Ce[222],Re([1,0,5,2,8,7]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;class R{constructor(g,w,A,k={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=A,this.f=k,this.a=new E.$Ud}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,A,k)=>{const l=function(b){w.call(A,b)};return l.extension=g,this.a.event(l,void 0,k)}}async $participateInSave(g,w,A){const k=N.URI.revive(g),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const p=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(w)},A,async(r,o)=>{const t=Date.now(),n=await await Promise.resolve(r);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier),!A.isCancellationRequested&&n&&(n instanceof L.$1K?p.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",o.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(p.length===0)return!0;const b={edits:[]};for(const r of p){const{edits:o}=I.WorkspaceEdit.from(r);b.edits=b.edits.concat(o)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Kgc=R}),define(Ce[107],Re([1,0,11,8,7]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,w,A,k,l){this.id=m,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(I.$cM.isNotebookRange))throw(0,E.$7)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,w){m.f.$tryRevealRange(m.id,N.NotebookRange.from(g),w??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(N.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$vgc=L}),define(Ce[223],Re([1,0,11,5,15,8]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mgc=void 0;let R=class{constructor(g,w){this.c=g,this.d=w,this.a=new N.$Sd({onListenerError:E.$2}),this.b=new N.$Sd({onListenerError:E.$2}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const A=this.d.getEditorById(g);w.visibleRanges&&A._acceptVisibleRanges(w.visibleRanges.ranges.map(L.NotebookRange.to)),w.selections&&A._acceptSelections(w.selections.selections.map(L.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const w in g)this.d.getEditorById(w)._acceptViewColumn(L.ViewColumn.to(g[w]))}};e.$Mgc=R,e.$Mgc=R=Ge([Ke(0,I.$jj)],R)}),define(Ce[224],Re([1,0,8,72,163,20,66,11]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,p,b){const r=this.b++,{title:o,location:t,cancellable:n}=p,a={label:(0,I.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(r,{location:E.ProgressLocation.from(t),title:o,source:a,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$2),this.d(r,b,!!n)}d(l,p,b){let r;b&&(r=new L.$3d,this.c.set(l,r));const o=n=>{this.a.$progressEnd(n),this.c.delete(n),r?.dispose()};let t;try{t=p(new A(this.a,l),b&&r?r.token:L.CancellationToken.None)}catch(n){throw o(l),n}return t.then(n=>o(l),n=>o(l)),t}$acceptProgressCanceled(l){const p=this.c.get(l);p&&(p.cancel(),this.c.delete(l))}}e.$Tgc=g;function w(k,l){return k.message=l.message,typeof l.increment=="number"&&(typeof k.increment=="number"?k.increment+=l.increment:k.increment=l.increment),k}class A extends N.$hv{constructor(l,p){super(b=>this.throttledReport(b)),this.c=l,this.d=p}throttledReport(l){this.c.$progressReport(this.d,l)}}Ge([(0,R.$vh)(100,(k,l)=>w(k,l),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ce[108],Re([1,0,29,104,48,77,58,8,2]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=void 0;const w=(a,c,h,i)=>{let s=c;return{enumerable:!0,configurable:!1,get(){return s},set(u){if(!h(s,u)){const d=s;s=u,a.listener?.(i(u,d))}}}},A=(a,c)=>a===c,k={range:(a,c)=>a===c?!0:!a||!c?!1:a.isEqual(c),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(a,c)=>!(a.length!==c.length||a.some(h=>!c.find(i=>h.id===i.id)))},l=a=>c=>({op:4,update:a(c)}),p=(a,c)=>({range:(()=>{let h;const i=l(s=>({range:E.$Hs.lift(m.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){a.listener?.({op:6}),k.range(h,s)||(h=s,a.listener?.(i(s)))}}})(),label:w(a,c,k.label,l(h=>({label:h}))),description:w(a,void 0,k.description,l(h=>({description:h}))),sortText:w(a,void 0,k.sortText,l(h=>({sortText:h}))),canResolveChildren:w(a,!1,k.canResolveChildren,h=>({op:2,state:h})),busy:w(a,!1,k.busy,l(h=>({busy:h}))),error:w(a,void 0,k.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(a,[],k.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),b=a=>{const c=I.$GJ.fromString(a.extId),h=new o(c.controllerId,c.localId,a.label,g.URI.revive(a.uri)||void 0);return h.range=m.Range.to(a.range||void 0),h.description=a.description||void 0,h.sortText=a.sortText||void 0,h.tags=a.tags.map(i=>m.TestTag.to({id:(0,R.$LJ)(i).tagId})),h},r=a=>{let c;for(const h of a.tests){const i=b(h.item);(0,N.$OM)(i).parent=c,c=i}return c};e.$5M=r;class o{constructor(c,h,i,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,N.$NM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,L.$MM)(u,N.$OM,o),enumerable:!0,writable:!1},...p(u,i)})}}e.$6M=o;class t extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$7M=t;class n extends L.$IM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:N.$OM,getChildren:s=>s.children,root:new t(c,h),toITestItem:m.TestItem.from})}}e.$8M=n}),define(Ce[109],Re([1,0,53,11,89,8,7]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=void 0;class m{static{this.c=new I.$XM("TextEditorDecorationType")}constructor(l,p,b){const r=m.c.nextId();l.$registerTextEditorDecorationType(p.identifier,r,L.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$ZM=m;class g{constructor(l,p){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=p.undoStopBefore,this.f=p.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,p){this.k();let b=null;if(l instanceof R.$RK)b=new R.$SK(l,l);else if(l instanceof R.$SK)b=l;else throw new Error("Unrecognized location");this.l(b,p,!1)}insert(l,p){this.k(),this.l(new R.$SK(l,l),p,!0)}delete(l){this.k();let p=null;if(l instanceof R.$SK)p=l;else throw new Error("Unrecognized location");this.l(p,null,!0)}l(l,p,b){const r=this.c.validateRange(l);this.g.push({range:r,text:p,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==R.EndOfLine.LF&&l!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=l}}class w{constructor(l,p,b,r){this.c=l,this.d=p,this._accept(b),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(t){o.m(t)},get indentSize(){return o.g},set indentSize(t){o.o(t)},get insertSpaces(){return o.h},set insertSpaces(t){o.q(t)},get cursorStyle(){return o.j},set cursorStyle(t){o.s(t)},get lineNumbers(){return o.k},set lineNumbers(t){o.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}m(l){const p=this.l(l);if(p!==null){if(typeof p=="number"){if(this.f===p)return;this.f=p}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:p}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const p=Math.floor(l);return p>0?p:null}if(typeof l=="string"){const p=parseInt(l,10);return isNaN(p)?null:p>0?p:null}return null}o(l){const p=this.n(l);if(p!==null){if(typeof p=="number"){if(this.g===p)return;this.g=p}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:p}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const p=this.p(l);if(typeof p=="boolean"){if(this.h===p)return;this.h=p}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:p}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(l)})))}assign(l){const p={};let b=!1;if(typeof l.tabSize<"u"){const r=this.l(l.tabSize);r==="auto"?(b=!0,p.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,b=!0,p.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.n(l.indentSize);r==="tabSize"?(b=!0,p.indentSize=r):typeof r=="number"&&this.g!==r&&(this.g=r,b=!0,p.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.p(l.insertSpaces);r==="auto"?(b=!0,p.insertSpaces=r):this.h!==r&&(this.h=r,b=!0,p.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,b=!0,p.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,b=!0,p.lineNumbers=L.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,p))}u(l,p){p.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$1M=w;class A{constructor(l,p,b,r,o,t,n,a){this.id=l,this.j=p,this.k=b,this.g=!1,this.h=new Set,this.c=o,this.d=new w(this.j,this.id,t,b),this.e=n,this.f=a;const c=this;this.value=Object.freeze({get document(){return r.value},set document(h){throw new N.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof R.$TK))throw(0,N.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof R.$TK)))throw(0,N.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new N.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new N.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new g(r.value,i);return h(s),c.m(s)},insertSnippet(h,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>L.Range.from(d));else if(i instanceof R.$RK){const{lineNumber:d,column:v}=L.Position.from(i);u=[{startLineNumber:d,startColumn:v,endLineNumber:d,endColumn:v}]}else if(i instanceof R.$SK)u=[L.Range.from(i)];else{u=[];for(const d of i)if(d instanceof R.$SK)u.push(L.Range.from(d));else{const{lineNumber:v,column:f}=L.Position.from(d);u.push({startLineNumber:v,startColumn:f,endLineNumber:v,endColumn:f})}}return p.$tryInsertSnippet(l,r.value.version,h.value,u,s)},setDecorations(h,i){const s=i.length===0;s&&!c.h.has(h.key)||(s?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(L.$PM(i))return p.$trySetDecorations(l,h.key,L.$QM(i));{const u=new Array(4*i.length);for(let d=0,v=i.length;d<v;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return p.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>p.$tryRevealRange(l,L.Range.from(h),i||R.TextEditorRevealType.Default))},show(h){p.$tryShowEditor(l,L.ViewColumn.from(h))},hide(){p.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const p=l.finalize();if(p.edits.length===0&&!p.setEndOfLine)return Promise.resolve(!0);const b=p.edits.map(o=>o.range);b.sort((o,t)=>o.end.line===t.end.line?o.end.character===t.end.character?o.start.line===t.start.line?o.start.character-t.start.character:o.start.line-t.start.line:o.end.character-t.end.character:o.end.line-t.end.line);for(let o=0,t=b.length-1;o<t;o++){const n=b[o].end;if(b[o+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=p.edits.map(o=>({range:L.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,p.documentVersionId,r,{setEndOfLine:typeof p.setEndOfLine=="number"?L.EndOfLine.from(p.setEndOfLine):void 0,undoStopBefore:p.undoStopBefore,undoStopAfter:p.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,p=>(p instanceof Error&&p.name==="DISPOSED"||this.k.warn(p),null))}}e.$2M=A}),define(Ce[225],Re([1,0,167,25,2,5,6,205,14,7,16,18,8,52,20,132,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;function t(c,h){if((0,A.$Ef)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends R.$Sc{constructor(h,i,s){super(),this.f=h,this.g=i,this.h=s,this.a=new Map,this.b=new r.$$7;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(v=>u(v)?this.r(v):v):d})}registerTreeDataProvider(h,i,s){const u=this.createTreeView(h,{treeDataProvider:i},s);return{dispose:()=>u.dispose()}}createTreeView(h,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],v=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,S=this.m(h,i,s),F={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:v,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},$=this.f.$registerTreeViewDataProvider(h,F),y={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$mF)(s,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$mF)(s,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(D){(0,p.$fk)(D)&&(0,o.$mF)(s,"treeViewMarkdownMessage"),S.message=D},get title(){return S.title},set title(D){S.title=D},get description(){return S.description},set description(D){S.description=D},get badge(){return S.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?S.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(S.badge=void 0)},reveal:(D,M)=>S.reveal(D,M),dispose:async()=>{await $,this.a.delete(h),S.dispose()}};return this.B(y),y}$getChildren(h,i){const s=this.a.get(h);return s?s.getChildren(i):Promise.reject(new m.$WE(h))}async $handleDrop(h,i,s,u,d,v,f,S){const F=this.a.get(h);if(!F)return Promise.reject(new m.$WE(h));const $=l.DataTransfer.toDataTransfer(s,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&S&&await this.j($,F,S,d,v),F.onDrop($,u,d)}async j(h,i,s,u,d){const v=this.b.removeDragOperationTransfer(d);if(v)(await v)?.forEach((f,S)=>{f&&h.set(S,f)});else if(d&&i.handleDrag){const f=i.handleDrag(s,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,s,u){const d=this.a.get(h);if(!d)return Promise.reject(new m.$WE(h));const v=await this.j(new w.$IL,d,i,u,s);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$WE(h);return i.hasResolve}$resolve(h,i,s){const u=this.a.get(h);if(!u)throw new m.$WE(h);return u.resolveTreeItem(i,s)}$setExpanded(h,i,s){const u=this.a.get(h);if(!u)throw new m.$WE(h);u.setExpanded(i,s)}$setSelectionAndFocus(h,i,s){const u=this.a.get(h);if(!u)throw new m.$WE(h);u.setSelectionAndFocus(i,s)}$setVisible(h,i){const s=this.a.get(h);if(!s){if(!i)return;throw new m.$WE(h)}s.setVisible(i)}$changeCheckboxState(h,i){const s=this.a.get(h);if(!s)throw new m.$WE(h);s.setCheckboxState(i)}m(h,i,s){const u=this.B(new a(h,i,this.f,this.g.converter,this.h,s));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$ahc=n;class a extends R.$Sc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,A.$Nf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,s,u,d,v){if(super(),this.I=h,this.J=s,this.L=u,this.M=d,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new L.$Sd),this.onDidExpandElement=this.u.event,this.w=this.B(new L.$Sd),this.onDidCollapseElement=this.w.event,this.y=this.B(new L.$Sd),this.onDidChangeSelection=this.y.event,this.z=this.B(new L.$Sd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new L.$Sd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new L.$Sd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new L.$Sd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$3d,v.contributes&&v.contributes.views)for(const $ in v.contributes.views)for(const y of v.contributes.views[$])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData($=>this.F.fire({message:!1,element:$})));let f,S;const F=L.Event.debounce(this.F.event,($,y)=>($||($={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>S=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?$.elements.push(...y.element):$.elements.push(y.element)),y.message&&($.message=!0),$),200,!0);this.B(F(({message:$,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=S;return f=null,this.$(y).then(()=>D())})),$&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let s=this.X(h);return s||(s=await this.Y(i)),s?s.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const s=(0,A.$Nf)(i.select)?!0:i.select,u=(0,A.$Nf)(i.focus)?!1:i.focus,d=(0,A.$Nf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(v=>this.W(h,v[v.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:v.map(S=>S.item)},{select:s,focus:u,expand:d})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:s,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const s=this.getExtensionElement(h);s&&(i?this.u.fire(Object.freeze({element:s})):this.w.fire(Object.freeze({element:s})))}setSelectionAndFocus(h,i){const s=!(0,k.$ub)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,s&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async s=>{const u=this.getExtensionElement(s.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(h,i,s){const u=[];for(const d of h){const v=this.getExtensionElement(d);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,s){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Ug)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const s=this.j.get(h);if(s){const u=this.m.get(s);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,s,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(s=>this.W(i,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Ug)(()=>this.f.getParent(h))}W(h,i){const s=this.m.get(h);return s?Promise.resolve(s):(0,g.$Ug)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const v=this.m.get(d);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const s=this.getExtensionElement(h);i=s?this.m.get(s):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new b.$3d(this.Z.token);try{const s=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=(0,k.$Hb)(u||[]),v=await Promise.all((0,k.$Hb)(d).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const f=v.map((S,F)=>S?this.db(d[F],S,s):null);return(0,k.$Hb)(f)}finally{i.dispose()}}$(h){if(h.some(s=>!s))return this.Z.dispose(!0),this.Z=new b.$3d,this.tb(),this.J.$refresh(this.I);{const s=this.ab(h);if(s.length)return this.bb(s)}return Promise.resolve(void 0)}ab(h){const i=new Set,s=h.map(d=>this.m.get(d));for(const d of s)if(d&&!i.has(d.item.handle)){let v=d;for(;v&&v.parent&&s.findIndex(f=>v&&v.parent&&f&&f.item.handle===v.parent.item.handle)===-1;){const f=this.j.get(v.parent.item.handle);v=f?this.m.get(f):void 0}v&&!v.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const v=this.j.get(d);if(v){const f=this.m.get(v);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(s=>this.cb(s).then(u=>{u&&(i[s]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const s=this.m.get(i);if(s)return this.rb(i),(0,g.$Ug)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,s.parent);return this.pb(i,d,s,s.parent),s.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,s){const u=this.ib(h,i,s);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,s),u}eb(h){return w.$fL.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,s,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,s=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:s,accessibilityInformation:u}}hb(h){if(!w.$DL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,s){this.hb(i);const u=this.B(new R.$Rc),d=this.kb(h,i,s),v=this.lb(i);return{item:{handle:d,parentHandle:s?s.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:v,iconDark:this.mb(i)||v,themeIcon:this.jb(i),collapsibleState:(0,A.$Nf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$LL?h.iconPath:void 0}kb(h,{id:i,label:s,resourceUri:u},d,v){if(i)return`${a.b}/${i}`;const f=t(s,this.N),S=d?d.item.handle:a.a;let F=f?f.label:u?(0,N.$Ag)(u):"";F=F.indexOf("/")!==-1?F.replace("/","//"):F;const $=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,M=0;do{if(D=`${S}/${M}:${F}`,v||!this.j.has(D)||$===D)break;M++}while(M<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$LL))return typeof h.iconPath=="string"||I.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$LL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return I.URI.isUri(h)?h:I.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,s,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==s.item.handle&&this.j.delete(s.item.handle),this.ob(h,i);const d=this.X(u)||[],v=d.filter(f=>f.item.handle===s.item.handle)[0];v&&d.splice(d.indexOf(v),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const s of i.children){const u=this.j.get(s.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[226],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[227],Re([1,0,179,11,31,97,73,30,22,226,189,101]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=void 0;const l=m.$un.as(R.$vn.JSONContribution);class p{constructor(h,i,s){this.a=h,this.b=i,this.c=s}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(I.default.Error,h)}warn(h){this.d(I.default.Warning,h)}info(h){this.d(I.default.Info,h)}}e.$aF=p;class b{static a(h){const i=new g.$im;for(let s=0,u=h.length;s<u;s++)i.add(h[s].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new b(i,[]);if(!i||!i.length)return new b([],h);const s=this.a(h),u=this.a(i),d=i.filter(f=>!s.has(f.description.identifier)),v=h.filter(f=>!u.has(f.description.identifier));return new b(d,v)}constructor(h,i){this.added=h,this.removed=i}}e.$bF=b;class r{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,N.$1)(h)}}}e.$cF=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$dF={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$gm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$_n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$_n}},extensionKind:{description:E.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new r(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&k.$4E.register(h.extensionPoint,h.activationEventsGenerator),e.$dF.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$dF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$eF=n;const a={ExtensionsRegistry:"ExtensionsRegistry"};m.$un.add(a.ExtensionsRegistry,new n),e.$fF=m.$un.as(a.ExtensionsRegistry),l.registerSchema(t,e.$dF),l.registerSchema(A.$Cj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Ce[228],Re([1,0,175,16,26,227,35,5]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hG=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function p(b,r,o){if(!b)return;const t=N.$Ef(b.type)?b.type:void 0;if(!t||t.length===0){o.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const a of b.required)N.$Ef(a)&&n.push(a);return{extensionId:r.value,taskType:t,required:n,properties:b.properties?I.$in(b.properties):{},when:b.when?R.$Zi.deserialize(b.when):void 0}}l.from=p})(w||(w={}));const A=L.$fF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,p)=>{for(const b of l)b.type&&p.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class k{constructor(){this.d=new m.$Sd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((p,b)=>{A.setHandler((r,o)=>{this.c=void 0;try{for(const t of o.removed){const n=t.value;for(const a of n)this.a&&a.type&&this.a[a.type]&&delete this.a[a.type]}for(const t of o.added){const n=t.value;for(const a of n){const c=w.from(a,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}p(void 0)})})}onReady(){return this.b}get(p){return this.a[p]}all(){return Object.keys(this.a).map(p=>this.a[p])}getJsonSchema(){if(this.c===void 0){const p=[];for(const b of this.all()){const r={type:"object",additionalProperties:!1};b.required.length>0&&(r.required=b.required.slice(0)),b.properties!==void 0?r.properties=I.$in(b.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[b.taskType]},p.push(r)}this.c={oneOf:p}}return this.c}}e.$hG=new k}),define(Ce[229],Re([1,0,176,16,25,26,35,228]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$rG=e.JsonSchemaVersion=e.ExecutionEngine=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$lG=e.ShellQuoting=e.$kG=e.$jG=e.$iG=void 0,e.$iG="settings",e.$jG=new R.$gj("taskRunning",!1,E.localize(0,null)),e.$kG={value:E.localize(1,null),original:"Tasks"};var g;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$lG="$customized",function(C){function P(J){if(!J)return C.Strong;switch(J.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=P}(g||(e.ShellQuoting=g={}));var w;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function P(J){switch(J.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=P}(A||(e.RevealKind=A={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function P(J){switch(J.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=P}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function P(J){switch(J.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=P}(l||(e.PanelKind=l={}));var p;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(p||(e.PresentationOptions=p={}));var b;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(C){function P(ce){switch(ce.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=P;function J(ce){switch(ce){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=J}(b||(e.RuntimeType=b={}));var r;(function(C){function P(J){return N.$Ef(J)?J:J.value}C.value=P})(r||(e.CommandString=r={}));var o;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function P(ce){return ce===C.Clean._id||ce===C.Build._id||ce===C.Rebuild._id||ce===C.Test._id}C.is=P;function J(ce){if(ce!==void 0)return N.$Ef(ce)?P(ce)?{_id:ce,isDefault:!1}:void 0:ce}C.from=J})(o||(e.TaskGroup=o={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function P(J){switch(J){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=P})(n||(e.TaskSourceKind=n={}));var a;(function(C){C.parallel="parallel",C.sequence="sequence"})(a||(e.DependsOrder=a={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(P,J,ce,me,be,Se){this._label="",this._id=P,J&&(this._label=J),ce&&(this.type=ce),this.runOptions=me,this.configurationProperties=be,this._source=Se}getDefinition(P){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const P={folder:this.d(),id:this._id};return JSON.stringify(P)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(P,J=!1){if(P===void 0)return!1;if(N.$Ef(P))return P===this._label||P===this.configurationProperties.identifier||J&&P===this._id;const ce=this.getDefinition(!0);return ce!==void 0&&ce._key===P._key}getQualifiedLabel(){const P=this.getWorkspaceFolder();return P?`${this._label} (${P.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(P){this.c===void 0&&(this.c=[]),P&&(this.c=this.c.concat(P))}get taskLoadMessages(){return this.c}}e.$mG=i;class s extends i{constructor(P,J,ce,me,be,Se,he,fe){super(P,ce,void 0,he,fe,J),this.command={},this._source=J,this.hasDefinedMatchers=Se,be&&(this.command=be)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(P=!1){if(P&&this._source.customizes!==void 0)return this._source.customizes;{let J;switch(this.command?this.command.runtime:void 0){case b.Shell:J="shell";break;case b.Process:J="process";break;case b.CustomExecution:J="customExecution";break;case void 0:J="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:J,_key:this._id,id:this._id}}}static is(P){return P instanceof s}getMapKey(){const P=this._source.config.workspaceFolder;return P?`${P.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$iG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const P=this.d();if(!P)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ce={type:e.$lG,folder:P,id:J};return JSON.stringify(ce)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(P){return new s(P._id,P._source,P._label,P.type,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$nG=s;class u extends i{constructor(P,J,ce,me,be,Se,he){super(P,ce,me,Se,he,J),this._source=J,this.configures=be}static is(P){return P instanceof u}f(P){return P}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Ag(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$iG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const P=this.d();if(!P)return;let J=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(J+=this._source.kind);const ce={type:e.$lG,folder:P,id:J};return JSON.stringify(ce)}}e.$oG=u;class d extends i{constructor(P,J,ce,me,be,Se,he,fe,ie){super(P,ce,me,fe,ie,J),this.defines=be,this.hasDefinedMatchers=he,this.command=Se,this.icon=ie.icon,this.hide=ie.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(P){return P instanceof d}getMapKey(){const P=this._source.workspaceFolder;return P?`${this._source.scope.toString()}|${P.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const P={type:"contributed",scope:this._source.scope,id:this._id};return P.folder=this.d(),JSON.stringify(P)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(P){return new d(P._id,P._source,P._label,P.type,P.defines,P.command,P.hasDefinedMatchers,P.runOptions,P.configurationProperties)}}e.$pG=d;class v extends i{constructor(P,J,ce,me,be,Se){super(P,ce,me,be,Se,J),this._source=J}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(P){return P instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(P){return new v(P._id,P._source,P._label,P.type,P.runOptions,P.configurationProperties)}}e.$qG=v;var f;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(C){C._default=C.Terminal}(f||(e.ExecutionEngine=f={}));var S;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(S||(e.JsonSchemaVersion=S={}));class F{constructor(P){this.c=new Map;for(let J=0;J<P.length;J++)this.c.set(P[J].uri.toString(),J)}compare(P,J){const ce=P.getWorkspaceFolder(),me=J.getWorkspaceFolder();if(ce&&me){let be=this.c.get(ce.uri.toString());be=be===void 0?0:be+1;let Se=this.c.get(me.uri.toString());return Se=Se===void 0?0:Se+1,be===Se?P._label.localeCompare(J._label):be-Se}else return!ce&&me?-1:ce&&!me?1:0}}e.$rG=F;var $;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})($||(e.TaskEventKind=$={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var M;(function(C){function P(fe){return{taskId:fe._id,taskName:fe.configurationProperties.name,runType:fe.configurationProperties.isBackground?"background":"singleRun",group:fe.configurationProperties.group,__task:fe}}function J(fe,ie,ke){return{...P(fe),kind:"start",terminalId:ie,resolvedVariables:ke}}C.start=J;function ce(fe,ie,ke){return{...P(fe),kind:"processStarted",terminalId:ie,processId:ke}}C.processStarted=ce;function me(fe,ie,ke){return{...P(fe),kind:"processEnded",terminalId:ie,exitCode:ke}}C.processEnded=me;function be(fe,ie,ke){return{...P(fe),kind:"terminated",exitReason:ke,terminalId:ie}}C.terminated=be;function Se(fe,ie,ke){return{...P(ie),kind:fe,terminalId:ke}}C.general=Se;function he(){return{kind:"changed"}}C.changed=he})(M||(e.TaskEvent=M={}));var O;(function(C){function P(ce){const me=Object.keys(ce).sort();let be="";for(const Se of me){let he=ce[Se];he instanceof Object?he=P(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),be+=Se+","+he+","}return be}function J(ce){const be={_key:P(ce),type:ce.taskType};return Object.assign(be,ce),be}C.create=J})(O||(e.KeyedTaskIdentifier=O={}));var W;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var z;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var q;(function(C){function P(J,ce){const me=m.$hG.get(J.type);if(me===void 0){const fe=L.$in(J);return delete fe._key,O.create(fe)}const be=Object.create(null);be.type=me.taskType;const Se=new Set;me.required.forEach(fe=>Se.add(fe));const he=me.properties;for(const fe of Object.keys(he)){const ie=J[fe];if(ie!=null)be[fe]=ie;else if(Se.has(fe)){const ke=he[fe];if(ke.default!==void 0)be[fe]=L.$in(ke.default);else switch(ke.type){case"boolean":be[fe]=!1;break;case"number":case"integer":be[fe]=0;break;case"string":be[fe]="";break;default:ce.error(E.localize(2,null,JSON.stringify(J,void 0,0),fe));return}}}return O.create(be)}C.createTaskIdentifier=P})(q||(e.TaskDefinition=q={}))}),define(Ce[230],Re([1,0,11]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=e.$p7b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,m)=>{this.b=R,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,E.$1)(R))}then(R,m){return this.j().then(R,m)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$p7b=N;class I extends N{constructor(){super(),this.h=!0,this.i=new E.$5}}e.$q7b=I}),define(Ce[49],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fv=e.$Ev=e.$Dv=e.$Cv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$Cv=E;const N=[];function I(m){const g=new E(m);return N[g.nid]=g,g}e.$Dv=I;function L(m){return N[m].sid}e.$Ev=L;class R{constructor(g){this.value=g}}e.$Fv=R}),define(Ce[3],Re([1,0,49]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$NK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var L;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(o){return o._id=k.a++,o}}e.$NK=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var p;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(p||(e.ISuggestResultDtoField=p={}));var b;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$OK={MainThreadAuthentication:(0,E.$Dv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$Dv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$Dv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$Dv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$Dv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$Dv)("MainThreadClipboard"),MainThreadCommands:(0,E.$Dv)("MainThreadCommands"),MainThreadComments:(0,E.$Dv)("MainThreadComments"),MainThreadConfiguration:(0,E.$Dv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$Dv)("MainThreadConsole"),MainThreadDebugService:(0,E.$Dv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$Dv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$Dv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$Dv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$Dv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$Dv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$Dv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$Dv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$Dv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$Dv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$Dv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$Dv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$Dv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$Dv)("MainThreadLanguages"),MainThreadLogger:(0,E.$Dv)("MainThreadLogger"),MainThreadMessageService:(0,E.$Dv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$Dv)("MainThreadOutputService"),MainThreadProgress:(0,E.$Dv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$Dv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$Dv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$Dv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$Dv)("MainThreadSecretState"),MainThreadStorage:(0,E.$Dv)("MainThreadStorage"),MainThreadSpeech:(0,E.$Dv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$Dv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$Dv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$Dv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$Dv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$Dv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$Dv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$Dv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$Dv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$Dv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$Dv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$Dv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$Dv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$Dv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$Dv)("MainThreadSCM"),MainThreadSearch:(0,E.$Dv)("MainThreadSearch"),MainThreadShare:(0,E.$Dv)("MainThreadShare"),MainThreadTask:(0,E.$Dv)("MainThreadTask"),MainThreadWindow:(0,E.$Dv)("MainThreadWindow"),MainThreadLabelService:(0,E.$Dv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$Dv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$Dv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$Dv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$Dv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$Dv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$Dv)("MainThreadInteractive"),MainThreadChat:(0,E.$Dv)("MainThreadChat"),MainThreadInlineChat:(0,E.$Dv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$Dv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$Dv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$Dv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$Dv)("MainThreadTimeline"),MainThreadTesting:(0,E.$Dv)("MainThreadTesting"),MainThreadLocalization:(0,E.$Dv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$Dv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$Dv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$Dv)("MainThreadIssueReporter")},e.$PK={ExtHostCommands:(0,E.$Dv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$Dv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$Dv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$Dv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$Dv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$Dv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$Dv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$Dv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$Dv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$Dv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$Dv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$Dv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$Dv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$Dv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$Dv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$Dv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$Dv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$Dv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$Dv)("ExtHostStatusBar"),ExtHostShare:(0,E.$Dv)("ExtHostShare"),ExtHostExtensionService:(0,E.$Dv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$Dv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$Dv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$Dv)("ExtHostSCM"),ExtHostSearch:(0,E.$Dv)("ExtHostSearch"),ExtHostTask:(0,E.$Dv)("ExtHostTask"),ExtHostWorkspace:(0,E.$Dv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$Dv)("ExtHostWindow"),ExtHostWebviews:(0,E.$Dv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$Dv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$Dv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$Dv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$Dv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$Dv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$Dv)("ExtHostProgress"),ExtHostComments:(0,E.$Dv)("ExtHostComments"),ExtHostSecretState:(0,E.$Dv)("ExtHostSecretState"),ExtHostStorage:(0,E.$Dv)("ExtHostStorage"),ExtHostUrls:(0,E.$Dv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$Dv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$Dv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$Dv)("ExtHostOutputService"),ExtHostLabelService:(0,E.$Dv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$Dv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$Dv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$Dv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$Dv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$Dv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$Dv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$Dv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$Dv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$Dv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$Dv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$Dv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$Dv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$Dv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$Dv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$Dv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$Dv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$Dv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$Dv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$Dv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$Dv)("ExtHostTimeline"),ExtHostTesting:(0,E.$Dv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$Dv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$Dv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$Dv)("ExtHostIssueReporter")}}),define(Ce[231],Re([1,0,3,7]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$afc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$OK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(R);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,g)??[]}getRelatedInformation(R,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(R,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,m),new N.$QK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$afc=I}),define(Ce[81],Re([1,0,4,15,3,17]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=e.$gfc=void 0,e.$gfc=(0,E.$2h)("IExtHostApiDeprecationService");let R=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(I.$OK.MainThreadTelemetry)}report(g,w,A){const k=this.d(g,w);this.a.has(k)||(this.a.add(k),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$hfc=R,e.$hfc=R=Ge([Ke(0,L.$SM),Ke(1,N.$jj)],R),e.$ifc=Object.freeze(new class{report(m,g,w){}})}),define(Ce[232],Re([1,0,5,3,7,22]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lfc=void 0;class R{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Sd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=w.getProxy(N.$OK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,A,k,l={}){const p=L.$hm.toKey(w.identifier),b=[...k].sort().join(" ");return await this.f.getOrCreate(`${p} ${A} ${b}`,async()=>{await this.a.$ensureProvider(A);const r=w.displayName||w.name;return this.a.$getSession(A,k,p,r,l)})}async getSessions(w,A,k){const l=L.$hm.toKey(w.identifier),p=[...k].sort().join(" ");return await this.g.getOrCreate(`${l} ${p}`,async()=>{await this.a.$ensureProvider(A);const b=w.displayName||w.name;return this.a.$getSessions(A,k,l,b)})}async removeSession(w,A){const k=this.b.get(w);return k?k.provider.removeSession(A):this.a.$removeSession(w,A)}registerAuthenticationProvider(w,A,k,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:A});const p=k.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,A,l?.supportsMultipleAccounts??!1),new I.$QK(()=>{p.dispose(),this.b.delete(w);const b=this.c.findIndex(r=>r.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,A,k){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,A){const k=this.b.get(w);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,A){return this.d.fire({provider:{id:w,label:A}}),Promise.resolve()}}e.$lfc=R;class m{constructor(){this.a=new Map}getOrCreate(w,A){const k=this.a.get(w);if(k)return k;const l=A().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Ce[233],Re([1,0,3,17,8]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=void 0;let L=class{constructor(m,g){this.a=m.getProxy(E.$OK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,w){const A=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,w?.isRefactoring??!1)}};e.$mfc=L,e.$mfc=L=Ge([Ke(0,N.$SM)],L)}),define(Ce[234],Re([1,0,67,6,3,8]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=void 0;class R{static{this.a=0}constructor(w,A){this.extension=w,this.provider=A,this.handle=R.a++}}class m{static{this.a=0}constructor(w){this.b=new Map,this.c=new Map,this.d=w.getProxy(I.$OK.MainThreadChat)}registerChatProvider(w,A,k){const l=new R(w,k);return this.b.set(l.handle,l),this.d.$registerChatProvider(l.handle,A),(0,N.$Qc)(()=>{this.d.$unregisterChatProvider(l.handle),this.b.delete(l.handle)})}transferChatSession(w,A){const k=E.Iterable.find(this.c.keys(),l=>this.c.get(l)===w)??0;typeof k=="number"&&this.d.$transferChatSession(k,A)}sendInteractiveRequestToProvider(w,A){this.d.$sendRequestToProvider(w,A)}async $prepareChat(w,A){const k=this.b.get(w);if(!k)return;const l=await k.provider.prepareSession(A);if(!l)return;const p=m.a++;return this.c.set(p,l),{id:p,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $provideWelcomeMessage(w,A){const k=this.b.get(w);if(!k||!k.provider.provideWelcomeMessage)return;const l=await k.provider.provideWelcomeMessage(A);if(l)return l.map(p=>typeof p=="string"?p:Array.isArray(p)?p.map(b=>L.ChatReplyFollowup.from(b)):L.MarkdownString.from(p))}async $provideSampleQuestions(w,A){const k=this.b.get(w);if(!k||!k.provider.provideSampleQuestions)return;const l=await k.provider.provideSampleQuestions(A);if(l)return l?.map(p=>L.ChatReplyFollowup.from(p))}$releaseSession(w){this.c.delete(w)}}e.$nfc=m}),define(Ce[235],Re([1,0,14,20,40,5,60,16,2,157,72,3,8,7,206,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class o{static{this.a=0}constructor(a,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=a.getProxy(k.$OK.MainThreadChatAgents2)}createChatAgent(a,c,h){const i=o.a++,s=new t(a,c,this.d,i,h);return this.b.set(i,s),this.d.$registerAgent(i,c,{}),s.apiAgent}async $invokeAgent(a,c,h,i,s,u){this.g.delete(c);const d=this.b.get(a);if(!d)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);let v=!1;function f(){if(v)throw new Error("Only valid while executing the command")}const S=new E.$mh;u.onCancellationRequested(()=>S.complete()),setTimeout(()=>S.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,S.p);const F=i.command?await d.validateSlashCommand(i.command):void 0,$=R.$Od.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:F},{history:s.history.map(l.ChatMessage.to)},new A.$hv(M=>{f(),typeof y>"u"&&"content"in M&&(y=$.elapsed());const O=l.ChatResponseProgress.from(d.extension,M);if(!O){this.j.error("Unknown progress type: "+JSON.stringify(M));return}if("placeholder"in M&&"resolvedContent"in M){const W=Promise.all([this.d.$handleProgressChunk(h,O),M.resolvedContent]);(0,E.$Qg)(W,u).then(z=>{if(!z)return;const[q,C]=z,P=l.ChatResponseProgress.from(d.extension,C);if(!P){this.j.error("Unknown progress type: "+JSON.stringify(C));return}this.d.$handleProgressChunk(h,P,q??void 0)})}else this.d.$handleProgressChunk(h,O)}),u);return await(0,E.$Qg)(Promise.resolve(D).then(M=>{if(M){this.g.set(c,M);let O=this.h.get(c);O||(O=new Map,this.h.set(c,O)),O.set(h,M);const W={firstProgress:y,totalElapsed:$.elapsed()};return{errorDetails:M.errorDetails,timings:W}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,I.$Mi)(D)),responseIsIncomplete:!0}}}finally{v=!0,S.complete()}}$releaseSession(a){this.g.delete(a),this.h.delete(a)}async $provideSlashCommands(a,c){const h=this.b.get(a);return h?h.provideSlashCommand(c):[]}$provideFollowups(a,c,h){const i=this.b.get(a);if(!i)return Promise.resolve([]);const s=this.g.get(c);return s?i.provideFollowups(s,h):Promise.resolve([])}$acceptFeedback(a,c,h,i,s){const u=this.b.get(a);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let v;switch(i){case b.InteractiveSessionVoteDirection.Down:v=p.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:v=p.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(s?{result:d,kind:v,reportIssue:s}:{result:d,kind:v}))}$acceptAction(a,c,h,i){const s=this.b.get(a);if(!s)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:i.action,result:u}))}async $invokeCompletionProvider(a,c,h){const i=this.b.get(a);return i?(await i.invokeCompletionProvider(c,h)).map(l.ChatAgentCompletionItem.from):[]}}e.$pfc=o;class t{constructor(a,c,h,i,s){this.extension=a,this.t=c,this.u=h,this.w=i,this.x=s,this.o=new L.$Sd,this.q=new L.$Sd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.q.fire(a)}async invokeCompletionProvider(a,c){return this.s?await this.s.provider.provideCompletionItems(a,c)??[]:[]}async validateSlashCommand(a){this.b||(await this.provideSlashCommand(N.CancellationToken.None),(0,m.$Of)(this.b));const c=this.b.find(h=>h.name===a);if(!c)throw new Error(`Unknown slashCommand: ${a}`);return c}async provideSlashCommand(a){if(!this.a)return[];const c=await this.a.provideSlashCommands(a);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(a,c){if(!this.d)return[];const h=await this.d.provideFollowups(a,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let a=!1,c=!1;const h=()=>{a||c||(c=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof p.$LL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.t},get description(){return i.g??""},set description(s){i.g=s,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(s){i.h=s,h()},get iconPath(){return i.i},set iconPath(s){i.i=s,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(s){i.a=s,h()},get followupProvider(){return i.d},set followupProvider(s){i.d=s,h()},get isDefault(){return(0,r.$mF)(i.extension,"defaultChatAgent"),i.j},set isDefault(s){(0,r.$mF)(i.extension,"defaultChatAgent"),i.j=s,h()},get helpTextPrefix(){return(0,r.$mF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(s){if((0,r.$mF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=s,h()},get helpTextPostfix(){return(0,r.$mF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(s){if((0,r.$mF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=s,h()},get isSecondary(){return(0,r.$mF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(s){(0,r.$mF)(i.extension,"defaultChatAgent"),i.n=s,h()},get sampleRequest(){return i.m},set sampleRequest(s){i.m=s,h()},get supportIssueReporting(){return(0,r.$mF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(s){(0,r.$mF)(i.extension,"chatAgents2Additions"),i.r=s,h()},get onDidReceiveFeedback(){return i.o.event},set agentVariableProvider(s){if(i.s=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");i.u.$registerAgentCompletionsProvider(i.w,s.triggerCharacters)}else i.u.$unregisterAgentCompletionsProvider(i.w)},get agentVariableProvider(){return i.s},onDidPerformAction:(0,r.$lF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){a=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.u.$unregisterAgent(i.w)}}}invoke(a,c,h,i){return this.x(a,c,h,i)}}}),define(Ce[236],Re([1,0,20,6,3,8,72,22,14,5]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=void 0;class A{constructor(b,r){this.stream=new g.$sh,this.stream=r??new g.$sh;const o=this;this.apiObj={option:b,response:o.stream.asyncIterable}}}class k{constructor(b,r){this.a=new w.$Sd,this.b=new Map,this.c=new g.$sh,this.d=!1;const o=this;this.apiObject={result:b,response:o.c.asyncIterable,onDidStartResponseStream:o.a.event,cancel(){r.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let r=this.b.get(b.index);r||(this.b.size===0?r=new A(b.index,this.c):r=new A(b.index),this.b.set(b.index,r),this.a.fire(r.apiObj)),r.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,r){this.d=r,this.c=new Map,this.e=new Map,this.f=new m.$jm,this.b=b.getProxy(I.$OK.MainThreadChatProvider)}registerProvider(b,r,o,t){const n=l.a++;return this.c.set(n,{extension:b,provider:o}),this.b.$registerProvider(n,r,{extension:b,model:t.name??""}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,r,o,t,n){const a=this.c.get(b);if(!a)return;const c=new R.$hv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:h.index,part:h.part})});return a.provider.provideChatResponse(o.map(L.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,r){this.f.set(b,r),r.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,r){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const o=await this.b.$prepareChatAccess(r);if(!o)throw new Error(`ChatAccess '${r}' NOT found`);const t=this;return{get model(){return o.model},get isRevoked(){return!t.f.has(b)},makeRequest(n,a,c){if(!t.f.has(b))throw new Error("Access to chat has been revoked");const h=new E.$3d(c),i=Math.random()*1e6|0,s=t.b.$fetchResponse(b,r,i,n.map(L.ChatMessage.from),a??{},h.token),u=new k(s,h);return t.e.set(i,{res:u}),s.finally(()=>{t.e.delete(i)}),u.apiObject}}}async $handleResponseFragment(b,r){const o=this.e.get(b);o&&o.res.handleFragment(r)}}e.$ofc=l}),define(Ce[237],Re([1,0,6,3,11,8]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfc=void 0;class R{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(N.$OK.MainThreadChatVariables)}async $resolveVariable(g,w,A){const k=this.b.get(g);if(k)try{const l=await k.resolver.resolve(k.data.name,{message:w},A);if(l)return l.map(L.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(g,w,A,k){const l=R.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:A},resolver:k}),this.c.$registerVariable(l,{name:w,description:A}),(0,E.$Qc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$qfc=R}),define(Ce[238],Re([1,0,3]),function(ge,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=void 0;class N{constructor(L){const R=L.getProxy(E.$OK.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(m){return R.$writeText(m)}})}}e.$rfc=N}),define(Ce[32],Re([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=void 0;let u=class{#e;#t;#i;constructor($,y,D){this.b=new Map,this.c=new Map,this.#e=$.getProxy(R.$OK.MainThreadCommands),this.d=y,this.#i=D,this.#t=$.getProxy(R.$OK.MainThreadTelemetry),this.converter=new d(this,M=>{const O=this.c.get(M);return O?.result===f.Void?O:void 0},y),this.f=[{processArgument(M){return(0,w.$yh)(M)}},{processArgument(M){return(0,L.$kn)(M,function(O){if(A.$Hs.isIRange(O))return I.Range.to(O);if(k.$Gs.isIPosition(O))return I.Position.to(O);if(A.$Hs.isIRange(O.range)&&l.URI.isUri(O.uri))return I.location.to(O);if(O instanceof t.$ge)return O.buffer.buffer;if(!Array.isArray(O))return O})}}]}registerArgumentProcessor($){this.f.push($)}registerApiCommand($){const y=this.registerCommand(!1,$.id,async(...D)=>{const M=$.args.map((W,z)=>{if(!W.validate(D[z]))throw new Error(`Invalid argument '${W.name}' when running '${$.id}', received: ${typeof D[z]=="object"?JSON.stringify(D[z],null,"	"):D[z]} `);return W.convert(D[z])}),O=await this.executeCommand($.internalId,...M);return $.result.convert(O,D,this.converter)},void 0,{description:$.description,args:$.args,returns:$.result.description});return this.c.set($.id,$),new N.$QK(()=>{y.dispose(),this.c.delete($.id)})}registerCommand($,y,D,M,O,W){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:M,metadata:O,extension:W}),$&&this.#e.$registerCommand(y),new N.$QK(()=>{this.b.delete(y)&&$&&this.#e.$unregisterCommand(y)})}executeCommand($,...y){return this.d.trace("ExtHostCommands#executeCommand",$),this.g($,y,!0)}async g($,y,D){if(this.b.has($))return this.#e.$fireCommandActivationEvent($),this.h($,y,!1);{let M=!1;const O=(0,L.$kn)(y,function(W){if(W instanceof N.$RK)return I.Position.from(W);if(W instanceof N.$SK)return I.Range.from(W);if(W instanceof N.$3K)return I.location.from(W);if(N.$cM.isNotebookRange(W))return I.NotebookRange.from(W);if(W instanceof ArrayBuffer)return M=!0,t.$ge.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return M=!0,t.$ge.wrap(W);if(W instanceof t.$ge)return M=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand($,M?new n.$Fv(O):O,D);return(0,w.$yh)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g($,y,!1);throw W}}}async h($,y,D){const M=this.b.get($);if(!M)throw new Error("Unknown command");const{callback:O,thisArg:W,metadata:z}=M;if(z?.args)for(let C=0;C<z.args.length;C++)try{(0,E.$Vf)(y[C],z.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${$}' failed. Illegal argument '${z.args[C].name}' - ${z.args[C].description}`)}const q=c.$Od.create();try{return await O.apply(W,y)}catch(C){if($===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...y);P&&($=P.command)}if(this.d.error(C,$,M.extension?.identifier),!D)throw C;if(M.extension?.identifier){const P=this.#i.onExtensionError(M.extension.identifier,C);this.d.trace("forwarded error to extension?",P,M.extension?.identifier)}throw new class extends Error{constructor(){super((0,a.$Mi)(C)),this.id=$,this.source=M.extension?.displayName??M.extension?.name}}}finally{this.j(M,$,q.elapsed())}}j($,y,D){$.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:$.extension.identifier.value,id:new h.$xo(y),duration:D})}$executeContributedCommand($,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",$);const D=this.b.get($);return D?(y=y.map(M=>this.f.reduce((O,W)=>W.processArgument(O,D.extension?.identifier),M)),this.h($,y,!0)):Promise.reject(new Error(`Contributed command '${$}' does not exist.`))}getCommands($=!1){return this.d.trace("ExtHostCommands#getCommands",$),this.#e.$getCommands().then(y=>($&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const $=Object.create(null);for(const[y,D]of this.b){const{metadata:M}=D;M&&($[y]=M)}return Promise.resolve($)}};e.$bN=u,e.$bN=u=Ge([Ke(0,r.$SM),Ke(1,g.$jj),Ke(2,i.$aN)],u),e.$cN=(0,b.$2h)("IExtHostCommands");class d{constructor($,y,D){this.d=$,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,s.$mg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal($,y){if(!$)return;const D={$ident:void 0,id:$.command,title:$.title,tooltip:$.tooltip};if(!$.command)return D;const M=this.f($.command);if(M)D.id=M.internalId,D.arguments=M.args.map((O,W)=>O.convert($.arguments&&$.arguments[W]));else if((0,m.$Lb)($.arguments)){const O=`${$.command} /${++this.c}`;this.b.set(O,$),y.add((0,p.$Qc)(()=>{this.b.delete(O),this.g.trace("CommandsConverter#DISPOSE",O)})),D.$ident=O,D.id=this.delegatingCommandId,D.arguments=[O],this.g.trace("CommandsConverter#CREATE",$.command,O)}return D}fromInternal($){return typeof $.$ident=="string"?this.b.get($.$ident):{command:$.id,title:$.title,arguments:$.arguments}}getActualCommand(...$){return this.b.get($[0])}h(...$){const y=this.getActualCommand(...$);return this.g.trace("CommandsConverter#EXECUTE",$[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${$[0]}`)}}e.$dN=d;class v{static{this.Uri=new v("uri","Uri of a text document",$=>l.URI.isUri($),$=>$)}static{this.Position=new v("position","A position in a text document",$=>N.$RK.isPosition($),I.Position.from)}static{this.Range=new v("range","A range in a text document",$=>N.$SK.isRange($),I.Range.from)}static{this.Selection=new v("selection","A selection in a text document",$=>N.$TK.isSelection($),I.Selection.from)}static{this.Number=new v("number","",$=>typeof $=="number",$=>$)}static{this.String=new v("string","",$=>typeof $=="string",$=>$)}static{this.StringArray=v.Arr(v.String)}static Arr($){return new v(`${$.name}_array`,`Array of ${$.name}, ${$.description}`,y=>Array.isArray(y)&&y.every(D=>$.validate(D)),y=>y.map(D=>$.convert(D)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",$=>$ instanceof N.$bL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",$=>$ instanceof N.$vM,I.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",$=>$ instanceof o.$6M,I.TestItem.from)}constructor($,y,D,M){this.name=$,this.description=y,this.validate=D,this.convert=M}optional(){return new v(this.name,`(optional) ${this.description}`,$=>$==null||this.validate($),$=>$===void 0?void 0:$===null?null:this.convert($))}with($,y){return new v($??this.name,y??this.description,this.validate,this.convert)}}e.$eN=v;class f{static{this.Void=new f("no result",$=>$)}constructor($,y){this.description=$,this.convert=y}}e.$fN=f;class S{constructor($,y,D,M,O){this.id=$,this.internalId=y,this.description=D,this.args=M,this.result=O}}e.$gN=S}),define(Ce[239],Re([1,0,18,13,2,80,96,35,32,8,7]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfc=void 0;const k=[new g.$gN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of DocumentHighlight-instances.",p(w.DocumentHighlight.to))),new g.$gN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$eN.Uri],new g.$fN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,E.$Kb)(r))return;class t extends A.$9K{static to(a){const c=new t(a.name,w.SymbolKind.to(a.kind),a.containerName||"",new A.$3K(o[0],w.Range.to(a.range)));return c.detail=a.detail,c.range=c.location.range,c.selectionRange=w.Range.to(a.selectionRange),c.children=a.children?a.children.map(t.to):[],c}}return r.map(t.to)})),new g.$gN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$eN.Uri,new g.$eN("options","Formatting options",r=>!0,r=>r)],new g.$fN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$gN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$eN.Uri,g.$eN.Range,new g.$eN("options","Formatting options",r=>!0,r=>r)],new g.$fN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$gN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$eN.Uri,g.$eN.Position,new g.$eN("ch","Trigger character",r=>typeof r=="string",r=>r),new g.$eN("options","Formatting options",r=>!0,r=>r)],new g.$fN("A promise that resolves to an array of TextEdits.",p(w.TextEdit.to))),new g.$gN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$gN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$gN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$gN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$gN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Location-instances.",p(w.location.to))),new g.$gN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of Hover-instances.",p(w.Hover.to))),new g.$gN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$eN.Uri,new g.$eN("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.$RK.isPosition(o)),r=>r.map(w.Position.from))],new g.$fN("A promise that resolves to an array of ranges.",r=>r.map(o=>{let t;for(const n of o.reverse())t=new A.$aL(w.Range.to(n),t);return t}))),new g.$gN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$eN.String.with("query","Search string")],new g.$fN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(w.WorkspaceSymbol.to))),new g.$gN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(w.CallHierarchyItem.to))),new g.$gN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$eN.CallHierarchyItem],new g.$fN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(w.CallHierarchyIncomingCall.to))),new g.$gN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$eN.CallHierarchyItem],new g.$fN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(w.CallHierarchyOutgoingCall.to))),new g.$gN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:w.Range.to(r.range),placeholder:r.text}})),new g.$gN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$eN.Uri,g.$eN.Position,g.$eN.String.with("newName","The new symbol name")],new g.$fN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return w.WorkspaceEdit.to(r)}})),new g.$gN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$eN.Uri,g.$eN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$fN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(w.DocumentLink.to))),new g.$gN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$eN.Uri],new g.$fN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$7L(r.tokenTypes,r.tokenModifiers)})),new g.$gN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$eN.Uri],new g.$fN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$i$)(r);if(o.type==="full")return new A.$9L(o.data,void 0)})),new g.$gN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$eN.Uri,g.$eN.Range.optional()],new g.$fN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$7L(r.tokenTypes,r.tokenModifiers)})),new g.$gN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$eN.Uri,g.$eN.Range],new g.$fN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,R.$i$)(r);if(o.type==="full")return new A.$9L(o.data,void 0)})),new g.$gN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$eN.Uri,g.$eN.Position,g.$eN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$eN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$fN("A promise that resolves to a CompletionList-instance.",(r,o,t)=>{if(!r)return new A.$mL([]);const n=r.suggestions.map(a=>w.CompletionItem.to(a,t));return new A.$mL(n,r.incomplete)})),new g.$gN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$eN.Uri,g.$eN.Position,g.$eN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$fN("A promise that resolves to SignatureHelp.",r=>{if(r)return w.SignatureHelp.to(r)})),new g.$gN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$eN.Uri,g.$eN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$fN("A promise that resolves to an array of CodeLens-instances.",(r,o,t)=>p(n=>new A.$eL(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(r))),new g.$gN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$eN.Uri,new g.$eN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$SK.isRange(r),r=>A.$TK.isSelection(r)?w.Selection.from(r):w.Range.from(r)),g.$eN.String.with("kind","Code action kind to return code actions for").optional(),g.$eN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$fN("A promise that resolves to an array of Command-instances.",(r,o,t)=>p(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const a=new A.$$K(n.title,n.kind?new A.$_K(n.kind):void 0);return n.edit&&(a.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(a.command=t.fromInternal(n.command)),a.isPreferred=n.isPreferred,a}})(r))),new g.$gN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$eN.Uri],new g.$fN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.$sL(w.Range.to(o.range),w.Color.to(o.color))):[])),new g.$gN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$eN("color","The color to show and insert",r=>r instanceof A.$rL,w.Color.from),new g.$eN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:w.Range.from(r.range)}))],new g.$fN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(w.ColorPresentation.to):[])),new g.$gN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$eN.Uri,g.$eN.Range],new g.$fN("A promise that resolves to an array of Inlay objects",(r,o,t)=>r.map(w.InlayHint.to.bind(void 0,t)))),new g.$gN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$eN.Uri],new g.$fN("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(w.FoldingRange.to)})),new g.$gN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$fN("A promise that resolves to an array of NotebookContentProvider static info objects.",p(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>w.NotebookExclusiveDocumentPattern.to(o))})))),new g.$gN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$eN.Uri,g.$eN.Range,new g.$eN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$SK,r=>w.InlineValueContext.from(r))],new g.$fN("A promise that resolves to an array of InlineValue objects",r=>r.map(w.InlineValue.to))),new g.$gN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$eN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,N.$bg)(r,N.Schemas.http,N.Schemas.https),r=>r),new g.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional(),g.$eN.String.with("label","").optional()],g.$fN.Void),new g.$gN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$eN.Uri.with("resource","Resource to open"),g.$eN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[w.ViewColumn.from(r),void 0]:[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)])).optional()],g.$fN.Void),new g.$gN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$eN.Uri.with("left","Left-hand side resource of the diff editor"),g.$eN.Uri.with("right","Right-hand side resource of the diff editor"),g.$eN.String.with("title","Human readable title for the diff editor").optional(),new g.$eN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[w.ViewColumn.from(r.viewColumn),w.TextEditorOpenOptions.from(r)]).optional()],g.$fN.Void),new g.$gN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$eN.String.with("title","Human readable title for the changes editor"),new g.$eN("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[t,n,a]=o;if(!I.URI.isUri(t)||!I.URI.isUri(n)&&n!==void 0&&n!==null||!I.URI.isUri(a)&&a!==void 0&&a!==null)return!1}return!0},r=>r)],g.$fN.Void),new g.$gN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$eN.Uri,g.$eN.Position],new g.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$gN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$eN.TypeHierarchyItem],new g.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$gN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$eN.TypeHierarchyItem],new g.$fN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(w.TypeHierarchyItem.to))),new g.$gN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$eN.TestItem],g.$fN.Void),new g.$gN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$eN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$fN.Void),new g.$gN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$eN.String.with("name","The context key name"),new g.$eN("value","The context key value",()=>!0,r=>r)],g.$fN.Void),new g.$gN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$eN.Uri,g.$eN.StringArray,new g.$eN("MappedEditsContext","Mapped Edits Context",r=>w.MappedEditsContext.is(r),r=>w.MappedEditsContext.from(r))],new g.$fN("A promise that resolves to a workspace edit or null",r=>r?w.WorkspaceEdit.to(r):null))];class l{static register(o){k.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",m.$1i)}}e.$kfc=l;function p(r){return o=>{if(Array.isArray(o))return o.map(r)}}function b(r){if(!Array.isArray(r))return;const o=[];for(const t of r)L.$tt(t)?o.push(w.DefinitionLink.to(t)):o.push(w.location.to(t));return o}}),define(Ce[240],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=void 0;function p(b,r,o){const t=b.getProxy(k.$OK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$jm,r.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const S=this.b.get(f.handle);return S?S.value:f}else if(f&&f.$mid===7){const S=this.b.get(f.commentControlHandle);if(!S)return f;const F=S.getCommentThread(f.commentThreadHandle);return F?F.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const F=S.getCommentThread(f.thread.commentThreadHandle);return F?f.$mid===8?F.value:{thread:F.value,text:f.text}:f}else if(f&&f.$mid===10){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const F=S.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const $=f.commentUniqueId,y=F.getCommentByUniqueId($);return y||f}else if(f&&f.$mid===11){const S=this.b.get(f.thread.commentControlHandle);if(!S)return f;const F=S.getCommentThread(f.thread.commentThreadHandle);if(!F)return f;const $=f.text,y=f.commentUniqueId,D=F.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=$:D.body=new A.$fL($),D):f}return f}})}createCommentController(f,S,F){const $=n.a++,y=new c(f,$,S,F);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,S,F){const $=this.b.get(f);$&&$.$createCommentThreadTemplate(S,F)}async $updateCommentThreadTemplate(f,S,F){const $=this.b.get(f);$&&$.$updateCommentThreadTemplate(S,F)}$deleteCommentThread(f,S){this.b.get(f)?.$deleteCommentThread(S)}$provideCommentingRanges(f,S,F){const $=this.b.get(f);if(!$||!$.commentingRangeProvider)return Promise.resolve(void 0);const y=o.getDocument(R.URI.revive(S));return(0,E.$Ug)(async()=>{const D=await $.commentingRangeProvider.provideCommentingRanges(y,F);let M;return Array.isArray(D)?M={ranges:D,fileComments:!1}:D?M={ranges:D.ranges||[],fileComments:D.fileComments||!1}:M=D??void 0,M}).then(D=>{let M;return D&&(M={ranges:D.ranges.map(O=>w.Range.from(O)),fileComments:D.fileComments}),M})}$toggleReaction(f,S,F,$,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Ug)(()=>{const M=D.getCommentThread(S);if(M){const O=M.getCommentByUniqueId($.uniqueIdInThread);if(D!==void 0&&O&&D.reactionHandler)return D.reactionHandler(O,s(y))}return Promise.resolve(void 0)})}}class a{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,S,F,$,y,D,M,O){this.m=S,this.n=F,this.o=$,this.p=y,this.q=D,this.extensionDescription=M,this.r=O,this.handle=a.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Sd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$Tc,this.l.value=new L.$Rc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(S,this.handle,this.n,this.o,w.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(S,this.handle)}});const W=this;this.value={get uri(){return W.uri},get range(){return W.range},set range(z){W.range=z},get comments(){return W.comments},set comments(z){W.comments=z},get collapsibleState(){return W.collapsibleState},set collapsibleState(z){W.collapsibleState=z},get canReply(){return W.canReply},set canReply(z){W.canReply=z},get contextValue(){return W.contextValue},set contextValue(z){W.contextValue=z},get label(){return W.label},set label(z){W.label=z},get state(){return W.state},set state(z){W.state=z},dispose:()=>{W.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$Rc);const f=F=>Object.prototype.hasOwnProperty.call(this.b,F),S={};f("range")&&(S.range=w.Range.from(this.p)),f("label")&&(S.label=this.label),f("contextValue")&&(S.contextValue=this.contextValue??null),f("comments")&&(S.comments=this.q.map(F=>h(this,F,this.k,this.extensionDescription))),f("collapsibleState")&&(S.collapseState=u(this.g)),f("canReply")&&(S.canReply=this.canReply),f("state")&&(S.state=d(this.h)),f("isTemplate")&&(S.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,S)}getCommentByUniqueId(f){for(const S of this.k){const F=S[0],$=S[1];if(f===$)return F}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}Ge([(0,N.$uh)(100)],a.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,S,F,$){this.f=f,this.g=S,this.h=F,this.i=$,this.a=new Map,t.$registerCommentController(this.handle,F,$,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,M,O){return y.createCommentThread(D,M,O).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,S,F){S===void 0&&(0,l.$mF)(this.f,"fileComments");const $=new a(this.id,this.handle,void 0,f,S,F,this.f,!1);return this.a.set($.handle,$),$}$createCommentThreadTemplate(f,S){const F=new a(this.id,this.handle,void 0,R.URI.revive(f),w.Range.to(S),[],this.f,!0);return F.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(F.handle,F),F}$updateCommentThreadTemplate(f,S){const F=this.a.get(f);F&&(F.range=w.Range.to(S))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(v,f,S,F){let $=S.get(f);return $||($=++v.commentHandle,S.set(f,$)),f.state!==void 0&&(0,l.$mF)(F,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:$,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(v){return{label:v.label,iconPath:v.iconPath?w.$RM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function s(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?R.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function u(v){if(v!==void 0)switch(v){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(v){if(v!==void 0)switch(v){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$ufc=p}),define(Ce[241],Re([1,0,26,3,27,17]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=void 0;let R=class{constructor(A,k){this.a=A.getProxy(N.$OK.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,p=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,p,arguments)}})}e(A,k,l,p){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:g(p,this.b)}),this.c&&this.f(A,l,p)}};e.$ihc=R,e.$ihc=R=Ge([Ke(0,L.$SM),Ke(1,I.$9M)],R);const m=1e5;function g(w,A){const k=[];if(w.length)for(let l=0;l<w.length;l++){let p=w[l];if(typeof p>"u")p="undefined";else if(p instanceof Error){const b=p;b.stack?p=b.stack:p=b.toString()}k.push(p)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$nn)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ce[110],Re([1,0,2,3,7,4,17,15,18,12,19,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=void 0;let p=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(N.$OK.MainThreadDecorations)}registerFileDecorationProvider(r,o){const t=l.c++;this.f.set(t,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const n=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const c=(0,g.$3b)(a);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Le)(u.path,"/")})),i=(0,g.$zb)(h,(u,d)=>u.rank-d.rank||(0,w.$1e)(u.uri.path,d.uri.path)),s=[];e:for(const u of i){let d;for(const v of u){const f=(0,A.$mc)(v.uri.path);if(d!==f&&(d=f,s.push(v.uri)>=l.d))break e}}this.g.$onDidChange(t,s)});return new I.$QK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(r,o,t){if(!this.f.has(r))return Object.create(null);const n=Object.create(null),{provider:a,extensionDescription:c}=this.f.get(r);return await Promise.all(o.map(async h=>{try{const{uri:i,id:s}=h,u=await Promise.resolve(a.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{I.$aM.validate(u),u.badge&&typeof u.badge!="string"&&(0,k.$mF)(c,"codiconDecoration"),n[s]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$kgc=p,e.$kgc=p=l=Ge([Ke(0,R.$SM),Ke(1,m.$jj)],p),e.$lgc=(0,L.$2h)("IExtHostDecorations")}),define(Ce[242],Re([1,0,158,99,2,3,7,8,5,15,28,43]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=e.$efc=void 0;class p{#e;#t;#i;constructor(o,t,n,a,c,h,i,s){this.d=o,this.e=t,this.f=n,this.g=a,this.h=c,this.c=!1,this.f=Math.max(a,n),this.#i=new A.$Ac(u=>h.getComparisonKey(u)),this.#e=i,this.#t=s}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let n=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),n=[o]}else if(Array.isArray(o)){n=[];let h;o=[...o].sort(p.k);for(const i of o){const[s,u]=i;if((!h||s.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=s,n.push(s),this.#i.set(s,[])),u)this.#i.get(s)?.push(...u);else{const d=this.#i.get(s);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const a=[];let c=0;for(const h of n){let i=[];const s=this.#i.get(h);if(s)if(s.length>this.g){i=[];const u=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const v of s)if(v.severity===u[d]&&i.push({...m.Diagnostic.from(v),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:N.MarkerSeverity.Info,message:(0,E.localize)(0,null,s.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=s.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(a.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[n,a]of this)o.call(t,n,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$efc=p;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const t=new A.$Ac;for(const n of o)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,n,a){this.j=t,this.k=n,this.l=a,this.g=new Map,this.h=new g.$Wd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(L.$OK.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:n,f:a,h:c,j:h,k:i,l:s}=this,u=new class{$changeMany(f,S){a.$changeMany(f,S),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,f,S.length===0?"CLEARING":S)}$clear(f){a.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,f)}dispose(){a.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends p{constructor(){super(t,d,l.e,l.d,f=>s.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,n=[];for(const a of this.g.values())a.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(o){let t=[];for(const n of this.g.values())n.has(o)&&(t=t.concat(n.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",n=new p(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of o)this.n.set(I.URI.revive(t),n.map(m.Diagnostic.to))}};e.$ffc=b,e.$ffc=b=l=Ge([Ke(1,w.$jj),Ke(2,k.$dfc)],b)}),define(Ce[243],Re([1,0,2,3,23]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class L{constructor(m){this.a=m.getProxy(N.$OK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,I.$mF)(m,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(A=>E.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?E.URI.revive(g):void 0)}}e.$mgc=L}),define(Ce[244],Re([1,0,11,2,7,3,13,20,12]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class w{static{this.a=0}constructor(k,l,p){this.d=l,this.e=p,this.b=new Map,this.c=k.getProxy(L.$OK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(R.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const p=w.a++;this.b.set(p,l),this.c.$registerTextContentProvider(p,k);let b;if(typeof l.onDidChange=="function"){let r;b=l.onDidChange(async o=>{if(o.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const t=this.$provideTextDocumentContent(p,o).then(async n=>{if(!n&&typeof n!="string")return;const a=this.d.getDocument(o);if(!a)return;const c=(0,g.$Ve)(n);if(!a.equalLines(c))return this.c.$onVirtualDocumentChange(o,n)}).catch(E.$1).finally(()=>{r===t&&(r=void 0)});r=t})}return new I.$QK(()=>{this.b.delete(p)&&this.c.$unregisterTextContentProvider(p),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(k,l){const p=this.b.get(k);return p?Promise.resolve(p.provideTextDocumentContent(N.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$ngc=w}),define(Ce[245],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=void 0;class l{constructor(b,r){this.a=new E.$Sd({onListenerError:k.$2}),this.b=new E.$Sd({onListenerError:k.$2}),this.c=new E.$Sd({onListenerError:k.$2}),this.d=new E.$Sd({onListenerError:k.$2}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Rc,this.h=new Map,this.f=b.getProxy(L.$OK.MainThreadDocuments),this.g=r,this.g.onDidRemoveDocuments(o=>{for(const t of o)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const t of o)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const r=this.g.getDocument(b);if(r)return r}getDocument(b){const r=this.getDocumentData(b);if(!r?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return r.document}ensureDocumentData(b){const r=this.g.getDocument(b);if(r)return Promise.resolve(r);let o=this.h.get(b.toString());return o||(o=this.f.$tryOpenDocument(b).then(t=>{this.h.delete(b.toString());const n=I.URI.revive(t);return(0,g.$Pf)(this.g.getDocument(n))},t=>(this.h.delete(b.toString()),Promise.reject(t))),this.h.set(b.toString(),o)),o}createDocumentData(b){return this.f.$tryCreateDocument(b).then(r=>I.URI.revive(r))}$acceptModelLanguageChanged(b,r){const o=I.URI.revive(b),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(r),this.a.fire(t.document)}$acceptModelSaved(b){const r=I.URI.revive(b),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(b,r){const o=I.URI.revive(b),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");t._acceptIsDirty(r),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,r,o){const t=I.URI.revive(b),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(o),n.onEvents(r);let a;r.isUndoing?a=A.TextDocumentChangeReason.Undo:r.isRedoing&&(a=A.TextDocumentChangeReason.Redo),this.c.fire((0,w.$jn)({document:n.document,contentChanges:r.changes.map(c=>({range:m.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:a}))}setWordDefinitionFor(b,r){(0,R.$UM)(b,r)}}e.$bfc=l}),define(Ce[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new p.$Ac,this.d=new N.$Sd,this.e=new N.$Sd,this.f=new N.$Sd,this.g=new N.$Sd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],s=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=L.URI.revive(u),v=this.c.get(d);v?.unref()&&(this.c.delete(d),h.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=L.URI.revive(u.uri);let v=this.c.get(d);if(v&&d.scheme!==b.Schemas.vscodeNotebookCell&&d.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);v||(v=new t(new g.$VM(this.h.getProxy(m.$OK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,v),i.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&s.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=L.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(d).value,f=new A.$2M(u.id,this.h.getProxy(m.$OK.MainThreadTextEditors),this.i,new o.$V(()=>v.document),u.selections.map(k.Selection.to),u.options,u.visibleRanges.map(S=>k.Range.to(S)),typeof u.editorPosition=="number"?k.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,I.$Nc)(h),(0,I.$Nc)(s),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return r.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$3M=n,e.$3M=n=Ge([Ke(0,w.$SM),Ke(1,l.$jj)],n),e.$4M=(0,R.$2h)("IExtHostDocumentsAndEditors")}),define(Ce[62],Re([1,0,246,5,16,2,4,3,17,8,7]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=e.$Nfc=void 0,e.$Nfc=(0,R.$2h)("IExtHostEditorTabs");class k{constructor(o,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$wM(L.URI.revive(this.b.input.uri));case 2:return new A.$xM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified));case 3:return new A.$yM(L.URI.revive(this.b.input.base),L.URI.revive(this.b.input.input1),L.URI.revive(this.b.input.input2),L.URI.revive(this.b.input.result));case 6:return new A.$zM(L.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$AM(this.b.input.viewType);case 4:return new A.$BM(L.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$CM(L.URI.revive(this.b.input.original),L.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$DM;case 9:return new A.$EM(L.URI.revive(this.b.input.uri),L.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$FM(this.b.input.providerId);default:return}}}class l{constructor(o,t){this.c=[],this.d="",this.b=o,this.e=t;for(const n of o.tabs)n.isActive&&(this.d=n.id),this.c.push(new k(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,t={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return w.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(n=>n.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const n=new k(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,n),o.tabDto.isActive&&(this.d=n.tabId),n}else if(o.kind===1){const n=this.c.splice(o.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(o.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,n),n}const t=this.c.find(n=>n.tabId===o.tabDto.id);if(!t)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(o.tabDto),t}activeTabId(){return this.d}}let p=class{constructor(o){this.b=new N.$Sd,this.c=new N.$Sd,this.e=[],this.a=o.getProxy(m.$OK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,t={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(n=>n.apiObject))},get activeTabGroup(){const n=o.d;return(0,I.$Pf)(o.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,a)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,a):this.i(c,a):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(o){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(o.map(u=>u.groupId)),a=(0,E.$L)(t,n),c=this.e.filter(u=>a.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=o.map(u=>{const d=new l(u,()=>this.d);return a.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const s=(0,I.$Pf)(o.find(u=>u.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const t=this.e.find(n=>n.groupId===o.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const t=this.e.find(a=>a.groupId===o.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(o){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===o)return n}h(o){return this.e.find(t=>t.apiObject===o)}async i(o,t){const n=[];for(const a of o){const c=this.g(a);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(o,t){const n=[];for(const a of o){const c=this.h(a);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$Ofc=p,e.$Ofc=p=Ge([Ke(0,g.$SM)],p);function b(r){return r.tabs!==void 0}}),define(Ce[247],Re([1,0,3,7]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pgc=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(E.$OK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(R);if(!w)throw new Error("Embedding vector provider not found");const A=await w.provideEmbeddingVector(m,g);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider(m,w),new N.$QK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$pgc=I}),define(Ce[248],Re([1,0,2,3,6,7,8,296,12,24,23,52]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const o=this.a.indexOf(r);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),o=[];let t,n,a=14,c=14;for(const h of r){let i=t?(0,g.$0e)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(a=c,c=9):c+=1,o.push([n,h.toUpperCase().charCodeAt(i),c]),o.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=a}o.push([9,58,10]),o.push([10,47,12]),this.b=new m.$mZ(o)}}provideDocumentLinks(r){this.c();const o=[],t=m.$nZ.computeLinks({getLineContent(n){return r.lineAt(n-1).text},getLineCount(){return r.lineCount}},this.b);for(const n of t){const a=R.DocumentLink.to(n);a.target&&o.push(a)}return o}}class p{constructor(r,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(N.$OK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,o,t,n={}){if(p.j(t),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const a=this.h++;this.b.add(o),this.d.add(o),this.c.set(a,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,A.$mF)(r,"fsChunks"),c+=4);let h;n.isReadonly&&(0,k.$fk)(n.isReadonly)&&((0,A.$mF)(r,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(a,o,c,h).catch(s=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${o}`),console.error(s)});const i=t.onDidChangeFile(s=>{const u=[];for(const d of s){const{uri:v,type:f}=d;if(v.scheme!==o)continue;let S;switch(f){case L.FileChangeType.Changed:S=0;break;case L.FileChangeType.Created:S=1;break;case L.FileChangeType.Deleted:S=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:S})}this.a.$onFileSystemChange(a,u)});return(0,I.$Qc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(a),this.a.$unregisterProvider(a)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:o,ctime:t,mtime:n,size:a,permissions:c}=r;return{type:o,ctime:t,mtime:n,size:a,permissions:c}}$stat(r,o){return Promise.resolve(this.l(r).stat(E.URI.revive(o))).then(t=>p.k(t))}$readdir(r,o){return Promise.resolve(this.l(r).readDirectory(E.URI.revive(o)))}$readFile(r,o){return Promise.resolve(this.l(r).readFile(E.URI.revive(o))).then(t=>w.$ge.wrap(t))}$writeFile(r,o,t,n){return Promise.resolve(this.l(r).writeFile(E.URI.revive(o),t.buffer,n))}$delete(r,o,t){return Promise.resolve(this.l(r).delete(E.URI.revive(o),t))}$rename(r,o,t,n){return Promise.resolve(this.l(r).rename(E.URI.revive(o),E.URI.revive(t),n))}$copy(r,o,t,n){const a=this.l(r);if(!a.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(a.copy(E.URI.revive(o),E.URI.revive(t),n))}$mkdir(r,o){return Promise.resolve(this.l(r).createDirectory(E.URI.revive(o)))}$watch(r,o,t,n){const a=this.l(r).watch(E.URI.revive(t),n);this.f.set(o,a)}$unwatch(r,o){const t=this.f.get(o);t&&(t.dispose(),this.f.delete(o))}$open(r,o,t){const n=this.l(r);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(o),t))}$close(r,o){const t=this.l(r);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(o))}$read(r,o,t,n){const a=this.l(r);if(!a.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$ge.alloc(n);return Promise.resolve(a.read(o,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(r,o,t,n){const a=this.l(r);if(!a.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(a.write(o,t,n.buffer,0,n.byteLength))}l(r){const o=this.c.get(r);if(!o){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return o}}e.$qgc=p}),define(Ce[63],Re([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=e.$Cfc=void 0;let b=p=class{constructor(o,t){this.b=new Map,this.c=new A.$$g,this.a=o.getProxy(E.$OK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(a){try{let c;const h=n.b.get(a.scheme);return h?(await n.a.$ensureActivation(a.scheme),c=await h.impl.stat(a)):c=await n.a.$stat(a),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===N.FilePermission.Readonly?1:void 0}}catch(c){p.e(c)}},async readDirectory(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readDirectory(a)).slice()):await n.a.$readdir(a)}catch(c){return p.e(c)}},async createDirectory(a){try{const c=n.b.get(a.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(c.impl,c.extUri,a)):await n.a.$mkdir(a)}catch(c){return p.e(c)}},async readFile(a){try{const c=n.b.get(a.scheme);return c?(await n.a.$ensureActivation(a.scheme),(await c.impl.readFile(a)).slice()):(await n.a.$readFile(a)).buffer}catch(c){return p.e(c)}},async writeFile(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(a)),await n.c.queueFor(a).queue(()=>Promise.resolve(h.impl.writeFile(a,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(a,L.$ge.wrap(c))}catch(h){return p.e(h)}},async delete(a,c){try{const h=n.b.get(a.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(a.scheme),await h.impl.delete(a,{recursive:!1,...c})):await n.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return p.e(h)}},async rename(a,c,h){try{return await n.a.$rename(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},async copy(a,c,h){try{return await n.a.$copy(a,c,{overwrite:!1,...h})}catch(i){return p.e(i)}},isWritableFileSystem(a){const c=t.getCapabilities(a);if(typeof c=="number")return!(c&2048)}})}async d(o,t,n){const a=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&N.FileType.Directory))throw I.$5L.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(N.$Ck(c)!==N.FileSystemProviderErrorCode.FileNotFound)throw c;a.push(t.basename(n)),n=t.dirname(n)}for(let c=a.length-1;c>=0;c--){n=t.joinPath(n,a[c]);try{await o.createDirectory(n)}catch(h){if(N.$Ck(h)!==N.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof I.$5L)throw o;if(o instanceof N.$yk)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw I.$5L.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw I.$5L.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw I.$5L.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw I.$5L.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw I.$5L.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw I.$5L.Unavailable(o.message);default:throw new I.$5L(o.message,o.name)}if(!(o instanceof Error))throw new I.$5L(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$5L.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw I.$5L.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw I.$5L.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw I.$5L.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw I.$5L.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw I.$5L.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw I.$5L.Unavailable(o.message);default:throw new I.$5L(o.message,o.name)}}addFileSystemProvider(o,t,n){return this.b.set(o,{impl:t,extUri:n?.isCaseSensitive?k.$tg:k.$vg,isReadonly:!!n?.isReadonly}),(0,w.$Qc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??k.$tg}};e.$Cfc=b,e.$Cfc=b=p=Ge([Ke(0,m.$SM),Ke(1,g.$dfc)],b),e.$Dfc=(0,R.$2h)("IExtHostConsumerFileSystem")}),define(Ce[249],Re([1,0,5,34,2,3,8,7,39]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rgc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(p,b,r,o,t,n){this.a=Math.random(),this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const a=(0,N.$Ij)(t),c=typeof t=="string",h=n?.correlate,i=o(s=>{if(!(typeof s.session=="number"&&s.session!==this.a)&&!(h&&typeof s.session>"u")){if(!n?.ignoreCreateEvents)for(const u of s.created){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of s.changed){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of s.deleted){const d=I.URI.revive(u);a(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=m.$QK.from(this.i(p,r,t,n,n?.correlate),this.b,this.c,this.d,i)}i(p,b,r,o,t){const n=m.$QK.from();if(typeof r=="string")return n;const a=p.getProxy(L.$OK.MainThreadFileSystemEventService);let c=!1;return(r.pattern.includes(N.$Ej)||r.pattern.includes(N.$Fj))&&(c=!0),a.$watch(b.identifier.value,this.a,r.baseUri,{recursive:c,excludes:o?.excludes??[]},!!t),m.$QK.from({dispose:()=>a.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(p){this.a=p,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(I.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor(p,b,r){this.j=p,this.k=b,this.l=r,this.a=new E.$Sd,this.b=new E.$Sd,this.c=new E.$Sd,this.d=new E.$Sd,this.g=new E.$Ud,this.h=new E.$Ud,this.i=new E.$Ud,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(p,b,r,o){return new w(this.j,p,b,this.a.event,R.GlobPattern.from(r),o)}$onFileEvent(p){this.a.fire(new A(p))}$onDidRunFileOperation(p,b){switch(p){case 2:this.b.fire(Object.freeze({files:b.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(p){return this.m(p,this.g)}getOnWillCreateFileEvent(p){return this.m(p,this.h)}getOnWillDeleteFileEvent(p){return this.m(p,this.i)}m(p,b){return(r,o,t)=>{const n=function(c){r.call(o,c)};return n.extension=p,b.event(n,void 0,t)}}async $onWillRunFileOperation(p,b,r,o){switch(p){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:I.URI.revive(t.source),newUri:I.URI.revive(t.target)}))},r,o);case 1:return await this.n(this.i,{files:b.map(t=>I.URI.revive(t.target))},r,o);case 0:case 3:return await this.n(this.h,{files:b.map(t=>I.URI.revive(t.target))},r,o)}}async n(p,b,r,o){const t=new Set,n=[];if(await p.fireAsync(b,o,async(c,h)=>{const i=Date.now(),s=await Promise.resolve(c);s instanceof m.$1K&&(n.push([h.extension,s]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>r&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||n.length===0)return;const a={edits:[]};for(const[,c]of n){const{edits:h}=R.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});a.edits=a.edits.concat(h)}return{edit:a,extensionNames:Array.from(t)}}}e.$rgc=k}),define(Ce[250],Re([1,0,6,2,3,8,7,32,14]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=void 0;class w{static{this.a=0}constructor(p,b){this.extension=p,this.provider=b,this.handle=w.a++}}class A{constructor(p){this.session=p,this.responses=[]}}class k{static{this.a=0}constructor(p,b,r,o){this.f=r,this.g=o,this.b=new Map,this.d=new Map,this.e=p.getProxy(I.$OK.MainThreadInlineChat),b.registerApiCommand(new m.$gN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$eN("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?L.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?L.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?L.Position.from(t.position):void 0}})],m.$fN.Void))}registerProvider(p,b,r){const o=new w(p,b);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,r?.label??p.displayName??p.name,p.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",r?.supportReportIssue??!1),(0,E.$Qc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(p,b,r,o){const t=this.b.get(p);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(N.URI.revive(b)),a=L.Selection.to(r),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:a},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=k.a++;return this.d.set(h,new A(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:L.Range.from(c.wholeRange),message:c.message}}async $provideResponse(p,b,r,o){const t=this.b.get(p);if(!t)return;const n=this.d.get(b.id);if(!n)return;const a={prompt:r.prompt,selection:L.Selection.to(r.selection),wholeRange:L.Range.to(r.wholeRange),attempt:r.attempt,live:r.live};let c=!1;const h={report:async v=>{if(!r.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:v.message,edits:v.edits?.map(L.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:R.$fL.isMarkdownString(v.content)?v.content.value:v.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,a,h,o));let s;try{s=await(0,g.$Qg)(i,o)}finally{c=!0}if(!s)return;const u=n.responses.push(s)-1,d={wholeRange:L.Range.from(s.wholeRange),placeholder:s.placeholder};if(k.h(s)){const{edits:v,contents:f}=s,S=f!==void 0?L.MarkdownString.from(f):void 0;return v instanceof R.$1K?{...d,id:u,type:"bulkEdit",edits:L.WorkspaceEdit.from(v),message:S}:{...d,id:u,type:"editorEdit",edits:v.map(L.TextEdit.from),message:S}}return{...d,id:u,type:"message",message:L.MarkdownString.from(s.contents)}}async $provideFollowups(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,a,o));return(await(0,g.$Qg)(c,o))?.map(L.ChatReplyFollowup.from)}}$handleFeedback(p,b,r,o){const t=this.b.get(p),n=this.d.get(b),a=n?.responses[r];if(t&&a){const c=L.InteractiveEditorResponseFeedbackKind.to(o);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,a,c)}}$releaseSession(p,b){}static h(p){return typeof p=="object"&&typeof p.edits=="object"}}e.$sgc=k}),define(Ce[251],Re([1,0,2,32]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class I{constructor(R,m,g,w,A){this.a=m,this.b=g,this.c=w;const k=new N.$gN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$eN("showOptions","Show Options",l=>!0,l=>l),new N.$eN("resource","Interactive resource Uri",l=>!0,l=>l),new N.$eN("controllerId","Notebook controller Id",l=>!0,l=>l),new N.$eN("title","Interactive editor title",l=>!0,l=>l)],new N.$fN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const p=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",p.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:p.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(R,m,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$Fgc=I}),define(Ce[252],Re([1,0,3,7]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class I{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(E.$OK.MainThreadIssueReporter)}async $getIssueReporterUri(R,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(R);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(R,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(R);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(R,m){const g=R.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new N.$QK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(R,m){const g=R.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new N.$QK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$Ggc=I}),define(Ce[253],Re([1,0,6,3]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(N.$OK.MainThreadLabelService)}$registerResourceLabelFormatter(R){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,R),(0,E.$Qc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Hgc=I}),define(Ce[254],Re([1,0,2,26,8,7,80,3,12,29,18,16,297,20,22,6,96,89,75,60,11,14,23,160]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jfc=void 0;class u{constructor(T,K){this.d=T,this.e=K}async provideDocumentSymbols(T,K){const H=this.d.getDocument(T),U=await this.e.provideDocumentSymbols(H,K);if(!(0,A.$Kb)(U))return U[0]instanceof L.$0K?U.map(I.DocumentSymbol.from):u.f(U)}static f(T){T=T.slice(0).sort((U,Z)=>{let x=U.location.range.start.compareTo(Z.location.range.start);return x===0&&(x=Z.location.range.end.compareTo(U.location.range.end)),x});const K=[],H=[];for(const U of T){const Z={name:U.name||"!!MISSING: name!!",kind:I.SymbolKind.from(U.kind),tags:U.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:U.containerName,range:I.Range.from(U.location.range),selectionRange:I.Range.from(U.location.range),children:[]};for(;;){if(H.length===0){H.push(Z),K.push(Z);break}const x=H[H.length-1];if(w.$Hs.containsRange(x.range,Z.range)&&!w.$Hs.equalsRange(x.range,Z.range)){x.children?.push(Z),H.push(Z);break}H.pop()}}return K}}class d{constructor(T,K,H,U,Z,x){this.f=T,this.g=K,this.h=H,this.j=U,this.k=Z,this.l=x,this.d=new n.$_ec("CodeLens"),this.e=new Map}async provideCodeLenses(T,K){const H=this.f.getDocument(T),U=await this.h.provideCodeLenses(H,K);if(!U||K.isCancellationRequested)return;const Z=this.d.add(U),x=new r.$Rc;this.e.set(Z,x);const ye={cacheId:Z,lenses:[]};for(let Te=0;Te<U.length;Te++)ye.lenses.push({cacheId:[Z,Te],range:I.Range.from(U[Te].range),command:this.g.toInternal(U[Te].command,x)});return ye}async resolveCodeLens(T,K){const H=T.cacheId&&this.d.get(...T.cacheId);if(!H)return;let U;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?U=H:U=await this.h.resolveCodeLens(H,K),U||(U=H),K.isCancellationRequested)return;const Z=T.cacheId&&this.e.get(T.cacheId[0]);if(Z){if(!U.command){const x=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,x),this.l.error(x);return}return T.command=this.g.toInternal(U.command,Z),T}}releaseCodeLenses(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}}function v(we){return Array.isArray(we)?we.map(I.DefinitionLink.from):we?[I.DefinitionLink.from(we)]:[]}class f{constructor(T,K){this.d=T,this.e=K}async provideDefinition(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideDefinition(U,Z,H);return v(x)}}class S{constructor(T,K){this.d=T,this.e=K}async provideDeclaration(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideDeclaration(U,Z,H);return v(x)}}class F{constructor(T,K){this.d=T,this.e=K}async provideImplementation(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideImplementation(U,Z,H);return v(x)}}class ${constructor(T,K){this.d=T,this.e=K}async provideTypeDefinition(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideTypeDefinition(U,Z,H);return v(x)}}class y{constructor(T,K){this.d=T,this.e=K}async provideHover(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideHover(U,Z,H);if(!(!x||(0,A.$Kb)(x.contents)))return x.range||(x.range=U.getWordRangeAtPosition(Z)),x.range||(x.range=new L.$SK(Z,Z)),I.Hover.from(x)}}class D{constructor(T,K){this.d=T,this.e=K}async provideEvaluatableExpression(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideEvaluatableExpression(U,Z,H);if(x)return I.EvaluatableExpression.from(x)}}class M{constructor(T,K){this.d=T,this.e=K}async provideInlineValues(T,K,H,U){const Z=this.d.getDocument(T),x=await this.e.provideInlineValues(Z,I.Range.to(K),I.InlineValueContext.to(H),U);if(Array.isArray(x))return x.map(ye=>I.InlineValue.from(ye))}}class O{constructor(T,K){this.d=T,this.e=K}async provideDocumentHighlights(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideDocumentHighlights(U,Z,H);if(Array.isArray(x))return x.map(I.DocumentHighlight.from)}}class W{constructor(T,K){this.d=T,this.e=K}async provideMultiDocumentHighlights(T,K,H,U){const Z=this.d.getDocument(T),x=H.map(We=>this.d.getDocument(We)),ye=I.Position.to(K),Te=await this.e.provideMultiDocumentHighlights(Z,ye,x,U);if(Array.isArray(Te))return Te.map(I.MultiDocumentHighlight.from)}}class z{constructor(T,K){this.d=T,this.e=K}async provideLinkedEditingRanges(T,K,H){const U=this.d.getDocument(T),Z=I.Position.to(K),x=await this.e.provideLinkedEditingRanges(U,Z,H);if(x&&Array.isArray(x.ranges))return{ranges:(0,A.$Hb)(x.ranges.map(I.Range.from)),wordPattern:x.wordPattern}}}class q{constructor(T,K){this.d=T,this.e=K}async provideReferences(T,K,H,U){const Z=this.d.getDocument(T),x=I.Position.to(K),ye=await this.e.provideReferences(Z,x,H,U);if(Array.isArray(ye))return ye.map(I.location.from)}}class C{static{this.d=1e3}constructor(T,K,H,U,Z,x,ye){this.g=T,this.h=K,this.j=H,this.k=U,this.l=Z,this.m=x,this.n=ye,this.e=new n.$_ec("CodeAction"),this.f=new Map}async provideCodeActions(T,K,H,U){const Z=this.g.getDocument(T),x=l.$Js.isISelection(K)?I.Selection.to(K):I.Range.to(K),ye=[];for(const it of this.j.getDiagnostics(T))if(x.intersection(it.range)&&ye.push(it)>C.d)break;const Te={diagnostics:ye,only:H.only?new L.$_K(H.only):void 0,triggerKind:I.CodeActionTriggerKind.to(H.trigger)},We=await this.k.provideCodeActions(Z,x,Te,U);if(!(0,A.$Lb)(We)||U.isCancellationRequested)return;const He=this.e.add(We),Xe=new r.$Rc;this.f.set(He,Xe);const rt=[];for(let it=0;it<We.length;it++){const et=We[it];et&&(C.o(et)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),rt.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,Xe)})):(Te.only&&(et.kind?Te.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),rt.push({cacheId:[He,it],title:et.title,command:et.command&&this.h.toInternal(et.command,Xe),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,i.$lF)(this.m,"codeActionAI")?et.isAI:!1,disabled:et.disabled?.reason})))}return{cacheId:He,actions:rt}}async resolveCodeAction(T,K){const[H,U]=T,Z=this.e.get(H,U);if(!Z||C.o(Z))return{};if(!this.k.resolveCodeAction)return{};const x=await this.k.resolveCodeAction(Z,K)??Z;let ye;x.edit&&(ye=I.WorkspaceEdit.from(x.edit,void 0));let Te;if(x.command){const We=this.f.get(H);We&&(Te=this.h.toInternal(x.command,We))}return{edit:ye,command:Te}}releaseCodeActions(T){this.f.get(T)?.dispose(),this.f.delete(T),this.e.delete(T)}static o(T){return typeof T.command=="string"&&typeof T.title=="string"}}class P{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,H,U,Z){this.d=T,this.e=K,this.f=H,this.g=U,this.h=Z}async prepareDocumentPaste(T,K,H,U){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(T),x=K.map(We=>I.Range.to(We)),ye=I.DataTransfer.toDataTransfer(H,()=>{throw new c.$$});if(await this.f.prepareDocumentPaste(Z,x,ye,U),U.isCancellationRequested)return;const Te=Array.from(ye).filter(([,We])=>!(We instanceof L.$FL));return I.DataTransfer.from(Te)}async providePasteEdits(T,K,H,U,Z){if(!this.f.provideDocumentPasteEdits)return;const x=this.e.getDocument(K),ye=H.map(He=>I.Range.to(He)),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolvePasteFileData(this.g,T,He)).buffer),We=await this.f.provideDocumentPasteEdits(x,ye,Te,Z);if(We)return{label:We.label??(0,s.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:P.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class J{constructor(T,K){this.d=T,this.e=K}async provideDocumentFormattingEdits(T,K,H){const U=this.d.getDocument(T),Z=await this.e.provideDocumentFormattingEdits(U,K,H);if(Array.isArray(Z))return Z.map(I.TextEdit.from)}}class ce{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeFormattingEdits(T,K,H,U){const Z=this.d.getDocument(T),x=I.Range.to(K),ye=await this.e.provideDocumentRangeFormattingEdits(Z,x,H,U);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(T,K,H,U){(0,k.$Of)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(T),x=K.map(I.Range.to),ye=await this.e.provideDocumentRangesFormattingEdits(Z,x,H,U);if(Array.isArray(ye))return ye.map(I.TextEdit.from)}}class me{constructor(T,K){this.d=T,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(T,K,H,U,Z){const x=this.d.getDocument(T),ye=I.Position.to(K),Te=await this.e.provideOnTypeFormattingEdits(x,ye,H,U,Z);if(Array.isArray(Te))return Te.map(I.TextEdit.from)}}class be{constructor(T,K){this.e=T,this.f=K,this.d=new n.$_ec("WorkspaceSymbols")}async provideWorkspaceSymbols(T,K){const H=await this.e.provideWorkspaceSymbols(T,K);if(!(0,A.$Lb)(H))return{symbols:[]};const U=this.d.add(H),Z={cacheId:U,symbols:[]};for(let x=0;x<H.length;x++){const ye=H[x];if(!ye||!ye.name){this.f.warn("INVALID SymbolInformation",ye);continue}Z.symbols.push({...I.WorkspaceSymbol.from(ye),cacheId:[U,x]})}return Z}async resolveWorkspaceSymbol(T,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!T.cacheId)return T;const H=this.d.get(...T.cacheId);if(H){const U=await this.e.resolveWorkspaceSymbol(H,K);return U&&(0,N.$ln)(T,I.WorkspaceSymbol.from(U),!0)}}releaseWorkspaceSymbols(T){this.d.delete(T)}}class Se{static supportsResolving(T){return typeof T.prepareRename=="function"}constructor(T,K,H){this.d=T,this.e=K,this.f=H}async provideRenameEdits(T,K,H,U){const Z=this.d.getDocument(T),x=I.Position.to(K);try{const ye=await this.e.provideRenameEdits(Z,x,H,U);return ye?I.WorkspaceEdit.from(ye):void 0}catch(ye){const Te=Se.g(ye);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(ye)}}async resolveRenameLocation(T,K,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const U=this.d.getDocument(T),Z=I.Position.to(K);try{const x=await this.e.prepareRename(U,Z,H);let ye,Te;if(L.$SK.isRange(x)?(ye=x,Te=U.getText(x)):(0,k.$Gf)(x)&&(ye=x.range,Te=x.placeholder),!ye||!Te)return;if(ye.start.line>Z.line||ye.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ye),text:Te}}catch(x){const ye=Se.g(x);return ye?{rejectReason:ye,range:void 0,text:void 0}:Promise.reject(x)}}static g(T){return typeof T=="string"?T:T instanceof Error&&typeof T.message=="string"?T.message:void 0}}class he{constructor(T,K){this.resultId=T,this.tokens=K}}class fe{constructor(T,K){this.f=T,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(T,K,H){const U=this.f.getDocument(T),Z=K!==0?this.d.get(K):null;let x=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(U,Z.resultId,H):await this.g.provideDocumentSemanticTokens(U,H);return Z&&this.d.delete(K),x?(x=fe.h(x),this.o(fe.n(Z,x),x)):null}async releaseDocumentSemanticColoring(T){this.d.delete(T)}static h(T){return fe.j(T)?fe.k(T)?T:new L.$9L(new Uint32Array(T.data),T.resultId):fe.l(T)?fe.m(T)?T:new L.$$L(T.edits.map(K=>new L.$0L(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),T.resultId):T}static j(T){return T&&!!T.data}static k(T){return T.data instanceof Uint32Array}static l(T){return T&&Array.isArray(T.edits)}static m(T){for(const K of T.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(T,K){if(!fe.j(K)||!T||!T.tokens)return K;const H=T.tokens,U=H.length,Z=K.data,x=Z.length;let ye=0;const Te=Math.min(U,x);for(;ye<Te&&H[ye]===Z[ye];)ye++;if(ye===U&&ye===x)return new L.$$L([],K.resultId);let We=0;const He=Te-ye;for(;We<He&&H[U-We-1]===Z[x-We-1];)We++;return new L.$$L([{start:ye,deleteCount:U-ye-We,data:Z.subarray(ye,x-We)}],K.resultId)}o(T,K){if(fe.j(T)){const H=this.e++;return this.d.set(H,new he(T.resultId,T.data)),(0,o.$h$)({id:H,type:"full",data:T.data})}if(fe.l(T)){const H=this.e++;return fe.j(K)?this.d.set(H,new he(K.resultId,K.data)):this.d.set(H,new he(T.resultId)),(0,o.$h$)({id:H,type:"delta",deltas:(T.edits||[]).map(U=>({start:U.start,deleteCount:U.deleteCount,data:U.data}))})}return null}}class ie{constructor(T,K){this.d=T,this.e=K}async provideDocumentRangeSemanticTokens(T,K,H){const U=this.d.getDocument(T),Z=await this.e.provideDocumentRangeSemanticTokens(U,I.Range.to(K),H);return Z?this.f(Z):null}f(T){return(0,o.$h$)({id:0,type:"full",data:T.data})}}class ke{static supportsResolving(T){return typeof T.resolveCompletionItem=="function"}constructor(T,K,H,U,Z){this.f=T,this.g=K,this.h=H,this.j=U,this.k=Z,this.d=new n.$_ec("CompletionItem"),this.e=new Map}async provideCompletionItems(T,K,H,U){const Z=this.f.getDocument(T),x=I.Position.to(K),ye=Z.getWordRangeAtPosition(x)||new L.$SK(x,x),Te=ye.with({end:x}),We=new a.$Od,He=await this.h.provideCompletionItems(Z,x,U,I.CompletionContext.to(H));if(!He||U.isCancellationRequested)return;const Xe=Array.isArray(He)?new L.$mL(He):He,rt=ke.supportsResolving(this.h)?this.d.add(Xe.items):this.d.add([]),it=new r.$Rc;this.e.set(rt,it);const et=[],ot={x:rt,b:et,a:{replace:I.Range.from(ye),insert:I.Range.from(Te)},c:Xe.isIncomplete||void 0,d:We.elapsed()};for(let at=0;at<Xe.items.length;at++){const ze=Xe.items[at],pt=this.l(ze,[rt,at],Te,ye);et.push(pt)}return ot}async resolveCompletionItem(T,K){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...T);if(!H)return;const U=this.l(H,T),Z=await this.h.resolveCompletionItem(H,K);if(!Z)return;const x=this.l(Z,T);return(U.h!==x.h||U.i!==x.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(U.n!==x.n||U.o!==x.o||!(0,N.$mn)(U.p,x.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...U,d:x.d,c:x.c,l:x.l,h:x.h,i:x.i,n:x.n,o:x.o,p:x.p}}releaseCompletionItems(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K,H,U){const Z=this.e.get(K[0]);if(!Z)throw Error("DisposableStore is missing...");const x=this.g.toInternal(T.command,Z),ye={x:K,a:T.label,b:T.kind!==void 0?I.CompletionItemKind.from(T.kind):void 0,m:T.tags&&T.tags.map(I.CompletionItemTag.from),c:T.detail,d:typeof T.documentation>"u"?void 0:I.MarkdownString.fromStrict(T.documentation),e:T.sortText!==T.label?T.sortText:void 0,f:T.filterText!==T.label?T.filterText:void 0,g:T.preselect||void 0,i:T.keepWhitespace?1:0,k:T.commitCharacters?.join(""),l:T.additionalTextEdits&&T.additionalTextEdits.map(I.TextEdit.from),n:x?.$ident,o:x?.id,p:x?.$ident?void 0:x?.arguments};T.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ye.h=T.textEdit.newText):typeof T.insertText=="string"?ye.h=T.insertText:T.insertText instanceof L.$2K&&(ye.h=T.insertText.value,ye.i|=4);let Te;return T.textEdit?Te=T.textEdit.range:T.range&&(Te=T.range),L.$SK.isRange(Te)?ye.j=I.Range.from(Te):Te&&(!H?.isEqual(Te.inserting)||!U?.isEqual(Te.replacing))&&(ye.j={insert:I.Range.from(Te.inserting),replace:I.Range.from(Te.replacing)}),ye}}class oe{async provideInlineCompletions(T,K,H,U){}disposeCompletions(T){}handleDidShowCompletionItem(T,K,H){}handlePartialAccept(T,K,H){}}class Y extends oe{constructor(T,K,H,U){super(),this.f=T,this.g=K,this.h=H,this.j=U,this.d=new V,this.e=(0,i.$lF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$lF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(T,K,H,U){const Z=this.g.getDocument(T),x=I.Position.to(K),ye=await this.h.provideInlineCompletionItems(Z,x,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:I.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},U);if(!ye||U.isCancellationRequested)return;const Te=Array.isArray(ye)?ye:ye.items,We=this.e?Array.isArray(ye)?[]:ye.commands||[]:[],He=this.e&&!Array.isArray(ye)?ye.enableForwardStability:void 0;let Xe;return{pid:this.d.createReferenceId({dispose(){Xe?.dispose()},items:Te}),items:Te.map((it,et)=>{let ot;it.command&&(Xe||(Xe=new r.$Rc),ot=this.j.toInternal(it.command,Xe));const at=it.insertText;return{insertText:typeof at=="string"?at:{snippet:at.value},filterText:it.filterText,range:it.range?I.Range.from(it.range):void 0,command:ot,idx:et,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:We.map(it=>(Xe||(Xe=new r.$Rc),this.j.toInternal(it,Xe))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(T){this.d.disposeReferenceId(T)?.dispose()}handleDidShowCompletionItem(T,K,H){const U=this.d.get(T)?.items[K];U&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(U,H)}handlePartialAccept(T,K,H){const U=this.d.get(T)?.items[K];U&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(U,H)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(T){const K=this.e++;return this.d.set(K,T),K}disposeReferenceId(T){const K=this.d.get(T);return this.d.delete(T),K}get(T){return this.d.get(T)}}class ne{constructor(T,K){this.e=T,this.f=K,this.d=new n.$_ec("SignatureHelp")}async provideSignatureHelp(T,K,H,U){const Z=this.e.getDocument(T),x=I.Position.to(K),ye=this.g(H),Te=await this.f.provideSignatureHelp(Z,x,U,ye);if(Te){const We=this.d.add([Te]);return{...I.SignatureHelp.from(Te),id:We}}}g(T){let K;if(T.activeSignatureHelp){const H=I.SignatureHelp.to(T.activeSignatureHelp),U=this.d.get(T.activeSignatureHelp.id,0);U?(K=U,K.activeSignature=H.activeSignature,K.activeParameter=H.activeParameter):K=H}return{...T,activeSignatureHelp:K}}releaseSignatureHelp(T){this.d.delete(T)}}class Ie{constructor(T,K,H,U,Z){this.f=T,this.g=K,this.h=H,this.j=U,this.k=Z,this.d=new n.$_ec("InlayHints"),this.e=new Map}async provideInlayHints(T,K,H){const U=this.f.getDocument(T),Z=I.Range.to(K),x=await this.h.provideInlayHints(U,Z,H);if(!Array.isArray(x)||x.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(H.isCancellationRequested)return;const ye=this.d.add(x);this.e.set(ye,new r.$Rc);const Te={hints:[],cacheId:ye};for(let We=0;We<x.length;We++)this.l(x[We],Z)&&Te.hints.push(this.m(x[We],[ye,We]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),Te}async resolveInlayHint(T,K){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...T);if(!H)return;const U=await this.h.resolveInlayHint(H,K);if(U&&this.l(U))return this.m(U,T)}releaseHints(T){this.e.get(T)?.dispose(),this.e.delete(T),this.d.delete(T)}l(T,K){return T.label.length===0||Array.isArray(T.label)&&T.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",T),!1):!(K&&!K.contains(T.position))}m(T,K){const H=this.e.get(K[0]);if(!H)throw Error("DisposableStore is missing...");const U={label:"",cacheId:K,tooltip:I.MarkdownString.fromStrict(T.tooltip),position:I.Position.from(T.position),textEdits:T.textEdits&&T.textEdits.map(I.TextEdit.from),kind:T.kind&&I.InlayHintKind.from(T.kind),paddingLeft:T.paddingLeft,paddingRight:T.paddingRight};if(typeof T.label=="string")U.label=T.label;else{const Z=[];U.label=Z;for(const x of T.label){if(!x.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const ye={label:x.value,tooltip:I.MarkdownString.fromStrict(x.tooltip)};L.$3K.isLocation(x.location)&&(ye.location=I.location.from(x.location)),x.command&&(ye.command=this.g.toInternal(x.command,H)),Z.push(ye)}}return U}}class Ae{constructor(T,K){this.e=T,this.f=K,this.d=new n.$_ec("DocumentLink")}async provideLinks(T,K){const H=this.e.getDocument(T),U=await this.f.provideDocumentLinks(H,K);if(!(!Array.isArray(U)||U.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:U.filter(Ae.g).map(I.DocumentLink.from)};{const Z=this.d.add(U),x={links:[],cacheId:Z};for(let ye=0;ye<U.length;ye++){if(!Ae.g(U[ye]))continue;const Te=I.DocumentLink.from(U[ye]);Te.cacheId=[Z,ye],x.links.push(Te)}return x}}}static g(T){return T.target&&T.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(T,K){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...T);if(!H)return;const U=await this.f.resolveDocumentLink(H,K);if(!(!U||!Ae.g(U)))return I.DocumentLink.from(U)}releaseLinks(T){this.d.delete(T)}}class Pe{constructor(T,K){this.d=T,this.e=K}async provideColors(T,K){const H=this.d.getDocument(T),U=await this.e.provideDocumentColors(H,K);return Array.isArray(U)?U.map(x=>({color:I.Color.from(x.color),range:I.Range.from(x.range)})):[]}async provideColorPresentations(T,K,H){const U=this.d.getDocument(T),Z=I.Range.to(K.range),x=I.Color.to(K.color),ye=await this.e.provideColorPresentations(x,{document:U,range:Z},H);if(Array.isArray(ye))return ye.map(I.ColorPresentation.from)}}class ae{constructor(T,K){this.d=T,this.e=K}async provideFoldingRanges(T,K,H){const U=this.d.getDocument(T),Z=await this.e.provideFoldingRanges(U,K,H);if(Array.isArray(Z))return Z.map(I.FoldingRange.from)}}class te{constructor(T,K,H){this.d=T,this.e=K,this.f=H}async provideSelectionRanges(T,K,H){const U=this.d.getDocument(T),Z=K.map(I.Position.to),x=await this.e.provideSelectionRanges(U,Z,H);if(!(0,A.$Lb)(x))return[];if(x.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ye=[];for(let Te=0;Te<Z.length;Te++){const We=[];ye.push(We);let He=Z[Te],Xe=x[Te];for(;;){if(!Xe.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(Xe)),!Xe.parent)break;He=Xe.range,Xe=Xe.parent}}return ye}}class Q{constructor(T,K){this.f=T,this.g=K,this.d=new t.$XM(""),this.e=new Map}async prepareSession(T,K,H){const U=this.f.getDocument(T),Z=I.Position.to(K),x=await this.g.prepareCallHierarchy(U,Z,H);if(!x)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(x)?x.map(Te=>this.h(ye,Te)):[this.h(ye,x)]}async provideCallsTo(T,K,H){const U=this.j(T,K);if(!U)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(U,H);if(Z)return Z.map(x=>({from:this.h(T,x.from),fromRanges:x.fromRanges.map(ye=>I.Range.from(ye))}))}async provideCallsFrom(T,K,H){const U=this.j(T,K);if(!U)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(U,H);if(Z)return Z.map(x=>({to:this.h(T,x.to),fromRanges:x.fromRanges.map(ye=>I.Range.from(ye))}))}releaseSession(T){this.e.delete(T)}h(T,K){const H=this.e.get(T),U=I.CallHierarchyItem.from(K,T,H.size.toString(36));return H.set(U._itemId,K),U}j(T,K){return this.e.get(T)?.get(K)}}class ee{constructor(T,K){this.f=T,this.g=K,this.d=new t.$XM(""),this.e=new Map}async prepareSession(T,K,H){const U=this.f.getDocument(T),Z=I.Position.to(K),x=await this.g.prepareTypeHierarchy(U,Z,H);if(!x)return;const ye=this.d.nextId();return this.e.set(ye,new Map),Array.isArray(x)?x.map(Te=>this.h(ye,Te)):[this.h(ye,x)]}async provideSupertypes(T,K,H){const U=this.j(T,K);if(!U)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(U,H);if(Z)return Z.map(x=>this.h(T,x))}async provideSubtypes(T,K,H){const U=this.j(T,K);if(!U)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(U,H);if(Z)return Z.map(x=>this.h(T,x))}releaseSession(T){this.e.delete(T)}h(T,K){const H=this.e.get(T),U=I.TypeHierarchyItem.from(K,T,H.size.toString(36));return H.set(U._itemId,K),U}j(T,K){return this.e.get(T)?.get(K)}}class $e{static toInternalProviderId(T,K){return T+"."+K}constructor(T,K,H,U,Z){this.d=T,this.e=K,this.f=H,this.g=U,this.h=Z}async provideDocumentOnDropEdits(T,K,H,U,Z){const x=this.e.getDocument(K),ye=I.Position.to(H),Te=I.DataTransfer.toDataTransfer(U,async He=>(await this.d.$resolveDocumentOnDropFileData(this.g,T,He)).buffer),We=await this.f.provideDocumentDropEdits(x,ye,Te,Z);if(We)return{label:We.label??(0,s.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(He=>"mimeType"in He?He:{providerId:$e.toInternalProviderId(He.extensionId,He.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class ve{constructor(T,K){this.d=T,this.e=K}async provideMappedEdits(T,K,H,U){const Z=E.URI.revive(T),x=this.d.getDocument(Z),ye=H.documents.map(He=>He.map(Xe=>({uri:E.URI.revive(Xe.uri),version:Xe.version,ranges:Xe.ranges.map(rt=>I.Range.to(rt))}))),Te={documents:ye,selections:ye[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(x,K,Te,U);return We?I.WorkspaceEdit.from(We):null}}class Fe{constructor(T,K){this.adapter=T,this.extension=K}}class le{static{this.d=0}constructor(T,K,H,U,Z,x,ye,Te){this.g=K,this.h=H,this.j=U,this.k=Z,this.l=x,this.m=ye,this.n=Te,this.f=new Map,this.e=T.getProxy(m.$OK.MainThreadLanguageFeatures)}o(T,K){return I.DocumentSelector.from(T,this.g,K)}p(T){return new L.$QK(()=>{this.f.delete(T),this.e.$unregister(T)})}q(){return le.d++}async s(T,K,H,U,Z,x=!1){const ye=this.f.get(T);if(!ye||!(ye.adapter instanceof K))return U;const Te=Date.now();x||this.l.trace(`[${ye.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const We=H(ye.adapter,ye.extension);return Promise.resolve(We).catch(He=>{(0,c.$4)(He)||(this.l.error(`[${ye.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(ye.extension.identifier,He))}).finally(()=>{x||this.l.trace(`[${ye.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),p.CancellationToken.isCancellationToken(Z)?(0,h.$Rg)(We,Z):We}t(T,K){const H=this.q();return this.f.set(H,new Fe(T,K)),H}static u(T){return T.displayName||T.name}registerDocumentSymbolProvider(T,K,H,U){const Z=this.t(new u(this.h,H),T),x=U&&U.label||le.u(T);return this.e.$registerDocumentSymbolProvider(Z,this.o(K,T),x),this.p(Z)}$provideDocumentSymbols(T,K,H){return this.s(T,u,U=>U.provideDocumentSymbols(E.URI.revive(K),H),void 0,H)}registerCodeLensProvider(T,K,H){const U=this.q(),Z=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(U,new Fe(new d(this.h,this.j.converter,H,T,this.n,this.l),T)),this.e.$registerCodeLensSupport(U,this.o(K,T),Z);let x=this.p(U);if(Z!==void 0){const ye=H.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(Z));x=L.$QK.from(x,ye)}return x}$provideCodeLenses(T,K,H){return this.s(T,d,U=>U.provideCodeLenses(E.URI.revive(K),H),void 0,H)}$resolveCodeLens(T,K,H){return this.s(T,d,U=>U.resolveCodeLens(K,H),void 0,void 0)}$releaseCodeLenses(T,K){this.s(T,d,H=>Promise.resolve(H.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(T,K,H){const U=this.t(new f(this.h,H),T);return this.e.$registerDefinitionSupport(U,this.o(K,T)),this.p(U)}$provideDefinition(T,K,H,U){return this.s(T,f,Z=>Z.provideDefinition(E.URI.revive(K),H,U),[],U)}registerDeclarationProvider(T,K,H){const U=this.t(new S(this.h,H),T);return this.e.$registerDeclarationSupport(U,this.o(K,T)),this.p(U)}$provideDeclaration(T,K,H,U){return this.s(T,S,Z=>Z.provideDeclaration(E.URI.revive(K),H,U),[],U)}registerImplementationProvider(T,K,H){const U=this.t(new F(this.h,H),T);return this.e.$registerImplementationSupport(U,this.o(K,T)),this.p(U)}$provideImplementation(T,K,H,U){return this.s(T,F,Z=>Z.provideImplementation(E.URI.revive(K),H,U),[],U)}registerTypeDefinitionProvider(T,K,H){const U=this.t(new $(this.h,H),T);return this.e.$registerTypeDefinitionSupport(U,this.o(K,T)),this.p(U)}$provideTypeDefinition(T,K,H,U){return this.s(T,$,Z=>Z.provideTypeDefinition(E.URI.revive(K),H,U),[],U)}registerHoverProvider(T,K,H,U){const Z=this.t(new y(this.h,H),T);return this.e.$registerHoverProvider(Z,this.o(K,T)),this.p(Z)}$provideHover(T,K,H,U){return this.s(T,y,Z=>Z.provideHover(E.URI.revive(K),H,U),void 0,U)}registerEvaluatableExpressionProvider(T,K,H,U){const Z=this.t(new D(this.h,H),T);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(K,T)),this.p(Z)}$provideEvaluatableExpression(T,K,H,U){return this.s(T,D,Z=>Z.provideEvaluatableExpression(E.URI.revive(K),H,U),void 0,U)}registerInlineValuesProvider(T,K,H,U){const Z=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,x=this.t(new M(this.h,H),T);this.e.$registerInlineValuesProvider(x,this.o(K,T),Z);let ye=this.p(x);if(Z!==void 0){const Te=H.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));ye=L.$QK.from(ye,Te)}return ye}$provideInlineValues(T,K,H,U,Z){return this.s(T,M,x=>x.provideInlineValues(E.URI.revive(K),H,U,Z),void 0,Z)}registerDocumentHighlightProvider(T,K,H){const U=this.t(new O(this.h,H),T);return this.e.$registerDocumentHighlightProvider(U,this.o(K,T)),this.p(U)}registerMultiDocumentHighlightProvider(T,K,H){const U=this.t(new W(this.h,H),T);return this.e.$registerMultiDocumentHighlightProvider(U,this.o(K,T)),this.p(U)}$provideDocumentHighlights(T,K,H,U){return this.s(T,O,Z=>Z.provideDocumentHighlights(E.URI.revive(K),H,U),void 0,U)}$provideMultiDocumentHighlights(T,K,H,U,Z){return this.s(T,W,x=>x.provideMultiDocumentHighlights(E.URI.revive(K),H,U.map(ye=>E.URI.revive(ye)),Z),void 0,Z)}registerLinkedEditingRangeProvider(T,K,H){const U=this.t(new z(this.h,H),T);return this.e.$registerLinkedEditingRangeProvider(U,this.o(K,T)),this.p(U)}$provideLinkedEditingRanges(T,K,H,U){return this.s(T,z,async Z=>{const x=await Z.provideLinkedEditingRanges(E.URI.revive(K),H,U);if(x)return{ranges:x.ranges,wordPattern:x.wordPattern?le.w(x.wordPattern):void 0}},void 0,U)}registerReferenceProvider(T,K,H){const U=this.t(new q(this.h,H),T);return this.e.$registerReferenceSupport(U,this.o(K,T)),this.p(U)}$provideReferences(T,K,H,U,Z){return this.s(T,q,x=>x.provideReferences(E.URI.revive(K),H,U,Z),void 0,Z)}registerCodeActionProvider(T,K,H,U){const Z=new r.$Rc,x=this.t(new C(this.h,this.j.converter,this.k,H,this.l,T,this.m),T);return this.e.$registerQuickFixSupport(x,this.o(K,T),{providedKinds:U?.providedCodeActionKinds?.map(ye=>ye.value),documentation:U?.documentation?.map(ye=>({kind:ye.kind.value,command:this.j.converter.toInternal(ye.command,Z)}))},le.u(T),!!H.resolveCodeAction),Z.add(this.p(x)),Z}$provideCodeActions(T,K,H,U,Z){return this.s(T,C,x=>x.provideCodeActions(E.URI.revive(K),H,U,Z),void 0,Z)}$resolveCodeAction(T,K,H){return this.s(T,C,U=>U.resolveCodeAction(K,H),{},void 0)}$releaseCodeActions(T,K){this.s(T,C,H=>Promise.resolve(H.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(T,K,H){const U=this.t(new J(this.h,H),T);return this.e.$registerDocumentFormattingSupport(U,this.o(K,T),T.identifier,T.displayName||T.name),this.p(U)}$provideDocumentFormattingEdits(T,K,H,U){return this.s(T,J,Z=>Z.provideDocumentFormattingEdits(E.URI.revive(K),H,U),void 0,U)}registerDocumentRangeFormattingEditProvider(T,K,H){const U=typeof H.provideDocumentRangesFormattingEdits=="function",Z=this.t(new ce(this.h,H),T);return this.e.$registerRangeFormattingSupport(Z,this.o(K,T),T.identifier,T.displayName||T.name,U),this.p(Z)}$provideDocumentRangeFormattingEdits(T,K,H,U,Z){return this.s(T,ce,x=>x.provideDocumentRangeFormattingEdits(E.URI.revive(K),H,U,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(T,K,H,U,Z){return this.s(T,ce,x=>x.provideDocumentRangesFormattingEdits(E.URI.revive(K),H,U,Z),void 0,Z)}registerOnTypeFormattingEditProvider(T,K,H,U){const Z=this.t(new me(this.h,H),T);return this.e.$registerOnTypeFormattingSupport(Z,this.o(K,T),U,T.identifier),this.p(Z)}$provideOnTypeFormattingEdits(T,K,H,U,Z,x){return this.s(T,me,ye=>ye.provideOnTypeFormattingEdits(E.URI.revive(K),H,U,Z,x),void 0,x)}registerWorkspaceSymbolProvider(T,K){const H=this.t(new be(K,this.l),T);return this.e.$registerNavigateTypeSupport(H,typeof K.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(T,K,H){return this.s(T,be,U=>U.provideWorkspaceSymbols(K,H),{symbols:[]},H)}$resolveWorkspaceSymbol(T,K,H){return this.s(T,be,U=>U.resolveWorkspaceSymbol(K,H),void 0,void 0)}$releaseWorkspaceSymbols(T,K){this.s(T,be,H=>H.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(T,K,H){const U=this.t(new Se(this.h,H,this.l),T);return this.e.$registerRenameSupport(U,this.o(K,T),Se.supportsResolving(H)),this.p(U)}$provideRenameEdits(T,K,H,U,Z){return this.s(T,Se,x=>x.provideRenameEdits(E.URI.revive(K),H,U,Z),void 0,Z)}$resolveRenameLocation(T,K,H,U){return this.s(T,Se,Z=>Z.resolveRenameLocation(E.URI.revive(K),H,U),void 0,U)}registerDocumentSemanticTokensProvider(T,K,H,U){const Z=this.t(new fe(this.h,H),T),x=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(K,T),U,x);let ye=this.p(Z);if(x){const Te=H.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(x));ye=L.$QK.from(ye,Te)}return ye}$provideDocumentSemanticTokens(T,K,H,U){return this.s(T,fe,Z=>Z.provideDocumentSemanticTokens(E.URI.revive(K),H,U),null,U)}$releaseDocumentSemanticTokens(T,K){this.s(T,fe,H=>H.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(T,K,H,U){const Z=this.t(new ie(this.h,H),T);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(K,T),U),this.p(Z)}$provideDocumentRangeSemanticTokens(T,K,H,U){return this.s(T,ie,Z=>Z.provideDocumentRangeSemanticTokens(E.URI.revive(K),H,U),null,U)}registerCompletionItemProvider(T,K,H,U){const Z=this.t(new ke(this.h,this.j.converter,H,this.m,T),T);return this.e.$registerCompletionsProvider(Z,this.o(K,T),U,ke.supportsResolving(H),T.identifier),this.p(Z)}$provideCompletionItems(T,K,H,U,Z){return this.s(T,ke,x=>x.provideCompletionItems(E.URI.revive(K),H,U,Z),void 0,Z)}$resolveCompletionItem(T,K,H){return this.s(T,ke,U=>U.resolveCompletionItem(K,H),void 0,H)}$releaseCompletionItems(T,K){this.s(T,ke,H=>H.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(T,K,H,U){const Z=new Y(T,this.h,H,this.j.converter),x=this.t(Z,T);return this.e.$registerInlineCompletionsSupport(x,this.o(K,T),Z.supportsHandleEvents,b.$hm.toKey(T.identifier.value),U?.yieldTo?.map(ye=>b.$hm.toKey(ye))||[]),this.p(x)}$provideInlineCompletions(T,K,H,U,Z){return this.s(T,oe,x=>x.provideInlineCompletions(E.URI.revive(K),H,U,Z),void 0,Z)}$handleInlineCompletionDidShow(T,K,H,U){this.s(T,oe,async Z=>{Z.handleDidShowCompletionItem(K,H,U)},void 0,void 0)}$handleInlineCompletionPartialAccept(T,K,H,U){this.s(T,oe,async Z=>{Z.handlePartialAccept(K,H,U)},void 0,void 0)}$freeInlineCompletionsList(T,K){this.s(T,oe,async H=>{H.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(T,K,H,U){const Z=Array.isArray(U)?{triggerCharacters:U,retriggerCharacters:[]}:U,x=this.t(new ne(this.h,H),T);return this.e.$registerSignatureHelpProvider(x,this.o(K,T),Z),this.p(x)}$provideSignatureHelp(T,K,H,U,Z){return this.s(T,ne,x=>x.provideSignatureHelp(E.URI.revive(K),H,U,Z),void 0,Z)}$releaseSignatureHelp(T,K){this.s(T,ne,H=>H.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(T,K,H){const U=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Ie(this.h,this.j.converter,H,this.l,T),T);this.e.$registerInlayHintsProvider(Z,this.o(K,T),typeof H.resolveInlayHint=="function",U,le.u(T));let x=this.p(Z);if(U!==void 0){const ye=H.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(U));x=L.$QK.from(x,ye)}return x}$provideInlayHints(T,K,H,U){return this.s(T,Ie,Z=>Z.provideInlayHints(E.URI.revive(K),H,U),void 0,U)}$resolveInlayHint(T,K,H){return this.s(T,Ie,U=>U.resolveInlayHint(K,H),void 0,H)}$releaseInlayHints(T,K){this.s(T,Ie,H=>H.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(T,K,H){const U=this.t(new Ae(this.h,H),T);return this.e.$registerDocumentLinkProvider(U,this.o(K,T),typeof H.resolveDocumentLink=="function"),this.p(U)}$provideDocumentLinks(T,K,H){return this.s(T,Ae,U=>U.provideLinks(E.URI.revive(K),H),void 0,H,K.scheme==="output")}$resolveDocumentLink(T,K,H){return this.s(T,Ae,U=>U.resolveLink(K,H),void 0,void 0,!0)}$releaseDocumentLinks(T,K){this.s(T,Ae,H=>H.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(T,K,H){const U=this.t(new Pe(this.h,H),T);return this.e.$registerDocumentColorProvider(U,this.o(K,T)),this.p(U)}$provideDocumentColors(T,K,H){return this.s(T,Pe,U=>U.provideColors(E.URI.revive(K),H),[],H)}$provideColorPresentations(T,K,H,U){return this.s(T,Pe,Z=>Z.provideColorPresentations(E.URI.revive(K),H,U),void 0,U)}registerFoldingRangeProvider(T,K,H){const U=this.q(),Z=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(U,new Fe(new ae(this.h,H),T)),this.e.$registerFoldingRangeProvider(U,this.o(K,T),T.identifier,Z);let x=this.p(U);if(Z!==void 0){const ye=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));x=L.$QK.from(x,ye)}return x}$provideFoldingRanges(T,K,H,U){return this.s(T,ae,Z=>Z.provideFoldingRanges(E.URI.revive(K),H,U),void 0,U)}registerSelectionRangeProvider(T,K,H){const U=this.t(new te(this.h,H,this.l),T);return this.e.$registerSelectionRangeProvider(U,this.o(K,T)),this.p(U)}$provideSelectionRanges(T,K,H,U){return this.s(T,te,Z=>Z.provideSelectionRanges(E.URI.revive(K),H,U),[],U)}registerCallHierarchyProvider(T,K,H){const U=this.t(new Q(this.h,H),T);return this.e.$registerCallHierarchyProvider(U,this.o(K,T)),this.p(U)}$prepareCallHierarchy(T,K,H,U){return this.s(T,Q,Z=>Promise.resolve(Z.prepareSession(E.URI.revive(K),H,U)),void 0,U)}$provideCallHierarchyIncomingCalls(T,K,H,U){return this.s(T,Q,Z=>Z.provideCallsTo(K,H,U),void 0,U)}$provideCallHierarchyOutgoingCalls(T,K,H,U){return this.s(T,Q,Z=>Z.provideCallsFrom(K,H,U),void 0,U)}$releaseCallHierarchy(T,K){this.s(T,Q,H=>Promise.resolve(H.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(T,K,H){const U=this.t(new ee(this.h,H),T);return this.e.$registerTypeHierarchyProvider(U,this.o(K,T)),this.p(U)}$prepareTypeHierarchy(T,K,H,U){return this.s(T,ee,Z=>Promise.resolve(Z.prepareSession(E.URI.revive(K),H,U)),void 0,U)}$provideTypeHierarchySupertypes(T,K,H,U){return this.s(T,ee,Z=>Z.provideSupertypes(K,H,U),void 0,U)}$provideTypeHierarchySubtypes(T,K,H,U){return this.s(T,ee,Z=>Z.provideSubtypes(K,H,U),void 0,U)}$releaseTypeHierarchy(T,K){this.s(T,ee,H=>Promise.resolve(H.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(T,K,H,U){const Z=this.q();this.f.set(Z,new Fe(new $e(this.e,this.h,H,Z,T),T));const x=(0,i.$lF)(T,"dropMetadata")&&U?$e.toInternalProviderId(T.identifier.value,U.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(K,T),x,(0,i.$lF)(T,"dropMetadata")?U:void 0),this.p(Z)}$provideDocumentOnDropEdits(T,K,H,U,Z,x){return this.s(T,$e,ye=>Promise.resolve(ye.provideDocumentOnDropEdits(K,E.URI.revive(H),U,Z,x)),void 0,void 0)}registerMappedEditsProvider(T,K,H){const U=this.t(new ve(this.h,H),T);return this.e.$registerMappedEditsProvider(U,this.o(K,T)),this.p(U)}$provideMappedEdits(T,K,H,U,Z){return this.s(T,ve,x=>Promise.resolve(x.provideMappedEdits(K,H,U,Z)),null,Z)}registerDocumentPasteEditProvider(T,K,H,U){const Z=this.q();this.f.set(Z,new Fe(new P(this.e,this.h,H,Z,T),T));const x=P.toInternalProviderId(T.identifier.value,U.id);return this.e.$registerPasteEditProvider(Z,this.o(K,T),x,{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,copyMimeTypes:U.copyMimeTypes,pasteMimeTypes:U.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(T,K,H,U,Z){return this.s(T,P,x=>x.prepareDocumentPaste(E.URI.revive(K),H,U,Z),void 0,Z)}$providePasteEdits(T,K,H,U,Z,x){return this.s(T,P,ye=>ye.providePasteEdits(K,E.URI.revive(H),U,Z,x),void 0,x)}static w(T){return{pattern:T.source,flags:T.flags}}static y(T){return{decreaseIndentPattern:le.w(T.decreaseIndentPattern),increaseIndentPattern:le.w(T.increaseIndentPattern),indentNextLinePattern:T.indentNextLinePattern?le.w(T.indentNextLinePattern):void 0,unIndentedLinePattern:T.unIndentedLinePattern?le.w(T.unIndentedLinePattern):void 0}}static z(T){return{beforeText:le.w(T.beforeText),afterText:T.afterText?le.w(T.afterText):void 0,previousLineText:T.previousLineText?le.w(T.previousLineText):void 0,action:T.action}}static B(T){return T.map(le.z)}static C(T){return{open:T.open,close:T.close,notIn:T.notIn?T.notIn.map(K=>L.SyntaxTokenType.toString(K)):void 0}}static D(T){return T.map(le.C)}setLanguageConfiguration(T,K,H){const{wordPattern:U}=H;if(U&&(0,g.$Ue)(U))throw new Error(`Invalid language configuration: wordPattern '${U}' is not allowed to match the empty string.`);U?this.h.setWordDefinitionFor(K,U):this.h.setWordDefinitionFor(K,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",T,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",T,"Do not use.");const Z=this.q(),x={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?le.w(H.wordPattern):void 0,indentationRules:H.indentationRules?le.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?le.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?le.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,K,x),this.p(Z)}$setWordDefinitions(T){for(const K of T)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$jfc=le}),define(Ce[255],Re([1,0,3,8,7,31,14,6,23]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=void 0;class w{constructor(k,l,p,b){this.c=l,this.d=p,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(E.$OK.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const p=this.c.getDocumentData(k);if(!p)throw new Error(`document '${k.toString()}' NOT found`);return p.document}async tokenAtPosition(k,l){const p=k.version,b=N.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,b),o={type:I.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new I.$SK(l.line,l.character,l.line,l.character)};if(!r)return o;const t={range:N.Range.to(r.range),type:N.TokenType.to(r.type)};return!t.range.contains(l)||p!==k.version?o:t}createLanguageStatusItem(k,l,p){const b=this.f++,r=this.a,o=this.g,t=`${k.identifier.value}/${l}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(t);const n={selector:p,id:l,name:k.displayName??k.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const c=new m.$Rc,h=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,R.$4g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??k.displayName??k.name,source:k.displayName??k.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===I.LanguageStatusSeverity.Error?L.default.Error:n.severity===I.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),a?.dispose(),r.$removeLanguageStatus(b),o.delete(t)},get id(){return n.id},get name(){return n.name},set name(s){n.name=s,h()},get selector(){return n.selector},set selector(s){n.selector=s,h()},get text(){return n.text},set text(s){n.text=s,h()},set text2(s){(0,g.$mF)(k,"languageStatusText"),n.text=s,h()},get text2(){return(0,g.$mF)(k,"languageStatusText"),n.text},get detail(){return n.detail},set detail(s){n.detail=s,h()},get severity(){return n.severity},set severity(s){n.severity=s,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(s){n.accessibilityInformation=s,h()},get command(){return n.command},set command(s){n.command=s,h()},get busy(){return n.busy},set busy(s){n.busy=s,h()}};return h(),i}}e.$Igc=w}),define(Ce[82],Re([1,0,21,12,2,4,15,3,27,17]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=e.$7fc=void 0;let A=class{constructor(l,p,b){this.f=b,this.d=new Map,this.a=p.getProxy(m.$OK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,p){const{message:b,args:r,comment:o}=p;if(this.c)return(0,N.$Ie)(b,r??{});let t=b;o&&o.length>0&&(t+=`/${Array.isArray(o)?o.join(""):o}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,N.$Ie)(n??b,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let p;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(b),o=JSON.parse(r);p=l.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${r.message}`);return}p&&this.d.set(l.identifier.value,{contents:p,uri:b})}async g(l){if(l.isBuiltin){const p=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive(p)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$7fc=A,e.$7fc=A=Ge([Ke(0,g.$9M),Ke(1,w.$SM),Ke(2,R.$jj)],A),e.$8fc=(0,L.$2h)("IExtHostLocalizationService")}),define(Ce[256],Re([1,0,15,3,27,17,2,51]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=void 0;let g=class extends E.$uj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map(p=>(0,m.$yh)(p))),this.r=k.getProxy(N.$OK.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(R.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,p){return new w(this.r,k,l,p)}};e.$hhc=g,e.$hhc=g=Ge([Ke(0,L.$SM),Ke(1,I.$9M)],g);class w extends E.$pj{constructor(k,l,p,b){super(b?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel(p),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const p=[[k,l]];this.m?this.u(p):this.n.push(...p)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Ce[83],Re([1,0,3,4,6,17,24]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0fc=e.$9fc=void 0,e.$9fc=(0,N.$2h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(E.$OK.MainThreadManagedSockets)}setFactory(k,l){for(const p of this.d.values())p.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,p=await this.c.makeConnection(),b=new I.$Rc;return this.d.set(l,new w(l,p,b)),b.add((0,I.$Qc)(()=>this.d.delete(l))),b.add(p.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add(p.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),b.dispose()})),b.add(p.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,R.$ge.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$0fc=m,e.$0fc=m=Ge([Ke(0,L.$SM)],m);class g{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class w extends I.$Sc{constructor(k,l,p){super(),this.socketId=k,this.actual=l,this.B(p)}}}),define(Ce[257],Re([1,0,3,15,23]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;function L(m){return m&&m.title}let R=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$OK.MainThreadMessageService)}showMessage(g,w,A,k,l){const p={source:{identifier:g.identifier,label:g.displayName||g.name}};let b;typeof k=="string"||L(k)?b=[k,...l]:(p.modal=k?.modal,p.useCustom=k?.useCustom,p.detail=k?.detail,b=l),p.useCustom&&(0,I.$mF)(g,"resolvers");const r=[];for(let o=0;o<b.length;o++){const t=b[o];if(typeof t=="string")r.push({title:t,handle:o,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:a}=t;r.push({title:n,isCloseAffordance:!!a,handle:o})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(w,A,p,r).then(o=>{if(typeof o=="number")return b[o]})}};e.$Jgc=R,e.$Jgc=R=Ge([Ke(1,N.$jj)],R)}),define(Ce[258],Re([1,0,18,14,20,5,6,28,2,22,15,3,32,8,7,78,211,23,49]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=void 0;let a=class{constructor(f,S,F,$,y){this.m=S,this.n=F,this.o=$,this.q=y,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new L.$Sd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(k.$OK.MainThreadNotebookKernels);const D=new l.$gN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$eN("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const O=this.n.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:O}}else if(M&&"notebookEditor"in M){const O=this.n.getIdByEditor(M.notebookEditor);if(O===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:O}}return M})],l.$fN.Void);this.o.registerApiCommand(D)}createNotebookController(f,S,F,$,y,D){for(const ie of this.j.values())if(ie.controller.id===S&&w.$hm.equals(f.identifier,ie.extensionId))throw new Error(`notebook controller with id '${S}' ALREADY exist`);const M=this.k++,O=this;this.q.trace(`NotebookController[${M}], CREATED by ${f.identifier.value}, ${S}`);const W=()=>console.warn(`NO execute handler from notebook controller '${P.id}' of extension: '${f.identifier}'`);let z=!1;const q=new L.$Sd,C=new L.$Sd,P={id:d(f.identifier,S),notebookType:F,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:$||f.identifier.value,preloads:D?D.map(p.NotebookRendererScript.from):[]};let J=y??W,ce,me;this.a.$addKernel(M,P).catch(ie=>{console.log(ie),z=!0});let be=0;const Se=()=>{if(z)return;const ie=++be;Promise.resolve().then(()=>{ie===be&&this.a.$updateKernel(M,P)})},he=new m.$Ac,fe={get id(){return S},get notebookType(){return P.notebookType},onDidChangeSelectedNotebooks:q.event,get label(){return P.label},set label(ie){P.label=ie??f.displayName??f.name,Se()},get detail(){return P.detail??""},set detail(ie){P.detail=ie,Se()},get description(){return P.description??""},set description(ie){P.description=ie,Se()},get supportedLanguages(){return P.supportedLanguages},set supportedLanguages(ie){P.supportedLanguages=ie,Se()},get supportsExecutionOrder(){return P.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){P.supportsExecutionOrder=ie,Se()},get rendererScripts(){return P.preloads?P.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return J},set executeHandler(ie){J=ie??W},get interruptHandler(){return ce},set interruptHandler(ie){ce=ie,P.supportsInterrupt=!!ie,Se()},set variableProvider(ie){(0,t.$mF)(f,"notebookVariableProvider"),me=ie,P.hasVariableProvider=!!ie,ie?.onDidChangeVariables(ke=>O.a.$variablesUpdated(ke.uri)),Se()},get variableProvider(){return me},createNotebookCellExecution(ie){if(z)throw new Error("notebook controller is DISPOSED");if(!he.has(ie.notebook.uri))throw O.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return O._createNotebookCellExecution(ie,d(f.identifier,this.id))},createNotebookExecution(ie){if((0,t.$mF)(f,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!he.has(ie.uri))throw O.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(he.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.uri.toString()}`);return O._createNotebookExecution(ie,d(f.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${M}], DISPOSED`),z=!0,this.j.delete(M),q.dispose(),C.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(ie,ke){ke===b.NotebookControllerAffinity2.Hidden&&(0,t.$mF)(f,"notebookControllerAffinityHidden"),O.a.$updateNotebookPriority(M,ie.uri,ke)},onDidReceiveMessage:C.event,postMessage(ie,ke){return(0,t.$mF)(f,"notebookMessaging"),O.a.$postMessage(M,ke&&O.n.getIdByEditor(ke),ie)},asWebviewUri(ie){return(0,t.$mF)(f,"notebookMessaging"),(0,r.$lvb)(ie,O.m.remote)}};return this.j.set(M,{extensionId:f.identifier,controller:fe,onDidReceiveMessage:C,onDidChangeSelection:q,associatedNotebooks:he}),fe}getIdByController(f){for(const[S,F]of this.j)if(F.controller===f)return d(F.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,S){const F=this.g++,$=this;this.q.trace(`NotebookControllerDetectionTask[${F}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(F,S);const y={dispose:()=>{this.f.delete(F),$.a.$removeKernelDetectionTask(F)}};return this.f.set(F,y),y}registerKernelSourceActionProvider(f,S,F){const $=this.i++,y=typeof F.onDidChangeNotebookKernelSourceActions=="function"?$:void 0,D=this;this.h.set($,F),this.q.trace(`NotebookKernelSourceActionProvider[${$}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider($,$,S);let M;return y!==void 0&&(M=F.onDidChangeNotebookKernelSourceActions(O=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete($),D.a.$removeKernelSourceActionProvider($,$),M?.dispose()}}}async $provideKernelSourceActions(f,S){const F=this.h.get(f);if(F){const $=new R.$Rc;return(await F.provideNotebookKernelSourceActions(S)??[]).map(D=>p.NotebookKernelSourceAction.from(D,this.o.converter,$))}return[]}$acceptNotebookAssociation(f,S,F){const $=this.j.get(f);if($){const y=this.n.getNotebookDocument(g.URI.revive(S));F?$.associatedNotebooks.set(y.uri,!0):$.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),F),$.onDidChangeSelection.fire({selected:F,notebook:y.apiNotebook})}}async $executeCells(f,S,F){const $=this.j.get(f);if(!$)return;const y=this.n.getNotebookDocument(g.URI.revive(S)),D=[];for(const M of F){const O=y.getCell(M);O&&D.push(O.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await $.controller.executeHandler.call($.controller,D,y.apiNotebook,$.controller)}catch(M){this.q.error(`NotebookController[${f}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(f,S,F){const $=this.j.get(f);if(!$)return;const y=this.n.getNotebookDocument(g.URI.revive(S));if($.controller.interruptHandler)await $.controller.interruptHandler.call($.controller,y.apiNotebook);else for(const D of F){const M=y.getCell(D);M&&this.b.get(M.uri)?.cancel()}if($.controller.interruptHandler){const D=this.c.get(y.uri);F.length&&Array.isArray(D)&&D.length&&D.forEach(M=>M.dispose())}}async $provideVariables(f,S,F,$,y,D,M){const O=this.j.get(f);if(!O)return;const W=this.n.getNotebookDocument(g.URI.revive(F)),z=O.controller.variableProvider;if(!z)return;const q=$?{name:$,value:""}:void 0,C=y==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,P=z.provideVariables(W.apiNotebook,q,C,D,M);for await(const J of P){if(M.isCancellationRequested)return;this.a.$receiveVariable(S,J)}}$acceptKernelMessageFromRenderer(f,S,F){const $=this.j.get(f);if(!$)return;const y=this.n.getEditorById(S);$.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:F}))}$cellExecutionChanged(f,S,F){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(S);if(y){const D=F?p.NotebookCellExecutionState.to(F):b.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,S){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const $=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!$)throw new Error("invalid cell");if(this.b.has($.uri))throw new Error(`duplicate execution for ${$.uri}`);const y=new h(S,$,this.a);this.b.set($.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete($.uri))});return y.asApiObject()}_createNotebookExecution(f,S){const F=this.n.getNotebookDocument(f.uri),$=f.getCells().find(M=>{const O=F.getCellFromApiCell(M);return O&&this.b.has(O.uri)});if($)throw new Error(`duplicate cell execution for ${$.document.uri}`);if(this.c.has(F.uri))throw new Error(`duplicate notebook execution for ${F.uri}`);const y=new s(S,F,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(F.uri))});return this.c.set(F.uri,[y,D]),y.asApiObject()}};e.$Ngc=a,e.$Ngc=a=Ge([Ke(4,A.$jj)],a);var c;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(c||(c={}));class h extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,S,F){super(),this.m=S,this.n=F,this.b=h.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new I.$3d),this.h=new u(10,$=>this.s($)),this.j=S.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const S=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Fv(S))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let S=this.m;if(f&&(S=this.m.notebook.getCellFromApiCell(f)),!S)throw new Error("INVALID cell");return S.handle}y(f){return f.map(S=>{const F=b.$gM.ensureUniqueMimeTypes(S.items,!0);return F===S.items?p.NotebookCellOutput.from(S):p.NotebookCellOutput.from({items:F,id:S.id,metadata:S.metadata})})}async z(f,S,F){const $=this.w(S),y=this.y((0,E.$3b)(f));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:$,append:F,outputs:y})}async C(f,S,F){return f=b.$gM.ensureUniqueMimeTypes((0,E.$3b)(f),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:f.map(p.NotebookCellOutputItem.from),outputId:S.id,append:F})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(F){f.j=F,f.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(F){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:F})},end(F,$){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Fv({runEndTime:$,lastRunSuccess:F}))},clearOutput(F){return f.t(),f.z([],F,!1)},appendOutput(F,$){return f.t(),f.z(F,$,!0)},replaceOutput(F,$){return f.t(),f.z(F,$,!1)},appendOutputItems(F,$){return f.t(),f.C(F,$,!0)},replaceOutputItems(F,$){return f.t(),f.C(F,$,!1)}})}}var i;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(i||(i={}));class s extends R.$Sc{static{this.a=0}get state(){return this.f}constructor(f,S,F){super(),this.h=S,this.j=F,this.b=s.a++,this.c=new L.$Sd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new I.$3d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,S){this.f=f,this.g=S,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new N.$mh,this.b=Date.now(),(0,N.$3g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const S=this.a;return this.a=[],this.g(S).finally(()=>f.complete())}}function d(v,f){return`${v.value}/${f}`}e.$Ogc=d}),define(Ce[259],Re([1,0,5,3,107]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;class L{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(N.$OK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,w){const A=this.c.getEditorById(m);this.a.get(g)?.fire({editor:A.apiEditor,message:w})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(A=>A.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(A,k,l)=>this.d(g).event(A,k,l),postMessage:(A,k)=>{I.$vgc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&I.$vgc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,g,A)}}}d(m){let g=this.a.get(m);return g||(g=new E.$Sd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$Pgc=L}),define(Ce[260],Re([1,0,6,16,2,23,3]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(R.$OK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,A,k){if((0,L.$mF)(w,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,w.identifier.value),(0,E.$Qc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(w,A,k,l){const p=this.b.get(w);if(!p)throw new Error(`Unknown handler with id: ${w}`);return p.saveProfile(A,k,l)}async $readProfile(w,A,k){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,N.$Ef)(A)?A:I.URI.revive(A),k)}}e.$Sgc=m}),define(Ce[261],Re([1,0,2,3,14,8]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class R{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(N.$OK.MainThreadQuickDiff)}$provideOriginalResource(g,w,A){const k=E.URI.revive(w),l=this.c.get(g);return l?(0,I.$Ug)(()=>l.provideOriginalResource(k,A)).then(p=>p||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,A,k){const l=R.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,L.DocumentSelector.from(g,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Ugc=R}),define(Ce[262],Re([1,0,20,5,6,3,2,7,11,18,31,45,23,8]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;function b(r,o,t){const n=r.getProxy(L.$OK.MainThreadQuickOpen);class a{constructor(S,F){this.e=new Map,this.f=0,this.a=S,this.b=F}showQuickPick(S,F,$,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(F),M=++this.f,O=n.$show(M,{title:$?.title,placeHolder:$?.placeHolder,matchOnDescription:$?.matchOnDescription,matchOnDetail:$?.matchOnDetail,ignoreFocusLost:$?.ignoreFocusOut,canPickMany:$?.canPickMany},y),W={},z=O.then(()=>W);return Promise.race([z,D]).then(q=>{if(q===W)return;const C=(0,l.$lF)(S,"quickPickItemTooltip");return D.then(P=>{const J=[];for(let ce=0;ce<P.length;ce++){const me=P[ce];if(typeof me=="string")J.push({label:me,handle:ce});else if(me.kind===m.QuickPickItemKind.Separator)J.push({type:"separator",label:me.label});else{me.tooltip&&!C&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const be=me.iconPath?u(me.iconPath):void 0;J.push({label:me.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:me.description,detail:me.detail,picked:me.picked,alwaysShow:me.alwaysShow,tooltip:C?p.MarkdownString.fromStrict(me.tooltip):void 0,handle:ce})}}return $&&typeof $.onDidSelectItem=="function"&&(this.c=ce=>{$.onDidSelectItem(P[ce])}),n.$setItems(M,J),O.then(ce=>{if(typeof ce=="number")return P[ce];if(Array.isArray(ce))return ce.map(me=>P[me])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return n.$setError(M,q),Promise.reject(q)})}$onItemSelected(S){this.c?.(S)}showInput(S,F=E.CancellationToken.None){return this.d=S?.validateInput,n.$input(S,typeof this.d=="function",F).then(void 0,$=>{if(!(0,g.$4)($))return Promise.reject($)})}async $validateInput(S){if(!this.d)return;const F=await this.d(S);if(!F||typeof F=="string")return F;let $;switch(F.severity){case m.InputBoxValidationSeverity.Info:$=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:$=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:$=A.default.Error;break;default:$=F.message?A.default.Error:A.default.Ignore;break}return{content:F.message,severity:$}}async showWorkspaceFolderPick(S,F=E.CancellationToken.None){const $=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!$)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===$.uri.toString())}createQuickPick(S){const F=new d(S,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}createInputBox(S){const F=new v(S,()=>this.e.delete(F._id));return this.e.set(F._id,F),F}$onDidChangeValue(S,F){this.e.get(S)?._fireDidChangeValue(F)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,F){const $=this.e.get(S);$ instanceof d&&$._fireDidChangeActive(F)}$onDidChangeSelection(S,F){const $=this.e.get(S);$ instanceof d&&$._fireDidChangeSelection(F)}$onDidTriggerButton(S,F){this.e.get(S)?._fireDidTriggerButton(F)}$onDidTriggerItemButton(S,F,$){const y=this.e.get(S);y instanceof d&&y._fireDidTriggerItemButton(F,$)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class c{static{this.a=1}constructor(S,F){this.x=S,this.y=F,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Sd,this.q=new N.$Sd,this.r=new N.$Sd,this.s=new N.$Sd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((F,$)=>{const y=F===m.$_L.Back?-1:$;this.o.set(y,F)}),this.z({buttons:S.map((F,$)=>({...u(F.iconPath),tooltip:F.tooltip,handle:F===m.$_L.Back?-1:$}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const F=this.o.get(S);F&&this.r.fire(F)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Nc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(S){if(!this.v){for(const F of Object.keys(S)){const $=S[F];this.u[F]=$===void 0?null:$}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof m.$LL)return{id:f.id};const S=s(f),F=i(f);return{dark:typeof S=="string"?R.URI.file(S):S,light:typeof F=="string"?R.URI.file(F):F}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function s(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const S=h(f);let F,$;return"id"in S?$=k.ThemeIcon.asClassName(S):F=S,{iconPath:F,iconClass:$}}class d extends c{constructor(S,F){super(S.identifier,F),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Sd,this.L=[],this.M=new N.$Sd,this.N=new N.$Sd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const F=(0,l.$lF)(this.O,"quickPickItemTooltip"),$=[];for(let y=0;y<S.length;y++){const D=S[y];if(D.kind===m.QuickPickItemKind.Separator)$.push({type:"separator",label:D.label});else{D.tooltip&&!F&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const M=D.iconPath?u(D.iconPath):void 0;$.push({handle:y,label:D.label,iconPath:M?.iconPath,iconClass:M?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:F?p.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((O,W)=>({...u(O.iconPath),tooltip:O.tooltip,handle:W}))})}}this.z({items:$})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(F=>this.D.has(F)),this.z({activeItems:this.J.map(F=>this.D.get(F))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(F=>this.D.has(F)),this.z({selectedItems:this.L.map(F=>this.D.get(F))})}_fireDidChangeActive(S){const F=(0,w.$Hb)(S.map($=>this.C.get($)));this.J=F,this.K.fire(F)}_fireDidChangeSelection(S){const F=(0,w.$Hb)(S.map($=>this.C.get($)));this.L=F,this.M.fire(F)}_fireDidTriggerItemButton(S,F){const $=this.C.get(S);if(!$||!$.buttons||!$.buttons.length)return;const y=$.buttons[F];y&&this.N.fire({button:y,item:$})}}class v extends c{constructor(S,F){super(S.identifier,F),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:A.default.Error}):this.z({validationMessage:S.message,severity:S.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new a(o,t)}e.$Vgc=b}),define(Ce[263],Re([1,0,2,5,66,6,14,3,18,138,15,22,45,8,23,13,21]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=void 0;function n(M){return M instanceof E.URI}function a(M,O){return M.scheme===r.Schemas.file&&O.scheme===r.Schemas.file&&o.$k?M.toString()===O.toString():M.toString().toLowerCase()===O.toString().toLowerCase()}function c(M){if(M)return typeof M.iconPath=="string"?E.URI.file(M.iconPath):E.URI.isUri(M.iconPath)||l.ThemeIcon.isThemeIcon(M.iconPath)?M.iconPath:void 0}function h(M){if(M.icon){if(E.URI.isUri(M.icon))return M.icon;if(l.ThemeIcon.isThemeIcon(M.icon))return M.icon;{const O=M.icon;return{light:O.light,dark:O.dark}}}else return}function i(M,O){if(!M.iconPath&&!O.iconPath)return 0;if(M.iconPath){if(!O.iconPath)return 1}else return-1;const W=typeof M.iconPath=="string"?M.iconPath:E.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id,z=typeof O.iconPath=="string"?O.iconPath:E.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,w.$Fq)(W,z)}function s(M,O){let W=0;if(M.strikeThrough!==O.strikeThrough)return M.strikeThrough?1:-1;if(M.faded!==O.faded)return M.faded?1:-1;if(M.tooltip!==O.tooltip)return(M.tooltip||"").localeCompare(O.tooltip||"");if(W=i(M,O),W!==0)return W;if(M.light&&O.light)W=i(M.light,O.light);else{if(M.light)return 1;if(O.light)return-1}if(W!==0)return W;if(M.dark&&O.dark)W=i(M.dark,O.dark);else{if(M.dark)return 1;if(O.dark)return-1}return W}function u(M,O){if(M.command!==O.command)return M.command<O.command?-1:1;if(M.title!==O.title)return M.title<O.title?-1:1;if(M.tooltip!==O.tooltip){if(M.tooltip!==void 0&&O.tooltip!==void 0)return M.tooltip<O.tooltip?-1:1;if(M.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(M.arguments===O.arguments)return 0;if(M.arguments)if(O.arguments){if(M.arguments.length!==O.arguments.length)return M.arguments.length-O.arguments.length}else return 1;else return-1;for(let W=0;W<M.arguments.length;W++){const z=M.arguments[W],q=O.arguments[W];if(z!==q&&!(n(z)&&n(q)&&a(z,q)))return z<q?-1:1}return 0}function d(M,O){let W=(0,w.$Fq)(M.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(W!==0)return W;if(M.command&&O.command)W=u(M.command,O.command);else{if(M.command)return 1;if(O.command)return-1}if(W!==0)return W;if(M.decorations&&O.decorations)W=s(M.decorations,O.decorations);else{if(M.decorations)return 1;if(O.decorations)return-1}return W}function v(M,O){for(let W=0;W<M.length;W++)if(M[W]!==O[W])return!1;return!0}function f(M,O){return M.command===O.command&&M.title===O.title&&M.tooltip===O.tooltip&&(M.arguments&&O.arguments?v(M.arguments,O.arguments):M.arguments===O.arguments)}function S(M,O){return(0,g.$ub)(M,O,f)}class F{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.l,O),this.n(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.l,O),this.f=O}get validateInput(){return(0,b.$mF)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,b.$mF)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.l,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.l,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.l,O))}get document(){return(0,b.$mF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(O,W,z,q,C){this.k=O,this.l=q,this.m=C,this.d="",this.e=new N.$Sd,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=z}showValidationMessage(O,W){(0,b.$mF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,O,W)}$onInputBoxValueChange(O){this.n(O)}n(O){this.d=O,this.e.fire(O)}}e.$Wgc=F;class ${static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,W,z,q,C){this.q=O,this.s=W,this.t=z,this.u=q,this.v=C,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Sd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Sd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=$.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,W){const z=this.h.get(O);return z?(0,R.$Ug)(()=>this.s.executeCommand(z.command,...z.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(d),z=(0,g.$Db)(this.o,O,d).map(P=>{const J=P.toInsert.map(ce=>{const me=this.e++;this.g.set(me,ce);const be=ce.resourceUri;let Se;if(ce.command)if(ce.command.command==="vscode.open"||ce.command.command==="vscode.diff"||ce.command.command==="vscode.changes"){const Ae=new L.$Rc;Se=this.s.converter.toInternal(ce.command,Ae),this.j.set(me,Ae)}else this.h.set(me,ce.command);const he=c(ce.decorations),fe=ce.decorations&&c(ce.decorations.light)||he,ie=ce.decorations&&c(ce.decorations.dark)||he,ke=[fe,ie],oe=ce.decorations&&ce.decorations.tooltip||"",Y=ce.decorations&&!!ce.decorations.strikeThrough,V=ce.decorations&&!!ce.decorations.faded,ne=ce.contextValue||"";return{rawResource:[me,be,ke,oe,Y,V,ne,Se],handle:me}});return{start:P.start,deleteCount:P.deleteCount,toInsert:J}}),q=z.map(({start:P,deleteCount:J,toInsert:ce})=>[P,J,ce.map(me=>me.rawResource)]),C=z.reverse();for(const{start:P,deleteCount:J,toInsert:ce}of C){const me=ce.map(Se=>Se.handle),be=this.n.splice(P,J,...me);for(const Se of be)this.g.delete(Se),this.h.delete(Se),this.j.get(Se)?.dispose(),this.j.delete(Se)}return this.o=O,q}dispose(){this.l=!0,this.m.fire()}}class y{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.w,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let W;(0,b.$lF)(this.x,"quickDiffProvider")&&(W=O?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!O,quickDiffLabel:W})}get historyProvider(){return(0,b.$mF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(O){(0,b.$mF)(this.x,"scmHistoryProvider"),this.j=O,this.k.value=new L.$Rc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!O}),O&&this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(O){O!==this.m&&(this.m=O,this.#e.$updateSourceControl(this.w,{commitTemplate:O}))}get acceptInputCommand(){return this.o}set acceptInputCommand(O){this.n.value=new L.$Rc,this.o=O;const W=this.y.converter.toInternal(O,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,b.$mF)(this.x,"scmActionButton"),this.q}set actionButton(O){(0,b.$mF)(this.x,"scmActionButton"),this.p.value=new L.$Rc,this.q=O;const W=O!==void 0?{command:this.y.converter.toInternal(O.command,this.p.value),secondaryCommands:O.secondaryCommands?.map(z=>z.map(q=>this.y.converter.toInternal(q,this.p.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(O){if(this.t&&O&&S(this.t,O))return;this.s.value=new L.$Rc,this.t=O;const W=(O||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(O,W,z,q,C,P,J){this.x=O,this.y=q,this.z=C,this.A=P,this.B=J,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new L.$Tc,this.m=void 0,this.n=new L.$Tc,this.o=void 0,this.p=new L.$Tc,this.s=new L.$Tc,this.t=void 0,this.u=!1,this.v=new N.$Sd,this.onDidChangeSelection=this.v.event,this.w=y.d++,this.C=new Map,this.D=new Set,this.#e=z;const ce=E.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:J?`rootUri=${encodeURIComponent(J.toString())}`:void 0});this.f=new F(O,W,this.#e,this.w,ce),this.#e.$registerSourceControl(this.w,C,P,J,ce)}createResourceGroup(O,W){const z=new $(this.#e,this.y,this.w,O,W),q=N.Event.once(z.onDidDispose)(()=>this.C.delete(z));return this.C.set(z,q),this.eventuallyAddResourceGroups(),z}eventuallyAddResourceGroups(){const O=[],W=[];for(const[z,q]of this.C){q.dispose();const C=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});N.Event.once(z.onDidDispose)(()=>{this.D.delete(z),C.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),O.push([z.handle,z.id,z.label,z.features]);const P=z._takeResourceStateSnapshot();P.length>0&&W.push([z.handle,P]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,O,W),this.C.clear()}eventuallyUpdateResourceStates(){const O=[];this.D.forEach(W=>{const z=W._takeResourceStateSnapshot();z.length!==0&&O.push([W.handle,z])}),O.length>0&&this.#e.$spliceResourceStates(this.w,O),this.D.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.u=O,this.v.fire(O)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,I.$uh)(100)],y.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$uh)(100)],y.prototype,"eventuallyUpdateResourceStates",null);let D=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(O,W,z,q){this.l=W,this.m=z,this.n=q,this.g=new Map,this.h=new k.$jm,this.j=new N.$Sd,this.e=O.getProxy(m.$OK.MainThreadSCM),this.f=O.getProxy(m.$OK.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const P=this.g.get(C.sourceControlHandle);if(!P)return C;const J=P.getResourceGroup(C.groupHandle);return J?J.getResourceState(C.handle):C}else if(C&&C.$mid===4){const P=this.g.get(C.sourceControlHandle);return P?P.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const P=this.g.get(C.handle);return P||C}return C}})}createSourceControl(O,W,z,q){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,W,z,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const C=t.d++,P=new y(O,this.m,this.e,this.l,W,z,q);this.g.set(C,P);const J=this.h.get(O.identifier)||[];return J.push(P),this.h.set(O.identifier,J),P}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const W=this.h.get(O.identifier),z=W&&W[W.length-1];return z&&z.inputBox}$provideOriginalResource(O,W,z){const q=E.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",O,q.toString());const C=this.g.get(O);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Ug)(()=>C.quickDiffProvider.provideOriginalResource(q,z)).then(P=>P||null)}$onInputBoxValueChange(O,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const z=this.g.get(O);return z&&z.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(O,W,z,q){this.n.trace("ExtHostSCM#$executeResourceCommand",O,W,z);const C=this.g.get(O);if(!C)return Promise.resolve(void 0);const P=C.getResourceGroup(W);return P?P.$executeResourceCommand(z,q):Promise.resolve(void 0)}$validateInput(O,W,z){this.n.trace("ExtHostSCM#$validateInput",O);const q=this.g.get(O);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Ug)(()=>q.inputBox.validateInput(W,z)).then(C=>{if(!C)return Promise.resolve(void 0);const P=p.MarkdownString.fromStrict(C.message);return P?Promise.resolve([P,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,W,z){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupBase(W,z)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,W,z,q){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,z,q)??void 0}async $provideHistoryItems(O,W,z,q){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(W,z,q))?.map(J=>({...J,icon:h(J)}))??void 0}async $provideHistoryItemChanges(O,W,z){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(W,z)??void 0}};e.$Xgc=D,e.$Xgc=D=t=Ge([Ke(3,A.$jj)],D)}),define(Ce[84],Re([1,0,3,5,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=e.$4fc=void 0;class L{constructor(m){this.b=new N.$Sd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(E.$OK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,w){return this.a.$setPassword(m,g,w)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$4fc=L,e.$5fc=(0,I.$2h)("IExtHostSecretState")}),define(Ce[264],Re([1,0,3,8,2]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class L{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(E.$OK.MainThreadShare)}async $provideShare(m,g,w){return await this.c.get(m)?.provideShare({selection:N.Range.to(g.selection),resourceUri:I.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider(m,g){const w=L.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,N.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$Ygc=L}),define(Ce[265],Re([1,0,20,6,3]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class L{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$OK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const w=this.c.get(m);if(!w)return;const A=new N.$Rc,k=new E.$3d;this.d.set(g,k);const l=A.add(w.provideSpeechToTextSession(k.token));A.add(l.onDidChange(p=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,p)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,w){const A=L.a++;return this.c.set(A,w),this.b.$registerProvider(A,g,{extension:m,displayName:m.value}),(0,N.$Qc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$Zgc=L}),define(Ce[266],Re([1,0,7,3,164,6,8,16]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$ML("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$ML("statusBarItem.warningForeground")]])}#e;#t;constructor(l,p,b,r,o,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new L.$Rc,this.#e=l,this.#t=p,o&&r){this.c=(0,E.$pL)(r.identifier,o);const a=b.get(this.c);a&&(t=a.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=a.priority,this.j=!0,this.name=a.name,this.text=a.text,this.tooltip=a.tooltip,this.command=a.command,this.accessibilityInformation=a.accessibilityInformation)}else this.c=String(g.a++);this.e=r,this.f=o,this.g=t,this.h=this.u(n)}u(l){if((0,m.$If)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new L.$Rc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let p;this.m?p=this.m:p=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=g.b.get(this.o.id));const r=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,p,this.k,r,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$1gc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const p={message:l};return this.b.unshift(p),this.c(),new E.$QK(()=>{const b=this.b.indexOf(p);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,p){this.e=new Map,this.a=l.getProxy(N.$OK.MainThreadStatusBar),this.b=p,this.c=new w(this)}$acceptStaticEntries(l){for(const p of l)this.e.set(p.entryId,p)}createStatusBarEntry(l,p,b,r){return new g(this.a,this.b,this.e,l,p,b,r)}setStatusBarMessage(l,p){const b=this.c.setMessage(l);let r;return typeof p=="number"?r=setTimeout(()=>b.dispose(),p):typeof p<"u"&&p.then(()=>b.dispose(),()=>b.dispose()),new E.$QK(()=>{b.dispose(),clearTimeout(r)})}}e.$2gc=A}),define(Ce[85],Re([1,0,3,5,4]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=void 0;class L{constructor(m,g){this.c=g,this.b=new N.$Sd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(E.$OK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,w){const A=await this.a.$initializeExtensionStorage(m,g);let k;return A&&(k=this.d(m,g,A)),k||w}setValue(m,g,w){return this.a.$setValue(m,g,w)}$acceptValue(m,g,w){const A=this.d(m,g,w);A&&this.b.fire({shared:m,key:g,value:A})}d(m,g,w){try{return JSON.parse(w)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${A}`)}}}e.$Vfc=L,e.$Wfc=(0,I.$2h)("IExtHostStorage")}),define(Ce[86],Re([1,0,4,27,15,63,2]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=void 0,e.$Efc=(0,E.$2h)("IExtensionStoragePaths");let m=class{constructor(w,A,k){this.d=A,this.f=k,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return R.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,A=await this.g(w);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(w){if(this.c)return R.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return R.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Ffc=m,e.$Ffc=m=Ge([Ke(0,N.$9M),Ke(1,I.$jj),Ke(2,L.$Dfc)],m)}),define(Ce[64],Re([1,0,5,3,4,2,17,6,7,166,11,194,20,33,195,45,14,8,32]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=e.$2fc=e.$1fc=e.$Zfc=void 0,e.$Zfc=(0,I.$2h)("IExtHostTerminalService");class a{constructor($,y,D,M){this.l=$,this._id=y,this.m=D,this.n=M,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(W=>this.f=W);const O=this;this.value={get name(){return O.n||""},get processId(){return O.b},get creationOptions(){return O.m},get exitStatus(){return O.h},get state(){return O.j},get selection(){return O.k},sendText(W,z=!0){O.q(),O.l.$sendText(O._id,W,z)},show(W){O.q(),O.l.$show(O._id,W)},hide(){O.q(),O.l.$hide(O._id)},dispose(){O.a||(O.a=!0,O.l.$dispose(O._id))},get dimensions(){if(!(O.d===void 0||O.g===void 0))return{columns:O.d,rows:O.g}}}}async create($,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:$.name,shellPath:$.shellPath??void 0,shellArgs:$.shellArgs??void 0,cwd:$.cwd??y?.cwd??void 0,env:$.env??void 0,icon:v($.iconPath)??void 0,color:r.ThemeColor.isThemeColor($.color)?$.color.id:void 0,initialText:$.message??void 0,strictEnv:$.strictEnv??void 0,hideFromUser:$.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o($.location,y?.resolvedExtHostIdentifier),isTransient:$.isTransient??void 0})}async createExtensionTerminal($,y,D,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:D,color:r.ThemeColor.isThemeColor(M)?M.id:void 0,location:this.o($,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o($,y){return typeof $=="object"?"parentTerminal"in $&&$.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in $?{viewColumn:t.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus}:void 0:$}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name($){this.n=$}setExitStatus($,y){this.h=Object.freeze({code:$,reason:y})}setDimensions($,y){return $===this.d&&y===this.g||$===0||y===0?!1:(this.d=$,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection($){this.k=$}_setProcessId($){this.f?(this.f($),this.f=void 0):this.b.then(y=>{y!==$&&(this.b=Promise.resolve($))})}}e.$1fc=a;class c{get onProcessReady(){return this.b.event}constructor($){this.g=$,this.id=0,this.shouldPersist=!1,this.a=new E.$Sd,this.onProcessData=this.a.event,this.b=new E.$Sd,this.d=new E.$Sd,this.onDidChangeProperty=this.d.event,this.f=new E.$Sd,this.onProcessExit=this.f.event}refreshProperty($){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${$}`)}updateProperty($,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${$}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input($){this.g.handleInput?.($)}resize($,y){this.g.setDimensions?.({columns:$,rows:y})}clearBuffer(){}async processBinary($){}acknowledgeDataEvent($){}async setUnicodeVersion($){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents($){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open($||void 0),$&&this.g.setDimensions?.($),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Sc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map($=>$.value)}constructor($,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Tc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Sd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Sd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Sd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Sd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Sd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Sd,this.onDidChangeShell=this.N.event,this.O=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Sd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(N.$OK.MainThreadTerminalService),this.y=new b.$zrb(this.a.$sendProcessData),this.a.$registerProcessSupport($),this.Q.registerArgumentProcessor({processArgument:M=>{const O=W=>{const z=W;return this.W(z.instanceId)?.value};switch(M?.$mid){case 15:return O(M);default:{if(Array.isArray(M))for(let W=0;W<M.length&&M[W].$mid===15;W++)M[W]=O(M[W]);return M}}}}),this.B({dispose:()=>{for(const[M,O]of this.g)O.shutdown(!0)}})}getDefaultShell($){return($?this.u:this.s)?.path||""}getDefaultShellArgs($){return($?this.u:this.s)?.args||[]}createExtensionTerminal($,y){const D=new a(this.a,(0,p.$mg)(),$,$.name),M=new c($.pty);return D.createExtensionTerminal($.location,this.R($,y).resolvedExtHostIdentifier,v($.iconPath),f($.color)).then(O=>{const W=this.S(O,M);this.h[O]=W}),this.f.push(D),D.value}R($,y){if(y=y||{},$.location&&typeof $.location=="object"&&"parentTerminal"in $.location){const D=$.location.parentTerminal;if(D){const M=this.f.find(O=>O.value===D);M&&(y.resolvedExtHostIdentifier=M._id)}}else $.location&&typeof $.location!="object"?y.location=$.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal($,y){if(!this.W($))throw new Error(`Cannot resolve terminal with id ${$} for virtual process`);const M=new c(y),O=this.S($,M);this.h[$]=O}async $acceptActiveTerminalChanged($){const y=this.b;if($===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W($);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData($,y){const D=this.W($);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions($,y,D){const M=this.W($);M&&M.setDimensions(y,D)&&this.L.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptDidExecuteCommand($,y){const D=this.W($);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions($,y,D){this.g.get($)?.resize(y,D)}async $acceptTerminalTitleChange($,y){const D=this.W($);D&&(D.name=y)}async $acceptTerminalClosed($,y,D){const M=this.Y(this.f,$);if(M!==null){const O=this.f.splice(M,1)[0];O.setExitStatus(y,D),this.H.fire(O.value)}}$acceptTerminalOpened($,y,D,M){if(y){const z=this.Y(this.f,y);if(z!==null){this.f[z]._id=$,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const O={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:L.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},W=new a(this.a,$,O,D);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId($,y){this.W($)?._setProcessId(y)}async $startExtensionTerminal($,y){const D=this.W($);if(!D)return{message:(0,w.localize)(0,null,$)};D.isOpen||await new Promise(O=>{const W=this.onDidOpenTerminal(async z=>{z===D.value&&(W.dispose(),O())})});const M=this.g.get($);M?M.startSendingEvents(y):this.j[$]={initialDimensions:y}}S($,y){const D=new m.$Rc;D.add(y.onProcessReady(O=>this.a.$sendProcessReady($,O.pid,O.cwd,O.windowsPty))),D.add(y.onDidChangeProperty(O=>this.a.$sendProcessProperty($,O))),this.y.startBuffering($,y.onProcessData),D.add(y.onProcessExit(O=>this.U($,O))),this.g.set($,y);const M=this.j[$];return M&&y instanceof c&&(y.startSendingEvents(M.initialDimensions),delete this.j[$]),D}$acceptProcessAckDataEvent($,y){this.g.get($)?.acknowledgeDataEvent(y)}$acceptProcessInput($,y){this.g.get($)?.input(y)}$acceptTerminalInteraction($){const y=this.W($);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection($,y){this.W($)?.setSelection(y)}$acceptProcessResize($,y,D){try{this.g.get($)?.resize(y,D)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown($,y){this.g.get($)?.shutdown(y)}$acceptProcessRequestInitialCwd($){this.g.get($)?.getInitialCwd().then(y=>this.a.$sendProcessProperty($,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd($){this.g.get($)?.getCwd().then(y=>this.a.$sendProcessProperty($,{type:"cwd",value:y}))}$acceptProcessRequestLatency($){return Promise.resolve($)}registerLinkProvider($){return this.z.add($),this.z.size===1&&this.a.$startLinkProvider(),new g.$QK(()=>{this.z.delete($),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider($,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,$.identifier.value),new g.$QK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider($,y,D){if(this.D.has($))throw new Error(`Terminal quick fix provider "${$}" is already registered`);return this.D.set($,D),this.a.$registerQuickFixProvider($,y),new g.$QK(()=>{this.D.delete($),this.a.$unregisterQuickFixProvider($)})}async $provideTerminalQuickFixes($,y){const D=new l.$3d().token;if(D.isCancellationRequested)return;const M=this.D.get($);if(!M)return;const O=await M.provideTerminalQuickFixes(y,D);if(O===null||Array.isArray(O)&&O.length===0)return;const W=new m.$Rc;if(this.w.value=W,!Array.isArray(O))return O?t.TerminalQuickFix.from(O,this.Q.converter,W):void 0;const z=[];for(const q of O){const C=t.TerminalQuickFix.from(q,this.Q.converter,W);C&&z.push(C)}return z}async $createContributedProfileTerminal($,y){const D=new l.$3d().token;let M=await this.C.get($)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${$}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,y);return}this.createTerminalFromOptions(M.options,y)}}async $provideLinks($,y){const D=this.W($);if(!D)return[];this.F.delete($),this.G.get($)?.dispose(!0);const O=new l.$3d;this.G.set($,O);const W=[],z={terminal:D.value,line:y},q=[];for(const J of this.z)q.push(o.Promises.withAsyncBody(async ce=>{O.token.onCancellationRequested(()=>ce({provider:J,links:[]}));const me=await J.provideTerminalLinks(z,O.token)||[];O.token.isCancellationRequested||ce({provider:J,links:me})}));const C=await Promise.all(q);if(O.token.isCancellationRequested)return[];const P=new Map;for(const J of C)J&&J.links.length>0&&W.push(...J.links.map(ce=>{const me={id:h++,startIndex:ce.startIndex,length:ce.length,label:ce.tooltip};return P.set(me.id,{provider:J.provider,link:ce}),me}));return this.F.set($,P),W}$activateLink($,y){const D=this.F.get($)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U($,y){this.y.stopBuffering($),this.g.delete($),delete this.j[$];const D=this.h[$];D&&(D.dispose(),delete this.h[$]),this.a.$sendProcessExit($,y)}W($){return this.X(this.f,$)}X($,y){const D=this.Y($,y);return D!==null?$[D]:null}Y($,y){const D=$.findIndex(M=>M._id===y);return D===-1?null:D}getEnvironmentVariableCollection($){let y=this.n.get($.identifier.value);return y||(y=new s,this.$($.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z($,y){const D=(0,k.$yr)(y.map),M=(0,k.$zr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection($,y.persistent,D.length===0?void 0:D,M)}$initEnvironmentVariableCollections($){$.forEach(y=>{const D=y[0],M=new s(y[1]);this.$(D,M)})}$acceptDefaultProfile($,y){const D=this.s;this.s=$,this.u=y,D?.path!==$.path&&this.N.fire($.path)}$($,y){this.n.set($,y),y.onDidChangeCollection(()=>{this.Z($,y)})}};e.$2fc=i,e.$2fc=i=Ge([Ke(1,n.$cN),Ke(2,R.$SM)],i);class s{get persistent(){return this.b}set persistent($){this.b=$,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor($){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Sd,this.map=new Map($)}getScopedEnvironmentVariableCollection($){const y=this.h($);let D=this.a.get(y);return D||(D=new u(this,$),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace($,y,D,M){this.f($,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:M})}append($,y,D,M){this.f($,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:M})}prepend($,y,D,M){this.f($,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:M})}f($,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g($,y.scope),M=this.map.get(D),O=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!M||M.value!==y.value||M.type!==y.type||M.options?.applyAtProcessCreation!==O.applyAtProcessCreation||M.options?.applyAtShellIntegration!==O.applyAtShellIntegration||M.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const W=this.g($,y.scope),z={variable:$,...y,options:O};this.map.set(W,z),this.d.fire()}}get($,y){const D=this.g($,y),M=this.map.get(D);return M?S(M):void 0}g($,y){const D=this.h(y);return D.length?`${$}:::${D}`:$}h($){return this.j($?.workspaceFolder)??""}j($){return $?$.uri.toString():void 0}getVariableMap($){const y=new Map;for(const[D,M]of this.map)this.h(M.scope)===this.h($)&&y.set(M.variable,S(M));return y}delete($,y){const D=this.g($,y);this.map.delete(D),this.d.fire()}clear($){if($?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===$.workspaceFolder.index&&this.map.delete(y);this.k($)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription($,y){const D=this.h(y),M=this.descriptionMap.get(D);if(!M||M.description!==$){let O;typeof $=="string"?O=$:O=$?.value.split(`

`)[0];const W={description:O,scope:y};this.descriptionMap.set(D,W),this.d.fire()}}getDescription($){const y=this.h($);return this.descriptionMap.get(y)?.description}k($){const y=this.h($);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent($){this.b.persistent=$}get onDidChangeCollection(){return this.a&&this.a.event}constructor($,y){this.b=$,this.d=y,this.a=new E.$Sd}getScoped($){return this.b.getScopedEnvironmentVariableCollection($)}replace($,y,D){this.b.replace($,y,D,this.d)}append($,y,D){this.b.append($,y,D,this.d)}prepend($,y,D){this.b.prepend($,y,D,this.d)}get($){return this.b.get($,this.d)}forEach($,y){this.b.getVariableMap(this.d).forEach((D,M)=>$.call(y,M,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete($){this.b.delete($,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description($){this.b.setDescription($,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor($,y){super(!1,$,y)}createTerminal($,y,D){throw new A.$_}createTerminalFromOptions($,y){throw new A.$_}};e.$3fc=d,e.$3fc=d=Ge([Ke(0,n.$cN),Ke(1,R.$SM)],d);function v(F){if(!(!F||typeof F=="string"))return"id"in F?{id:F.id,color:F.color}:F}function f(F){return r.ThemeColor.isThemeColor(F)?F:void 0}function S(F){const $={...F};return delete $.scope,$.options=$.options??void 0,delete $.variable,$}}),define(Ce[267],Re([1,0,14,24,20,5,219,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=e.$7gc=e.$6gc=void 0;let h=class extends g.$Sc{constructor(W,z,q){super(),this.w=q,this.f=this.B(new L.$Sd),this.g=new Map,this.s=this.B(new L.$Sd),this.onResultsChanged=this.f.event,this.results=[],this.h=W.getProxy(l.$OK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),z.registerArgumentProcessor({processArgument:C=>{switch(C?.$mid){case 16:{const P=C,J=P.tests[P.tests.length-1].item.extId;return this.g.get(t.$GJ.root(J))?.collection.tree.get(J)?.actual??(0,b.$5M)(C)}case 18:{const{extId:P,message:J}=C;return{test:this.g.get(t.$GJ.root(P))?.collection.tree.get(P)?.actual,message:r.TestMessage.to(J)}}default:return C}}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const C=await z.executeCommand("_testing.getExplorerSelection"),P=J=>{const ce=this.g.get(t.$GJ.root(J));if(ce)return t.$GJ.isRoot(J)?ce.controller:ce.collection.tree.get(J)?.actual};return{include:C?.include.map(P).filter(A.$Mf)||[],exclude:C?.exclude.map(P).filter(A.$Mf)||[]}})}createTestController(W,z,q,C){if(this.g.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const P=new g.$Rc,J=P.add(new b.$8M(z,q,this.w));J.root.label=q;const ce=new Map,me=new Set,be=this.h,Se={items:J.root.children,get label(){return q},set label(fe){q=fe,J.root.label=fe,be.$updateController(z,{label:q})},get refreshHandler(){return C},set refreshHandler(fe){C=fe,be.$updateController(z,{canRefresh:!!fe})},get id(){return z},createRunProfile:(fe,ie,ke,oe,Y,V)=>{let ne=(0,m.$Pi)(fe);for(;ce.has(ne);)ne++;return new D(this.h,ce,W,me,this.s.event,z,ne,fe,ie,ke,oe,Y,V)},createTestItem(fe,ie,ke){return new b.$6M(z,fe,ie,ke)},createTestRun:(fe,ie,ke=!0)=>this.j.createTestRun(W,z,J,fe,ie,ke),invalidateTestResults:fe=>{if(fe===void 0)this.h.$markTestRetired(void 0);else{const ie=fe instanceof Array?fe:[fe];this.h.$markTestRetired(ie.map(ke=>t.$GJ.fromExtHostTestItem(ke,z).toString()))}},set resolveHandler(fe){J.resolveHandler=fe},get resolveHandler(){return J.resolveHandler},dispose:()=>{P.dispose()}};be.$registerTestController(z,q,!!C),P.add((0,g.$Qc)(()=>be.$unregisterTestController(z)));const he={controller:Se,collection:J,profiles:ce,extension:W,activeProfiles:me};return this.g.set(z,he),P.add((0,g.$Qc)(()=>this.g.delete(z))),P.add(J.onDidGenerateDiff(fe=>be.$publishDiff(z,fe.map(a.TestsDiffOp.serialize)))),Se}createTestObserver(){return this.m.checkout()}async runTests(W,z=I.CancellationToken.None){const q=v(W);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(q.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:W.include?.map(P=>t.$GJ.fromExtHostTestItem(P,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:M[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:W.exclude?.map(P=>P.id)},z)}$syncTests(){for(const{collection:W}of this.g.values())W.flushDiff();return Promise.resolve()}async $provideFileCoverage(W,z,q){return await this.j.getCoverageReport(W,z)?.provideFileCoverage(q)??[]}async $resolveFileCoverage(W,z,q,C){return await this.j.getCoverageReport(W,z)?.resolveFileCoverage(q,C)??[]}$configureRunProfile(W,z){this.g.get(W)?.profiles.get(z)?.configureHandler?.()}$setActiveRunProfiles(W){const z=new Map;for(const[q,C]of Object.entries(W)){const P=this.g.get(q);if(!P)continue;const J=new Map,ce=C.filter(be=>!P.activeProfiles.has(be)),me=[...P.activeProfiles].filter(be=>!C.includes(be));for(const be of ce)J.set(be,!0),P.activeProfiles.add(be);for(const be of me)J.set(be,!1),P.activeProfiles.delete(be);J.size&&z.set(q,J)}this.s.fire(z)}async $refreshTests(W,z){await this.g.get(W)?.controller.refreshHandler?.(z)}$publishTestResults(W){this.results=Object.freeze(W.map(z=>(0,w.$jn)(r.TestResults.to(z))).concat(this.results).sort((z,q)=>q.completedAt-z.completedAt).slice(0,32)),this.f.fire()}async $expandTest(W,z){const q=this.g.get(t.$GJ.fromString(W).controllerId)?.collection;q&&(await q.expand(W,z<0?1/0:z),q.flushDiff())}$acceptDiff(W){this.m.applyDiff(W.map(z=>a.TestsDiffOp.deserialize({asCanonicalUri:q=>q},z)))}async $runControllerTests(W,z){return Promise.all(W.map(q=>this.y(q,!1,z)))}async $startContinuousRun(W,z){const q=new I.$3d(z),C=await Promise.all(W.map(P=>this.y(P,!0,q.token)));return!z.isCancellationRequested&&!C.some(P=>P.error)&&await new Promise(P=>z.onCancellationRequested(P)),q.dispose(!0),C}async y(W,z,q){const C=this.g.get(W.controllerId);if(!C)return{};const{collection:P,profiles:J,extension:ce}=C,me=J.get(W.profileId);if(!me)return{};const be=W.testIds.map(ie=>P.tree.get(ie)).filter(A.$Mf),Se=W.excludeExtIds.map(ie=>C.collection.tree.get(ie)).filter(A.$Mf).filter(ie=>be.some(ke=>ke.fullId.compare(ie.fullId)===2));if(!be.length)return{};const he=new o.$nM(be.some(ie=>ie.actual instanceof b.$7M)?void 0:be.map(ie=>ie.actual),Se.map(ie=>ie.actual),me,z),fe=(0,a.$IJ)(W)&&this.j.prepareForMainThreadTestRun(he,f.fromInternal(W,C.collection),ce,q);try{return await me.runHandler(he,q),{}}catch(ie){return{error:String(ie)}}finally{fe&&(fe.hasRunningTasks&&!q.isCancellationRequested&&await L.Event.toPromise(fe.onEnd),fe.dispose())}}$cancelExtensionTestRun(W){W===void 0?this.j.cancelAllRuns():this.j.cancelRunById(W)}};e.$6gc=h,e.$6gc=h=Ge([Ke(0,p.$SM)],h);const i=1e4;var s;(function(O){O[O.Running=0]="Running",O[O.Cancelling=1]="Cancelling",O[O.Ended=2]="Ended"})(s||(s={}));class u extends g.$Sc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(W,z,q,C){super(),this.s=W,this.w=z,this.y=q,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new L.$Sd),this.m=this.B(new L.$Sd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$3d(C));const P=this.B(new E.$bh(()=>this.z(),i));this.B(this.h.token.onCancellationRequested(()=>P.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.z()}createRun(W){const z=this.s.id,q=this.s.controllerId,C=(0,k.$mg)(),P=this.y,J=this.m;let ce;const me=fe=>(ie,...ke)=>{if(Se){console.warn(`Setting the state of test "${ie.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ie)&&(this.D(ie),fe(ie,...ke))},be=(fe,ie)=>{const ke=ie instanceof Array?ie.map(r.TestMessage.from):[r.TestMessage.from(ie)];if(fe.uri&&fe.range){const oe={range:r.Range.from(fe.range),uri:fe.uri};for(const Y of ke)Y.location=Y.location||oe}this.w.$appendTestMessagesInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),ke)};let Se=!1;const he={isPersisted:this.s.isPersisted,token:this.h.token,name:W,get coverageProvider(){return ce?.provider},set coverageProvider(fe){(0,c.$mF)(P,"testCoverage"),ce=fe&&new S(fe),J.fire({taskId:C,runId:z,coverage:ce})},enqueued:me(fe=>{this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),1)}),skipped:me(fe=>{this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),5)}),started:me(fe=>{this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),2)}),errored:me((fe,ie,ke)=>{be(fe,ie),this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),6,ke)}),failed:me((fe,ie,ke)=>{be(fe,ie),this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,q).toString(),4,ke)}),passed:me((fe,ie)=>{this.w.$updateTestStateInRun(z,C,t.$GJ.fromExtHostTestItem(fe,this.s.controllerId).toString(),3,ie)}),appendOutput:(fe,ie,ke)=>{Se||(ke&&(this.s.isIncluded(ke)?this.D(ke):ke=void 0),this.w.$appendOutputToRun(z,C,N.$ge.fromString(fe),ie&&r.location.from(ie),ke&&t.$GJ.fromExtHostTestItem(ke,q).toString()))},end:()=>{Se||(Se=!0,this.w.$finishedTestRunTask(z,C),this.f.delete(C),this.f.size||this.C())}};return this.f.set(C,{run:he}),this.w.$startedTestRunTask(z,{id:C,name:W,running:!0}),he}z(){for(const{run:W}of this.f.values())W.end()}C(){this.c!==2&&(this.c=2,this.j.fire())}D(W){if(!(W instanceof b.$6M))throw new n.$KM(W.id);if(this.g.has(t.$GJ.fromExtHostTestItem(W,this.s.controllerId).toString()))return;const z=[],q=this.s.colllection.root;for(;;){const C=r.TestItem.from(W);if(z.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),W===q))break;W=W.parent||q}this.w.$addTestsToRun(this.s.controllerId,this.s.id,z)}dispose(){this.C(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(W){this.g=W,this.c=new Map,this.f=[]}getCoverageReport(W,z){return this.f.find(q=>q.runId===W)?.coverage.get(z)}prepareForMainThreadTestRun(W,z,q,C){return this.h(W,z,q,C)}cancelRunById(W){for(const z of this.c.values())if(z.id===W){z.cancel();return}}cancelAllRuns(){for(const W of this.c.values())W.cancel()}createTestRun(W,z,q,C,P,J){const ce=this.c.get(C);if(ce)return ce.createRun(P);const me=f.fromPublic(z,q,C,J),be=v(C);this.g.$startedExtensionTestRun({controllerId:z,continuous:!!C.continuous,profile:be&&{group:M[be.kind],id:be.profileId},exclude:C.exclude?.map(he=>t.$GJ.fromExtHostTestItem(he,q.root.id).toString())??[],id:me.id,include:C.include?.map(he=>t.$GJ.fromExtHostTestItem(he,q.root.id).toString())??[q.root.id],persist:J});const Se=this.h(C,me,W);return L.Event.once(Se.onEnd)(()=>{this.g.$finishedExtensionTestRun(me.id),Se.dispose()}),Se.createRun(P)}h(W,z,q,C){const P=new u(z,this.g,q,C);this.c.set(W,P);let J;const ce=P.onDidCoverage(({runId:me,taskId:be,coverage:Se})=>{J||(J={runId:me,coverage:new Map},this.f.unshift(J),this.f.length>a.$NJ&&this.f.pop()),J.coverage.set(be,Se),this.g.$signalCoverageAvailable(me,be,!!Se)});return L.Event.once(P.onEnd)(()=>{this.c.delete(W),ce.dispose()}),P}}e.$7gc=d;const v=O=>{if(O.profile){if(!(O.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return O.profile}};class f{static fromPublic(W,z,q,C){return new f(W,(0,k.$mg)(),q.include?.map(P=>t.$GJ.fromExtHostTestItem(P,W).toString())??[W],q.exclude?.map(P=>t.$GJ.fromExtHostTestItem(P,W).toString())??[],C,z)}static fromInternal(W,z){return new f(W.controllerId,W.runId,W.testIds,W.excludeExtIds,!0,z)}constructor(W,z,q,C,P,J){this.controllerId=W,this.id=z,this.isPersisted=P,this.colllection=J,this.c=q.map(ce=>ce+"\0"),this.f=C.map(ce=>ce+"\0")}isIncluded(W){const z=t.$GJ.fromExtHostTestItem(W,this.controllerId).toString()+"\0";for(const q of this.f)if(z===q||z.startsWith(q))return!1;for(const q of this.c)if(z===q||z.startsWith(q))return!0;return!1}}e.$8gc=f;class S{constructor(W){this.provider=W}async provideFileCoverage(W){this.c||(this.c=(async()=>this.provider.provideFileCoverage(W))());try{return(await this.c)?.map(r.TestCoverage.fromFile)??[]}catch(z){throw this.c=void 0,z}}async resolveFileCoverage(W,z){const q=await this.c;let C=q?.[W];return!this.provider||!q||!C?[]:(C.detailedCoverage||(C=q[W]=await this.provider.resolveFileCoverage?.(C,z)??C),C.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class F{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(W){this.j=W,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(W){this.c.add(W)}update(W){Object.assign(W.revived,r.TestItem.toPlain(W.item)),this.c.has(W)||this.f.add(W)}remove(W){if(this.c.has(W)){this.c.delete(W);return}this.f.delete(W);const z=t.$GJ.parentId(W.item.extId);if(z&&this.h.has(z.toString())){this.h.add(W.item.extId);return}this.g.add(W)}getChangeEvent(){const{c:W,f:z,g:q}=this;return{get added(){return[...W].map(C=>C.revived)},get updated(){return[...z].map(C=>C.revived)},get removed(){return[...q].map(C=>C.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class $ extends a.$OJ{constructor(){super(...arguments),this.s=new L.$Sd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(W){return this.f.get(W)}getMirroredTestDataByReference(W){return this.f.get(W.id)}w(W,z){return{...W,revived:r.TestItem.toPlain(W.item),depth:z?z.depth+1:0,children:new Set}}v(){return new F(this.s)}}class y{constructor(W){this.f=W}checkout(){this.c||(this.c=this.g());const W=this.c;return W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,get tests(){return[...W.tests.rootTests].map(z=>z.revived)},dispose:(0,R.$db)(()=>{--W.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(W){return this.c?.tests.getMirroredTestDataByReference(W)}applyDiff(W){this.c?.tests.apply(W)}g(){const W=new $({asCanonicalUri:z=>z});return this.f.$subscribeToDiffs(),{observers:0,tests:W}}}class D{#e;#t;#i;#o;#r;get label(){return this.f}set label(W){W!==this.f&&(this.f=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:W}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(W){W!==this.h&&(this.h=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:W}))}get isDefault(){return this.g}set isDefault(W){W!==this.g&&(this.g=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:W}))}get tag(){return this._tag}set tag(W){W?.id!==this._tag?.id&&(this._tag=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:W?r.TestTag.namespace(this.controllerId,W.id):null}))}get configureHandler(){return this.c}set configureHandler(W){W!==this.c&&(this.c=W,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!W}))}get isSelected(){return(0,c.$mF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$mF)(this.#t,"testingActiveProfile"),L.Event.chain(this.#o,W=>W.map(z=>z.get(this.controllerId)?.get(this.profileId)).filter(A.$Mf))}constructor(W,z,q,C,P,J,ce,me,be,Se,he=!1,fe=void 0,ie=!1){this.controllerId=J,this.profileId=ce,this.f=me,this.kind=be,this.runHandler=Se,this.g=he,this._tag=fe,this.h=ie,this.#e=W,this.#r=z,this.#t=q,this.#i=C,this.#o=P,z.set(ce,this);const ke=M[be];if(typeof ke!="number")throw new Error(`Unknown TestRunProfile.group ${be}`);this.#e.$publishTestRunProfile({profileId:ce,controllerId:J,tag:fe?r.TestTag.namespace(this.controllerId,fe.id):null,label:me,group:ke,isDefault:he,hasConfigurationHandler:!1,supportsContinuousRun:ie})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$9gc=D;const M={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[268],Re([1,0,18,11,5,3,109,8,7]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;class w{constructor(k,l){this.i=l,this.a=new I.$Sd({onListenerError:N.$2}),this.b=new I.$Sd({onListenerError:N.$2}),this.c=new I.$Sd({onListenerError:N.$2}),this.d=new I.$Sd({onListenerError:N.$2}),this.f=new I.$Sd({onListenerError:N.$2}),this.g=new I.$Sd({onListenerError:N.$2}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(L.$OK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(p=>this.g.fire(p)),this.i.onDidChangeActiveTextEditor(p=>this.f.fire(p))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const l=this.i.allEditors();return k?l:l.map(p=>p.value)}async showTextDocument(k,l,p){let b;typeof l=="number"?b={position:m.ViewColumn.from(l),preserveFocus:p}:typeof l=="object"?b={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:b={preserveFocus:!1};const r=await this.h.$tryShowTextDocument(k.uri,b),o=r&&this.i.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,l){return new R.$ZM(this.h,k,l).value}$acceptEditorPropertiesChanged(k,l){const p=this.i.getEditor(k);if(!p)throw new Error("unknown text editor");if(l.options&&p._acceptOptions(l.options),l.selections){const b=l.selections.selections.map(m.Selection.to);p._acceptSelections(b)}if(l.visibleRanges){const b=E.$Hb(l.visibleRanges.map(m.Range.to));p._acceptVisibleRanges(b)}if(l.options&&this.b.fire({textEditor:p.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const b=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),r=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:p.value,selections:r,kind:b})}if(l.visibleRanges){const b=E.$Hb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:p.value,visibleRanges:b})}}$acceptEditorPositionData(k){for(const l in k){const p=this.i.getEditor(l);if(!p)throw new Error("Unknown text editor");const b=m.ViewColumn.to(k[l]);p.value.viewColumn!==b&&(p._acceptViewColumn(b),this.d.fire({textEditor:p.value,viewColumn:b}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.$sfc=w}),define(Ce[269],Re([1,0,2,4,3,6,7,8,22,16]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0,e.$$gc=(0,N.$2h)("IExtHostTimeline");class A{constructor(p,b){this.b=new Map,this.c=new Map,this.a=p.getProxy(I.$OK.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(r,o)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&g.$hm.equals(o,this.b.get(r.source)?.extension)){const t=r.uri===void 0?void 0:E.URI.revive(r.uri);return this.c.get(r.source)?.get(k(t))?.get(r.handle)}else return;return r}})}async $getTimeline(p,b,r,o){return this.b.get(p)?.provider.provideTimeline(E.URI.revive(b),r,o)}registerTimelineProvider(p,b,r,o){const t=new L.$Rc,n=this.d(b.id,o,t).bind(this);let a;b.onDidChange&&(a=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:p,onDidChange:void 0,async provideTimeline(h,i,s){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(h,i,s);if(u==null)return;const d=n(h,i);return{...u,source:b.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();a?.dispose(),t.dispose()}},r)}d(p,b,r){return(o,t)=>{let n;if(t?.cacheResults){let a=this.c.get(p);a===void 0&&(a=new Map,this.c.set(p,a));const c=k(o);n=a.get(c),n===void 0&&(n=new Map,a.set(c,n))}return a=>{const{iconPath:c,...h}=a,i=`${p}|${a.id??a.timestamp}`;n?.set(i,a);let s,u,d;a.iconPath&&(c instanceof R.$LL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(s=c,u=c):{light:s,dark:u}=c);let v;return R.$fL.isMarkdownString(h.tooltip)?v=m.MarkdownString.from(h.tooltip):(0,w.$Ef)(h.tooltip)?v=h.tooltip:R.$fL.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(h.detail)):(0,w.$Ef)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.detail),{...h,id:h.id??void 0,handle:i,source:p,command:a.command?b.toInternal(a.command,r):void 0,icon:s,iconDark:u,themeIcon:d,tooltip:v,accessibilityInformation:a.accessibilityInformation}}}}f(p,b){if(this.b.get(p.id))throw new Error(`Timeline Provider ${p.id} already exists.`);return this.a.$registerTimelineProvider({id:p.id,label:p.label,scheme:p.scheme}),this.b.set(p.id,{provider:p,extension:b}),(0,L.$Qc)(()=>{for(const o of this.c.values())o.get(p.id)?.clear();this.b.delete(p.id),this.a.$unregisterTimelineProvider(p.id),p.dispose()})}}e.$_gc=A;function k(l){return l?.toString()}}),define(Ce[87],Re([1,0,20,5,6,168,4,15,197,3,27,17,7]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dyb=e.$cyb=e.TunnelDtoConverter=void 0;class p extends g.$vv{}var b;(function(o){function t(a){return{remoteAddress:a.remoteAddress,localAddress:a.localAddress,public:!!a.public,privacy:a.privacy??(a.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:a.protocol}}o.fromApiTunnel=t;function n(a){return{remoteAddress:{host:a.tunnelRemoteHost,port:a.tunnelRemotePort},localAddress:a.localAddress,public:a.privacy!==g.TunnelPrivacyId.ConstantPrivate&&a.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:a.privacy,protocol:a.protocol}}o.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$cyb=(0,R.$2h)("IExtHostTunnelService");let r=class extends I.$Sc{constructor(t,n,a){super(),this.s=a,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Sd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$OK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const a=await this.a.$openTunnel(n,t.displayName);if(a){const c=new p(a.remoteAddress,a.localAddress,()=>this.a.$closeTunnel(a.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const a=this.u();return this.r.set(a,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,a),new l.$QK(()=>{this.r.delete(a),this.a.$unregisterPortsAttributesProvider(a)})}async $providePortAttributes(t,n,a,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async v=>{let f;try{f=await d.provider.providePortAttributes({port:v,pid:a,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(v,a,c,h)}return{providedAttributes:f,port:v}})))}const s=i.filter(u=>!!u.providedAttributes);return s.length>0?s.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$3d().token)??void 0;const a=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(a),Promise.resolve((0,I.$Qc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const a=t.tunnelFactory??(n?this.w(n):void 0);if(a){this.b=a;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,I.$Qc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const a=this.g.get(t.host);a.has(t.port)&&(n&&a.get(t.port).disposeListener.dispose(),await a.get(t.port).tunnel.dispose(),a.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const a=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),a!==void 0){const c=await a;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(a){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),a instanceof Error)return a.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),a=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${a.map(c=>c.port).join(", ")}`),a}};e.$dyb=r,e.$dyb=r=Ge([Ke(0,k.$SM),Ke(1,A.$9M),Ke(2,m.$jj)],r)}),define(Ce[270],Re([1,0,6,13,2,3]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(L.$OK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,A,k){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=k.schemes.find(p=>!R.a.has(p));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,A),this.b.$registerUriOpener(w,k.schemes,g,k.label),(0,E.$Qc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener with id: ${g}`);const l=I.URI.revive(w);return k.canOpenExternalUri(l,A)}async $openUri(g,w,A){const k=this.c.get(g);if(!k)throw new Error(`Unknown opener id: '${g}'`);return k.openExternalUri(I.URI.revive(w.resolvedUri),{sourceUri:I.URI.revive(w.sourceUri)},A)}}e.$bhc=R}),define(Ce[271],Re([1,0,3,2,6,11,22]),function(ge,e,E,N,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;class m{static{this.a=0}constructor(w){this.c=new R.$im,this.d=new Map,this.b=w.getProxy(E.$OK.MainThreadUrls)}registerUriHandler(w,A){const k=w.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,w.displayName||w.name),(0,I.$Qc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,A){const k=this.d.get(w);if(!k)return Promise.resolve(void 0);try{k.handleUri(N.URI.revive(A))}catch(l){(0,L.$1)(l)}return Promise.resolve(void 0)}async createAppUri(w){return N.URI.revive(await this.b.$createAppUri(w))}}e.$chc=m}),define(Ce[65],Re([1,0,5,6,13,26,2,182,204,78,3]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=e.$Jfc=e.$Ifc=e.$Hfc=e.$Gfc=void 0;class k{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,s,u,d,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Sd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Sd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=s,this.#r=u,this.#n=d,this.#l=l(d),this.#d=p(d),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$lvb)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===I.Schemas.https||c.scheme===I.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$kvb}return w.$kvb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),L.$mn(this.#s,c)||this.#t.$setOptions(this.#e,o(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$4kb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===I.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,v,f,S)=>{const F=R.URI.from({scheme:v||"file",path:decodeURIComponent(f)}),$=(0,w.$lvb)(F,{isRemote:h,authority:i}).toString();return`${u}${$}${S}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(s,u,d,v,f,S)=>{const F=R.URI.from({scheme:v||"file",path:decodeURIComponent(f)}),$=(0,w.$lvb)(F,{isRemote:h,authority:i}).toString();return`${u}${$}${S}`})}}e.$Gfc=k;function l(a){try{const c=(0,m.$2o)((0,m.$1o)(a.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$Hfc=l;function p(a){try{const c=(0,m.$2o)((0,m.$1o)(a.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends N.$Sc{constructor(c,h,i,s,u){super(),this.c=h,this.f=i,this.g=s,this.h=u,this.b=new Map,this.a=c.getProxy(A.$OK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const s=this.j(c);if(s){const{message:u}=(0,g.$5kb)(h,i.value);s._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const s=new k(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,s);const u=s._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return s}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Ifc=b;function r(a){return{id:a.identifier,location:a.extensionLocation}}e.$Jfc=r;function o(a,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(a,c)}}e.$Kfc=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(c=>R.URI.from(c))}}function n(a,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),a.extensionLocation]}}),define(Ce[272],Re([1,0,20,98,6,13,25,2,8,65,75,3,7]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class p{constructor(s,u){this.document=s,this.b=u,this.a=1,this.c=new A.$_ec("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,u){await this.f(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.f(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=h(this.document.uri)+this.a++;return(0,R.$Dg)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const u=this.c.get(s,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(s,u){return this.a.get(this.b(s,u))}add(s,u,d){const v=this.b(s,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const f=new p(u,d);return this.a.set(v,f),f}delete(s,u){const d=this.b(s,u.uri);this.a.delete(d)}b(s,u){return`${s}@@@${u}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(s,u,d){return this.b(0,s,u,d)}addCustomProvider(s,u,d){return this.b(1,s,u,d)}get(s){return this.a.get(s)}b(s,u,d,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:s,extension:d,provider:v}),new l.$QK(()=>this.a.delete(u))}}class t{constructor(s,u,d,v,f){this.d=u,this.f=d,this.g=v,this.h=f,this.b=new o,this.c=new b,this.a=s.getProxy(k.$OK.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,d,v){const f=new I.$Rc;return a(d)?(f.add(this.b.addTextProvider(u,s,d)),this.a.$registerTextEditorProvider((0,w.$Jfc)(s),u,v.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$Hfc)(s))):(f.add(this.b.addCustomProvider(u,s,d)),n(d)&&f.add(d.onDidChangeCustomDocument(S=>{const F=this.i(u,S.document.uri);if(c(S)){const $=F.addEdit(S);this.a.$onDidEdit(S.document.uri,u,$,S.label)}else this.a.$onContentChange(S.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$Jfc)(s),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,w.$Hfc)(s))),l.$QK.from(f,new l.$QK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,d,v,f){const S=this.b.get(u);if(!S)throw new Error(`No provider found for '${u}'`);if(S.type!==1)throw new Error(`Invalid provide type for '${u}'`);const F=m.URI.revive(s),$=await S.provider.openCustomDocument(F,{backupId:d,untitledDocumentData:v?.buffer},f);let y;return n(S.provider)&&this.f&&(y=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(u,$,y),{editable:n(S.provider)}}async $disposeCustomDocument(s,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=m.URI.revive(s),{document:f}=this.i(u,v);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(s,u,d,v,f,S){const F=this.b.get(d);if(!F)throw new Error(`No provider found for '${d}'`);const $=g.ViewColumn.to(f),y=this.g.createNewWebview(u,v.contentOptions,F.extension),D=this.h.createNewWebviewPanel(u,d,v.title,$,v.options,y,v.active),M=m.URI.revive(s);switch(F.type){case 1:{const{document:O}=this.i(d,M);return F.provider.resolveCustomEditor(O,D,S)}case 0:{const O=this.d.getDocument(M);return F.provider.resolveCustomTextEditor(O,D,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,d){this.i(u,s).disposeEdits(d)}async $onMoveCustomEditor(s,u,d){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(s);if(!f)throw new Error("No webview found");const S=m.URI.revive(u),F=this.d.getDocument(S);await v.provider.moveCustomTextEditor(F,f,E.CancellationToken.None)}async $undo(s,u,d,v){return this.i(u,s).undo(d,v)}async $redo(s,u,d,v){return this.i(u,s).redo(d,v)}async $revert(s,u,d){const v=this.i(u,s);await this.j(u).revertCustomDocument(v.document,d),v.disposeBackup()}async $onSave(s,u,d){const v=this.i(u,s);await this.j(u).saveCustomDocument(v.document,d),v.disposeBackup()}async $onSaveAs(s,u,d,v){const f=this.i(u,s);return this.j(u).saveCustomDocumentAs(f.document,m.URI.revive(d),v)}async $backup(s,u,d){const v=this.i(u,s),S=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},d);return v.updateBackup(S),S.id}i(s,u){const d=this.c.get(s,m.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(s){const d=this.b.get(s)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$Mfc=t;function n(i){return!!i.onDidChangeCustomDocument}function a(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const s=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,N.$Pi)(s)+""}}),define(Ce[273],Re([1,0,5,6,2,33,8,65,3,7]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class A extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(b,r,o,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Sd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Sd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=r,this.#o=o,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:R.ViewColumn.from(b),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends N.$Sc{static c(){return(0,L.$mg)()}constructor(b,r,o){super(),this.j=r,this.m=o,this.g=new Map,this.h=new Map,this.f=b.getProxy(g.$OK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,r,o,t,n={}){const a=typeof t=="object"?t.viewColumn:t,c={viewColumn:R.ViewColumn.from(a),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,m.$Hfc)(b),i=k.c();this.f.$createWebviewPanel((0,m.$Jfc)(b),i,r,{title:o,panelOptions:l(n),webviewOptions:(0,m.$Kfc)(b,this.m,n),serializeBuffersForPostMessage:h},c);const s=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,r,o,a,n,s,!0)}$onDidChangeWebviewPanelViewStates(b){const r=Object.keys(b);r.sort((o,t)=>{const n=b[o],a=b[t];return n.active?1:a.active?-1:+n.visible-+a.visible});for(const o of r){const t=this.getWebviewPanel(o);if(!t)continue;const n=b[o];t._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,r,o){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:o,extension:b}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$Hfc)(b)}),new w.$QK(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(b,r,o,t){const n=this.h.get(r);if(!n)throw new Error(`No serializer found for '${r}'`);const{serializer:a,extension:c}=n,h=this.j.createNewWebview(b,o.webviewOptions,c),i=this.createNewWebviewPanel(b,r,o.title,t,o.panelOptions,h,o.active);await a.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(b,r,o,t,n,a,c){const h=new A(b,this.f,a,{viewType:r,title:o,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$Lfc=k;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}}),define(Ce[274],Re([1,0,5,6,65,8,3,7]),function(ge,e,E,N,I,L,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;class g extends N.$Sc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(k,l,p,b,r,o){super(),this.#r=!1,this.#u=this.B(new E.$Sd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Sd),this.onDidDispose=this.#l.event,this.#i=p,this.#a=b,this.#e=k,this.#t=l,this.#o=r,this.#n=o}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#s}set description(k){this.a(),this.#s!==k&&(this.#s=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(k){k===this.#n||this.#r||(this.#n=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=L.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(R.$OK.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,p,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:p,extension:k}),this.a.$registerWebviewViewProvider((0,I.$Jfc)(k),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Hfc)(k)}),new m.$QK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,p,b,r){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=o,a=this.d.createNewWebview(k,{},n),c=new g(k,this.a,l,p,a,!0);this.c.set(k,c),await t.resolveWebviewView(c,{state:b},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$dhc=w}),define(Ce[111],Re([1,0,5,3,2,13,12,4,17,23]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(p){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$mF)(p,"windowActivity"),b.active}}}constructor(p){this.c=new E.$Sd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=p.getProxy(N.$OK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:r})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus(p){this.onDidChangeWindowProperty("focused",p)}$onDidChangeWindowActive(p){this.onDidChangeWindowProperty("active",p)}onDidChangeWindowProperty(p,b){b!==this.d[p]&&(this.d={...this.d,[p]:b},this.c.fire(this.d))}openUri(p,b){let r;if(typeof p=="string"){r=p;try{p=I.URI.parse(p)}catch{return Promise.reject(`Invalid uri - '${p}'`)}}return(0,R.$Ge)(p.scheme)?Promise.reject("Invalid scheme - cannot be empty"):p.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${p.scheme}'`):this.b.$openUri(p,r,b)}async asExternalUri(p,b){if((0,R.$Ge)(p.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri(p,b);return I.URI.from(r)}};e.$ehc=k,e.$ehc=k=A=Ge([Ke(0,g.$SM)],k),e.$fhc=(0,m.$2h)("IExtHostWindow")}),define(Ce[275],Re([1,0,241,27,17]),function(ge,e,E,N,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qjc=void 0;let L=class extends E.$ihc{constructor(m,g){super(m,g)}f(m,g,w){g.apply(console,w)}};e.$qjc=L,e.$qjc=L=Ge([Ke(0,I.$SM),Ke(1,N.$9M)],L)}),define(Ce[276],Re([1,0,14,24,20,11,5,6,139,230,49]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=e.ResponsiveState=e.RequestInitiator=e.$s7b=e.$r7b=void 0;function l(D,M){try{return JSON.stringify(D,M)}catch{return"null"}}const p="$$ref$$",b={[p]:-1};class r{constructor(M,O){this.jsonString=M,this.referencedBuffers=O}}function o(D,M=null,O=!1){const W=[];return{jsonString:(O?l:JSON.stringify)(D,(q,C)=>{if(typeof C>"u")return b;if(typeof C=="object"){if(C instanceof N.$ge){const P=W.push(C)-1;return{[p]:P}}if(M)return M(q,C)}return C}),referencedBuffers:W}}e.$r7b=o;function t(D,M,O){return JSON.parse(D,(W,z)=>{if(z){const q=z[p];if(typeof q=="number")return M[q];if(O&&z.$mid===1)return O.transformIncoming(z)}return z})}e.$s7b=t;function n(D,M){return JSON.stringify(D,M)}function a(D){return D?(M,O)=>O&&O.$mid===1?D.transformOutgoing(O):O:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends m.$Sc{static{k=s}static{this.a=3*1e3}constructor(M,O=null,W=null){super(),this[k]=!0,this.b=this.B(new R.$Sd),this.onDidChangeResponsiveState=this.b.event,this.c=M,this.f=O,this.g=W,this.h=a(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,q=A.$Cv.count;z<q;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$bh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(M=>{const O=this.w[M];delete this.w[M],O.resolveErr(L.$6())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(M){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(M){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(M){this.y!==M&&(this.y=M,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(M){return this.g?(0,g.$3m)(M,this.g):M}getProxy(M){const{nid:O,sid:W}=M;return this.s[O]||(this.s[O]=this.J(O,W)),this.s[O]}J(M,O){const W={get:(z,q)=>(typeof q=="string"&&!z[q]&&q.charCodeAt(0)===36&&(z[q]=(...C)=>this.U(M,q,C)),q===u?O:z[q])};return new Proxy(Object.create(null),W)}set(M,O){return this.m[M.nid]=O,O}assertRegistered(M){for(let O=0,W=M.length;O<W;O++){const z=M[O];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(M){if(this.j)return;const O=M.byteLength,W=f.read(M,0),z=W.readUInt8(),q=W.readUInt32();switch(z){case 1:case 2:{let{rpcId:C,method:P,args:J}=F.deserializeRequestJSONArgs(W);this.g&&(J=(0,g.$3m)(J,this.g)),this.M(O,q,C,P,J,z===2);break}case 3:case 4:{let{rpcId:C,method:P,args:J}=F.deserializeRequestMixedArgs(W);this.g&&(J=(0,g.$3m)(J,this.g)),this.M(O,q,C,P,J,z===4);break}case 5:{this.f?.logIncoming(O,q,0,"ack"),this.G(q);break}case 6:{this.N(O,q);break}case 7:{this.O(O,q,void 0);break}case 9:{let C=F.deserializeReplyOKJSON(W);this.g&&(C=(0,g.$3m)(C,this.g)),this.O(O,q,C);break}case 10:{const C=F.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(O,q,C);break}case 8:{const C=F.deserializeReplyOKVSBuffer(W);this.O(O,q,C);break}case 11:{let C=F.deserializeReplyErrError(W);this.g&&(C=(0,g.$3m)(C,this.g)),this.P(O,q,C);break}case 12:{this.P(O,q,void 0);break}default:console.error("received unexpected message"),console.error(M)}}M(M,O,W,z,q,C){this.f?.logIncoming(M,O,1,`receiveRequest ${(0,A.$Ev)(W)}.${z}(`,q);const P=String(O);let J,ce;if(C){const be=new I.$3d;q.push(be.token),J=this.Q(W,z,q),ce=()=>be.cancel()}else J=this.Q(W,z,q),ce=i;this.u[P]=ce;const me=F.serializeAcknowledged(O);this.f?.logOutgoing(me.byteLength,O,1,"ack"),this.c.send(me),J.then(be=>{delete this.u[P];const Se=F.serializeReplyOK(O,be,this.h);this.f?.logOutgoing(Se.byteLength,O,1,"reply:",be),this.c.send(Se)},be=>{delete this.u[P];const Se=F.serializeReplyErr(O,be);this.f?.logOutgoing(Se.byteLength,O,1,"replyErr:",be),this.c.send(Se)})}N(M,O){this.f?.logIncoming(M,O,1,"receiveCancel");const W=String(O);this.u[W]?.()}O(M,O,W){this.f?.logIncoming(M,O,0,"receiveReply:",W);const z=String(O);if(!this.w.hasOwnProperty(z))return;const q=this.w[z];delete this.w[z],q.resolveOk(W)}P(M,O,W){this.f?.logIncoming(M,O,0,"receiveReplyErr:",W);const z=String(O);if(!this.w.hasOwnProperty(z))return;const q=this.w[z];delete this.w[z];let C;W&&(W.$isError?(C=new Error,C.name=W.name,C.message=W.message,C.stack=W.stack):C=W),q.resolveErr(C)}Q(M,O,W){try{return Promise.resolve(this.S(M,O,W))}catch(z){return Promise.reject(z)}}S(M,O,W){const z=this.m[M];if(!z)throw new Error("Unknown actor "+(0,A.$Ev)(M));const q=z[O];if(typeof q!="function")throw new Error("Unknown method "+O+" on actor "+(0,A.$Ev)(M));return q.apply(z,W)}U(M,O,W){if(this.j)return new w.$q7b;let z=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(z=W.pop()),z&&z.isCancellationRequested)return Promise.reject(L.$6());const q=F.serializeRequestArguments(W,this.h),C=++this.t,P=String(C),J=new w.$p7b,ce=new m.$Rc;z&&ce.add(z.onCancellationRequested(()=>{const be=F.serializeCancel(C);this.f?.logOutgoing(be.byteLength,C,0,"cancel"),this.c.send(F.serializeCancel(C))})),this.w[P]=new v(J,ce),this.F(C);const me=F.serializeRequest(C,M,O,q,!!z);return this.f?.logOutgoing(me.byteLength,C,0,`request: ${(0,A.$Ev)(M)}.${O}(`,W),this.c.send(me),J}}e.$t7b=d;class v{constructor(M,O){this.a=M,this.b=O}resolveOk(M){this.a.resolveOk(M),this.b.dispose()}resolveErr(M){this.a.resolveErr(M),this.b.dispose()}}class f{static alloc(M,O,W){const z=new f(N.$ge.alloc(W+1+4),0);return z.writeUInt8(M),z.writeUInt32(O),z}static read(M,O){return new f(M,O)}get buffer(){return this.a}constructor(M,O){this.a=M,this.b=O}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(M){this.a.writeUInt8(M,this.b),this.b+=1}readUInt8(){const M=this.a.readUInt8(this.b);return this.b+=1,M}writeUInt32(M){this.a.writeUInt32BE(M,this.b),this.b+=4}readUInt32(){const M=this.a.readUInt32BE(this.b);return this.b+=4,M}static sizeShortString(M){return 1+M.byteLength}writeShortString(M){this.a.writeUInt8(M.byteLength,this.b),this.b+=1,this.a.set(M,this.b),this.b+=M.byteLength}readShortString(){const M=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+M).toString();return this.b+=M,W}static sizeLongString(M){return 4+M.byteLength}writeLongString(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readLongString(){const M=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+M).toString();return this.b+=M,W}writeBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}static sizeVSBuffer(M){return 4+M.byteLength}writeVSBuffer(M){this.a.writeUInt32BE(M.byteLength,this.b),this.b+=4,this.a.set(M,this.b),this.b+=M.byteLength}readVSBuffer(){const M=this.a.readUInt32BE(this.b);this.b+=4;const O=this.a.slice(this.b,this.b+M);return this.b+=M,O}static sizeMixedArray(M){let O=0;O+=1;for(let W=0,z=M.length;W<z;W++){const q=M[W];switch(O+=1,q.type){case 1:O+=this.sizeLongString(q.value);break;case 2:O+=this.sizeVSBuffer(q.value);break;case 3:O+=this.sizeUInt32,O+=this.sizeLongString(q.value);for(let C=0;C<q.buffers.length;++C)O+=this.sizeVSBuffer(q.buffers[C]);break;case 4:break}}return O}writeMixedArray(M){this.a.writeUInt8(M.length,this.b),this.b+=1;for(let O=0,W=M.length;O<W;O++){const z=M[O];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let q=0;q<z.buffers.length;++q)this.writeBuffer(z.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const M=this.a.readUInt8(this.b);this.b+=1;const O=new Array(M);for(let W=0;W<M;W++)switch(this.readUInt8()){case 1:O[W]=this.readLongString();break;case 2:O[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),C=this.readLongString(),P=[];for(let J=0;J<q;++J)P.push(this.readVSBuffer());O[W]=new A.$Fv(t(C,P,null));break}case 4:O[W]=void 0;break}return O}}var S;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(S||(S={}));class F{static a(M){for(let O=0,W=M.length;O<W;O++)if(M[O]instanceof N.$ge||M[O]instanceof A.$Fv||typeof M[O]>"u")return!0;return!1}static serializeRequestArguments(M,O){if(this.a(M)){const W=[];for(let z=0,q=M.length;z<q;z++){const C=M[z];if(C instanceof N.$ge)W[z]={type:2,value:C};else if(typeof C>"u")W[z]={type:4};else if(C instanceof A.$Fv){const{jsonString:P,referencedBuffers:J}=o(C.value,O);W[z]={type:3,value:N.$ge.fromString(P),buffers:J}}else W[z]={type:1,value:N.$ge.fromString(n(C,O))}}return{type:1,args:W}}return{type:0,args:n(M,O)}}static serializeRequest(M,O,W,z,q){switch(z.type){case 0:return this.b(M,O,W,z.args,q);case 1:return this.c(M,O,W,z.args,q)}}static b(M,O,W,z,q){const C=N.$ge.fromString(W),P=N.$ge.fromString(z);let J=0;J+=f.sizeUInt8(),J+=f.sizeShortString(C),J+=f.sizeLongString(P);const ce=f.alloc(q?2:1,M,J);return ce.writeUInt8(O),ce.writeShortString(C),ce.writeLongString(P),ce.buffer}static deserializeRequestJSONArgs(M){const O=M.readUInt8(),W=M.readShortString(),z=M.readLongString();return{rpcId:O,method:W,args:JSON.parse(z)}}static c(M,O,W,z,q){const C=N.$ge.fromString(W);let P=0;P+=f.sizeUInt8(),P+=f.sizeShortString(C),P+=f.sizeMixedArray(z);const J=f.alloc(q?4:3,M,P);return J.writeUInt8(O),J.writeShortString(C),J.writeMixedArray(z),J.buffer}static deserializeRequestMixedArgs(M){const O=M.readUInt8(),W=M.readShortString(),z=M.readMixedArray(),q=new Array(z.length);for(let C=0,P=z.length;C<P;C++){const J=z[C];typeof J=="string"?q[C]=JSON.parse(J):q[C]=J}return{rpcId:O,method:W,args:q}}static serializeAcknowledged(M){return f.alloc(5,M,0).buffer}static serializeCancel(M){return f.alloc(6,M,0).buffer}static serializeReplyOK(M,O,W){if(typeof O>"u")return this.d(M);if(O instanceof N.$ge)return this.e(M,O);if(O instanceof A.$Fv){const{jsonString:z,referencedBuffers:q}=o(O.value,W,!0);return this.g(M,z,q)}else return this.f(M,l(O,W))}static d(M){return f.alloc(7,M,0).buffer}static e(M,O){let W=0;W+=f.sizeVSBuffer(O);const z=f.alloc(8,M,W);return z.writeVSBuffer(O),z.buffer}static deserializeReplyOKVSBuffer(M){return M.readVSBuffer()}static f(M,O){const W=N.$ge.fromString(O);let z=0;z+=f.sizeLongString(W);const q=f.alloc(9,M,z);return q.writeLongString(W),q.buffer}static g(M,O,W){const z=N.$ge.fromString(O);let q=0;q+=f.sizeUInt32,q+=f.sizeLongString(z);for(const P of W)q+=f.sizeVSBuffer(P);const C=f.alloc(10,M,q);C.writeUInt32(W.length),C.writeLongString(z);for(const P of W)C.writeBuffer(P);return C.buffer}static deserializeReplyOKJSON(M){const O=M.readLongString();return JSON.parse(O)}static deserializeReplyOKJSONWithBuffers(M,O){const W=M.readUInt32(),z=M.readLongString(),q=[];for(let C=0;C<W;++C)q.push(M.readVSBuffer());return new A.$Fv(t(z,q,O))}static serializeReplyErr(M,O){const W=O?l(L.$3(O),null):void 0;if(typeof W!="string")return this.h(M);const z=N.$ge.fromString(W);let q=0;q+=f.sizeLongString(z);const C=f.alloc(11,M,q);return C.writeLongString(z),C.buffer}static deserializeReplyErrError(M){const O=M.readLongString();return JSON.parse(O)}static h(M){return f.alloc(12,M,0).buffer}}var $;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})($||($={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Ce[277],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sjc=void 0;const E=function(L){const R=m=>{globalThis.removeEventListener("message",R);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,A){g.postMessage(w,A)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class N extends EventTarget{constructor(L,R,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${R}'))`,w=new Blob([g],{type:"application/javascript"}),A=URL.createObjectURL(w),k=new MessageChannel,l=A,p={type:"_newWorker",id:l,port:k.port2,url:A,options:m};L(p,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{L({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(b){k.port1.onmessage=b}},onmessageerror:{get(){return k.port1.onmessageerror},set(b){k.port1.onmessageerror=b}}}),k.port1.addEventListener("messageerror",b=>{const r=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",b=>{const r=new MessageEvent("message",{data:b.data});this.dispatchEvent(r)}),k.port1.start()}}e.$sjc=N}),define(Ce[278],Re([1,0,5,30,35,4]),function(ge,e,E,N,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.OutputChannelUpdateMode=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=void 0,e.$ZJ="text/x-code-output",e.$1J="output",e.$2J="Log",e.$3J="text/x-code-log-output",e.$4J="log",e.$5J="workbench.panel.output",e.$6J=new I.$gj("inOutput",!1),e.$7J=new I.$gj("activeLogOutput",!1),e.$8J=new I.$gj("outputView.scrollLock",!1),e.$9J=(0,L.$2h)("outputService");var R;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$0J={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new E.$Sd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Sd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(A=>w.push(A)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}N.$un.add(e.$0J.OutputChannels,new m),e.$$J=new I.$gj("activeOutputChannel","")}),define(Ce[112],Re([1,0,3,4,17,22,15,278,63,27,43,136,24,16,42,5,6]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=e.$Qgc=void 0;class t extends R.$pj{get disposed(){return this.n}constructor(h,i,s,u,d){super(),this.id=h,this.name=i,this.r=s,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$ge.fromString(i).byteLength,(0,R.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let a=class{constructor(h,i,s,u,d,v){this.i=i,this.j=s,this.k=u,this.l=d,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$OK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,k.$sm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(h,i,s){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,p.$Ef)(i)?i:void 0;if((0,p.$Ef)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const f=this.i.environment.extensionLogLevel?.find(([F])=>L.$hm.equals(s.identifier,F))?.[1];f&&(v=(0,R.$zj)(f));const S=u?this.o(h,v,s):this.n(h,d,s);return S.then(F=>{this.g.set(F.id,F),F.visible=F.id===this.h}),u?this.r(h,v??this.m.getLevel(),S):this.q(h,S)}async n(h,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,s.identifier.value);return new t(f,h,v,this.a,s)}async o(h,i,s){const u=await this.p(s),d=h.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${d}.log`),f=`${s.identifier.value}.${d}`,S=this.l.createLogger(v,{id:f,name:h,logLevel:i,extensionId:s.identifier.value});return new n(f,h,S,this.a,s)}p(h){let i=this.d.get(h.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(u){if((0,b.$Ck)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return s})())}return i}q(h,i){let s=!1;const u=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(v=>v.append(d))},appendLine(d){u(),i.then(v=>v.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(v=>v.replace(d))},show(d,v){u(),i.then(f=>f.show(d,v))},hide(){u(),i.then(d=>d.hide())},dispose(){s=!0,i.then(d=>d.dispose())}}}r(h,i,s){const u=new o.$Rc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new r.$Sd);function f(S){i=S,v.fire(S)}return s.then(S=>{u.add(S),S.logLevel!==i&&f(S.logLevel),u.add(S.onDidChangeLogLevel(F=>f(F)))}),{...this.q(h,s),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(S,...F){d(),s.then($=>$.trace(S,...F))},debug(S,...F){d(),s.then($=>$.debug(S,...F))},info(S,...F){d(),s.then($=>$.info(S,...F))},warn(S,...F){d(),s.then($=>$.warn(S,...F))},error(S,...F){d(),s.then($=>$.error(S,...F))},dispose(){u.dispose()}}}};e.$Qgc=a,e.$Qgc=a=Ge([Ke(0,I.$SM),Ke(1,w.$9M),Ke(2,g.$Dfc),Ke(3,A.$dfc),Ke(4,R.$kj),Ke(5,R.$jj)],a),e.$Rgc=(0,N.$2h)("IExtHostOutputService")}),define(Ce[113],Re([1,0,4,14]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=(0,E.$2h)("remoteAgentService"),e.$Im=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let L=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await I.getRoundTripTime();if(g===void 0)return;L=Math.min(L,g/2),await(0,N.$3g)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(L):R=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:R,current:L,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof R>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ce[279],Re([1,0,170,54,30,47,41,6,5,113,21,26]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=void 0,e.$BH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$CH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$DH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$EH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Sd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const p=new l;I.$un.add(e.$EH.ConfigurationMigration,p);let b=class extends m.$Sc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const c of a.added)await this.f(c,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(a=>this.g(a,t?.uri))])}async g(t,n){const a=this.a.inspect(t.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[h,i]of c){const s=[];for(const d of a.overrideIdentifiers??[]){const v=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of v??[]){let S=s.find(([[F,$]])=>F===f[0]&&(0,k.$mn)($.value,f[1].value));S||s.push(S=[f,[]]),S[1].push(d)}}const u=await this.h(t,{resource:n},h,a);for(const d of u??[])s.push([d,[]]);s.length&&await Promise.allSettled(s.map(async([[d,v],f])=>this.a.updateValue(d,v.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,a,c){const h=d=>i(this.a.inspect(d,n)),i=d=>{const v=d[a];return n.overrideIdentifier?v?.override:v?.value},s=c?i(c):h(t.key);if(s===void 0)return;const u=await t.migrateFn(s,h);return Array.isArray(u)?u:[[t.key,u]]}};e.$FH=b,e.$FH=b=Ge([Ke(0,R.$vi),Ke(1,L.$$h)],b);let r=class extends m.$Sc{constructor(t){super(),(async()=>{if(!A.$i&&(await t.getEnvironment())?.os!==1)return;I.$un.as(N.$zn.Configuration).registerConfiguration({...e.$DH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$GH=r,e.$GH=r=Ge([Ke(0,w.$Hm)],r)}),define(Ce[280],Re([1,0,34,13,19,25,178,279,54,4,30]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cb=e.$5cb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$4cb=e.$3cb=void 0,e.$3cb=(0,w.$2h)("editorResolverService"),e.$4cb="workbench.editorAssociations";const k=A.$un.as(g.$zn.Configuration),l={...m.$CH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var p;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})(p||(e.RegisteredEditorPriority=p={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function r(t){switch(t){case p.exclusive:return 5;case p.default:return 4;case p.builtin:return 3;case p.option:default:return 1}}e.$5cb=r;function o(t,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(I.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,L.$Ag)(n);return E.$Hj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$6cb=o}),define(Ce[281],Re([1,0,46,13,19,21,25,2,4,199,47,217,113]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$rK=e.$qK=void 0,e.$qK=(0,g.$2h)("pathService");let b=p=class{constructor(o,t,n,a){this.d=o,this.e=t,this.f=n,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,n)}h(o,t,n){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,E.$2f)(n??(0,R.$Ag)(o),t===1):!0}get defaultUriScheme(){return p.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,w.$nK)(t.getWorkspace());if(n)return n;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$fc:I.$gc)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return m.URI.from({scheme:N.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$rK=b,e.$rK=b=p=Ge([Ke(1,l.$Hm),Ke(2,k.$_J),Ke(3,A.$$h)],b)}),define(Ce[114],Re([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$6I=e.$5I=void 0;class E{constructor(R,m){this.line=R,this.character=m}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,m){return new E(0,0)}with(R){return new E(0,0)}}e.$5I=E;class N{constructor(R,m,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(R,m),this.end=new E(g,w)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$6I=N;var I;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ce[44],Re([1,0,18,34,26,46,12,4,19,11,114,14]),function(ge,e,E,N,I,L,R,m,g,w,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.SearchErrorCode=e.$iJ=e.$hJ=e.SearchSortOrder=e.ViewMode=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.SearchCompletionExitCode=e.$cJ=e.$bJ=e.$aJ=e.QueryType=e.SearchProviderType=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$7I="workbench.view.search",e.$8I="workbench.panel.search",e.$9I="workbench.view.search",e.$0I="search-result",e.$$I="search.exclude";const l="\u27EA ",p=" characters skipped \u27EB",b=(l.length+p.length+5)*2;e.$_I=(0,m.$2h)("searchService");var r;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(r||(e.SearchProviderType=r={}));var o;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(o||(e.QueryType=o={}));function t(he){return!!he.preview}e.$aJ=t;function n(he){return!!he.resource}e.$bJ=n;function a(he){return!!he.message}e.$cJ=a;var c;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(fe){this.resource=fe,this.results=[]}}e.$dJ=h;class i{constructor(fe,ie,ke,oe){this.ranges=ie,this.webviewIndex=oe;const Y=Array.isArray(ie)?ie:[ie];if(ke&&ke.matchLines===1&&s(Y)){fe=(0,R.$xf)(fe,ke.matchLines);let V="",ne=0,Ie=0;const Ae=Math.floor(ke.charsPerLine/5),Pe=[];for(const ae of Y){const te=Math.max(ae.startColumn-Ae,0),Q=ae.startColumn+ke.charsPerLine;if(te>Ie+Ae+b){const ee=l+(te-Ie)+p;V+=ee+fe.slice(te,Q),ne+=te-(Ie+ee.length)}else V+=fe.slice(Ie,Q);Pe.push(new d(0,ae.startColumn-ne,ae.endColumn-ne)),Ie=Q}this.preview={text:V,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const V=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:fe,matches:(0,E.$2b)(ie,ne=>new u(ne.startLineNumber-V,ne.startColumn,ne.endLineNumber-V,ne.endColumn))}}}}e.$eJ=i;function s(he){const fe=he[0].startLineNumber;for(const ie of he)if(ie.startLineNumber!==fe||ie.endLineNumber!==fe)return!1;return!0}class u{constructor(fe,ie,ke,oe){this.startLineNumber=fe,this.startColumn=ie,this.endLineNumber=ke,this.endColumn=oe}}e.$fJ=u;class d extends u{constructor(fe,ie,ke){super(fe,ie,fe,ke)}}e.$gJ=d;var v;(function(he){he.List="list",he.Tree="tree"})(v||(e.ViewMode=v={}));var f;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function S(he,fe=!0){const ie=he&&he.files&&he.files.exclude,ke=fe&&he&&he.search&&he.search.exclude;if(!ie&&!ke)return;if(!ie||!ke)return ie||ke;let oe=Object.create(null);return oe=I.$ln(oe,I.$in(ie)),oe=I.$ln(oe,I.$in(ke),!0),oe}e.$hJ=S;function F(he,fe){return he.excludePattern&&N.$Hj(he.excludePattern,fe)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&N.$Hj(he.includePattern,fe)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(ie=>{const ke=ie.folder.fsPath;if(L.$4f(fe,ke)){const oe=g.$lc(ke,fe);return!ie.includePattern||!!N.$Hj(ie.includePattern,oe)}else return!1}):!1:!0}e.$iJ=F;var $;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})($||(e.SearchErrorCode=$={}));class y extends Error{constructor(fe,ie){super(fe),this.code=ie}}e.$jJ=y;function D(he){const fe=he.message;if((0,w.$4)(he))return new y(fe,$.canceled);try{const ie=JSON.parse(fe);return new y(ie.message,ie.code)}catch{return new y(fe,$.other)}}e.$kJ=D;function M(he){const fe={message:he.message,code:he.code};return new Error(JSON.stringify(fe))}e.$lJ=M;function O(he){return he.type==="error"?!0:he.type==="success"}e.$mJ=O;function W(he){return he.type==="success"}e.$nJ=W;function z(he){return!!he.path}e.$oJ=z;function q(he,fe){const ie=he.searchPath?he.searchPath:he.relativePath;return(0,R.$uf)(ie,fe)}e.$pJ=q;class C{constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$qJ=C;function P(he,fe){const ie={...he||{},...fe||{}};return Object.keys(ie).filter(ke=>{const oe=ie[ke];return typeof oe=="boolean"&&oe})}e.$rJ=P;class J{constructor(fe,ie){this.c=null,this.a={...fe.excludePattern||{},...ie.excludePattern||{}},this.b=N.$Ij(this.a);let ke=fe.includePattern;ie.includePattern&&(ke?ke={...ke,...ie.includePattern}:ke=ie.includePattern),ke&&(this.c=N.$Ij(ke))}matchesExcludesSync(fe,ie,ke){return!!(this.b&&this.b(fe,ie,ke))}includedInQuerySync(fe,ie,ke){return!(this.b&&this.b(fe,ie,ke)||this.c&&!this.c(fe,ie,ke))}includedInQuery(fe,ie,ke){const oe=this.b(fe,ie,ke),Y=()=>this.c?!!this.c(fe,ie,ke):!0;return(0,k.$Og)(oe)?oe.then(V=>V?!1:Y()):Y()}hasSiblingExcludeClauses(){return ce(this.a)}}e.$sJ=J;function ce(he){for(const fe in he)if(typeof he[fe]!="boolean")return!0;return!1}function me(he){if(!he)return;let fe;return ie=>(fe||(fe=(he()||Promise.resolve([])).then(ke=>ke?Se(ke):{})),fe.then(ke=>!!ke[ie]))}e.$tJ=me;function be(he){if(!he)return;let fe;return ie=>{if(!fe){const ke=he();fe=ke?Se(ke):{}}return!!fe[ie]}}e.$uJ=be;function Se(he){const fe={};for(const ie of he)fe[ie]=!0;return fe}}),define(Ce[36],Re([1,0,18,14,20,5,6,50,13,122,25,12,2,169,4,15,188,47,43,27,17,8,7,57,44,3,51]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=void 0;function f(W,z,q){return new A.$sg(C=>y(C,q)).isEqual(W,z)}function S(W,z,q){return f(W.uri,z.uri,q)?0:(0,k.$1e)(W.uri.toString(),z.uri.toString())}function F(W,z,q){return W.index!==z.index?W.index<z.index?-1:1:f(W.uri,z.uri,q)?(0,k.$1e)(W.name,z.name):(0,k.$1e)(W.uri.toString(),z.uri.toString())}function $(W,z,q,C){const P=W.slice(0).sort((ce,me)=>q(ce,me,C)),J=z.slice(0).sort((ce,me)=>q(ce,me,C));return(0,E.$Eb)(P,J,(ce,me)=>q(ce,me,C))}function y(W,z){const q=z.getCapabilities(W.scheme);return!(q&&q&1024)}class D extends t.$ii{static toExtHostWorkspace(z,q,C,P){if(!z)return{workspace:null,added:[],removed:[]};const{id:J,name:ce,folders:me,configuration:be,transient:Se,isUntitled:he}=z,fe=[],ie=q;q?me.forEach((V,ne)=>{const Ie=l.URI.revive(V.uri),Ae=D.o(C||q,Ie,P);Ae?(Ae.name=V.name,Ae.index=V.index,fe.push(Ae)):fe.push({uri:Ie,name:V.name,index:ne})}):fe.push(...me.map(({uri:V,name:ne,index:Ie})=>({uri:l.URI.revive(V),name:ne,index:Ie}))),fe.sort((V,ne)=>V.index<ne.index?-1:1);const ke=new D(J,ce,fe,!!Se,be?l.URI.revive(be):null,!!he,V=>y(V,P)),{added:oe,removed:Y}=$(ie?ie.workspaceFolders:[],ke.workspaceFolders,S,P);return{workspace:ke,added:oe,removed:Y}}static o(z,q,C){for(let P=0;P<z.folders.length;P++){const J=z.workspaceFolders[P];if(f(J.uri,q,C))return J}}constructor(z,q,C,P,J,ce,me){super(z,C.map(be=>new t.$ji(be)),P,J,me),this.t=q,this.u=ce,this.q=[],this.s=m.$8h.forUris(me),C.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,q){return q&&this.s.get(z)&&(z=(0,A.$Cg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let M=class{constructor(z,q,C,P,J){this.c=new L.$Sd,this.onDidChangeWorkspace=this.c.event,this.g=new L.$Sd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$Ud,this.B=new Map,this.h=P,this.s=C,this.t=J,this.j=new w.$5l,this.k=new N.$1g,this.o=z.getProxy(d.$OK.MainThreadWorkspace),this.q=z.getProxy(d.$OK.MainThreadMessageService);const ce=q.workspace;this.l=ce?new D(ce.id,ce.name,[],!!ce.transient,ce.configuration?l.URI.revive(ce.configuration):null,!!ce.isUntitled,me=>y(me,C)):void 0}$initializeWorkspace(z,q){this.v=q,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,A.$Ag)((0,A.$Cg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,q,C,...P){const J=[];if(Array.isArray(P)&&P.forEach(he=>{l.URI.isUri(he.uri)&&!J.some(fe=>f(fe.uri,he.uri,this.s))&&J.push({uri:he.uri,name:he.name||(0,A.$zg)(he.uri)})}),this.n||[q,C].some(he=>typeof he!="number"||he<0)||C===0&&J.length===0)return!1;const ce=this.x?this.x.workspaceFolders:[];if(q+C>ce.length)return!1;const me=ce.slice(0);me.splice(q,C,...J.map(he=>({uri:he.uri,name:he.name||(0,A.$zg)(he.uri),index:void 0})));for(let he=0;he<me.length;he++){const fe=me[he];if(me.some((ie,ke)=>ke!==he&&f(fe.uri,ie.uri,this.s)))return!1}me.forEach((he,fe)=>he.index=fe);const{added:be,removed:Se}=$(ce,me,F,this.s);if(be.length===0&&Se.length===0)return!1;if(this.o){const he=z.displayName||z.name;this.o.$updateWorkspaceFolders(he,q,C,J).then(void 0,fe=>{this.n=void 0;const ie={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,fe.toString()),ie,[])})}return this.y(me),!0}getWorkspaceFolder(z,q){if(this.x)return this.x.getWorkspaceFolder(z,q)}async getWorkspaceFolder2(z,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,q)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,q){let C,P="";if(typeof z=="string"?(C=l.URI.file(z),P=z):typeof z<"u"&&(C=z,P=z.fsPath),!C)return P;const J=this.getWorkspaceFolder(C,!0);if(!J)return P;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ce=(0,A.$Fg)(J.uri,C);return q&&J.name&&(ce=`${J.name}/${ce}`),ce}y(z){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:q,added:C,removed:P}=D.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:P}))}findFiles(z,q,C,P,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${P.value}, entryPoint: findFiles`);let ce;if(q===null?ce=!1:q&&(typeof q=="string"?ce=q:ce=q.pattern),J&&J.isCancellationRequested)return Promise.resolve([]);const{includePattern:me,folder:be}=O(h.GlobPattern.from(z));return this.o.$startFileSearch(me??null,be??null,ce??null,C??null,J).then(Se=>Array.isArray(Se)?Se.map(he=>l.URI.revive(he)):[])}async findTextInFiles(z,q,C,P,J=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${P.value}, entryPoint: findTextInFiles`);const ce=this.j.getNext(),me=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:be,folder:Se}=O(h.GlobPattern.from(q.include)),he=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,fe={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:me,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:be,excludePattern:he},ie=!1;if(this.u[ce]=ke=>{if(ie)return;const oe=l.URI.revive(ke.resource);ke.results.forEach(Y=>{const V=(0,v.$yh)(Y);(0,u.$aJ)(V)?C({uri:oe,preview:{text:V.preview.text,matches:(0,E.$2b)(V.preview.matches,ne=>new i.$SK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,E.$2b)(V.ranges,ne=>new i.$SK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):C({uri:oe,text:V.text,lineNumber:V.lineNumber})})},J.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(z,Se??null,fe,ce,J);return delete this.u[ce],ke||{}}catch(ke){throw delete this.u[ce],ke}}$handleTextSearchResult(z,q){this.u[q]?.(z)}async save(z){const q=await this.o.$save(z,{saveAs:!1});return l.URI.revive(q)}async saveAs(z){const q=await this.o.$save(z,{saveAs:!0});return l.URI.revive(q)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,q){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,q);const C=this.t.transformOutgoingScheme(z),P=this.z++;return this.o.$registerEditSessionIdentityProvider(P,C),(0,R.$Qc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(P)})}async $getEditSessionIdentifier(z,q){this.h.info("Getting edit session identifier for workspaceFolder",z);const C=await this.resolveWorkspaceFolder(l.URI.revive(z));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const P=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!P),!P)return;const J=await P.provideEditSessionIdentity(C,q);if(this.h.info("Provider returned edit session identifier: ",J),!!J)return J}async $provideEditSessionIdentityMatch(z,q,C,P){this.h.info("Getting edit session identifier for workspaceFolder",z);const J=await this.resolveWorkspaceFolder(l.URI.revive(z));if(!J){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",J);const ce=this.w.get(J.uri.scheme);if(this.h.info(`Provider for scheme ${J.uri.scheme} is defined: `,!!ce),!ce)return;const me=await ce.provideEditSessionIdentityMatch?.(q,C,P);if(this.h.info("Provider returned edit session identifier match result: ",me),!!me)return me}getOnWillCreateEditSessionIdentityEvent(z){return(q,C,P)=>{const J=function(me){q.call(C,me)};return J.extension=z,this.A.event(J,void 0,P)}}async $onWillCreateEditSessionIdentity(z,q,C){const P=await this.resolveWorkspaceFolder(l.URI.revive(z));if(P===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:P},q,async(J,ce)=>{const me=Date.now();await Promise.resolve(J),Date.now()-me>C&&this.h.warn("SLOW edit session create-participant",ce.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(z,q){if(this.B.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.B.set(z,q);const C=this.t.transformOutgoingScheme(z),P=this.z++;return this.o.$registerCanonicalUriProvider(P,C),(0,R.$Qc)(()=>{this.B.delete(z),this.o.$unregisterCanonicalUriProvider(P)})}async provideCanonicalUri(z,q,C){const P=this.B.get(z.scheme);if(!P)return;const J=await P.provideCanonicalUri?.(l.URI.revive(z),q,C);if(J)return J}async $provideCanonicalUri(z,q,C){return this.provideCanonicalUri(l.URI.revive(z),{targetScheme:q},C)}};e.$xfc=M,e.$xfc=M=Ge([Ke(0,c.$SM),Ke(1,a.$9M),Ke(2,n.$dfc),Ke(3,r.$jj),Ke(4,s.$vfc)],M),e.$yfc=(0,b.$2h)("IExtHostWorkspace");function O(W){let z,q;return W&&(typeof W=="string"?z=W:(z=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:z,folder:q}}}),define(Ce[37],Re([1,0,26,5,36,3,7,190,54,16,14,4,17,15,2]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bfc=e.$Afc=e.$zfc=void 0;function r(s,u){if(u){const d=u.split(".");let v=s;for(let f=0;v&&f<d.length;f++)v=v[d[f]];return v}}function o(s){return s instanceof b.URI}function t(s){return s&&s.uri instanceof b.URI&&s.languageId&&typeof s.languageId=="string"}function n(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function a(s){return s&&s.uri instanceof b.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function c(s){if(o(s))return{resource:s};if(t(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(n(s))return{overrideIdentifier:s.languageId};if(a(s))return{resource:s.uri};if(s===null)return{resource:null}}let h=class{constructor(u,d,v){this.a=u.getProxy(L.$OK.MainThreadConfiguration),this.c=d,this.b=v,this.d=new A.$1g,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,d))}};e.$zfc=h,e.$zfc=h=Ge([Ke(0,l.$SM),Ke(1,I.$yfc),Ke(2,p.$jj)],h);class i{constructor(u,d,v,f){this.a=new N.$Sd,this.b=u,this.f=f,this.c=d,this.e=m.$Sn.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$Sn.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,v))}getConfiguration(u,d,v){const f=c(d)||{},S=this.g(u?r(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,v?.identifier);function F(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const $={has(y){return typeof r(S,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,v?.identifier);let M=r(S,y);if(typeof M>"u")M=D;else{let O;const W=(z,q)=>{if((0,w.$Gf)(z)){let C;const P=()=>{O=O||(0,E.$in)(S),C=C||r(O,q)};return new Proxy(z,{get:(J,ce)=>{if(typeof ce=="string"&&ce.toLowerCase()==="tojson")return P(),()=>C;if(O)return C=C||r(O,q),C[ce];const me=J[ce];return typeof ce=="string"?W(me,`${q}.${ce}`):me},set:(J,ce,me)=>(P(),C&&(C[ce]=me),!0),deleteProperty:(J,ce)=>(P(),C&&delete C[ce],!0),defineProperty:(J,ce,me)=>(P(),C&&Object.defineProperty(C,ce,me),!0)})}return Array.isArray(z)?(0,E.$in)(z):z};M=W(M,y)}return M},update:(y,D,M,O)=>{y=u?`${u}.${y}`:y;const W=F(M);return D!==void 0?this.b.$updateConfigurationOption(W,y,D,f,O):this.b.$removeConfigurationOption(W,y,f,O)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$in)(D.policy?.value??D.default?.value),globalValue:(0,E.$in)(D.user?.value??D.application?.value),workspaceValue:(0,E.$in)(D.workspace?.value),workspaceFolderValue:(0,E.$in)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$in)(D.default?.override),globalLanguageValue:(0,E.$in)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$in)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$in)(D.workspaceFolder?.override),languageIds:(0,E.$in)(D.overrideIdentifiers)}}};return typeof S=="object"&&(0,E.$ln)($,S,!1),Object.freeze($)}g(u){const d=v=>(0,w.$Gf)(v)?new Proxy(v,{get:(f,S)=>d(f[S]),set:(f,S,F)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(S)}' of object`)},deleteProperty:(f,S)=>{throw new Error(`TypeError: Cannot delete read only property '${String(S)}' of object`)},defineProperty:(f,S)=>{throw new Error(`TypeError: Cannot define property '${String(S)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return d(u)}h(u,d,v){const f=g.$Jn.test(u)?4:this.d.get(u),S=v?`[${v.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${S}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${S}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const v=new m.$Un(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,S)=>v.affectsConfiguration(f,c(S))})}k(u){return u.reduce((d,v)=>(d.set(v[0],v[1]),d),new Map)}}e.$Afc=i,e.$Bfc=(0,k.$2h)("IExtHostConfiguration")}),define(Ce[115],Re([1,0,2,14,5,3,7,36,61,37,20,64,17,27,4,13,21,15,81,229,11]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5gc=e.$4gc=e.$3gc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function z(C){if(C!=null)return C}W.from=z;function q(C){if(C!=null)return C}W.to=q})(h||(h={}));var i;(function(W){function z(C){if(C!=null)return C}W.from=z;function q(C){if(C!=null)return C}W.to=q})(i||(i={}));var s;(function(W){function z(C){if(C!=null)return C}W.from=z;function q(C){if(C!=null)return C}W.to=q})(s||(s={}));var u;(function(W){function z(P){if(P){const J=P;return J&&!!J.process}else return!1}W.is=z;function q(P){if(P==null)return;const J={process:P.process,args:P.args};return P.options&&(J.options=s.from(P.options)),J}W.from=q;function C(P){if(P!=null)return new R.$zL(P.process,P.args,P.options)}W.to=C})(u||(u={}));var d;(function(W){function z(C){if(C!=null)return C}W.from=z;function q(C){if(C!=null)return C}W.to=q})(d||(d={}));var v;(function(W){function z(P){if(P){const J=P;return J&&(!!J.commandLine||!!J.command)}else return!1}W.is=z;function q(P){if(P==null)return;const J={};return P.commandLine!==void 0?J.commandLine=P.commandLine:(J.command=P.command,J.args=P.args),P.options&&(J.options=d.from(P.options)),J}W.from=q;function C(P){if(!(P==null||P.command===void 0&&P.commandLine===void 0))return P.commandLine?new R.$AL(P.commandLine,P.options):new R.$AL(P.command,P.args?P.args:[],P.options)}W.to=C})(v||(v={}));var f;(function(W){function z(P){if(P){const J=P;return J&&J.customExecution==="customExecution"}else return!1}W.is=z;function q(P){return{customExecution:"customExecution"}}W.from=q;function C(P,J){return J.get(P)}W.to=C})(f||(e.CustomExecutionDTO=f={}));var S;(function(W){function z(q,C){let P;return q.scope!==void 0&&typeof q.scope!="number"?P=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===R.TaskScope.Workspace&&C&&C.workspaceFile?P=C.workspaceFile:P=a.$iG),{id:q._id,workspaceFolder:P}}W.from=z})(S||(e.TaskHandleDTO=S={}));var F;(function(W){function z(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=z})(F||(F={}));var $;(function(W){function z(P,J){if(P==null)return[];const ce=[];for(const me of P){const be=q(me,J);be&&ce.push(be)}return ce}W.fromMany=z;function q(P,J){if(P==null)return;let ce;P.execution instanceof R.$zL?ce=u.from(P.execution):P.execution instanceof R.$AL?ce=v.from(P.execution):P.execution&&P.execution instanceof R.$BL&&(ce=f.from(P.execution));const me=h.from(P.definition);let be;return P.scope?typeof P.scope=="number"?be=P.scope:be=P.scope.uri:be=R.TaskScope.Workspace,!me||!be?void 0:{_id:P._id,definition:me,name:P.name,source:{extensionId:J.identifier.value,label:P.source,scope:be},execution:ce,isBackground:P.isBackground,group:F.from(P.group),presentationOptions:i.from(P.presentationOptions),problemMatchers:P.problemMatchers,hasDefinedMatchers:P.hasDefinedMatchers,runOptions:P.runOptions?P.runOptions:{reevaluateOnRerun:!0},detail:P.detail}}W.from=q;async function C(P,J,ce){if(P==null)return;let me;u.is(P.execution)?me=u.to(P.execution):v.is(P.execution)?me=v.to(P.execution):f.is(P.execution)&&(me=f.to(P._id,ce));const be=h.to(P.definition);let Se;if(P.source&&(P.source.scope!==void 0?typeof P.source.scope=="number"?Se=P.source.scope:Se=await J.resolveWorkspaceFolder(E.URI.revive(P.source.scope)):Se=R.TaskScope.Workspace),!be||!Se)return;const he=new R.$CL(be,Se,P.name,P.source.label,me,P.problemMatchers);return P.isBackground!==void 0&&(he.isBackground=P.isBackground),P.group!==void 0&&(he.group=R.$yL.from(P.group._id),he.group&&P.group.isDefault&&(he.group=new R.$yL(he.group.id,he.group.label),P.group.isDefault===!0&&(he.group.isDefault=P.group.isDefault))),P.presentationOptions&&(he.presentationOptions=i.to(P.presentationOptions)),P._id&&(he._id=P._id),P.detail&&(he.detail=P.detail),he}W.to=C})($||(e.TaskDTO=$={}));var y;(function(W){function z(C){return C}W.from=z;function q(C){if(C)return Object.assign(Object.create(null),C)}W.to=q})(y||(y={}));class D{#e;constructor(z,q,C){this._id=q,this.a=C,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let M=class{constructor(z,q,C,P,J,ce,me,be){this.q=new I.$Sd,this.r=new I.$Sd,this.s=new I.$Sd,this.t=new I.$Sd,this.a=z.getProxy(L.$OK.MainThreadTask),this.b=C,this.c=P,this.d=J,this.e=ce,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=me,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,q,C){if(!C)return new R.$QK(()=>{});const P=this.w();return this.j.set(P,{type:q,provider:C,extension:z}),this.a.$registerTaskProvider(P,q),new R.$QK(()=>{this.j.delete(P),this.a.$unregisterTaskProvider(P)})}registerTaskSystem(z,q){this.a.$registerTaskSystem(z,q)}fetchTasks(z){return this.a.$fetchTasks(y.from(z)).then(async q=>{const C=[];for(const P of q){const J=await $.to(P,this.b,this.m);J&&C.push(J)}return C})}get taskExecutions(){const z=[];return this.k.forEach(q=>z.push(q)),z}terminateTask(z){if(!(z instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,q,C){const P=this.m.get(z.id);P&&(this.o.set(z.id,P),this.e.attachPtyToTerminal(q,await P.callback(C))),this.p=z.id,this.q.fire({execution:await this.y(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){const q=await this.y(z);this.l.delete(z.id),this.k.delete(z.id),this.A(z),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const q=await this.y(z.id);this.s.fire({execution:q,processId:z.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(z){const q=await this.y(z.id);this.t.fire({execution:q,exitCode:z.exitCode})}$provideTasks(z,q){const C=this.j.get(z);if(!C)return Promise.reject(new Error("no handler found"));const P=[],J=(0,N.$Ug)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(ce=>this.u(q,P,C,ce));return new Promise(ce=>{J.then(me=>{Promise.all(P).then(()=>{ce(me)})})})}async $resolveTask(z,q){const C=this.j.get(z);if(!C)return Promise.reject(new Error("no handler found"));if(q.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${C.type}].`);const P=await $.to(q,this.b,this.m);if(!P)throw new Error("Unexpected: Task cannot be resolved.");const J=await C.provider.resolveTask(P,A.CancellationToken.None);if(!J)return;this.z(J,C);const ce=$.from(J,C.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(J.definition!==P.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ce.execution)&&await this.x(ce,J,!0),await this.v(ce)}w(){return this.h++}async x(z,q,C){const P=await this.a.$createTaskId(z);!C&&!this.m.has(P)&&(this.n.add(P),this.o.set(P,q.execution)),this.m.set(P,q.execution)}async y(z,q){if(typeof z=="string"){const J=this.l.get(z);if(!J)throw new c.$bb("Unexpected: The specified task is missing an execution");return J}const C=this.l.get(z.id);if(C)return C;const P=new Promise((J,ce)=>{function me(be,Se,he){he?J(new D(be,Se.id,he)):ce("Unexpected: Task does not exist.")}q?me(this,z,q):$.to(z.task,this.b,this.m).then(be=>me(this,z,be))});return this.l.set(z.id,P),P.then(J=>(this.k.set(z.id,J),J),J=>Promise.reject(J))}z(z,q){z._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}A(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const C=this.n.values();let P=C.next();for(;!P.done;)!this.o.has(P.value)&&this.p!==P.value&&(this.m.delete(P.value),this.n.delete(P.value)),P=C.next()}};e.$3gc=M,e.$3gc=M=Ge([Ke(0,l.$SM),Ke(1,p.$9M),Ke(2,m.$yfc),Ke(3,g.$4M),Ke(4,w.$Bfc),Ke(5,k.$Zfc),Ke(6,t.$jj),Ke(7,n.$gfc)],M);let O=class extends M{constructor(z,q,C,P,J,ce,me,be){super(z,q,C,P,J,ce,me,be),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(z,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const C=$.from(q,z);if(C===void 0)throw new Error("Task is not valid");if(f.is(C.execution))await this.x(C,q,!1);else throw new c.$_;const P=await this.y(await this.a.$getTaskExecution(C),q);return this.a.$executeTask(C).catch(J=>{throw new Error(J)}),P}u(z,q,C,P){const J=[];if(P)for(const ce of P){if(this.z(ce,C),!ce.definition||!z[ce.definition.type]){const be=ce.source?ce.source:"No task source";this.f.warn(`The task [${be}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`)}const me=$.from(ce,C.extension);me&&f.is(me.execution)?(J.push(me),q.push(this.x(me,ce,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:J,extension:C.extension}}async v(z){if(f.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,q,C){}};e.$4gc=O,e.$4gc=O=Ge([Ke(0,l.$SM),Ke(1,p.$9M),Ke(2,m.$yfc),Ke(3,g.$4M),Ke(4,w.$Bfc),Ke(5,k.$Zfc),Ke(6,t.$jj),Ke(7,n.$gfc)],O),e.$5gc=(0,b.$2h)("IExtHostTask")}),define(Ce[282],Re([1,0,44,29]),function(ge,e,E,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CJ=e.$BJ=e.$AJ=void 0;function I(R){return"cellResults"in R}e.$AJ=I,e.$BJ="rawCell#";function L(R,m){let g=-1;const w=[];let A=[];return R.forEach(l=>{l.range.startLineNumber!==g&&A.length>0&&(w.push([...A]),A=[]),A.push(l),g=l.range.endLineNumber}),A.length>0&&w.push([...A]),w.map(l=>{const p=[],b=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let o=b;o<=r;o++)p.push(m.getLineContent(o));return new E.$eJ(p.join(`
`)+`
`,l.map(o=>new N.$Hs(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}e.$CJ=L}),define(Ce[283],Re([1,0,162,24,5,6,28,12,16,2,42,75,3,32,8,7,49,221,107,11,26,13,212,282,280]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,S,F,$,y,D){this.q=F,this.r=$,this.s=y,this.t=D,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new I.$Sd({onListenerError:a.$2}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Sd({onListenerError:a.$2}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Sd({onListenerError:a.$2}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Sd({onListenerError:a.$2}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$_ec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(l.$OK.MainThreadNotebook),this.c=f.getProxy(l.$OK.MainThreadNotebookDocuments),this.d=f.getProxy(l.$OK.MainThreadNotebookEditors),this.i=S.converter,S.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===13){const O=M.notebookEditor?.notebookUri,W=M.cell.handle,q=this.g.get(O)?.getCell(W);if(q)return q.apiCell}if(M&&M.$mid===14){const O=M.uri,W=this.g.get(O);if(W)return W.apiNotebook}return M}}),d.B(S)}getEditorById(f){const S=this.h.get(f);if(!S)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return S}getIdByEditor(f){for(const[S,F]of this.h)if(F.apiEditor===f)return S}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,S){const F=this.g.get(f);if(!F&&!S)throw new Error(`NO notebook document for '${f}'`);return F}static u(f,S){if(!S)return;const F=S.filenamePattern.map($=>b.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(S.filenamePattern&&!F){console.warn(`Notebook content provider view options file name pattern is invalid ${S.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:S.displayName,filenamePattern:F,exclusive:S.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,S,F){const $=d.a++,y=typeof F.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set($,F),this.b.$registerNotebookCellStatusBarItemProvider($,y,S);let D;return y!==void 0&&(D=F.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(y))),new r.$QK(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,y),D?.dispose()})}async createNotebookDocument(f){const S=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&b.NotebookData.from(f.content)});return w.URI.revive(S)}async openNotebookDocument(f){const S=this.g.get(f);if(S)return S.apiNotebook;const F=await this.c.$tryOpenNotebook(f),$=this.g.get(w.URI.revive(F));return(0,g.$Pf)($?.apiNotebook)}async showNotebookDocument(f,S){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let F;typeof S=="object"?F={position:b.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selections:S.selections&&S.selections.map(b.NotebookRange.from),pinned:typeof S.preview=="boolean"?!S.preview:void 0}:F={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,F),y=$&&this.h.get($)?.apiEditor;if(y)return y;throw $?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,S,F,$){const y=this.f.get(f),D=w.URI.revive(S),M=this.g.get(D);if(!M||!y)return;const O=M.getCellFromIndex(F);if(!O)return;const W=await y.provideCellStatusBarItems(O.apiCell,$);if(!W)return;const z=new L.$Rc,q=this.p.add([z]),P=(Array.isArray(W)?W:[W]).map(J=>b.NotebookStatusBarItem.from(J,this.i,z));return{cacheId:q,items:P}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,S,F,$,y){if((0,m.$Ge)(S))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:S,serializer:F,options:$}),this.b.$registerNotebookSerializer(D,{id:f.identifier,location:f.extensionLocation},S,b.NotebookDocumentContentOptions.from($),d.u(f,y)),(0,L.$Qc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(f,S,F){const $=this.x.get(f);if(!$)throw new Error("NO serializer found");const y=await $.serializer.deserializeNotebook(S.buffer,F);return new o.$Fv(b.NotebookData.from(y))}async $notebookToData(f,S,F){const $=this.x.get(f);if(!$)throw new Error("NO serializer found");const y=await $.serializer.serializeNotebook(b.NotebookData.to(S.value),F);return N.$ge.wrap(y)}async $saveNotebook(f,S,F,$,y){const D=w.URI.revive(S),M=this.x.get(f);if(!M)throw new Error("NO serializer found");const O=this.g.get(D);if(!O)throw new Error("Document NOT found");if(O.versionId!==F)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new A.$Hk((0,E.localize)(0,null,this.z(D)),6);await this.y(D,$);const W={metadata:(0,c.$qn)(O.apiNotebook.metadata,J=>!(M.options?.transientDocumentMetadata??{})[J]),cells:[]};for(const J of O.apiNotebook.getCells()){const ce=new r.$dM(J.kind,J.document.getText(),J.document.languageId,J.mime,M.options?.transientOutputs?[]:[...J.outputs],J.metadata,J.executionSummary);ce.metadata=(0,c.$qn)(J.metadata,me=>!(M.options?.transientCellMetadata??{})[me]),W.cells.push(ce)}const z=await M.serializer.serializeNotebook(W,y);await this.s.value.writeFile(D,z);const q=this.s.getFileSystemProviderExtUri(D.scheme),C=await this.s.value.stat(D);return{name:q.basename(D),isFile:(C.type&A.FileType.File)!==0,isDirectory:(C.type&A.FileType.Directory)!==0,isSymbolicLink:(C.type&A.FileType.SymbolicLink)!==0,mtime:C.mtime,ctime:C.ctime,size:C.size,readonly:!!((C.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((C.permissions??0)&A.FilePermission.Locked),etag:A.$Sk({mtime:C.mtime,size:C.size}),children:void 0}}async $searchInNotebooks(f,S,F,$,y){const D=this.x.get(f)?.serializer;if(!D)return{limitHit:!1,results:[]};const M=new R.$Bc;await(async(C,P,J)=>{await Promise.all(C.map(async ce=>await Promise.all(ce.filenamePatterns.map(me=>{const be={...J,type:1,filePattern:me};return this.t.doInternalFileSearchWithCustomCallback(be,P,Se=>{Se.forEach(he=>{M.has(he)||$.some(ie=>ce.isFromSettings&&!ie.isFromSettings?!1:ie.filenamePatterns.some(ke=>(0,u.$6cb)(ke,he)))||M.add(he)})})}))))})(F,y,S);const W=new R.$Ac;let z=!1;const q=Array.from(M).map(async C=>{const P=[];try{if(y.isCancellationRequested)return;if(S.maxResults&&[...W.values()].reduce((be,Se)=>be+Se.cellResults.length,0)>S.maxResults){z=!0;return}const J=[],ce=this.g.get(C);if(ce)ce.apiNotebook.getCells().forEach(Se=>J.push({input:Se.document.getText(),outputs:Se.outputs.flatMap(he=>he.items.map(fe=>fe.data.toString()))}));else{const be=await this.s.value.readFile(C),Se=N.$ge.fromString(be.toString()),he=await D.deserializeNotebook(Se.buffer,y);if(y.isCancellationRequested)return;b.NotebookData.from(he).cells.forEach(ie=>J.push({input:ie.source,outputs:ie.outputs.flatMap(ke=>ke.items.map(oe=>oe.valueBytes.toString()))}))}if(y.isCancellationRequested)return;J.forEach((be,Se)=>{const he=S.contentPattern.pattern,fe=new i.$0Pb(be.input,void 0,be.outputs),ie=fe.findInInputs(he),ke=fe.findInOutputs(he),oe=ke.flatMap(Y=>(0,s.$CJ)(Y.matches,Y.textBuffer)).map((Y,V)=>(Y.webviewIndex=V,Y));if(ie.length>0||ke.length>0){const Y={index:Se,contentResults:(0,s.$CJ)(ie,fe.inputTextBuffer),webviewResults:oe};P.push(Y)}});const me={resource:C,cellResults:P};W.set(C,me);return}catch{return}});return await Promise.all(q),{limitHit:z,results:[...W.values()]}}async y(f,S){const F=await this.s.value.stat(f);if(typeof S?.mtime=="number"&&typeof S.etag=="string"&&S.etag!==A.$Rk&&typeof F.mtime=="number"&&typeof F.size=="number"&&S.mtime<F.mtime&&S.etag!==A.$Sk({mtime:S.mtime,size:F.size}))throw new A.$Hk((0,E.localize)(1,null),3,S)}z(f){return f.scheme===h.Schemas.file?f.fsPath:f.toString()}A(f,S,F){if(this.h.has(S))throw new Error(`editor with id ALREADY EXSIST: ${S}`);const $=new n.$vgc(S,this.d,f,F.visibleRanges.map(b.NotebookRange.to),F.selections.map(b.NotebookRange.to),typeof F.viewColumn=="number"?b.ViewColumn.to(F.viewColumn):void 0);this.h.set(S,$)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const F of f.value.removedDocuments){const $=w.URI.revive(F),y=this.g.get($);y&&(y.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(y.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===$.toString()&&this.h.delete(D.id)}if(f.value.addedDocuments){const F=[];for(const $ of f.value.addedDocuments){const y=w.URI.revive($.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const D=new t.$ugc(this.c,this.q,this.r,y,$);F.push(...$.cells.map(M=>t.$tgc.asModelAddData(D.apiNotebook,M))),this.g.get(y)?.dispose(),this.g.set(y,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:F}),this.m.fire(D.apiNotebook)}}if(f.value.addedEditors)for(const F of f.value.addedEditors){if(this.h.has(F.id))return;const $=w.URI.revive(F.documentUri),y=this.g.get($);y&&this.A(y,F.id,F)}const S=[];if(f.value.removedEditors)for(const F of f.value.removedEditors){const $=this.h.get(F);$&&(this.h.delete(F),this.k?.id===$.id&&(this.k=void 0),S.push($))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const F=new Set;this.l.forEach($=>F.add($.id));for(const $ of this.h.values()){const y=F.has($.id);$._acceptVisibility(y)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const S=p.$eN.String.with("notebookType","A notebook type"),F=new p.$gN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[S,new p.$eN("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>N.$ge.wrap(y))],new p.$fN("Notebook Data",y=>b.NotebookData.to(y.value))),$=new p.$gN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[S,new p.$eN("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new o.$Fv(b.NotebookData.from(y)))],new p.$fN("Bytes",y=>y.buffer));f.registerApiCommand(F),f.registerApiCommand($)}}e.$Egc=d}),define(Ce[284],Re([1,0,19,20,40,34,25,60,44]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class w{constructor(l,p,b){this.k=l,this.l=p,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&L.$Ij(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&L.$Ij(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const p=this.k.folderQueries||[];return new Promise((b,r)=>{const o=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),a=E.$nc(n);this.j&&this.j(n,a)||this.v(o,{base:t,basename:a})}),Promise.all(p.map(t=>this.p(t,o))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{r(new Error((0,I.$Mi)(t)))})})}async p(l,p){const b=new N.$3d,r=this.q(l),o=this.r(),t=new g.$sJ(this.k,l),n=!t.hasSiblingExcludeClauses();let a;try{this.h.add(b),a=m.$Od.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,b.token),h=a.elapsed(),i=m.$Od.create();return this.g&&!this.e||(c&&c.forEach(s=>{const u=E.$gc.relative(l.folder.path,s.path);if(n){const d=E.$nc(s.path);this.v(p,{base:l.folder,relativePath:u,basename:d});return}this.s(o,l.folder,u,p)}),this.g&&!this.e)?null:(this.u(o,t,p),{providerTime:h,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const p=(0,g.$rJ)(this.k.includePattern,l.includePattern),b=(0,g.$rJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:p,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},p,b,r){if(b===this.a){const t=E.$nc(this.a);this.v(r,{base:p,relativePath:this.a,basename:t})}function o(t){const n=E.$nc(t),a=E.$mc(t);let c=l[a];c||(c=l[a]=[],o(a)),c.push({base:p,relativePath:t,basename:n})}o(b)}u({rootEntries:l,pathToEntries:p},b,r){const o=this,t=this.a;function n(a){const c=(0,g.$uJ)(()=>a.map(h=>h.basename));for(let h=0,i=a.length;h<i;h++){const s=a[h],{relativePath:u,basename:d}=s;if(b.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const v=p[u];if(v)n(v);else{if(u===t)continue;o.v(r,s)}if(o.e)break}}n(l)}v(l,p){(!this.b||p.relativePath&&this.b(p.relativePath,p.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(p))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,p,b,r){const o=this.c(l.cacheKey),t=new w(l,p,o&&o.token);let n=0;const a=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(t,A.a,a,r).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new N.$3d),this.b.get(l)}d(l){return l.relativePath?{resource:R.$Dg(l.base,l.relativePath)}:{resource:l.base}}e(l,p,b,r){const o=r.onCancellationRequested(()=>{l.cancel()}),t=a=>{a&&(n.push(a),p>0&&n.length>=p&&(b(n),n=[]))};let n=[];return l.search(t).then(a=>(n.length&&b(n),o.dispose(),a),a=>(n.length&&b(n),o.dispose(),Promise.reject(a)))}}e.$wgc=A}),define(Ce[285],Re([1,0,18,246,34,95,28,13,19,25,12,16,2,94,180,41,15,47,105,281,44]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$sK=void 0;let h=class{constructor(y,D,M,O,W){this.a=y,this.b=D,this.c=M,this.d=O,this.e=W}text(y,D,M={}){y=this.f(y,M);const O=this.a.getValue(),W=D&&D.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(D?.map(t.$ki),M),type:2,contentPattern:y,previewOptions:M.previewOptions,maxFileSize:M.maxFileSize,usePCRE2:O.search.usePCRE2||W||!1,beforeContext:M.beforeContext,afterContext:M.afterContext,userDisabledExcludesAndIgnoreFiles:M.disregardExcludeSettings&&M.disregardIgnoreFiles}}f(y,D){const M=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const O={...y,wordSeparators:M.editor.wordSeparators};return this.j(y,D)&&(O.isCaseSensitive=!0),this.k(y)&&(O.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),O}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(v):v(y),D?this.parseSearchPaths(y):{pattern:s(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const M=this.g(D.includePattern,D.expandPatterns),O=this.g(D.excludePattern,D.expandPatterns),W=y.length>1,z=(M.searchPaths&&M.searchPaths.length?M.searchPaths.map(P=>this.q(P,D,O)):y.map(P=>this.r(P,D,O,W))).filter(P=>!!P),q={_reason:D._reason,folderQueries:z,usingSearchPaths:!!(M.searchPaths&&M.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:O.pattern,includePattern:M.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const P=E.$Hb(E.$Rb(this.c.groups.map(me=>me.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(P));const J=P.filter(me=>(0,c.$iJ)(q,me.fsPath)),ce=this.i(J);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ce)),{...q,...ce}}const C=D.extraFileResources&&D.extraFileResources.filter(P=>(0,c.$iJ)(q,P.fsPath));return q.extraFileResources=C&&C.length?C:void 0,q}i(y){const D=[],M=new R.$Ac,O={};let W=!1;return y.forEach(z=>{if(z.scheme===m.Schemas.walkThrough)return;if((0,w.$Hg)(z)){const C=this.b.getWorkspaceFolder(z)?.uri??z.with({path:g.$mc(z.fsPath)});let P=M.get(C);P||(W=!0,P={folder:C,includePattern:{}},D.push(P),M.set(C,P));const J=g.$lc(C.fsPath,z.fsPath);(0,k.$Pf)(P.includePattern)[J.replace(/\\/g,"/")]=!0}else z.fsPath&&(W=!0,O[z.fsPath]=!0)}),{folderQueries:D,includePattern:O,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(A.$vf(y.pattern,!0))return!0}else if(A.$vf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,p.$MB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ce=>g.$ic(ce)||/^\.\.?([\/\\]|$)/.test(ce),O=(Array.isArray(y)?y:u(y)).map(ce=>{const me=this.e.resolvedUserHome;return me?(0,L.$Kv)(ce,me.scheme===m.Schemas.file?me.fsPath:me.path):ce}),W=N.$K(O,ce=>D(ce)?"searchPaths":"exprSegments"),z=(W.exprSegments||[]).map(ce=>A.$Qe(ce,"/")).map(ce=>A.$Qe(ce,"\\")).map(ce=>(ce[0]==="."&&(ce="*"+ce),d(ce))),q={},C=this.m(W.searchPaths||[]);C&&C.length&&(q.searchPaths=C);const P=E.$Rb(z),J=s(...P);return J&&(q.pattern=J),q}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$hJ)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(O=>{let{pathPortion:W,globPortion:z}=i(O);return z&&(z=f(z)),this.n(W).flatMap(C=>this.o(C,z))}),M=new Map;return D.forEach(O=>{const W=O.searchPath.toString(),z=M.get(W);z?O.pattern&&(z.pattern=z.pattern||{},z.pattern[O.pattern]=!0):M.set(W,{searchPath:O.searchPath,pattern:O.pattern?s(O.pattern):void 0})}),Array.from(M.values())}n(y){if(g.$ic(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==m.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$hc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=v(y),y.startsWith("../")||y===".."){const O=g.$gc.resolve(D.path,y);return[{searchPath:D.with({path:O})}]}const M=f(y);return[{searchPath:D,pattern:M}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(W=>{const z=D.match(new RegExp(`^${A.$Ke(W.name)}(?:/(.*)|$)`));return z?{match:z,folder:W}:null}).filter(k.$Mf);if(O.length)return O.map(W=>{const z=W.match[1];return{searchPath:W.folder.uri,pattern:z&&f(z)}});{const W=y.match(/\.[\/\\](.+)[\/\\]?/),z=W?W[1]:y,q=b.localize(0,null,z);throw new Error(q)}}}}o(y,D){const M=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,O=[{searchPath:y.searchPath,pattern:M}];return M&&!M.endsWith("**")&&O.push({searchPath:y.searchPath,pattern:M+"/**"}),O}q(y,D,M){const O=this.r((0,t.$ki)(y.searchPath),D,M,!1);return O?{...O,includePattern:y.pattern}:null}r(y,D,M,O){let W;const z=l.URI.isUri(y)?y:y.uri;if(M.searchPaths){const ce=M.searchPaths.filter(me=>(0,w.$wg)(me.searchPath,z))[0];if(ce&&!ce.pattern)return null;ce&&(W=ce.pattern)}const q=this.a.getValue({resource:z}),P={...this.l(q,D)||{},...W||{}},J=l.URI.isUri(y)?(0,w.$Ag)(y):y.name;return{folder:z,folderName:O?J:void 0,excludePattern:Object.keys(P).length>0?P:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!q.search.followSymlinks}}};e.$sK=h,e.$sK=h=Ge([Ke(0,r.$vi),Ke(1,t.$$h),Ke(2,n.$RC),Ke(3,o.$jj),Ke(4,a.$qK)],h);function i($){const y=$.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,M=$.substr(0,D).match(/[/|\\][^/\\]*$/);if(M){let O=$.substr(0,M.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:$.substr((M.index||0)+1)}}}return{pathPortion:$}}function s(...$){return $.length?$.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u($){return I.$Gj($,",").map(y=>y.trim()).filter(y=>!!y.length)}function d($){return[`**/${$}/**`,`**/${$}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function v($){return $.replace(/\\/g,"/")}function f($){return v($).replace(/^\.\//,"").replace(/\/+$/g,"")}function S($){return $.replace(/([?*[\]])/g,"[$1]")}function F($,y){$=E.$Mb($,O=>O.toString());const D=[],M=y.getWorkspace();return $&&$.forEach(O=>{let W;if(y.getWorkbenchState()===2)W=(0,w.$Fg)(M.folders[0].uri,O),W&&W!=="."&&(W="./"+W);else{const z=y.getWorkspaceFolder(O);if(z){const q=z.name;if(M.folders.filter(P=>P.name===q).length===1){const P=(0,w.$Fg)(z.uri,O);P===""?W=`./${z.name}`:W=`./${z.name}/${P}`}else W=O.fsPath}}W&&D.push(S(W))}),D}e.$tK=F}),define(Ce[286],Re([1,0,25,2,20,11,4,285,44,47]),function(ge,e,E,N,I,L,R,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gsb=e.$fsb=void 0;const A=7e3;function k(r,o){const t=o.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],a=[];for(const d of t)if(/^workspaceContains:/.test(d)){const v=d.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||r.forceUsingSearch?a.push(v):n.push(v)}if(n.length===0&&a.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,v)=>{c=d}),i=d=>c({activationEvent:d}),s=Promise.all(n.map(d=>l(r,d,i))).then(()=>{}),u=p(r,o.identifier,a,i);return Promise.all([s,u]).then(()=>{c(void 0)}),h}e.$fsb=k;async function l(r,o,t){for(const n of r.folders)if(await r.exists(E.$Dg(N.URI.revive(n),o))){t(`workspaceContains:${o}`);return}}async function p(r,o,t,n){if(t.length===0)return Promise.resolve(void 0);const a=new I.$3d,c=r.checkExists(r.folders,t,a.token),h=setTimeout(async()=>{a.cancel(),r.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},A);let i=!1;try{i=await c}catch(s){L.$4(s)||L.$1(s)}a.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function b(r,o,t,n){const a=r.get(R.$1h),c=r.get(g.$_I),i=a.createInstance(m.$sK).file(o.map(s=>(0,w.$ki)(N.URI.revive(s))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(s=>!!s.limitHit,s=>L.$4(s)?!1:Promise.reject(s))}e.$gsb=b}),define(Ce[38],Re([1,0,159,19,88,25,14,6,50,2,15,3,37,218,85,36,23,106,11,22,24,201,7,100,4,27,86,17,71,87,64,5,286,84,203,13,82,60,21,83]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,v,f,S,F,$,y,D,M,O,W,z,q,C,P){"use strict";var J;Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=e.$bgc=e.$agc=e.$_fc=e.$$fc=void 0,e.$$fc=(0,u.$2h)("IHostUtils");let ce=J=class extends m.$Sc{constructor(Y,V,ne,Ie,Ae,Pe,ae,te,Q,ee,$e,ve){super(),this.X=ve,this.a=this.B(new y.$Sd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ne,this.f=ae,this.j=Ie,this.m=Ae,this.s=Pe,this.t=Q,this.u=ee,this.w=$e,this.y=this.g.getProxy(k.$OK.MainThreadWorkspace),this.z=this.g.getProxy(k.$OK.MainThreadTelemetry),this.C=this.g.getProxy(k.$OK.MainThreadExtensionService),this.D=new R.$1g,this.F=new R.$1g,this.G=new R.$1g,this.H=new R.$1g,this.I=new ke(this.f.extensions.activationEvents),this.L=new t.$l7b(this.I,this.f.extensions.allExtensions);const Fe=new a.$im(this.f.extensions.myExtensions);this.J=new t.$l7b(this.I,fe(this.L,Fe)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Se(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Se(this.J)}`)),this.M=new b.$Vfc(this.g,this.s),this.N=new M.$4fc(this.g),this.O=te,this.h=Y.createChild(new S.$Zh([b.$Wfc,this.M],[M.$5fc,this.N])),this.P=this.B(new p.$Ufc(this.J,this.L,{onExtensionActivationError:(le,we,T)=>{this.C.$onExtensionActivationError(le,n.$3(we),T)},actualActivateExtension:async(le,we)=>{if(t.$l7b.isHostExtension(le,this.J,this.L))return await this.C.$activateExtension(le,we),new p.$Tfc;const T=this.J.getExtensionDescription(le);return this.db(T,we)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$1(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(Y)}terminate(Y,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const ne=this.Y();Promise.race([(0,R.$3g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const V=await this.C.$getExtension(Y);return V&&{...V,identifier:new a.$hm(V.identifier.value),extensionLocation:w.URI.revive(V.extensionLocation)}}Z(Y,V){return this.P.activateByEvent(Y,V)}$(Y,V){return this.P.activateById(Y,V)}activateByIdWithErrors(Y,V){return this.$(Y,V).then(()=>{const ne=this.P.getActivatedExtension(Y);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===W.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(Y.fsPath);return w.URI.file(V)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new ie(Y))),this.Q}async bb(Y){const V=g.$8h.forUris(ne=>L.$ug.ignorePathCasing(ne));return await Promise.all(Y.map(async ne=>{if(this.ub(ne)){const Ie=await this.ab(ne.extensionLocation);V.set(Ie,ne)}})),V}cb(Y){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return V;const ne=this.P.getActivatedExtension(Y);if(!ne)return V;try{typeof ne.module.deactivate=="function"&&(V=Promise.resolve(ne.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ie)}try{(0,m.$Nc)(ne.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Ie)}return V}async db(Y,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,V).then(ne=>{const Ie=ne.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,V),this.eb(Y,V,"success",Ie),ne},ne=>{throw this.eb(Y,V,"failure"),ne})}eb(Y,V,ne,Ie){const Ae=be(Y,V);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Ie||{},outcome:ne})}fb(Y,V){const ne=be(Y,V);this.z.$publicLog2("activatePlugin",ne);const Ie=this.ub(Y);if(!Ie)return Promise.resolve(new p.$Sfc(p.$Pfc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${Y.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Ae=new p.$Qfc(V.startup);return Promise.all([this.vb(Y,(0,L.$Dg)(Y.extensionLocation,Ie),Ae),this.gb(Y)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),J.hb(this.s,Y.identifier,Pe[0],Pe[1],Ae))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Pe))}gb(Y){const V=new h.$Yfc(Y,this.M),ne=new h.$Xfc(Y.identifier.value,!1,this.M),Ie=new O.$6fc(Y,this.N),Ae=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Pe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([V.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ae=this;let te,Q;const ee=(0,o.$lF)(Y,"ipc")?this.f.messagePorts?.get(a.$hm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ne,secrets:Ie,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath($e){return N.$jc(Y.extensionLocation.fsPath,$e)},get storagePath(){return ae.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ae.O.globalValue(Y).fsPath},get logPath(){return N.$jc(ae.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return w.URI.joinPath(ae.f.logsLocation,Y.identifier.value)},get storageUri(){return ae.O.workspaceValue(Y)},get globalStorageUri(){return ae.O.globalValue(Y)},get extensionMode(){return Ae},get extension(){return te===void 0&&(te=new he(ae,Y.identifier,Y,Pe,!1)),te},get extensionRuntime(){return(0,o.$mF)(Y,"extensionRuntime"),ae.extensionRuntime},get environmentVariableCollection(){return ae.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Q){if(!ee)return;const $e=y.Event.buffer(y.Event.fromDOMEventEmitter(ee,"message",ve=>ve.data));ee.start(),Q={onDidReceiveMessage:$e,postMessage:ee.postMessage.bind(ee)}}return Q}})})}static hb(Y,V,ne,Ie,Ae){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(Y,V,ne,Ie,Ae).then(Pe=>new p.$Rfc(!1,null,Ae.build(),ne,Pe,Ie.subscriptions))}static ib(Y,V,ne,Ie,Ae){if(typeof ne.activate=="function")try{Ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Pe=typeof global=="object"?global:self,ae=ne.activate.apply(Pe,[Ie]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(ae).then(te=>(Ae.activateResolveStop(),te))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ne)}jb(Y,V){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:V}).then(void 0,ne=>{this.s.error(ne)})}kb(Y,V=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Ae=V;Ae<Y.length;Ae+=1){const Pe=Y[Ae];for(const ae of Pe.activationEvents??[])if(ae==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Y,Ae);break}else this.jb(Pe,ae)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(Y=>{const V=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(V)this.kb(ne);else for(const Ie of ne)if(Ie.activationEvents)for(const Ae of Ie.activationEvents)Ae==="onStartupFinished"&&this.jb(Ie,Ae)})}mb(){const Y=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(V),Ie=this.pb(),Ae=Promise.all([Ie,Y,ne]).then(()=>{});return Promise.race([Ae,(0,R.$3g)(1e4)]).then(()=>{this.lb()}),Ae}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(Y,V))).then(()=>{})}async ob(Y,V){if(this.isActivated(V.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Y.map(Pe=>Pe.uri),forceUsingSearch:ne||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,ae,te)=>this.y.$checkExists(Pe,ae,te)},Ae=await(0,D.$fsb)(Ie,V);if(Ae)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Ae.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:V}=this.f.environment;if(!Y||!V)throw new Error(E.localize(0,null));const ne=await this.vb(null,V,new p.$Qfc(!1));if(!ne||typeof ne.run!="function")throw new Error(E.localize(1,null,V.toString()));return new Promise((Ie,Ae)=>{const Pe=(Q,ee)=>{Q?(C.$t&&this.s.error("Test runner called back with error",Q),Ae(Q)):(C.$t&&(ee?this.s.info(`Test runner called back with ${ee} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof ee=="number"&&ee>0?1:0))},ae=(0,L.$rg)(V),te=ne.run(ae,Pe);te&&te.then&&te.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(Q=>{C.$t&&this.s.error("Test runner finished with error",Q),Ae(Q instanceof Error&&Q.stack?Q.stack:String(Q))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$3g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,V){return this.R[Y]=V,(0,m.$Qc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:V}=await this.sb(Y);return V?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const V=Y.indexOf("+");if(V===-1)throw new i.$WK("Not an authority that can be resolved!",s.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Y.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(Y,V){const ne=q.$Od.create(!1),Ie=()=>`[resolveAuthority(${(0,s.$8k)(Y)},${V})][${ne.elapsed()}ms] `,Ae=H=>this.s.info(`${Ie()}${H}`),Pe=H=>this.s.warn(`${Ie()}${H}`),ae=(H,U=void 0)=>this.s.error(`${Ie()}${H}`,U),te=H=>{if(H instanceof i.$WK)return{type:"error",error:{code:H._code,message:H._message,detail:H._detail}};throw H},Q=async H=>{Ae(`activating resolver for ${H}...`);const{resolver:U,authorityPrefix:Z}=await this.sb(H);if(!U)throw ae(`no resolver for ${Z}`),new i.$WK(`No remote extension installed to resolve ${Z}.`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:U,authorityPrefix:Z,remoteAuthority:H}},ee=Y.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${ee.join(" -> ")}`);let $e;try{$e=await Promise.all(ee.map(Q)).catch(async H=>{if(!(H instanceof i.$WK)||H._code!==s.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw H;return Pe(`resolving nested authorities failed: ${H.message}`),[await Q(Y)]})}catch(H){return te(H)}const ve=new R.$ah;ve.cancelAndSet(()=>Ae("waiting..."),1e3);let Fe,le;for(const[H,{authorityPrefix:U,resolver:Z,remoteAuthority:x}]of $e.entries())try{if(H===$e.length-1)Ae("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${U}`),Fe=await Z.resolve(x,{resolveAttempt:V,execServer:le}),I.mark(`code/extHost/didResolveAuthorityOK/${U}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Z,i.$VK.isManagedResolvedAuthority(Fe)?Fe:void 0));else{if(Ae(`invoking resolveExecServer() for ${x}`),I.mark(`code/extHost/willResolveExecServer/${U}`),le=await Z.resolveExecServer?.(x,{resolveAttempt:V,execServer:le}),!le)throw new i.$WK(`Exec server was not available for ${x}`,s.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${U}`)}}catch(ye){return I.mark(`code/extHost/didResolveAuthorityError/${U}`),ae("returned an error",ye),ve.dispose(),te(ye)}ve.dispose();const we={environmentTunnels:Fe.environmentTunnels,features:Fe.tunnelFeatures},T={extensionHostEnv:Fe.extensionHostEnv,isTrusted:Fe.isTrusted,authenticationSession:Fe.authenticationSessionForInitializingExtensions?{id:Fe.authenticationSessionForInitializingExtensions.id,providerId:Fe.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$VK.isManagedResolvedAuthority(Fe)?"managed authority":`${Fe.host}:${Fe.port}`}`);let K;if(i.$VK.isManagedResolvedAuthority(Fe)){const H=V;this.X.setFactory(H,Fe.makeConnection),K={authority:Y,connectTo:new s.$5k(H),connectionToken:Fe.connectionToken}}else K={authority:Y,connectTo:new s.$6k(Fe.host,Fe.port),connectionToken:Fe.connectionToken};return{type:"ok",value:{authority:K,options:T,tunnelInformation:we}}}async $getCanonicalURI(Y,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,s.$8k)(Y)})`);const{resolver:ne}=await this.sb(Y);if(!ne)return null;const Ie=w.URI.revive(V);if(typeof ne.getCanonicalURI>"u")return Ie;const Ae=await(0,R.$Ug)(()=>ne.getCanonicalURI(Ie));return Ae||Ie}$startExtensionHost(Y){Y.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:V,myExtensions:ne}=me(this.I,this.L,this.J,Y);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Se(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Se(this.J)}`)),this.rb()}$activateByEvent(Y,V){return V===1?this.D.wait().then(ne=>this.Z(Y,!1)):this.G.wait().then(ne=>this.Z(Y,!1))}async $activate(Y,V){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,V),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Pe=>Pe.extensionLocation=w.URI.revive(Pe.extensionLocation));const{globalRegistry:V,myExtensions:ne}=me(this.I,this.L,this.J,Y),Ie=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ne),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Se(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Se(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const V=c.$ge.alloc(Y),ne=Math.random()%256;for(let Ie=0;Ie<Y;Ie++)V.writeUInt8(ne,Ie);return V}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$_fc=ce,e.$_fc=ce=J=Ge([Ke(0,u.$1h),Ke(1,e.$$fc),Ke(2,f.$SM),Ke(3,r.$yfc),Ke(4,l.$Bfc),Ke(5,A.$jj),Ke(6,d.$9M),Ke(7,v.$Efc),Ke(8,F.$cyb),Ke(9,$.$Zfc),Ke(10,z.$8fc),Ke(11,P.$9fc)],ce);function me(oe,Y,V,ne){oe.addActivationEvents(ne.addActivationEvents);const Ie=new t.$l7b(oe,Y.getAllExtensionDescriptions());Ie.deltaExtensions(ne.toAdd,ne.toRemove);const Ae=new a.$im(V.getAllExtensionDescriptions().map(ae=>ae.identifier));for(const ae of ne.myToRemove)Ae.delete(ae);for(const ae of ne.myToAdd)Ae.add(ae);const Pe=fe(Ie,Ae);return{globalRegistry:Ie,myExtensions:Pe}}function be(oe,Y){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function Se(oe){return oe.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$agc=(0,u.$2h)("IExtHostExtensionService");class he{#e;#t;#i;constructor(Y,V,ne,Ie,Ae){this.#e=Y,this.#t=V,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=N.$hc((0,L.$rg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$bgc=he;function fe(oe,Y){return oe.getAllExtensionDescriptions().filter(V=>Y.has(V.identifier))}class ie{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$cgc=ie;class ke{constructor(Y){this.a=new a.$jm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const V of Object.keys(Y))this.a.set(V,Y[V])}}}),define(Ce[287],Re([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=void 0;let r=class{constructor(c,h,i,s,u,d,v){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.h=d,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$khc=r,e.$khc=r=Ge([Ke(2,A.$1h),Ke(3,L.$Bfc),Ke(4,k.$agc),Ke(5,w.$9M),Ke(6,l.$jj)],r);let o=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,p.$Ke)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",s=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,s,u]=h,d=b.a.get(s);if(d!==void 0)return console.warn(`${s} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};o=b=Ge([Ke(0,w.$9M)],o);class t{constructor(c,h,i,s,u){this.c=c,this.d=h,this.e=i,this.f=s,this.g=u,this.nodeModuleName="vscode",this.a=new m.$jm}load(c,h){const i=this.d.findSubstr(h);if(i){let s=this.a.get(i.identifier);return s||(s=this.c(i,this.e,this.f),this.a.set(i.identifier,s)),s}if(!this.b){let s="";this.d.forEach((u,d)=>s+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${s}`),this.b=this.c(R.$gF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$OK.MainThreadTelemetry);const s=i.getProxy(I.$OK.MainThreadWindow);this.c=(u,d)=>{const v=N.URI.parse(u);return d?this.g(u,d):v.scheme==="http"||v.scheme==="https"?s.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?s.$openUri(v,u,{}):this.g(u,d)}}load(c,h,i){const s=this.e.findSubstr(h);return s&&(this.a=s.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Ge([Ke(2,g.$SM)],n)}),define(Ce[116],Re([1,0,39,6,19,74,4,61,62,38,7,36,215,37]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=e.$dgc=void 0,e.$dgc=(0,R.$2h)("IExtHostVariableResolverProvider");class b extends l.$TN{constructor(t,n,a,c,h,i,s){function u(){if(a){const d=a.activeEditor();if(d)return d.document.uri;const v=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof A.$xM||v.input instanceof A.$CM)return v.input.modified;if(v.input instanceof A.$wM||v.input instanceof A.$BM||v.input instanceof A.$zM)return v.input.uri}}}super({getFolderUri:d=>{const v=i.folders.filter(f=>f.name===d);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,v)=>h.getConfiguration(void 0,d).get(v),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return I.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const v=n.getWorkspaceFolder(d);if(v)return I.$hc(v.uri.fsPath)}}},getSelectedText:()=>{if(a){const d=a.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(a){const d=a.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let r=class extends N.$Sc{constructor(t,n,a,c,h){super(),this.b=t,this.c=n,this.g=a,this.h=c,this.j=h,this.a=new E.$V(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$egc=r,e.$egc=r=Ge([Ke(0,w.$agc),Ke(1,k.$yfc),Ke(2,m.$4M),Ke(3,p.$Bfc),Ke(4,g.$Nfc)],r)}),define(Ce[117],Re([1,0,14,5,2,4,3,62,38,17,7,36,207,209,37,116]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=e.$igc=e.$hgc=e.$ggc=e.$fgc=void 0,e.$fgc=(0,L.$2h)("IExtHostDebugService");let o=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(s,u,d,v,f,S){this.E=u,this.F=d,this.G=v,this.H=f,this.I=S,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new N.$Sd,this.n=new N.$Sd,this.o=new N.$Sd,this.u=new N.$Sd,this.k=s.getProxy(R.$OK.MainThreadDebugService),this.y=new N.$Sd,this.A=new N.$Sd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(F=>{F.onDidChange($=>{this.J(F)}),this.J(F)})}asDebugSourceUri(s,u){const d=s;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(v+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),v+=`${f}ref=${d.sourceReference}`,I.URI.parse(v)}else{if(d.path)return I.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(s){const u=[];for(const d of s.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const f of v)(0,p.$XF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const s=[];return this.w.forEach(u=>s.push(u)),s}addBreakpoints(s){const u=s.filter(f=>{const S=f.id;return this.w.has(S)?!1:(this.w.set(S,f),!0)});this.U(u,[],[]);const d=[],v=new Map;for(const f of u)if(f instanceof A.$QL){let S=v.get(f.location.uri.toString());S||(S={type:"sourceMulti",uri:f.location.uri,lines:[]},v.set(f.location.uri.toString(),S),d.push(S)),S.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof A.$RL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(s){const u=s.filter(S=>this.w.delete(S.id));this.U([],u,[]);const d=u.filter(S=>S instanceof A.$QL).map(S=>S.id),v=u.filter(S=>S instanceof A.$RL).map(S=>S.id),f=u.filter(S=>S instanceof A.$SL).map(S=>S.id);return this.k.$unregisterBreakpoints(d,v,f)}startDebugging(s,u,d){return this.k.$startDebugging(s?s.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(s){return this.k.$stopDebugging(s?s.id:void 0)}registerDebugConfigurationProvider(s,u,d){if(!u)return new A.$QK(()=>{});const v=this.d++;return this.f.push({type:s,handle:v,provider:u}),this.k.$registerDebugConfigurationProvider(s,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,v),new A.$QK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(s,u,d){if(!d)return new A.$QK(()=>{});if(!this.Q(s,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:u,handle:v,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,v),new A.$QK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(s,u){if(!u)return new A.$QK(()=>{});const d=this.i++;return this.j.push({type:s,handle:d,factory:u}),new A.$QK(()=>{this.j=this.j.filter(v=>v.factory!==u)})}async $runInTerminal(s,u){return Promise.resolve(void 0)}async $substituteVariables(s,u){let d;const v=await this.W(s);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(s,u){if(s.type==="implementation")return new c(s.implementation)}L(){}async $startDASession(s,u){const d=this,v=await this.V(u);return this.S(this.N(v.type),v).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const S=this.M(f),F=this.K(S,v);if(!F)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const $=F;return this.B.set(s,$),this.R(v).then(y=>(y&&this.C.set(s,y),$.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const M=D,O={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const W=await this.D.sign(M.arguments.value);O.body={signature:W},$.sendResponse(O)}else throw new Error("no signer")}catch(W){O.success=!1,O.message=W.message,$.sendResponse(O)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,p.$3F)(D,!0),d.k.$acceptDAMessage(s,D)}),$.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(s,D.name,D.message,D.stack)}),$.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(s,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),$.startSession()))})}$sendDAMessage(s,u){u=(0,p.$2F)(u,!1);const d=this.C.get(s);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(s)?.sendMessage(u)}$stopDASession(s){const u=this.C.get(s);this.C.delete(s),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(s);return this.B.delete(s),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(s){const u=[],d=[],v=[];if(s.added)for(const f of s.added){const S=f.id;if(S&&!this.w.has(S)){let F;if(f.type==="function")F=new A.$RL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")F=new A.$SL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const $=I.URI.revive(f.uri);F=new A.$QL(new A.$3K($,new A.$RK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,A.$OL)(F,S),this.w.set(S,F),u.push(F)}}if(s.removed)for(const f of s.removed){const S=this.w.get(f);S&&(this.w.delete(f),d.push(S))}if(s.changed){for(const f of s.changed)if(f.id){const S=this.w.get(f.id);if(S){if(S instanceof A.$RL&&f.type==="function"){const F=S;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.functionName=f.functionName}else if(S instanceof A.$QL&&f.type==="source"){const F=S;F.enabled=f.enabled,F.condition=f.condition,F.hitCondition=f.hitCondition,F.logMessage=f.logMessage,F.location=new A.$3K(I.URI.revive(f.uri),new A.$RK(f.line,f.character))}v.push(S)}}}this.U(u,d,v)}async $acceptStackFrameFocus(s){let u;const d=s.sessionId?await this.V(s.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");s.kind==="thread"?u=new A.$YL(d,s.threadId):u=new A.$XL(d,s.threadId,s.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(s,u,d){return(0,E.$Ug)(async()=>{const v=this.P(s);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return v.provideDebugConfigurations(f,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(s,u,d,v){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const S=await this.W(u);return f.resolveDebugConfiguration(S,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(s,u,d,v){return(0,E.$Ug)(async()=>{const f=this.P(s);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const S=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(S,d,v)})}async $provideDebugAdapter(s,u){const d=this.O(s);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(u);return this.S(d,v).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(s){const u=await this.V(s);this.m.fire(u)}async $acceptDebugSessionTerminated(s){const u=await this.V(s);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(s){this.q=s?await this.V(s):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(s,u){(await this.V(s))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(s,u){const v={session:await this.V(s),event:u.event,body:u.body};this.u.fire(v)}M(s){if(s instanceof A.$TL)return{type:"executable",command:s.command,args:s.args,options:s.options};if(s instanceof A.$UL)return{type:"server",port:s.port,host:s.host};if(s instanceof A.$VL)return{type:"pipeServer",path:s.path};if(s instanceof A.$WL)return{type:"implementation",implementation:s.implementation};throw new Error("convertToDto unexpected type")}N(s){const u=this.h.filter(d=>d.type===s);if(u.length>0)return u[0].factory}O(s){const u=this.h.filter(d=>d.handle===s);if(u.length>0)return u[0].factory}P(s){const u=this.f.filter(d=>d.handle===s);if(u.length>0)return u[0].provider}Q(s,u){if(s.contributes){const d=s.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===u)return!0}}return!1}R(s){const d=s.configuration.type,v=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Ug)(()=>f.factory.createDebugAdapterTracker(s)).then(S=>S,S=>null));return Promise.race([Promise.all(v).then(f=>{const S=f.filter(F=>!!F);if(S.length>0)return new a(S)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(s,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new A.$UL(d));if(s){const f=await this.F.getExtensionRegistry();return(0,E.$Ug)(()=>s.createDebugAdapterDescriptor(u,this.T(u,f))).then(S=>{if(S)return S})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,v))}T(s,u){}U(s,u,d){(s.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:s,removed:u,changed:d}))}async V(s){if(s)if(typeof s=="string"){const u=this.l.get(s);if(u)return u}else{let u=this.l.get(s.id);if(!u){const d=await this.W(s.folderUri),v=s.parent?this.l.get(s.parent):void 0;u=new t(this.k,s.id,s.type,s.name,d,s.configuration,v),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(s){if(s){const u=I.URI.revive(s);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$ggc=o,e.$ggc=o=Ge([Ke(0,w.$SM),Ke(1,k.$yfc),Ke(2,g.$agc),Ke(3,b.$Bfc),Ke(4,m.$Nfc),Ke(5,r.$dgc)],o);class t{constructor(s,u,d,v,f,S,F){this.d=s,this.f=u,this.g=d,this.h=v,this.i=f,this.j=S,this.k=F}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(s){this.h=s,this.d.$setDebugSessionName(this.f,s)}get parentSession(){return this.k}_acceptNameChanged(s){this.h=s}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(s,u){return this.d.$customDebugAdapterRequest(this.f,s,u)}getDebugProtocolBreakpoint(s){return this.d.$getDebugProtocolBreakpoint(this.f,s.id)}}e.$hgc=t;class n{constructor(s){this.value=Object.freeze({append(u){s.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$igc=n;class a{constructor(s){this.d=s}onWillStartSession(){this.d.forEach(s=>s.onWillStartSession?s.onWillStartSession():void 0)}onWillReceiveMessage(s){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(s):void 0)}onDidSendMessage(s){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(s):void 0)}onWillStopSession(){this.d.forEach(s=>s.onWillStopSession?s.onWillStopSession():void 0)}onError(s){this.d.forEach(u=>u.onError?u.onError(s):void 0)}onExit(s,u){this.d.forEach(d=>d.onExit?d.onExit(s,u):void 0)}}class c extends l.$xlb{constructor(s){super(),this.h=s,s.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(s){this.h.handleMessage(s)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends o{constructor(s,u,d,v,f,S){super(s,u,d,v,f,S)}};e.$jgc=h,e.$jgc=h=Ge([Ke(0,w.$SM),Ke(1,k.$yfc),Ke(2,g.$agc),Ke(3,b.$Bfc),Ke(4,m.$Nfc),Ke(5,r.$dgc)],h)}),define(Ce[288],Re([1,0,11,88,2,3,276,15,70,71,27,185,17,57,38,59]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mhc=e.$lhc=void 0;class o{static async installEarlyHandler(a){Error.stackTraceLimit=100;const c=a.get(m.$jj),i=a.get(l.$SM).getProxy(L.$OK.MainThreadErrors);E.setUnexpectedErrorHandler(s=>{c.error(s);const u=E.$3(s);i.$onUnexpectedError(u)})}static async installFullHandler(a){const c=a.get(m.$jj),h=a.get(l.$SM),i=a.get(b.$agc),s=a.get(r.$aN),u=h.getProxy(L.$OK.MainThreadExtensionService),d=h.getProxy(L.$OK.MainThreadErrors),v=await i.getExtensionPathIndex(),f=new WeakMap;function S(y,D){if(f.has(y))return f.get(y).stack;let M="",O,W;for(const q of D)M+=`
	at ${q.toString()}`,W=q.getFileName(),!O&&W&&(O=v.findSubstr(I.URI.file(W)));const z=`${y.name||"Error"}: ${y.message||""}${M}`;return f.set(y,{extensionIdentifier:O?.identifier,stack:z}),z}const F=Symbol("prepareStackTrace wrapped");let $=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return $},set(y){if(y===S||!y||y[F]){$=y||S;return}$=function(D,M){return S(D,M),y.call(Error,D,M)},Object.assign($,{[F]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$3(y),M=f.get(y);if(!M?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(M.extensionIdentifier,D);const O=s.onExtensionError(M.extensionIdentifier,y);c.trace("forwarded error to extension?",O,M)})}}e.$lhc=o;class t{constructor(a,c,h,i,s){this.a=h,this.b=new R.$t7b(a,null,i),c=t.e(c,this.b);const u=new w.$Zh(...(0,g.$Lr)());u.set(A.$9M,{_serviceBrand:void 0,...c,messagePorts:s}),u.set(l.$SM,new l.$TM(this.b)),u.set(p.$vfc,new p.$wfc(i)),u.set(b.$$fc,h);const d=new k.$rq(u,!0);d.invokeFunction(o.installEarlyHandler),this.d=d.invokeFunction(v=>v.get(m.$jj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(v=>v.get(b.$agc)),this.c.initialize(),d.invokeFunction(o.installFullHandler)}async asBrowserUri(a){const c=this.b.getProxy(L.$OK.MainThreadExtensionService);return I.URI.revive(await c.$asBrowserUri(a))}terminate(a){this.c.terminate(a)}static e(a,c){a.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),a.environment.appRoot=I.URI.revive(c.transformIncomingURIs(a.environment.appRoot));const h=a.environment.extensionDevelopmentLocationURI;return h&&(a.environment.extensionDevelopmentLocationURI=h.map(i=>I.URI.revive(c.transformIncomingURIs(i)))),a.environment.extensionTestsLocationURI=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=I.URI.revive(c.transformIncomingURIs(a.environment.workspaceStorageHome)),a.environment.extensionTelemetryLogResource=I.URI.revive(c.transformIncomingURIs(a.environment.extensionTelemetryLogResource)),a.nlsBaseUrl=I.URI.revive(c.transformIncomingURIs(a.nlsBaseUrl)),a.logsLocation=I.URI.revive(c.transformIncomingURIs(a.logsLocation)),a.workspace=c.transformIncomingURIs(a.workspace),a}}e.$mhc=t}),define(Ce[289],Re([1,0,18,14,20,40,13,19,25,2,44]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=e.$zgc=e.$ygc=e.$xgc=void 0;class k{constructor(n,a,c,h){this.d=n,this.e=a,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,a){const c=this.d.folderQueries||[],h=new I.$3d(a);return new Promise((i,s)=>{this.a=new p(n);let u=!1;const d=(v,f)=>{if(!u&&!this.b){const S=this.h(v);r(v)&&typeof this.d.maxResults=="number"&&this.c+S>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),v=this.j(v,this.d.maxResults-this.c));const F=this.h(v);this.c+=F,(F>0||!r(v))&&this.a.add(v,f)}};Promise.all(c.map((v,f)=>this.k(v,S=>d(S,f),h.token))).then(v=>{h.dispose(),this.a.flush();const f=v.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||f,messages:(0,E.$Rb)(v.map(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[])),stats:{type:this.g}})},v=>{h.dispose();const f=(0,L.$Mi)(v);s(new Error(f))})})}h(n){return r(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,a){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,a),preview:{matches:h.slice(0,a),text:n.preview.text},uri:n.uri}}async k(n,a,c){const h=new A.$sJ(this.d,n),i=[],s={report:v=>{if(!this.l(v))return;const f=n.folder.scheme===R.Schemas.file?(0,A.$tJ)(()=>this.f.readdir(g.$Cg(v.uri))):void 0,S=g.$Fg(n.folder,v.uri);if(S){const F=h.includedInQuery(S,m.$nc(S),f);(0,N.$Og)(F)?i.push(F.then($=>{$&&a(v)})):F&&a(v)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,s,c);return i.length&&await Promise.all(i),d}l(n){if(r(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const a=(0,A.$rJ)(this.d.includePattern,n.includePattern),c=(0,A.$rJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:a,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$xgc=k;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class p{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new o(512,a=>this.g(a))}add(n,a){this.d&&(this.b!==a||!g.$wg(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=a,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$ygc=p;function b(t){return r(t)?{preview:{matches:(0,E.$2b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$2b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function r(t){return!!t.preview}e.$zgc=r;class o{static{this.a=4e3}static{this.b=50}constructor(n,a){this.g=n,this.h=a,this.c=0,this.d=[],this.e=0}addItem(n,a){n&&this.j(n,a)}addItems(n,a){n&&this.k(n,a)}j(n,a){this.d.push(n),this.e+=a,this.l()}k(n,a){this.d=this.d.concat(n),this.e+=a,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Agc=o}),define(Ce[118],Re([1,0,6,3,4,284,17,57,15,2,289]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=e.$Cgc=e.$Bgc=void 0,e.$Bgc=(0,I.$2h)("IExtHostSearch");let k=class{constructor(r,o,t){this.k=r,this.l=o,this.n=t,this.c=this.k.getProxy(N.$OK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$wgc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const t=this.d++;return this.e.set(t,o),this.c.$registerTextSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.g.delete(r),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(r,o){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const t=this.d++;return this.h.set(t,o),this.c.$registerFileSearchProvider(t,this.o(r)),(0,E.$Qc)(()=>{this.i.delete(r),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(r,o,t,n){const a=l(t),c=this.h.get(r);if(c)return this.j.fileSearch(a,c,h=>{this.c.$handleFileMatch(r,o,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,t){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,t,n){const a=this.e.get(r);if(!a||!a.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const c=l(t);return this.q(c,a).search(i=>this.c.$handleTextMatch(r,o,i),n)}$enableExtensionHostSearch(){}q(r,o){return new A.$xgc(r,o,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Cgc=k,e.$Cgc=k=Ge([Ke(0,R.$SM),Ke(1,m.$vfc),Ke(2,g.$jj)],k);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(r=>w.URI.revive(r))}}e.$Dgc=l;function p(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Ce[290],Re([1,0,20,11,5,6,13,31,2,146,142,130,93,22,42,15,55,56,198,3,231,239,81,232,233,234,235,236,237,238,213,32,240,37,272,117,110,242,243,244,220,245,61,62,247,38,248,63,249,43,27,250,251,252,253,254,255,82,83,257,283,222,202,223,258,259,112,260,224,261,262,17,263,118,84,264,265,266,85,86,115,59,64,267,268,210,269,225,87,8,7,270,57,271,65,273,274,111,36,208,79,23,114]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,v,f,S,F,$,y,D,M,O,W,z,q,C,P,J,ce,me,be,Se,he,fe,ie,ke,oe,Y,V,ne,Ie,Ae,Pe,ae,te,Q,ee,$e,ve,Fe,le,we,T,K,H,U,Z,x,ye,Te,We,He,Xe,rt,it,et,ot,at,ze,pt,X,_,pe,Be,Qe,tt,nt,Ne,It,Ft,Kt,Ut,wt,qt,Mt,Qt,Ot,Ct,Ye,Ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;function Gt(ut){const mt=ut.get(Y.$9M),jt=ut.get(oe.$dfc),Bt=ut.get(ie.$Dfc),Et=ut.get(he.$agc),ht=ut.get(Qt.$yfc),Pt=ut.get(ze.$aN),Yt=ut.get(M.$Bfc),Dt=ut.get(Ft.$vfc),qe=ut.get(ye.$SM),At=ut.get(et.$Wfc),Wt=ut.get(ot.$Efc),Jt=ut.get(r.$kj),ft=ut.get(r.$jj),Lt=ut.get(tt.$cyb),Ee=ut.get(i.$gfc),Me=ut.get(Mt.$fhc),de=ut.get(He.$5fc),G=ut.get(be.$Nfc),Le=ut.get(Q.$9fc);qe.set(a.$PK.ExtHostFileSystemInfo,jt),qe.set(a.$PK.ExtHostLogLevelServiceShape,Jt),qe.set(a.$PK.ExtHostWorkspace,ht),qe.set(a.$PK.ExtHostConfiguration,Yt),qe.set(a.$PK.ExtHostExtensionService,Et),qe.set(a.$PK.ExtHostStorage,At),qe.set(a.$PK.ExtHostTunnelService,Lt),qe.set(a.$PK.ExtHostWindow,Me),qe.set(a.$PK.ExtHostSecretState,de),qe.set(a.$PK.ExtHostTelemetry,Pt),qe.set(a.$PK.ExtHostEditorTabs,G),qe.set(a.$PK.ExtHostManagedSockets,Le);const Ue=qe.set(a.$PK.ExtHostDecorations,ut.get(z.$lgc)),Ze=qe.set(a.$PK.ExtHostDocumentsAndEditors,ut.get(me.$4M)),Ve=qe.set(a.$PK.ExtHostCommands,ut.get(y.$cN)),_e=qe.set(a.$PK.ExtHostTerminalService,ut.get(pt.$Zfc)),gt=qe.set(a.$PK.ExtHostDebugService,ut.get(W.$fgc)),zt=qe.set(a.$PK.ExtHostSearch,ut.get(We.$Bgc)),yt=qe.set(a.$PK.ExtHostTask,ut.get(at.$5gc)),St=qe.set(a.$PK.ExtHostOutputService,ut.get(K.$Rgc)),bt=qe.set(a.$PK.ExtHostLocalization,ut.get(te.$8fc)),fi=qe.set(a.$PK.ExtHostUrls,new Kt.$chc(qe)),Rt=qe.set(a.$PK.ExtHostDocuments,new ce.$bfc(qe,Ze)),Si=qe.set(a.$PK.ExtHostDocumentContentProviders,new P.$ngc(qe,Ze,ft)),Vi=qe.set(a.$PK.ExtHostDocumentSaveParticipant,new J.$ogc(ft,Rt,qe.getProxy(a.$OK.MainThreadBulkEdits))),kt=qe.set(a.$PK.ExtHostNotebook,new $e.$Egc(qe,Ve,Ze,Rt,Bt,zt)),ni=qe.set(a.$PK.ExtHostNotebookDocuments,new Fe.$Lgc(kt)),gi=qe.set(a.$PK.ExtHostNotebookEditors,new le.$Mgc(ft,kt)),ai=qe.set(a.$PK.ExtHostNotebookKernels,new we.$Ngc(qe,mt,kt,Ve,ft)),ki=qe.set(a.$PK.ExtHostNotebookRenderers,new T.$Pgc(qe,kt)),Ii=qe.set(a.$PK.ExtHostNotebookDocumentSaveParticipant,new ve.$Kgc(ft,kt,qe.getProxy(a.$OK.MainThreadBulkEdits))),Tt=qe.set(a.$PK.ExtHostEditors,new _.$sfc(qe,Ze)),mi=qe.set(a.$PK.ExtHostTreeViews,new Qe.$ahc(qe.getProxy(a.$OK.MainThreadTreeViews),Ve,ft)),Ci=qe.set(a.$PK.ExtHostEditorInsets,new $.$tfc(qe.getProxy(a.$OK.MainThreadEditorInsets),Tt,mt.remote)),ci=qe.set(a.$PK.ExtHostDiagnostics,new q.$ffc(qe,ft,jt,Ze)),ui=qe.set(a.$PK.ExtHostLanguages,new ae.$Igc(qe,Rt,Ve.converter,Dt)),lt=qe.set(a.$PK.ExtHostLanguageFeatures,new Pe.$jfc(qe,Dt,Rt,Ve,ci,ft,Ee,Pt)),qi=qe.set(a.$PK.ExtHostFileSystem,new fe.$qgc(qe,lt)),xt=qe.set(a.$PK.ExtHostFileSystemEventService,new ke.$rgc(qe,ft,Ze)),ri=qe.set(a.$PK.ExtHostQuickOpen,(0,x.$Vgc)(qe,ht,Ve)),$i=qe.set(a.$PK.ExtHostSCM,new Te.$Xgc(qe,Ve,Rt,ft)),Pi=qe.set(a.$PK.ExtHostQuickDiff,new Z.$Ugc(qe,Dt)),Ki=qe.set(a.$PK.ExtHostShare,new Xe.$Ygc(qe,Dt)),Ri=qe.set(a.$PK.ExtHostComments,(0,D.$ufc)(qe,Ve,Rt)),pi=qe.set(a.$PK.ExtHostProgress,new U.$Tgc(qe.getProxy(a.$OK.MainThreadProgress))),Hi=qe.set(a.$PK.ExtHostLabelService,new Ae.$Hgc(qe)),Ai=qe.set(a.$PK.ExtHostTheming,new pe.$0gc(qe)),li=qe.set(a.$PK.ExtHostAuthentication,new s.$lfc(qe)),Gi=qe.set(a.$PK.ExtHostTimeline,new Be.$_gc(qe,Ve)),vi=qe.set(a.$PK.ExtHostWebviews,new Ut.$Ifc(qe,mt.remote,ht,ft,Ee)),Li=qe.set(a.$PK.ExtHostWebviewPanels,new wt.$Lfc(qe,vi,ht)),cn=qe.set(a.$PK.ExtHostCustomEditors,new O.$Mfc(qe,Rt,Wt,vi,Li)),Fi=qe.set(a.$PK.ExtHostWebviewViews,new qt.$dhc(qe,vi)),si=qe.set(a.$PK.ExtHostTesting,new X.$6gc(qe,Ve,Ze)),un=qe.set(a.$PK.ExtHostUriOpeners,new It.$bhc(qe)),ln=qe.set(a.$PK.ExtHostProfileContentHandlers,new H.$Sgc(qe));qe.set(a.$PK.ExtHostInteractive,new ne.$Fgc(qe,kt,Ze,Ve,ft));const Ji=qe.set(a.$PK.ExtHostInlineChat,new V.$sgc(qe,Ve,Rt,ft)),di=qe.set(a.$PK.ExtHostChatProvider,new f.$ofc(qe,ft)),Qi=qe.set(a.$PK.ExtHostChatAgents2,new v.$pfc(qe,di,ft)),Zi=qe.set(a.$PK.ExtHostChatVariables,new S.$qfc(qe)),bi=qe.set(a.$PK.ExtHostChat,new d.$nfc(qe)),Xi=qe.set(a.$PK.ExtHostAiRelatedInformation,new c.$afc(qe)),Mi=qe.set(a.$PK.ExtHostAiEmbeddingVector,new Se.$pgc(qe)),Ti=qe.set(a.$PK.ExtHostIssueReporter,new Ie.$Ggc(qe)),_t=qe.set(a.$PK.ExtHostStatusBar,new it.$2gc(qe,Ve.converter)),wi=qe.set(a.$PK.ExtHostSpeech,new rt.$Zgc(qe)),hn=Object.values(a.$PK);qe.assertRegistered(hn);const Zt=new u.$mfc(qe,Ze),yi=new F.$rfc(qe),Ei=new ee.$Jgc(qe,ft),Ni=new C.$mgc(qe);return h.$kfc.register(Ve),function(je,ei,Yi){const $t=function(){let re=!je.isUnderDevelopment;function ue(){re||(ft.info(`Extension '${je.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Oe(st){if(Array.isArray(st))st.forEach(Oe);else if(typeof st=="string")ue();else{const vt=st;typeof vt.scheme>"u"&&ue(),typeof vt.exclusive=="boolean"&&(0,Ye.$mF)(je,"documentFiltersExclusive")}return st}}(),xi={getSession(re,ue,Oe){return li.getSession(je,re,ue,Oe)},getSessions(re,ue){return(0,Ye.$mF)(je,"authGetSessions"),li.getSessions(je,re,ue)},async hasSession(re,ue){return(0,Ye.$mF)(je,"authSession"),!!await li.getSession(je,re,ue,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(re,ue,Oe,st){return li.registerAuthenticationProvider(re,ue,Oe,st)}},dn={registerCommand(re,ue,Oe){return Ve.registerCommand(!0,re,ue,Oe,void 0,je)},registerTextEditorCommand(re,ue,Oe){return Ve.registerCommand(!0,re,(...st)=>{const vt=Tt.getActiveTextEditor();if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}return vt.edit(Nt=>{ue.apply(Oe,[vt,Nt,...st])}).then(Nt=>{Nt||ft.warn("Edits from command "+re+" were not applied.")},Nt=>{ft.warn("An error occurred while running command "+re,Nt)})},void 0,void 0,je)},registerDiffInformationCommand:(re,ue,Oe)=>((0,Ye.$mF)(je,"diffCommand"),Ve.registerCommand(!0,re,async(...st)=>{const vt=Ze.activeEditor(!0);if(!vt){ft.warn("Cannot execute "+re+" because there is no active text editor.");return}const Nt=await Tt.getDiffInformation(vt.id);ue.apply(Oe,[Nt,...st])},void 0,void 0,je)),executeCommand(re,...ue){return Ve.executeCommand(re,...ue)},getCommands(re=!1){return Ve.getCommands(re)}},_i={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return _e.getDefaultShell(!1)},get onDidChangeShell(){return _e.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ye.$mF)(je,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$mF)(je,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ze.$_M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,ue){return ze.$$M.validateSender(re),Pt.instantiateLogger(je,re,ue)},openExternal(re,ue){return Me.openUri(re,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===mt.environment.appUriScheme)return fi.createAppUri(re);try{return await Me.asExternalUri(re,{allowTunneling:!!mt.remote.authority})}catch(ue){if((0,R.$ag)(re,R.Schemas.http)||(0,R.$ag)(re,R.Schemas.https))return re;throw ue}},get remoteName(){return(0,o.$0k)(mt.remote.authority)},get remoteAuthority(){return(0,Ye.$mF)(je,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,Ye.$mF)(je,"handleIssueUri"),Ti.registerIssueUriRequestHandler(je,re)},registerIssueDataProvider(re){return(0,Ye.$mF)(je,"handleIssueUri"),Ti.registerIssueDataProvider(je,re)},get appQuality(){return(0,Ye.$mF)(je,"resolvers"),mt.quality},get appCommit(){return(0,Ye.$mF)(je,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(re,ue,Oe){return si.createTestController(je,re,ue,Oe)},createTestObserver(){return(0,Ye.$mF)(je,"testObserver"),si.createTestObserver()},runTests(re){return(0,Ye.$mF)(je,"testObserver"),si.runTests(re)},get onDidChangeTestResults(){return(0,Ye.$mF)(je,"testObserver"),si.onResultsChanged},get testResults(){return(0,Ye.$mF)(je,"testObserver"),si.results}},hi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(re,ue){(0,Ye.$lF)(je,"extensionsAny")||(ue=!1);const Oe=ei.mine.getExtensionDescription(re);if(Oe)return new he.$bgc(Et,je.identifier,Oe,hi,!1);if(ue){const st=ei.all.getExtensionDescription(re);if(st)return new he.$bgc(Et,je.identifier,st,hi,!0)}},get all(){const re=[];for(const ue of ei.mine.getAllExtensionDescriptions())re.push(new he.$bgc(Et,je.identifier,ue,hi,!1));return re},get allAcrossExtensionHosts(){(0,Ye.$mF)(je,"extensionsAny");const re=new p.$im(ei.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ue=[];for(const Oe of ei.all.getAllExtensionDescriptions()){const st=!re.has(Oe.identifier);ue.push(new he.$bgc(Et,je.identifier,Oe,hi,st))}return ue},get onDidChange(){return(0,Ye.$lF)(je,"extensionsAny")?I.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(re){return ci.createDiagnosticCollection(je.identifier,re)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:re=>ci.getDiagnostics(re),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(re,ue){return ui.changeLanguage(re.uri,ue)},match(re,ue){const Oe=Rt.getDocumentData(ue.uri)?.notebook;return(0,A.$ot)(nt.LanguageSelector.from(re),ue.uri,ue.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(re,ue,Oe){return lt.registerCodeActionProvider(je,$t(re),ue,Oe)},registerDocumentPasteEditProvider(re,ue,Oe){return(0,Ye.$mF)(je,"documentPaste"),lt.registerDocumentPasteEditProvider(je,$t(re),ue,Oe)},registerCodeLensProvider(re,ue){return lt.registerCodeLensProvider(je,$t(re),ue)},registerDefinitionProvider(re,ue){return lt.registerDefinitionProvider(je,$t(re),ue)},registerDeclarationProvider(re,ue){return lt.registerDeclarationProvider(je,$t(re),ue)},registerImplementationProvider(re,ue){return lt.registerImplementationProvider(je,$t(re),ue)},registerTypeDefinitionProvider(re,ue){return lt.registerTypeDefinitionProvider(je,$t(re),ue)},registerHoverProvider(re,ue){return lt.registerHoverProvider(je,$t(re),ue,je.identifier)},registerEvaluatableExpressionProvider(re,ue){return lt.registerEvaluatableExpressionProvider(je,$t(re),ue,je.identifier)},registerInlineValuesProvider(re,ue){return lt.registerInlineValuesProvider(je,$t(re),ue,je.identifier)},registerDocumentHighlightProvider(re,ue){return lt.registerDocumentHighlightProvider(je,$t(re),ue)},registerMultiDocumentHighlightProvider(re,ue){return lt.registerMultiDocumentHighlightProvider(je,$t(re),ue)},registerLinkedEditingRangeProvider(re,ue){return lt.registerLinkedEditingRangeProvider(je,$t(re),ue)},registerReferenceProvider(re,ue){return lt.registerReferenceProvider(je,$t(re),ue)},registerRenameProvider(re,ue){return lt.registerRenameProvider(je,$t(re),ue)},registerDocumentSymbolProvider(re,ue,Oe){return lt.registerDocumentSymbolProvider(je,$t(re),ue,Oe)},registerWorkspaceSymbolProvider(re){return lt.registerWorkspaceSymbolProvider(je,re)},registerDocumentFormattingEditProvider(re,ue){return lt.registerDocumentFormattingEditProvider(je,$t(re),ue)},registerDocumentRangeFormattingEditProvider(re,ue){return lt.registerDocumentRangeFormattingEditProvider(je,$t(re),ue)},registerOnTypeFormattingEditProvider(re,ue,Oe,...st){return lt.registerOnTypeFormattingEditProvider(je,$t(re),ue,[Oe].concat(st))},registerDocumentSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentSemanticTokensProvider(je,$t(re),ue,Oe)},registerDocumentRangeSemanticTokensProvider(re,ue,Oe){return lt.registerDocumentRangeSemanticTokensProvider(je,$t(re),ue,Oe)},registerSignatureHelpProvider(re,ue,Oe,...st){return typeof Oe=="object"?lt.registerSignatureHelpProvider(je,$t(re),ue,Oe):lt.registerSignatureHelpProvider(je,$t(re),ue,typeof Oe>"u"?[]:[Oe,...st])},registerCompletionItemProvider(re,ue,...Oe){return lt.registerCompletionItemProvider(je,$t(re),ue,Oe)},registerInlineCompletionItemProvider(re,ue,Oe){return ue.handleDidShowCompletionItem&&(0,Ye.$mF)(je,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$mF)(je,"inlineCompletionsAdditions"),Oe&&(0,Ye.$mF)(je,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(je,$t(re),ue,Oe)},registerDocumentLinkProvider(re,ue){return lt.registerDocumentLinkProvider(je,$t(re),ue)},registerColorProvider(re,ue){return lt.registerColorProvider(je,$t(re),ue)},registerFoldingRangeProvider(re,ue){return lt.registerFoldingRangeProvider(je,$t(re),ue)},registerSelectionRangeProvider(re,ue){return lt.registerSelectionRangeProvider(je,re,ue)},registerCallHierarchyProvider(re,ue){return lt.registerCallHierarchyProvider(je,re,ue)},registerTypeHierarchyProvider(re,ue){return lt.registerTypeHierarchyProvider(je,re,ue)},setLanguageConfiguration:(re,ue)=>lt.setLanguageConfiguration(je,re,ue),getTokenInformationAtPosition(re,ue){return(0,Ye.$mF)(je,"tokenInformation"),ui.tokenAtPosition(re,ue)},registerInlayHintsProvider(re,ue){return lt.registerInlayHintsProvider(je,re,ue)},createLanguageStatusItem(re,ue){return ui.createLanguageStatusItem(je,re,ue)},registerDocumentDropEditProvider(re,ue,Oe){return lt.registerDocumentOnDropEditProvider(je,re,ue,(0,Ye.$lF)(je,"dropMetadata")?Oe:void 0)}},rn={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return _e.activeTerminal},get terminals(){return _e.terminals},async showTextDocument(re,ue,Oe){const st=await(g.URI.isUri(re)?Promise.resolve(sn.openTextDocument(re)):Promise.resolve(re));return Tt.showTextDocument(st,ue,Oe)},createTextEditorDecorationType(re){return Tt.createTextEditorDecorationType(je,re)},onDidChangeActiveTextEditor(re,ue,Oe){return Tt.onDidChangeActiveTextEditor(re,ue,Oe)},onDidChangeVisibleTextEditors(re,ue,Oe){return Tt.onDidChangeVisibleTextEditors(re,ue,Oe)},onDidChangeTextEditorSelection(re,ue,Oe){return Tt.onDidChangeTextEditorSelection(re,ue,Oe)},onDidChangeTextEditorOptions(re,ue,Oe){return Tt.onDidChangeTextEditorOptions(re,ue,Oe)},onDidChangeTextEditorVisibleRanges(re,ue,Oe){return Tt.onDidChangeTextEditorVisibleRanges(re,ue,Oe)},onDidChangeTextEditorViewColumn(re,ue,Oe){return Tt.onDidChangeTextEditorViewColumn(re,ue,Oe)},onDidCloseTerminal(re,ue,Oe){return _e.onDidCloseTerminal(re,ue,Oe)},onDidOpenTerminal(re,ue,Oe){return _e.onDidOpenTerminal(re,ue,Oe)},onDidChangeActiveTerminal(re,ue,Oe){return _e.onDidChangeActiveTerminal(re,ue,Oe)},onDidChangeTerminalDimensions(re,ue,Oe){return(0,Ye.$mF)(je,"terminalDimensions"),_e.onDidChangeTerminalDimensions(re,ue,Oe)},onDidChangeTerminalState(re,ue,Oe){return _e.onDidChangeTerminalState(re,ue,Oe)},onDidWriteTerminalData(re,ue,Oe){return(0,Ye.$mF)(je,"terminalDataWriteEvent"),_e.onDidWriteTerminalData(re,ue,Oe)},onDidExecuteTerminalCommand(re,ue,Oe){return(0,Ye.$mF)(je,"terminalExecuteCommandEvent"),_e.onDidExecuteTerminalCommand(re,ue,Oe)},get state(){return Me.getState(je)},onDidChangeWindowState(re,ue,Oe){return Me.onDidChangeWindowState(re,ue,Oe)},showInformationMessage(re,...ue){return Ei.showMessage(je,m.default.Info,re,ue[0],ue.slice(1))},showWarningMessage(re,...ue){return Ei.showMessage(je,m.default.Warning,re,ue[0],ue.slice(1))},showErrorMessage(re,...ue){return Ei.showMessage(je,m.default.Error,re,ue[0],ue.slice(1))},showQuickPick(re,ue,Oe){return ri.showQuickPick(je,re,ue,Oe)},showWorkspaceFolderPick(re){return ri.showWorkspaceFolderPick(re)},showInputBox(re,ue){return ri.showInput(re,ue)},showOpenDialog(re){return Ni.showOpenDialog(je,re)},showSaveDialog(re){return Ni.showSaveDialog(re)},createStatusBarItem(re,ue,Oe){let st,vt,Nt;return typeof re=="string"?(st=re,vt=ue,Nt=Oe):(vt=re,Nt=ue),_t.createStatusBarEntry(je,st,vt,Nt)},setStatusBarMessage(re,ue){return _t.setStatusBarMessage(re,ue)},withScmProgress(re){return Ee.report("window.withScmProgress",je,"Use 'withProgress' instead."),pi.withProgress(je,{location:Ne.ProgressLocation.SourceControl},(ue,Oe)=>re({report(st){}}))},withProgress(re,ue){return pi.withProgress(je,re,ue)},createOutputChannel(re,ue){return St.createOutputChannel(re,ue,je)},createWebviewPanel(re,ue,Oe,st){return Li.createWebviewPanel(je,re,ue,Oe,st)},createWebviewTextEditorInset(re,ue,Oe,st){return(0,Ye.$mF)(je,"editorInsets"),Ci.createWebviewEditorInset(re,ue,Oe,st,je)},createTerminal(re,ue,Oe){return typeof re=="object"?"pty"in re?_e.createExtensionTerminal(re):_e.createTerminalFromOptions(re):_e.createTerminal(re,ue,Oe)},registerTerminalLinkProvider(re){return _e.registerLinkProvider(re)},registerTerminalProfileProvider(re,ue){return _e.registerProfileProvider(je,re,ue)},registerTerminalQuickFixProvider(re,ue){return(0,Ye.$mF)(je,"terminalQuickFixProvider"),_e.registerTerminalQuickFixProvider(re,je.identifier.value,ue)},registerTreeDataProvider(re,ue){return mi.registerTreeDataProvider(re,ue,je)},createTreeView(re,ue){return mi.createTreeView(re,ue,je)},registerWebviewPanelSerializer:(re,ue)=>Li.registerWebviewPanelSerializer(je,re,ue),registerCustomEditorProvider:(re,ue,Oe={})=>cn.registerCustomEditorProvider(je,re,ue,Oe),registerFileDecorationProvider(re){return Ue.registerFileDecorationProvider(re,je)},registerUriHandler(re){return fi.registerUriHandler(je,re)},createQuickPick(){return ri.createQuickPick(je)},createInputBox(){return ri.createInputBox(je)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(re,ue,Oe){return Ai.onDidChangeActiveColorTheme(re,ue,Oe)},registerWebviewViewProvider(re,ue,Oe){return Fi.registerWebviewViewProvider(je,re,ue,Oe?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,ue,Oe){return kt.onDidChangeActiveNotebookEditor(re,ue,Oe)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,ue,Oe){return gi.onDidChangeNotebookEditorSelection(re,ue,Oe)},onDidChangeNotebookEditorVisibleRanges(re,ue,Oe){return gi.onDidChangeNotebookEditorVisibleRanges(re,ue,Oe)},showNotebookDocument(re,ue){return kt.showNotebookDocument(re,ue)},registerExternalUriOpener(re,ue,Oe){return(0,Ye.$mF)(je,"externalUriOpener"),un.registerExternalUriOpener(je.identifier,re,ue,Oe)},registerProfileContentHandler(re,ue){return(0,Ye.$mF)(je,"profileContentHandlers"),ln.registrProfileContentHandler(je,re,ue)},registerQuickDiffProvider(re,ue,Oe,st){return(0,Ye.$mF)(je,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(re),ue,Oe,st)},get tabGroups(){return G.tabGroups},registerShareProvider(re,ue){return(0,Ye.$mF)(je,"shareProvider"),Ki.registerShareProvider($t(re),ue)}},sn={get rootPath(){return Ee.report("workspace.rootPath",je,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw new N.$9("rootPath")},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw new N.$9("name")},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(re,ue,...Oe)=>ht.updateWorkspaceFolders(je,re,ue||0,...Oe),onDidChangeWorkspaceFolders:function(re,ue,Oe){return ht.onDidChangeWorkspace(re,ue,Oe)},asRelativePath:(re,ue)=>ht.getRelativePath(re,ue),findFiles:(re,ue,Oe,st)=>ht.findFiles(re,ue,Oe,je.identifier,st),findTextInFiles:(re,ue,Oe,st)=>{(0,Ye.$mF)(je,"findTextInFiles");let vt,Nt;return typeof ue=="object"?(vt=ue,Nt=Oe):(vt={},Nt=ue,st=Oe),ht.findTextInFiles(re,vt||{},Nt,je.identifier,st)},save:re=>((0,Ye.$mF)(je,"saveEditor"),ht.save(re)),saveAs:re=>((0,Ye.$mF)(je,"saveEditor"),ht.saveAs(re)),saveAll:re=>ht.saveAll(re),applyEdit(re,ue){return Zt.applyWorkspaceEdit(re,je,ue)},createFileSystemWatcher:(re,ue,Oe,st)=>{let vt;return typeof ue=="boolean"?vt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!st,correlate:!1}:ue&&((0,Ye.$mF)(je,"createFileSystemWatcher"),vt={...ue,correlate:!0}),xt.createFileSystemWatcher(ht,je,re,vt)},get textDocuments(){return Rt.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw new N.$9("textDocuments")},openTextDocument(re){let ue;const Oe=re;if(typeof re=="string")ue=Promise.resolve(g.URI.file(re));else if(g.URI.isUri(re))ue=Promise.resolve(re);else if(!Oe||typeof Oe=="object")ue=Rt.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>Rt.ensureDocumentData(st).then(vt=>vt.document))},onDidOpenTextDocument:(re,ue,Oe)=>Rt.onDidAddDocument(re,ue,Oe),onDidCloseTextDocument:(re,ue,Oe)=>Rt.onDidRemoveDocument(re,ue,Oe),onDidChangeTextDocument:(re,ue,Oe)=>Rt.onDidChangeDocument(re,ue,Oe),onDidSaveTextDocument:(re,ue,Oe)=>Rt.onDidSaveDocument(re,ue,Oe),onWillSaveTextDocument:(re,ue,Oe)=>Vi.getOnWillSaveTextDocumentEvent(je)(re,ue,Oe),get notebookDocuments(){return kt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,ue){let Oe;if(g.URI.isUri(re))Oe=re,await kt.openNotebookDocument(re);else if(typeof re=="string")Oe=g.URI.revive(await kt.createNotebookDocument({viewType:re,content:ue}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(re,ue,Oe){return ni.onDidSaveNotebookDocument(re,ue,Oe)},onDidChangeNotebookDocument(re,ue,Oe){return ni.onDidChangeNotebookDocument(re,ue,Oe)},onWillSaveNotebookDocument(re,ue,Oe){return Ii.getOnWillSaveNotebookDocumentEvent(je)(re,ue,Oe)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(re,ue,Oe,st){return kt.registerNotebookSerializer(je,re,ue,Oe,(0,Ye.$lF)(je,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(re,ue,Oe)=>Yi.onDidChangeConfiguration(re,ue,Oe),getConfiguration(re,ue){return ue=arguments.length===1?void 0:ue,Yi.getConfiguration(re,ue,je)},registerTextDocumentContentProvider(re,ue){return Si.registerTextDocumentContentProvider(re,ue)},registerTaskProvider:(re,ue)=>(Ee.report("window.registerTaskProvider",je,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(je,re,ue)),registerFileSystemProvider(re,ue,Oe){return(0,L.$Pc)(qi.registerFileSystemProvider(je,re,ue,Oe),Bt.addFileSystemProvider(re,ue,Oe))},get fs(){return Bt.value},registerFileSearchProvider:(re,ue)=>((0,Ye.$mF)(je,"fileSearchProvider"),zt.registerFileSearchProvider(re,ue)),registerTextSearchProvider:(re,ue)=>((0,Ye.$mF)(je,"textSearchProvider"),zt.registerTextSearchProvider(re,ue)),registerRemoteAuthorityResolver:(re,ue)=>((0,Ye.$mF)(je,"resolvers"),Et.registerRemoteAuthorityResolver(re,ue)),registerResourceLabelFormatter:re=>((0,Ye.$mF)(je,"resolvers"),Hi.$registerResourceLabelFormatter(re)),getRemoteExecServer:re=>((0,Ye.$mF)(je,"resolvers"),Et.getRemoteExecServer(re)),onDidCreateFiles:(re,ue,Oe)=>xt.onDidCreateFile(re,ue,Oe),onDidDeleteFiles:(re,ue,Oe)=>xt.onDidDeleteFile(re,ue,Oe),onDidRenameFiles:(re,ue,Oe)=>xt.onDidRenameFile(re,ue,Oe),onWillCreateFiles:(re,ue,Oe)=>xt.getOnWillCreateFileEvent(je)(re,ue,Oe),onWillDeleteFiles:(re,ue,Oe)=>xt.getOnWillDeleteFileEvent(je)(re,ue,Oe),onWillRenameFiles:(re,ue,Oe)=>xt.getOnWillRenameFileEvent(je)(re,ue,Oe),openTunnel:re=>((0,Ye.$mF)(je,"tunnels"),Lt.openTunnel(je,re).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$mF)(je,"tunnels"),Lt.getTunnels()},onDidChangeTunnels:(re,ue,Oe)=>((0,Ye.$mF)(je,"tunnels"),Lt.onDidChangeTunnels(re,ue,Oe)),registerPortAttributesProvider:(re,ue)=>((0,Ye.$mF)(je,"portsAttributes"),Lt.registerPortsAttributesProvider(re,ue)),registerTunnelProvider:(re,ue)=>((0,Ye.$mF)(je,"tunnelFactory"),Lt.registerTunnelProvider(re,ue)),registerTimelineProvider:(re,ue)=>((0,Ye.$mF)(je,"timeline"),Gi.registerTimelineProvider(re,ue,je.identifier,Ve.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Ye.$mF)(je,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,ue,Oe)=>ht.onDidGrantWorkspaceTrust(re,ue,Oe),registerEditSessionIdentityProvider:(re,ue)=>((0,Ye.$mF)(je,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,ue)),onWillCreateEditSessionIdentity:(re,ue,Oe)=>((0,Ye.$mF)(je,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent(je)(re,ue,Oe)),registerCanonicalUriProvider:(re,ue)=>((0,Ye.$mF)(je,"canonicalUriProvider"),ht.registerCanonicalUriProvider(re,ue)),getCanonicalUri:(re,ue,Oe)=>((0,Ye.$mF)(je,"canonicalUriProvider"),ht.provideCanonicalUri(re,ue,Oe))},fn={get inputBox(){return Ee.report("scm.inputBox",je,"Use 'SourceControl.inputBox' instead"),$i.getLastInputBox(je)},createSourceControl(re,ue,Oe){return $i.createSourceControl(je,re,ue,Oe)}},on={createCommentController(re,ue){return Ri.createCommentController(je,re,ue)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession(re,ue,Oe){return gt.onDidStartDebugSession(re,ue,Oe)},onDidTerminateDebugSession(re,ue,Oe){return gt.onDidTerminateDebugSession(re,ue,Oe)},onDidChangeActiveDebugSession(re,ue,Oe){return gt.onDidChangeActiveDebugSession(re,ue,Oe)},onDidReceiveDebugSessionCustomEvent(re,ue,Oe){return gt.onDidReceiveDebugSessionCustomEvent(re,ue,Oe)},onDidChangeBreakpoints(re,ue,Oe){return gt.onDidChangeBreakpoints(re,ue,Oe)},onDidChangeStackFrameFocus(re,ue,Oe){return(0,Ye.$mF)(je,"debugFocus"),gt.onDidChangeStackFrameFocus(re,ue,Oe)},registerDebugConfigurationProvider(re,ue,Oe){return gt.registerDebugConfigurationProvider(re,ue,Oe||Ot.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,ue){return gt.registerDebugAdapterDescriptorFactory(je,re,ue)},registerDebugAdapterTrackerFactory(re,ue){return gt.registerDebugAdapterTrackerFactory(re,ue)},startDebugging(re,ue,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?gt.startDebugging(re,ue,{parentSession:Oe}):gt.startDebugging(re,ue,Oe||{})},stopDebugging(re){return gt.stopDebugging(re)},addBreakpoints(re){return gt.addBreakpoints(re)},removeBreakpoints(re){return gt.removeBreakpoints(re)},asDebugSourceUri(re,ue){return gt.asDebugSourceUri(re,ue)}},Oi={registerTaskProvider:(re,ue)=>yt.registerTaskProvider(je,re,ue),fetchTasks:re=>yt.fetchTasks(re),executeTask:re=>yt.executeTask(je,re),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(re,ue,Oe)=>yt.onDidStartTask(re,ue,Oe),onDidEndTask:(re,ue,Oe)=>yt.onDidEndTask(re,ue,Oe),onDidStartTaskProcess:(re,ue,Oe)=>yt.onDidStartTaskProcess(re,ue,Oe),onDidEndTaskProcess:(re,ue,Oe)=>yt.onDidEndTaskProcess(re,ue,Oe)},ji={createNotebookController(re,ue,Oe,st,vt){return ai.createNotebookController(je,re,ue,Oe,st,(0,Ye.$lF)(je,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(re,ue)=>kt.registerNotebookCellStatusBarItemProvider(je,re,ue),createRendererMessaging(re){return ki.createRendererMessaging(je,re)},createNotebookControllerDetectionTask(re){return(0,Ye.$mF)(je,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(je,re)},registerKernelSourceActionProvider(re,ue){return(0,Ye.$mF)(je,"notebookKernelSource"),ai.registerKernelSourceActionProvider(je,re,ue)},onDidChangeNotebookCellExecutionState(re,ue,Oe){return(0,Ye.$mF)(je,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(re,ue,Oe)}},zi={t(...re){if(typeof re[0]=="string"){const ue=re.shift(),Oe=!re||typeof re[0]!="object"?re:re[0];return bt.getMessage(je.identifier.value,{message:ue,args:Oe})}return bt.getMessage(je.identifier.value,re[0])},get bundle(){return bt.getBundle(je.identifier.value)},get uri(){return bt.getBundleUri(je.identifier.value)}},Di={_version:1,registerInteractiveEditorSessionProvider(re,ue){return(0,Ye.$mF)(je,"interactive"),Ji.registerProvider(je,re,ue)},registerInteractiveSessionProvider(re,ue){return(0,Ye.$mF)(je,"interactive"),bi.registerChatProvider(je,re,ue)},sendInteractiveRequestToProvider(re,ue){return(0,Ye.$mF)(je,"interactive"),bi.sendInteractiveRequestToProvider(re,ue)},transferChatSession(re,ue){return(0,Ye.$mF)(je,"interactive"),bi.transferChatSession(re,ue)}},Ui={getRelatedInformation(re,ue){return(0,Ye.$mF)(je,"aiRelatedInformation"),Xi.getRelatedInformation(je,re,ue)},registerRelatedInformationProvider(re,ue){return(0,Ye.$mF)(je,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(je,re,ue)},registerEmbeddingVectorProvider(re,ue){return(0,Ye.$mF)(je,"aiRelatedInformation"),Mi.registerEmbeddingVectorProvider(je,re,ue)}},gn={registerChatResponseProvider(re,ue,Oe){return(0,Ye.$mF)(je,"chatProvider"),di.registerProvider(je.identifier,re,ue,Oe)},requestChatAccess(re){return(0,Ye.$mF)(je,"chatRequestAccess"),di.requestChatResponseProvider(je.identifier,re)},registerVariable(re,ue,Oe){return(0,Ye.$mF)(je,"chatVariables"),Zi.registerVariableResolver(je,re,ue,Oe)},registerMappedEditsProvider(re,ue){return(0,Ye.$mF)(je,"mappedEditsProvider"),lt.registerMappedEditsProvider(je,re,ue)},createChatAgent(re,ue){return(0,Ye.$mF)(je,"chatAgents2"),Qi.createChatAgent(je,re,ue)}},mn={registerSpeechProvider(re,ue){return(0,Ye.$mF)(je,"speech"),wi.registerProvider(je.identifier,re,ue)}};return{version:mt.version,ai:Ui,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Di,l10n:zi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Oi,tests:en,window:rn,workspace:sn,Breakpoint:Ne.$PL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$HM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$GM,CallHierarchyIncomingCall:Ne.$cL,CallHierarchyItem:Ne.$bL,CallHierarchyOutgoingCall:Ne.$dL,CancellationError:N.$5,CancellationTokenSource:E.$3d,CandidatePortSource:a.CandidatePortSource,CodeAction:Ne.$$K,CodeActionKind:Ne.$_K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$eL,Color:Ne.$rL,ColorInformation:Ne.$sL,ColorPresentation:Ne.$tL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$lL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$mL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$BL,DebugAdapterExecutable:Ne.$TL,DebugAdapterInlineImplementation:Ne.$WL,DebugAdapterNamedPipeServer:Ne.$VL,DebugAdapterServer:Ne.$UL,DebugConfigurationProviderTriggerKind:Ot.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$5K,DiagnosticRelatedInformation:Ne.$4K,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$QK,DocumentHighlight:Ne.$7K,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$8K,DocumentLink:Ne.$qL,DocumentSymbol:Ne.$0K,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$ZL,InlineValueText:Ne.$1L,InlineValueVariableLookup:Ne.$2L,InlineValueEvaluatableExpression:Ne.$3L,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Sd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$aM,FileDecoration2:Ne.$aM,FileSystemError:Ne.$5L,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$6L,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$RL,InlineCompletionItem:Ne.$nL,InlineCompletionList:Ne.$oL,Hover:Ne.$6K,IndentAction:k.IndentAction,Location:Ne.$3K,MarkdownString:Ne.$fL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$gL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$RK,ProcessExecution:Ne.$zL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$_L,Range:Ne.$SK,RelativePattern:Ne.$NL,Selection:Ne.$TK,SelectionRange:Ne.$aL,SemanticTokens:Ne.$9L,SemanticTokensBuilder:Ne.$8L,SemanticTokensEdit:Ne.$0L,SemanticTokensEdits:Ne.$$L,SemanticTokensLegend:Ne.$7L,ShellExecution:Ne.$AL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$iL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$hL,SnippetString:Ne.$2K,SourceBreakpoint:Ne.$QL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$9K,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$CL,TaskGroup:Ne.$yL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$uL,TerminalQuickFixTerminalCommand:Ne.$wL,TerminalQuickFixOpener:Ne.$vL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$xL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$XK,SnippetTextEdit:Ne.$ZK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$ML,ThemeIcon:Ne.$LL,TreeItem:Ne.$DL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$vM,UIKind:Ct.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$1K,DocumentDropEdit:Ne.$JL,DocumentPasteEdit:Ne.$KL,InlayHint:Ne.$kL,InlayHintLabelPart:Ne.$jL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$WK,ResolvedAuthority:Ne.$UK,ManagedResolvedAuthority:Ne.$VK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$kM,NotebookRange:Ne.$cM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$dM,NotebookData:Ne.$eM,NotebookRendererScript:Ne.$iM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$gM,NotebookCellOutputItem:Ne.$fM,NotebookCellStatusBarItem:Ne.$hM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$YK,NotebookKernelSourceAction:Ne.$jM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$mM,LinkedEditingRanges:Ne.$lM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$nM,TestMessage:Ne.$oM,TestMessage2:Ne.$oM,TestTag:Ne.$pM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Ht.TextSearchCompleteMessageType,DataTransfer:Ne.$IL,DataTransferItem:Ne.$EL,CoveredCount:Ne.$qM,FileCoverage:Ne.$rM,StatementCoverage:Ne.$sM,BranchCoverage:Ne.$tM,FunctionCoverage:Ne.$uM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$wM,TabInputTextDiff:Ne.$xM,TabInputTextMerge:Ne.$yM,TabInputCustom:Ne.$zM,TabInputNotebook:Ne.$BM,TabInputNotebookDiff:Ne.$CM,TabInputWebview:Ne.$AM,TabInputTerminal:Ne.$DM,TabInputInteractiveWindow:Ne.$EM,TabInputChat:Ne.$FM,TelemetryTrustedValue:t.$xo,LogLevel:r.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$XL,ThreadFocus:Ne.$YL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$ghc=Gt}),define(Ce[291],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,256,15,116,82,83]),function(ge,e,E,N,I,L,R,m,g,w,A,k,l,p,b,r,o,t,n,a,c,h,i,s,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Kr)(d.$8fc,d.$7fc,1),(0,E.$Kr)(s.$kj,i.$hhc,1),(0,E.$Kr)(r.$gfc,r.$hfc,1),(0,E.$Kr)(m.$cN,m.$bN,0),(0,E.$Kr)(R.$Bfc,R.$zfc,0),(0,E.$Kr)(t.$Dfc,t.$Cfc,0),(0,E.$Kr)(k.$fgc,k.$jgc,0),(0,E.$Kr)(L.$lgc,L.$kgc,0),(0,E.$Kr)(g.$4M,g.$3M,0),(0,E.$Kr)(v.$9fc,v.$0fc,0),(0,E.$Kr)(n.$dfc,n.$cfc,0),(0,E.$Kr)(N.$Rgc,N.$Qgc,1),(0,E.$Kr)(l.$Bgc,l.$Cgc,0),(0,E.$Kr)(p.$Wfc,p.$Vfc,0),(0,E.$Kr)(A.$5gc,A.$4gc,0),(0,E.$Kr)(w.$Zfc,w.$3fc,0),(0,E.$Kr)(b.$cyb,b.$dyb,0),(0,E.$Kr)(o.$fhc,o.$ehc,0),(0,E.$Kr)(I.$yfc,I.$xfc,0),(0,E.$Kr)(a.$5fc,a.$4fc,0),(0,E.$Kr)(c.$aN,c.$0M,0),(0,E.$Kr)(h.$Nfc,h.$Ofc,0),(0,E.$Kr)(u.$dgc,u.$egc,0)}),define(Ce[292],Re([1,0,290,38,2,287,7,14,275]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=void 0;class w extends L.$khc{j(){}getModule(p,b){for(const r of this.b){const o=r(p);if(o){p=o;break}}if(this.a.has(p))return this.a.get(p).load(p,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends N.$_fc{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$qjc);const p=this.h.invokeFunction(E.$ghc);this.r=this.h.createInstance(w,p,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub(p){return p.browser}async vb(p,b,r){b=b.with({path:k(b.path,".js")});const o=p?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const t=I.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),n.status!==200)throw new Error(n.statusText);const a=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${a}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(v){throw console.error(o?`Loading code for extension ${o} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${b.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}p&&await this.w.initializeLocalizedMessages(p);const s={},u={exports:s},d=v=>{const f=this.r.getModule(v,b);if(f===void 0)throw new Error(`Cannot load module '${v}'`);return f};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(u,s,d),u.exports!==s?u.exports:s}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(p){}async zb(p=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+p;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,m.$3g)(10)}}e.$rjc=A;function k(l,p){return l.endsWith(p)?l:l+p}}),define(Ce[293],Re([1,0,69,70,15,38,200,86,292]),function(ge,e,E,N,I,L,R,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$Kr)(I.$jj,new E.$Yh(R.$jhc,[!0],!0)),(0,N.$Kr)(L.$agc,g.$rjc,0),(0,N.$Kr)(m.$Efc,m.$Ffc,0)}),define(Ce[298],Re([1,0,24,5,79,288,277,19,88,13,2,291,293]),function(ge,e,E,N,I,L,R,m,g,w,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function p(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function r(i){self.fetch=async function(s,u){return s instanceof Request||p(String(s))&&(s=(await i(A.URI.parse(String(s)))).toString(!0)),b(s,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(s,u,d,v,f){(async()=>(p(u.toString())&&(u=(await i(A.URI.parse(u.toString()))).toString(!0)),super.open(s,u,d??!0,v,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(s,u){if(/^file:/i.test(s.toString()))s=w.$kg.uriToBrowserUri(A.URI.parse(s.toString())).toString(!0);else if(/^vscode-remote:/i.test(s.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function($){function y(O){return typeof O=="string"||O instanceof URL?String(O).replace(/^file:\/\//i,"vscode-file://vscode-app"):O}const D=fetch.bind(self);self.fetch=function(O,W){return O instanceof Request?D(O,W):D(y(O),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(O,W,z,q,C){return super.open(O,y(W),z??!0,q,C)}};const M=importScripts.bind(self);self.importScripts=(...O)=>{M(...O.map(y))},M($)}.toString()}('${s}'))`;u=u||{},u.name=u.name||m.$nc(s.toString());const f=new Blob([v],{type:"application/javascript"}),S=URL.createObjectURL(f);return new i(S,u)}}else self.Worker=class extends R.$sjc{constructor(i,s){super(l,i,{name:m.$nc(i.toString()),...s})}};const o=new class{constructor(){this.pid=void 0}exit(i){k()}};class t{constructor(){const s=new MessageChannel,u=new N.$Sd;let d=!1;l(s.port2,[s.port2]),s.port1.onmessage=v=>{const{data:f}=v;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const S=E.$ge.wrap(new Uint8Array(f,0,f.byteLength));if((0,I.$qm)(S,2)){d=!0,a("received terminate message from renderer");return}u.fire(S)},this.protocol={onMessage:u.event,send:v=>{if(!d){const f=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);s.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(s=>{const u=i.onMessage(d=>{u.dispose();const v=JSON.parse(d.toString());i.send((0,I.$pm)(0)),s({protocol:i,initData:v})});i.send((0,I.$pm)(1))})}let a=i=>k();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(s){c(s)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new L.$mhc(u.protocol,u.initData,o,null,s.data);r(v=>d.asBrowserUri(v)),a=v=>d.terminate(v)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/66c869c41f95221f297172dea95892381b19dbaf/core/vs/workbench/api/worker/extensionHostWorker.js.map
